// SPDX-License-Identifier: MIT
// Copyright (C) 2018-present iced project and contributors

// ⚠️This file was generated by GENERATOR!🦹‍♂️

#nullable enable

namespace Iced.Intel {
	static class InstructionMemorySizes {
#if HAS_SPAN
		internal static System.ReadOnlySpan<byte> SizesNormal => new byte[IcedConstants.CodeEnumCount] {
#else
		internal static readonly byte[] SizesNormal = new byte[IcedConstants.CodeEnumCount] {
#endif
			0,// INVALID
			0,// DeclareByte
			0,// DeclareWord
			0,// DeclareDword
			0,// DeclareQword
			(byte)MemorySize.UInt8,// Add_rm8_r8
			(byte)MemorySize.UInt16,// Add_rm16_r16
			(byte)MemorySize.UInt32,// Add_rm32_r32
			(byte)MemorySize.UInt64,// Add_rm64_r64
			(byte)MemorySize.UInt8,// Add_r8_rm8
			(byte)MemorySize.UInt16,// Add_r16_rm16
			(byte)MemorySize.UInt32,// Add_r32_rm32
			(byte)MemorySize.UInt64,// Add_r64_rm64
			0,// Add_AL_imm8
			0,// Add_AX_imm16
			0,// Add_EAX_imm32
			0,// Add_RAX_imm32
			0,// Pushw_ES
			0,// Pushd_ES
			0,// Popw_ES
			0,// Popd_ES
			(byte)MemorySize.UInt8,// Or_rm8_r8
			(byte)MemorySize.UInt16,// Or_rm16_r16
			(byte)MemorySize.UInt32,// Or_rm32_r32
			(byte)MemorySize.UInt64,// Or_rm64_r64
			(byte)MemorySize.UInt8,// Or_r8_rm8
			(byte)MemorySize.UInt16,// Or_r16_rm16
			(byte)MemorySize.UInt32,// Or_r32_rm32
			(byte)MemorySize.UInt64,// Or_r64_rm64
			0,// Or_AL_imm8
			0,// Or_AX_imm16
			0,// Or_EAX_imm32
			0,// Or_RAX_imm32
			0,// Pushw_CS
			0,// Pushd_CS
			0,// Popw_CS
			(byte)MemorySize.UInt8,// Adc_rm8_r8
			(byte)MemorySize.UInt16,// Adc_rm16_r16
			(byte)MemorySize.UInt32,// Adc_rm32_r32
			(byte)MemorySize.UInt64,// Adc_rm64_r64
			(byte)MemorySize.UInt8,// Adc_r8_rm8
			(byte)MemorySize.UInt16,// Adc_r16_rm16
			(byte)MemorySize.UInt32,// Adc_r32_rm32
			(byte)MemorySize.UInt64,// Adc_r64_rm64
			0,// Adc_AL_imm8
			0,// Adc_AX_imm16
			0,// Adc_EAX_imm32
			0,// Adc_RAX_imm32
			0,// Pushw_SS
			0,// Pushd_SS
			0,// Popw_SS
			0,// Popd_SS
			(byte)MemorySize.UInt8,// Sbb_rm8_r8
			(byte)MemorySize.UInt16,// Sbb_rm16_r16
			(byte)MemorySize.UInt32,// Sbb_rm32_r32
			(byte)MemorySize.UInt64,// Sbb_rm64_r64
			(byte)MemorySize.UInt8,// Sbb_r8_rm8
			(byte)MemorySize.UInt16,// Sbb_r16_rm16
			(byte)MemorySize.UInt32,// Sbb_r32_rm32
			(byte)MemorySize.UInt64,// Sbb_r64_rm64
			0,// Sbb_AL_imm8
			0,// Sbb_AX_imm16
			0,// Sbb_EAX_imm32
			0,// Sbb_RAX_imm32
			0,// Pushw_DS
			0,// Pushd_DS
			0,// Popw_DS
			0,// Popd_DS
			(byte)MemorySize.UInt8,// And_rm8_r8
			(byte)MemorySize.UInt16,// And_rm16_r16
			(byte)MemorySize.UInt32,// And_rm32_r32
			(byte)MemorySize.UInt64,// And_rm64_r64
			(byte)MemorySize.UInt8,// And_r8_rm8
			(byte)MemorySize.UInt16,// And_r16_rm16
			(byte)MemorySize.UInt32,// And_r32_rm32
			(byte)MemorySize.UInt64,// And_r64_rm64
			0,// And_AL_imm8
			0,// And_AX_imm16
			0,// And_EAX_imm32
			0,// And_RAX_imm32
			0,// Daa
			(byte)MemorySize.UInt8,// Sub_rm8_r8
			(byte)MemorySize.UInt16,// Sub_rm16_r16
			(byte)MemorySize.UInt32,// Sub_rm32_r32
			(byte)MemorySize.UInt64,// Sub_rm64_r64
			(byte)MemorySize.UInt8,// Sub_r8_rm8
			(byte)MemorySize.UInt16,// Sub_r16_rm16
			(byte)MemorySize.UInt32,// Sub_r32_rm32
			(byte)MemorySize.UInt64,// Sub_r64_rm64
			0,// Sub_AL_imm8
			0,// Sub_AX_imm16
			0,// Sub_EAX_imm32
			0,// Sub_RAX_imm32
			0,// Das
			(byte)MemorySize.UInt8,// Xor_rm8_r8
			(byte)MemorySize.UInt16,// Xor_rm16_r16
			(byte)MemorySize.UInt32,// Xor_rm32_r32
			(byte)MemorySize.UInt64,// Xor_rm64_r64
			(byte)MemorySize.UInt8,// Xor_r8_rm8
			(byte)MemorySize.UInt16,// Xor_r16_rm16
			(byte)MemorySize.UInt32,// Xor_r32_rm32
			(byte)MemorySize.UInt64,// Xor_r64_rm64
			0,// Xor_AL_imm8
			0,// Xor_AX_imm16
			0,// Xor_EAX_imm32
			0,// Xor_RAX_imm32
			0,// Aaa
			(byte)MemorySize.UInt8,// Cmp_rm8_r8
			(byte)MemorySize.UInt16,// Cmp_rm16_r16
			(byte)MemorySize.UInt32,// Cmp_rm32_r32
			(byte)MemorySize.UInt64,// Cmp_rm64_r64
			(byte)MemorySize.UInt8,// Cmp_r8_rm8
			(byte)MemorySize.UInt16,// Cmp_r16_rm16
			(byte)MemorySize.UInt32,// Cmp_r32_rm32
			(byte)MemorySize.UInt64,// Cmp_r64_rm64
			0,// Cmp_AL_imm8
			0,// Cmp_AX_imm16
			0,// Cmp_EAX_imm32
			0,// Cmp_RAX_imm32
			0,// Aas
			0,// Inc_r16
			0,// Inc_r32
			0,// Dec_r16
			0,// Dec_r32
			0,// Push_r16
			0,// Push_r32
			0,// Push_r64
			0,// Pop_r16
			0,// Pop_r32
			0,// Pop_r64
			0,// Pushaw
			0,// Pushad
			0,// Popaw
			0,// Popad
			(byte)MemorySize.Bound16_WordWord,// Bound_r16_m1616
			(byte)MemorySize.Bound32_DwordDword,// Bound_r32_m3232
			(byte)MemorySize.UInt16,// Arpl_rm16_r16
			(byte)MemorySize.UInt16,// Arpl_r32m16_r32
			(byte)MemorySize.Int16,// Movsxd_r16_rm16
			(byte)MemorySize.Int32,// Movsxd_r32_rm32
			(byte)MemorySize.Int32,// Movsxd_r64_rm32
			0,// Push_imm16
			0,// Pushd_imm32
			0,// Pushq_imm32
			(byte)MemorySize.Int16,// Imul_r16_rm16_imm16
			(byte)MemorySize.Int32,// Imul_r32_rm32_imm32
			(byte)MemorySize.Int64,// Imul_r64_rm64_imm32
			0,// Pushw_imm8
			0,// Pushd_imm8
			0,// Pushq_imm8
			(byte)MemorySize.Int16,// Imul_r16_rm16_imm8
			(byte)MemorySize.Int32,// Imul_r32_rm32_imm8
			(byte)MemorySize.Int64,// Imul_r64_rm64_imm8
			(byte)MemorySize.UInt8,// Insb_m8_DX
			(byte)MemorySize.UInt16,// Insw_m16_DX
			(byte)MemorySize.UInt32,// Insd_m32_DX
			(byte)MemorySize.UInt8,// Outsb_DX_m8
			(byte)MemorySize.UInt16,// Outsw_DX_m16
			(byte)MemorySize.UInt32,// Outsd_DX_m32
			0,// Jo_rel8_16
			0,// Jo_rel8_32
			0,// Jo_rel8_64
			0,// Jno_rel8_16
			0,// Jno_rel8_32
			0,// Jno_rel8_64
			0,// Jb_rel8_16
			0,// Jb_rel8_32
			0,// Jb_rel8_64
			0,// Jae_rel8_16
			0,// Jae_rel8_32
			0,// Jae_rel8_64
			0,// Je_rel8_16
			0,// Je_rel8_32
			0,// Je_rel8_64
			0,// Jne_rel8_16
			0,// Jne_rel8_32
			0,// Jne_rel8_64
			0,// Jbe_rel8_16
			0,// Jbe_rel8_32
			0,// Jbe_rel8_64
			0,// Ja_rel8_16
			0,// Ja_rel8_32
			0,// Ja_rel8_64
			0,// Js_rel8_16
			0,// Js_rel8_32
			0,// Js_rel8_64
			0,// Jns_rel8_16
			0,// Jns_rel8_32
			0,// Jns_rel8_64
			0,// Jp_rel8_16
			0,// Jp_rel8_32
			0,// Jp_rel8_64
			0,// Jnp_rel8_16
			0,// Jnp_rel8_32
			0,// Jnp_rel8_64
			0,// Jl_rel8_16
			0,// Jl_rel8_32
			0,// Jl_rel8_64
			0,// Jge_rel8_16
			0,// Jge_rel8_32
			0,// Jge_rel8_64
			0,// Jle_rel8_16
			0,// Jle_rel8_32
			0,// Jle_rel8_64
			0,// Jg_rel8_16
			0,// Jg_rel8_32
			0,// Jg_rel8_64
			(byte)MemorySize.UInt8,// Add_rm8_imm8
			(byte)MemorySize.UInt8,// Or_rm8_imm8
			(byte)MemorySize.UInt8,// Adc_rm8_imm8
			(byte)MemorySize.UInt8,// Sbb_rm8_imm8
			(byte)MemorySize.UInt8,// And_rm8_imm8
			(byte)MemorySize.UInt8,// Sub_rm8_imm8
			(byte)MemorySize.UInt8,// Xor_rm8_imm8
			(byte)MemorySize.UInt8,// Cmp_rm8_imm8
			(byte)MemorySize.UInt16,// Add_rm16_imm16
			(byte)MemorySize.UInt32,// Add_rm32_imm32
			(byte)MemorySize.UInt64,// Add_rm64_imm32
			(byte)MemorySize.UInt16,// Or_rm16_imm16
			(byte)MemorySize.UInt32,// Or_rm32_imm32
			(byte)MemorySize.UInt64,// Or_rm64_imm32
			(byte)MemorySize.UInt16,// Adc_rm16_imm16
			(byte)MemorySize.UInt32,// Adc_rm32_imm32
			(byte)MemorySize.UInt64,// Adc_rm64_imm32
			(byte)MemorySize.UInt16,// Sbb_rm16_imm16
			(byte)MemorySize.UInt32,// Sbb_rm32_imm32
			(byte)MemorySize.UInt64,// Sbb_rm64_imm32
			(byte)MemorySize.UInt16,// And_rm16_imm16
			(byte)MemorySize.UInt32,// And_rm32_imm32
			(byte)MemorySize.UInt64,// And_rm64_imm32
			(byte)MemorySize.UInt16,// Sub_rm16_imm16
			(byte)MemorySize.UInt32,// Sub_rm32_imm32
			(byte)MemorySize.UInt64,// Sub_rm64_imm32
			(byte)MemorySize.UInt16,// Xor_rm16_imm16
			(byte)MemorySize.UInt32,// Xor_rm32_imm32
			(byte)MemorySize.UInt64,// Xor_rm64_imm32
			(byte)MemorySize.UInt16,// Cmp_rm16_imm16
			(byte)MemorySize.UInt32,// Cmp_rm32_imm32
			(byte)MemorySize.UInt64,// Cmp_rm64_imm32
			(byte)MemorySize.UInt8,// Add_rm8_imm8_82
			(byte)MemorySize.UInt8,// Or_rm8_imm8_82
			(byte)MemorySize.UInt8,// Adc_rm8_imm8_82
			(byte)MemorySize.UInt8,// Sbb_rm8_imm8_82
			(byte)MemorySize.UInt8,// And_rm8_imm8_82
			(byte)MemorySize.UInt8,// Sub_rm8_imm8_82
			(byte)MemorySize.UInt8,// Xor_rm8_imm8_82
			(byte)MemorySize.UInt8,// Cmp_rm8_imm8_82
			(byte)MemorySize.UInt16,// Add_rm16_imm8
			(byte)MemorySize.UInt32,// Add_rm32_imm8
			(byte)MemorySize.UInt64,// Add_rm64_imm8
			(byte)MemorySize.UInt16,// Or_rm16_imm8
			(byte)MemorySize.UInt32,// Or_rm32_imm8
			(byte)MemorySize.UInt64,// Or_rm64_imm8
			(byte)MemorySize.UInt16,// Adc_rm16_imm8
			(byte)MemorySize.UInt32,// Adc_rm32_imm8
			(byte)MemorySize.UInt64,// Adc_rm64_imm8
			(byte)MemorySize.UInt16,// Sbb_rm16_imm8
			(byte)MemorySize.UInt32,// Sbb_rm32_imm8
			(byte)MemorySize.UInt64,// Sbb_rm64_imm8
			(byte)MemorySize.UInt16,// And_rm16_imm8
			(byte)MemorySize.UInt32,// And_rm32_imm8
			(byte)MemorySize.UInt64,// And_rm64_imm8
			(byte)MemorySize.UInt16,// Sub_rm16_imm8
			(byte)MemorySize.UInt32,// Sub_rm32_imm8
			(byte)MemorySize.UInt64,// Sub_rm64_imm8
			(byte)MemorySize.UInt16,// Xor_rm16_imm8
			(byte)MemorySize.UInt32,// Xor_rm32_imm8
			(byte)MemorySize.UInt64,// Xor_rm64_imm8
			(byte)MemorySize.UInt16,// Cmp_rm16_imm8
			(byte)MemorySize.UInt32,// Cmp_rm32_imm8
			(byte)MemorySize.UInt64,// Cmp_rm64_imm8
			(byte)MemorySize.UInt8,// Test_rm8_r8
			(byte)MemorySize.UInt16,// Test_rm16_r16
			(byte)MemorySize.UInt32,// Test_rm32_r32
			(byte)MemorySize.UInt64,// Test_rm64_r64
			(byte)MemorySize.UInt8,// Xchg_rm8_r8
			(byte)MemorySize.UInt16,// Xchg_rm16_r16
			(byte)MemorySize.UInt32,// Xchg_rm32_r32
			(byte)MemorySize.UInt64,// Xchg_rm64_r64
			(byte)MemorySize.UInt8,// Mov_rm8_r8
			(byte)MemorySize.UInt16,// Mov_rm16_r16
			(byte)MemorySize.UInt32,// Mov_rm32_r32
			(byte)MemorySize.UInt64,// Mov_rm64_r64
			(byte)MemorySize.UInt8,// Mov_r8_rm8
			(byte)MemorySize.UInt16,// Mov_r16_rm16
			(byte)MemorySize.UInt32,// Mov_r32_rm32
			(byte)MemorySize.UInt64,// Mov_r64_rm64
			(byte)MemorySize.UInt16,// Mov_rm16_Sreg
			(byte)MemorySize.UInt16,// Mov_r32m16_Sreg
			(byte)MemorySize.UInt16,// Mov_r64m16_Sreg
			0,// Lea_r16_m
			0,// Lea_r32_m
			0,// Lea_r64_m
			(byte)MemorySize.UInt16,// Mov_Sreg_rm16
			(byte)MemorySize.UInt16,// Mov_Sreg_r32m16
			(byte)MemorySize.UInt16,// Mov_Sreg_r64m16
			(byte)MemorySize.UInt16,// Pop_rm16
			(byte)MemorySize.UInt32,// Pop_rm32
			(byte)MemorySize.UInt64,// Pop_rm64
			0,// Nopw
			0,// Nopd
			0,// Nopq
			0,// Xchg_r16_AX
			0,// Xchg_r32_EAX
			0,// Xchg_r64_RAX
			0,// Pause
			0,// Cbw
			0,// Cwde
			0,// Cdqe
			0,// Cwd
			0,// Cdq
			0,// Cqo
			0,// Call_ptr1616
			0,// Call_ptr1632
			0,// Wait
			0,// Pushfw
			0,// Pushfd
			0,// Pushfq
			0,// Popfw
			0,// Popfd
			0,// Popfq
			0,// Sahf
			0,// Lahf
			(byte)MemorySize.UInt8,// Mov_AL_moffs8
			(byte)MemorySize.UInt16,// Mov_AX_moffs16
			(byte)MemorySize.UInt32,// Mov_EAX_moffs32
			(byte)MemorySize.UInt64,// Mov_RAX_moffs64
			(byte)MemorySize.UInt8,// Mov_moffs8_AL
			(byte)MemorySize.UInt16,// Mov_moffs16_AX
			(byte)MemorySize.UInt32,// Mov_moffs32_EAX
			(byte)MemorySize.UInt64,// Mov_moffs64_RAX
			(byte)MemorySize.UInt8,// Movsb_m8_m8
			(byte)MemorySize.UInt16,// Movsw_m16_m16
			(byte)MemorySize.UInt32,// Movsd_m32_m32
			(byte)MemorySize.UInt64,// Movsq_m64_m64
			(byte)MemorySize.UInt8,// Cmpsb_m8_m8
			(byte)MemorySize.UInt16,// Cmpsw_m16_m16
			(byte)MemorySize.UInt32,// Cmpsd_m32_m32
			(byte)MemorySize.UInt64,// Cmpsq_m64_m64
			0,// Test_AL_imm8
			0,// Test_AX_imm16
			0,// Test_EAX_imm32
			0,// Test_RAX_imm32
			(byte)MemorySize.UInt8,// Stosb_m8_AL
			(byte)MemorySize.UInt16,// Stosw_m16_AX
			(byte)MemorySize.UInt32,// Stosd_m32_EAX
			(byte)MemorySize.UInt64,// Stosq_m64_RAX
			(byte)MemorySize.UInt8,// Lodsb_AL_m8
			(byte)MemorySize.UInt16,// Lodsw_AX_m16
			(byte)MemorySize.UInt32,// Lodsd_EAX_m32
			(byte)MemorySize.UInt64,// Lodsq_RAX_m64
			(byte)MemorySize.UInt8,// Scasb_AL_m8
			(byte)MemorySize.UInt16,// Scasw_AX_m16
			(byte)MemorySize.UInt32,// Scasd_EAX_m32
			(byte)MemorySize.UInt64,// Scasq_RAX_m64
			0,// Mov_r8_imm8
			0,// Mov_r16_imm16
			0,// Mov_r32_imm32
			0,// Mov_r64_imm64
			(byte)MemorySize.UInt8,// Rol_rm8_imm8
			(byte)MemorySize.UInt8,// Ror_rm8_imm8
			(byte)MemorySize.UInt8,// Rcl_rm8_imm8
			(byte)MemorySize.UInt8,// Rcr_rm8_imm8
			(byte)MemorySize.UInt8,// Shl_rm8_imm8
			(byte)MemorySize.UInt8,// Shr_rm8_imm8
			(byte)MemorySize.UInt8,// Sal_rm8_imm8
			(byte)MemorySize.Int8,// Sar_rm8_imm8
			(byte)MemorySize.UInt16,// Rol_rm16_imm8
			(byte)MemorySize.UInt32,// Rol_rm32_imm8
			(byte)MemorySize.UInt64,// Rol_rm64_imm8
			(byte)MemorySize.UInt16,// Ror_rm16_imm8
			(byte)MemorySize.UInt32,// Ror_rm32_imm8
			(byte)MemorySize.UInt64,// Ror_rm64_imm8
			(byte)MemorySize.UInt16,// Rcl_rm16_imm8
			(byte)MemorySize.UInt32,// Rcl_rm32_imm8
			(byte)MemorySize.UInt64,// Rcl_rm64_imm8
			(byte)MemorySize.UInt16,// Rcr_rm16_imm8
			(byte)MemorySize.UInt32,// Rcr_rm32_imm8
			(byte)MemorySize.UInt64,// Rcr_rm64_imm8
			(byte)MemorySize.UInt16,// Shl_rm16_imm8
			(byte)MemorySize.UInt32,// Shl_rm32_imm8
			(byte)MemorySize.UInt64,// Shl_rm64_imm8
			(byte)MemorySize.UInt16,// Shr_rm16_imm8
			(byte)MemorySize.UInt32,// Shr_rm32_imm8
			(byte)MemorySize.UInt64,// Shr_rm64_imm8
			(byte)MemorySize.UInt16,// Sal_rm16_imm8
			(byte)MemorySize.UInt32,// Sal_rm32_imm8
			(byte)MemorySize.UInt64,// Sal_rm64_imm8
			(byte)MemorySize.Int16,// Sar_rm16_imm8
			(byte)MemorySize.Int32,// Sar_rm32_imm8
			(byte)MemorySize.Int64,// Sar_rm64_imm8
			0,// Retnw_imm16
			0,// Retnd_imm16
			0,// Retnq_imm16
			0,// Retnw
			0,// Retnd
			0,// Retnq
			(byte)MemorySize.SegPtr16,// Les_r16_m1616
			(byte)MemorySize.SegPtr32,// Les_r32_m1632
			(byte)MemorySize.SegPtr16,// Lds_r16_m1616
			(byte)MemorySize.SegPtr32,// Lds_r32_m1632
			(byte)MemorySize.UInt8,// Mov_rm8_imm8
			0,// Xabort_imm8
			(byte)MemorySize.UInt16,// Mov_rm16_imm16
			(byte)MemorySize.UInt32,// Mov_rm32_imm32
			(byte)MemorySize.UInt64,// Mov_rm64_imm32
			0,// Xbegin_rel16
			0,// Xbegin_rel32
			0,// Enterw_imm16_imm8
			0,// Enterd_imm16_imm8
			0,// Enterq_imm16_imm8
			0,// Leavew
			0,// Leaved
			0,// Leaveq
			0,// Retfw_imm16
			0,// Retfd_imm16
			0,// Retfq_imm16
			0,// Retfw
			0,// Retfd
			0,// Retfq
			0,// Int3
			0,// Int_imm8
			0,// Into
			0,// Iretw
			0,// Iretd
			0,// Iretq
			(byte)MemorySize.UInt8,// Rol_rm8_1
			(byte)MemorySize.UInt8,// Ror_rm8_1
			(byte)MemorySize.UInt8,// Rcl_rm8_1
			(byte)MemorySize.UInt8,// Rcr_rm8_1
			(byte)MemorySize.UInt8,// Shl_rm8_1
			(byte)MemorySize.UInt8,// Shr_rm8_1
			(byte)MemorySize.UInt8,// Sal_rm8_1
			(byte)MemorySize.Int8,// Sar_rm8_1
			(byte)MemorySize.UInt16,// Rol_rm16_1
			(byte)MemorySize.UInt32,// Rol_rm32_1
			(byte)MemorySize.UInt64,// Rol_rm64_1
			(byte)MemorySize.UInt16,// Ror_rm16_1
			(byte)MemorySize.UInt32,// Ror_rm32_1
			(byte)MemorySize.UInt64,// Ror_rm64_1
			(byte)MemorySize.UInt16,// Rcl_rm16_1
			(byte)MemorySize.UInt32,// Rcl_rm32_1
			(byte)MemorySize.UInt64,// Rcl_rm64_1
			(byte)MemorySize.UInt16,// Rcr_rm16_1
			(byte)MemorySize.UInt32,// Rcr_rm32_1
			(byte)MemorySize.UInt64,// Rcr_rm64_1
			(byte)MemorySize.UInt16,// Shl_rm16_1
			(byte)MemorySize.UInt32,// Shl_rm32_1
			(byte)MemorySize.UInt64,// Shl_rm64_1
			(byte)MemorySize.UInt16,// Shr_rm16_1
			(byte)MemorySize.UInt32,// Shr_rm32_1
			(byte)MemorySize.UInt64,// Shr_rm64_1
			(byte)MemorySize.UInt16,// Sal_rm16_1
			(byte)MemorySize.UInt32,// Sal_rm32_1
			(byte)MemorySize.UInt64,// Sal_rm64_1
			(byte)MemorySize.Int16,// Sar_rm16_1
			(byte)MemorySize.Int32,// Sar_rm32_1
			(byte)MemorySize.Int64,// Sar_rm64_1
			(byte)MemorySize.UInt8,// Rol_rm8_CL
			(byte)MemorySize.UInt8,// Ror_rm8_CL
			(byte)MemorySize.UInt8,// Rcl_rm8_CL
			(byte)MemorySize.UInt8,// Rcr_rm8_CL
			(byte)MemorySize.UInt8,// Shl_rm8_CL
			(byte)MemorySize.UInt8,// Shr_rm8_CL
			(byte)MemorySize.UInt8,// Sal_rm8_CL
			(byte)MemorySize.Int8,// Sar_rm8_CL
			(byte)MemorySize.UInt16,// Rol_rm16_CL
			(byte)MemorySize.UInt32,// Rol_rm32_CL
			(byte)MemorySize.UInt64,// Rol_rm64_CL
			(byte)MemorySize.UInt16,// Ror_rm16_CL
			(byte)MemorySize.UInt32,// Ror_rm32_CL
			(byte)MemorySize.UInt64,// Ror_rm64_CL
			(byte)MemorySize.UInt16,// Rcl_rm16_CL
			(byte)MemorySize.UInt32,// Rcl_rm32_CL
			(byte)MemorySize.UInt64,// Rcl_rm64_CL
			(byte)MemorySize.UInt16,// Rcr_rm16_CL
			(byte)MemorySize.UInt32,// Rcr_rm32_CL
			(byte)MemorySize.UInt64,// Rcr_rm64_CL
			(byte)MemorySize.UInt16,// Shl_rm16_CL
			(byte)MemorySize.UInt32,// Shl_rm32_CL
			(byte)MemorySize.UInt64,// Shl_rm64_CL
			(byte)MemorySize.UInt16,// Shr_rm16_CL
			(byte)MemorySize.UInt32,// Shr_rm32_CL
			(byte)MemorySize.UInt64,// Shr_rm64_CL
			(byte)MemorySize.UInt16,// Sal_rm16_CL
			(byte)MemorySize.UInt32,// Sal_rm32_CL
			(byte)MemorySize.UInt64,// Sal_rm64_CL
			(byte)MemorySize.Int16,// Sar_rm16_CL
			(byte)MemorySize.Int32,// Sar_rm32_CL
			(byte)MemorySize.Int64,// Sar_rm64_CL
			0,// Aam_imm8
			0,// Aad_imm8
			0,// Salc
			(byte)MemorySize.UInt8,// Xlat_m8
			(byte)MemorySize.Float32,// Fadd_m32fp
			(byte)MemorySize.Float32,// Fmul_m32fp
			(byte)MemorySize.Float32,// Fcom_m32fp
			(byte)MemorySize.Float32,// Fcomp_m32fp
			(byte)MemorySize.Float32,// Fsub_m32fp
			(byte)MemorySize.Float32,// Fsubr_m32fp
			(byte)MemorySize.Float32,// Fdiv_m32fp
			(byte)MemorySize.Float32,// Fdivr_m32fp
			0,// Fadd_st0_sti
			0,// Fmul_st0_sti
			0,// Fcom_st0_sti
			0,// Fcomp_st0_sti
			0,// Fsub_st0_sti
			0,// Fsubr_st0_sti
			0,// Fdiv_st0_sti
			0,// Fdivr_st0_sti
			(byte)MemorySize.Float32,// Fld_m32fp
			(byte)MemorySize.Float32,// Fst_m32fp
			(byte)MemorySize.Float32,// Fstp_m32fp
			(byte)MemorySize.FpuEnv14,// Fldenv_m14byte
			(byte)MemorySize.FpuEnv28,// Fldenv_m28byte
			(byte)MemorySize.UInt16,// Fldcw_m2byte
			(byte)MemorySize.FpuEnv14,// Fnstenv_m14byte
			(byte)MemorySize.FpuEnv14,// Fstenv_m14byte
			(byte)MemorySize.FpuEnv28,// Fnstenv_m28byte
			(byte)MemorySize.FpuEnv28,// Fstenv_m28byte
			(byte)MemorySize.UInt16,// Fnstcw_m2byte
			(byte)MemorySize.UInt16,// Fstcw_m2byte
			0,// Fld_sti
			0,// Fxch_st0_sti
			0,// Fnop
			0,// Fstpnce_sti
			0,// Fchs
			0,// Fabs
			0,// Ftst
			0,// Fxam
			0,// Fld1
			0,// Fldl2t
			0,// Fldl2e
			0,// Fldpi
			0,// Fldlg2
			0,// Fldln2
			0,// Fldz
			0,// F2xm1
			0,// Fyl2x
			0,// Fptan
			0,// Fpatan
			0,// Fxtract
			0,// Fprem1
			0,// Fdecstp
			0,// Fincstp
			0,// Fprem
			0,// Fyl2xp1
			0,// Fsqrt
			0,// Fsincos
			0,// Frndint
			0,// Fscale
			0,// Fsin
			0,// Fcos
			(byte)MemorySize.Int32,// Fiadd_m32int
			(byte)MemorySize.Int32,// Fimul_m32int
			(byte)MemorySize.Int32,// Ficom_m32int
			(byte)MemorySize.Int32,// Ficomp_m32int
			(byte)MemorySize.Int32,// Fisub_m32int
			(byte)MemorySize.Int32,// Fisubr_m32int
			(byte)MemorySize.Int32,// Fidiv_m32int
			(byte)MemorySize.Int32,// Fidivr_m32int
			0,// Fcmovb_st0_sti
			0,// Fcmove_st0_sti
			0,// Fcmovbe_st0_sti
			0,// Fcmovu_st0_sti
			0,// Fucompp
			(byte)MemorySize.Int32,// Fild_m32int
			(byte)MemorySize.Int32,// Fisttp_m32int
			(byte)MemorySize.Int32,// Fist_m32int
			(byte)MemorySize.Int32,// Fistp_m32int
			(byte)MemorySize.Float80,// Fld_m80fp
			(byte)MemorySize.Float80,// Fstp_m80fp
			0,// Fcmovnb_st0_sti
			0,// Fcmovne_st0_sti
			0,// Fcmovnbe_st0_sti
			0,// Fcmovnu_st0_sti
			0,// Fneni
			0,// Feni
			0,// Fndisi
			0,// Fdisi
			0,// Fnclex
			0,// Fclex
			0,// Fninit
			0,// Finit
			0,// Fnsetpm
			0,// Fsetpm
			0,// Frstpm
			0,// Fucomi_st0_sti
			0,// Fcomi_st0_sti
			(byte)MemorySize.Float64,// Fadd_m64fp
			(byte)MemorySize.Float64,// Fmul_m64fp
			(byte)MemorySize.Float64,// Fcom_m64fp
			(byte)MemorySize.Float64,// Fcomp_m64fp
			(byte)MemorySize.Float64,// Fsub_m64fp
			(byte)MemorySize.Float64,// Fsubr_m64fp
			(byte)MemorySize.Float64,// Fdiv_m64fp
			(byte)MemorySize.Float64,// Fdivr_m64fp
			0,// Fadd_sti_st0
			0,// Fmul_sti_st0
			0,// Fcom_st0_sti_DCD0
			0,// Fcomp_st0_sti_DCD8
			0,// Fsubr_sti_st0
			0,// Fsub_sti_st0
			0,// Fdivr_sti_st0
			0,// Fdiv_sti_st0
			(byte)MemorySize.Float64,// Fld_m64fp
			(byte)MemorySize.Int64,// Fisttp_m64int
			(byte)MemorySize.Float64,// Fst_m64fp
			(byte)MemorySize.Float64,// Fstp_m64fp
			(byte)MemorySize.FpuState94,// Frstor_m94byte
			(byte)MemorySize.FpuState108,// Frstor_m108byte
			(byte)MemorySize.FpuState94,// Fnsave_m94byte
			(byte)MemorySize.FpuState94,// Fsave_m94byte
			(byte)MemorySize.FpuState108,// Fnsave_m108byte
			(byte)MemorySize.FpuState108,// Fsave_m108byte
			(byte)MemorySize.UInt16,// Fnstsw_m2byte
			(byte)MemorySize.UInt16,// Fstsw_m2byte
			0,// Ffree_sti
			0,// Fxch_st0_sti_DDC8
			0,// Fst_sti
			0,// Fstp_sti
			0,// Fucom_st0_sti
			0,// Fucomp_st0_sti
			(byte)MemorySize.Int16,// Fiadd_m16int
			(byte)MemorySize.Int16,// Fimul_m16int
			(byte)MemorySize.Int16,// Ficom_m16int
			(byte)MemorySize.Int16,// Ficomp_m16int
			(byte)MemorySize.Int16,// Fisub_m16int
			(byte)MemorySize.Int16,// Fisubr_m16int
			(byte)MemorySize.Int16,// Fidiv_m16int
			(byte)MemorySize.Int16,// Fidivr_m16int
			0,// Faddp_sti_st0
			0,// Fmulp_sti_st0
			0,// Fcomp_st0_sti_DED0
			0,// Fcompp
			0,// Fsubrp_sti_st0
			0,// Fsubp_sti_st0
			0,// Fdivrp_sti_st0
			0,// Fdivp_sti_st0
			(byte)MemorySize.Int16,// Fild_m16int
			(byte)MemorySize.Int16,// Fisttp_m16int
			(byte)MemorySize.Int16,// Fist_m16int
			(byte)MemorySize.Int16,// Fistp_m16int
			(byte)MemorySize.Bcd,// Fbld_m80bcd
			(byte)MemorySize.Int64,// Fild_m64int
			(byte)MemorySize.Bcd,// Fbstp_m80bcd
			(byte)MemorySize.Int64,// Fistp_m64int
			0,// Ffreep_sti
			0,// Fxch_st0_sti_DFC8
			0,// Fstp_sti_DFD0
			0,// Fstp_sti_DFD8
			0,// Fnstsw_AX
			0,// Fstsw_AX
			0,// Fstdw_AX
			0,// Fstsg_AX
			0,// Fucomip_st0_sti
			0,// Fcomip_st0_sti
			0,// Loopne_rel8_16_CX
			0,// Loopne_rel8_32_CX
			0,// Loopne_rel8_16_ECX
			0,// Loopne_rel8_32_ECX
			0,// Loopne_rel8_64_ECX
			0,// Loopne_rel8_16_RCX
			0,// Loopne_rel8_64_RCX
			0,// Loope_rel8_16_CX
			0,// Loope_rel8_32_CX
			0,// Loope_rel8_16_ECX
			0,// Loope_rel8_32_ECX
			0,// Loope_rel8_64_ECX
			0,// Loope_rel8_16_RCX
			0,// Loope_rel8_64_RCX
			0,// Loop_rel8_16_CX
			0,// Loop_rel8_32_CX
			0,// Loop_rel8_16_ECX
			0,// Loop_rel8_32_ECX
			0,// Loop_rel8_64_ECX
			0,// Loop_rel8_16_RCX
			0,// Loop_rel8_64_RCX
			0,// Jcxz_rel8_16
			0,// Jcxz_rel8_32
			0,// Jecxz_rel8_16
			0,// Jecxz_rel8_32
			0,// Jecxz_rel8_64
			0,// Jrcxz_rel8_16
			0,// Jrcxz_rel8_64
			0,// In_AL_imm8
			0,// In_AX_imm8
			0,// In_EAX_imm8
			0,// Out_imm8_AL
			0,// Out_imm8_AX
			0,// Out_imm8_EAX
			0,// Call_rel16
			0,// Call_rel32_32
			0,// Call_rel32_64
			0,// Jmp_rel16
			0,// Jmp_rel32_32
			0,// Jmp_rel32_64
			0,// Jmp_ptr1616
			0,// Jmp_ptr1632
			0,// Jmp_rel8_16
			0,// Jmp_rel8_32
			0,// Jmp_rel8_64
			0,// In_AL_DX
			0,// In_AX_DX
			0,// In_EAX_DX
			0,// Out_DX_AL
			0,// Out_DX_AX
			0,// Out_DX_EAX
			0,// Int1
			0,// Hlt
			0,// Cmc
			(byte)MemorySize.UInt8,// Test_rm8_imm8
			(byte)MemorySize.UInt8,// Test_rm8_imm8_F6r1
			(byte)MemorySize.UInt8,// Not_rm8
			(byte)MemorySize.Int8,// Neg_rm8
			(byte)MemorySize.UInt8,// Mul_rm8
			(byte)MemorySize.Int8,// Imul_rm8
			(byte)MemorySize.UInt8,// Div_rm8
			(byte)MemorySize.Int8,// Idiv_rm8
			(byte)MemorySize.UInt16,// Test_rm16_imm16
			(byte)MemorySize.UInt32,// Test_rm32_imm32
			(byte)MemorySize.UInt64,// Test_rm64_imm32
			(byte)MemorySize.UInt16,// Test_rm16_imm16_F7r1
			(byte)MemorySize.UInt32,// Test_rm32_imm32_F7r1
			(byte)MemorySize.UInt64,// Test_rm64_imm32_F7r1
			(byte)MemorySize.UInt16,// Not_rm16
			(byte)MemorySize.UInt32,// Not_rm32
			(byte)MemorySize.UInt64,// Not_rm64
			(byte)MemorySize.Int16,// Neg_rm16
			(byte)MemorySize.Int32,// Neg_rm32
			(byte)MemorySize.Int64,// Neg_rm64
			(byte)MemorySize.UInt16,// Mul_rm16
			(byte)MemorySize.UInt32,// Mul_rm32
			(byte)MemorySize.UInt64,// Mul_rm64
			(byte)MemorySize.Int16,// Imul_rm16
			(byte)MemorySize.Int32,// Imul_rm32
			(byte)MemorySize.Int64,// Imul_rm64
			(byte)MemorySize.UInt16,// Div_rm16
			(byte)MemorySize.UInt32,// Div_rm32
			(byte)MemorySize.UInt64,// Div_rm64
			(byte)MemorySize.Int16,// Idiv_rm16
			(byte)MemorySize.Int32,// Idiv_rm32
			(byte)MemorySize.Int64,// Idiv_rm64
			0,// Clc
			0,// Stc
			0,// Cli
			0,// Sti
			0,// Cld
			0,// Std
			(byte)MemorySize.UInt8,// Inc_rm8
			(byte)MemorySize.UInt8,// Dec_rm8
			(byte)MemorySize.UInt16,// Inc_rm16
			(byte)MemorySize.UInt32,// Inc_rm32
			(byte)MemorySize.UInt64,// Inc_rm64
			(byte)MemorySize.UInt16,// Dec_rm16
			(byte)MemorySize.UInt32,// Dec_rm32
			(byte)MemorySize.UInt64,// Dec_rm64
			(byte)MemorySize.WordOffset,// Call_rm16
			(byte)MemorySize.DwordOffset,// Call_rm32
			(byte)MemorySize.QwordOffset,// Call_rm64
			(byte)MemorySize.SegPtr16,// Call_m1616
			(byte)MemorySize.SegPtr32,// Call_m1632
			(byte)MemorySize.SegPtr64,// Call_m1664
			(byte)MemorySize.WordOffset,// Jmp_rm16
			(byte)MemorySize.DwordOffset,// Jmp_rm32
			(byte)MemorySize.QwordOffset,// Jmp_rm64
			(byte)MemorySize.SegPtr16,// Jmp_m1616
			(byte)MemorySize.SegPtr32,// Jmp_m1632
			(byte)MemorySize.SegPtr64,// Jmp_m1664
			(byte)MemorySize.UInt16,// Push_rm16
			(byte)MemorySize.UInt32,// Push_rm32
			(byte)MemorySize.UInt64,// Push_rm64
			(byte)MemorySize.UInt16,// Sldt_rm16
			(byte)MemorySize.UInt16,// Sldt_r32m16
			(byte)MemorySize.UInt16,// Sldt_r64m16
			(byte)MemorySize.UInt16,// Str_rm16
			(byte)MemorySize.UInt16,// Str_r32m16
			(byte)MemorySize.UInt16,// Str_r64m16
			(byte)MemorySize.UInt16,// Lldt_rm16
			(byte)MemorySize.UInt16,// Lldt_r32m16
			(byte)MemorySize.UInt16,// Lldt_r64m16
			(byte)MemorySize.UInt16,// Ltr_rm16
			(byte)MemorySize.UInt16,// Ltr_r32m16
			(byte)MemorySize.UInt16,// Ltr_r64m16
			(byte)MemorySize.UInt16,// Verr_rm16
			(byte)MemorySize.UInt16,// Verr_r32m16
			(byte)MemorySize.UInt16,// Verr_r64m16
			(byte)MemorySize.UInt16,// Verw_rm16
			(byte)MemorySize.UInt16,// Verw_r32m16
			(byte)MemorySize.UInt16,// Verw_r64m16
			(byte)MemorySize.WordOffset,// Jmpe_rm16
			(byte)MemorySize.DwordOffset,// Jmpe_rm32
			(byte)MemorySize.Fword6,// Sgdt_m1632_16
			(byte)MemorySize.Fword6,// Sgdt_m1632
			(byte)MemorySize.Fword10,// Sgdt_m1664
			(byte)MemorySize.Fword6,// Sidt_m1632_16
			(byte)MemorySize.Fword6,// Sidt_m1632
			(byte)MemorySize.Fword10,// Sidt_m1664
			(byte)MemorySize.Fword6,// Lgdt_m1632_16
			(byte)MemorySize.Fword6,// Lgdt_m1632
			(byte)MemorySize.Fword10,// Lgdt_m1664
			(byte)MemorySize.Fword6,// Lidt_m1632_16
			(byte)MemorySize.Fword6,// Lidt_m1632
			(byte)MemorySize.Fword10,// Lidt_m1664
			(byte)MemorySize.UInt16,// Smsw_rm16
			(byte)MemorySize.UInt16,// Smsw_r32m16
			(byte)MemorySize.UInt16,// Smsw_r64m16
			(byte)MemorySize.UInt64,// Rstorssp_m64
			(byte)MemorySize.UInt16,// Lmsw_rm16
			(byte)MemorySize.UInt16,// Lmsw_r32m16
			(byte)MemorySize.UInt16,// Lmsw_r64m16
			0,// Invlpg_m
			0,// Enclv
			0,// Vmcall
			0,// Vmlaunch
			0,// Vmresume
			0,// Vmxoff
			0,// Pconfig
			0,// Monitorw
			0,// Monitord
			0,// Monitorq
			0,// Mwait
			0,// Clac
			0,// Stac
			0,// Encls
			0,// Xgetbv
			0,// Xsetbv
			0,// Vmfunc
			0,// Xend
			0,// Xtest
			0,// Enclu
			0,// Vmrunw
			0,// Vmrund
			0,// Vmrunq
			0,// Vmmcall
			0,// Vmloadw
			0,// Vmloadd
			0,// Vmloadq
			0,// Vmsavew
			0,// Vmsaved
			0,// Vmsaveq
			0,// Stgi
			0,// Clgi
			0,// Skinit
			0,// Invlpgaw
			0,// Invlpgad
			0,// Invlpgaq
			0,// Setssbsy
			0,// Saveprevssp
			0,// Rdpkru
			0,// Wrpkru
			0,// Swapgs
			0,// Rdtscp
			0,// Monitorxw
			0,// Monitorxd
			0,// Monitorxq
			0,// Mcommit
			0,// Mwaitx
			0,// Clzerow
			0,// Clzerod
			0,// Clzeroq
			0,// Rdpru
			(byte)MemorySize.UInt16,// Lar_r16_rm16
			(byte)MemorySize.UInt16,// Lar_r32_r32m16
			(byte)MemorySize.UInt16,// Lar_r64_r64m16
			(byte)MemorySize.UInt16,// Lsl_r16_rm16
			(byte)MemorySize.UInt16,// Lsl_r32_r32m16
			(byte)MemorySize.UInt16,// Lsl_r64_r64m16
			0,// Storeall
			0,// Loadall286
			0,// Syscall
			0,// Clts
			0,// Loadall386
			0,// Sysretd
			0,// Sysretq
			0,// Invd
			0,// Wbinvd
			0,// Wbnoinvd
			0,// Cl1invmb
			0,// Ud2
			(byte)MemorySize.UInt16,// Reservednop_rm16_r16_0F0D
			(byte)MemorySize.UInt32,// Reservednop_rm32_r32_0F0D
			(byte)MemorySize.UInt64,// Reservednop_rm64_r64_0F0D
			(byte)MemorySize.UInt8,// Prefetch_m8
			(byte)MemorySize.UInt8,// Prefetchw_m8
			(byte)MemorySize.UInt8,// Prefetchwt1_m8
			0,// Femms
			(byte)MemorySize.UInt8,// Umov_rm8_r8
			(byte)MemorySize.UInt16,// Umov_rm16_r16
			(byte)MemorySize.UInt32,// Umov_rm32_r32
			(byte)MemorySize.UInt8,// Umov_r8_rm8
			(byte)MemorySize.UInt16,// Umov_r16_rm16
			(byte)MemorySize.UInt32,// Umov_r32_rm32
			(byte)MemorySize.Packed128_Float32,// Movups_xmm_xmmm128
			(byte)MemorySize.Packed128_Float32,// VEX_Vmovups_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vmovups_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// EVEX_Vmovups_xmm_k1z_xmmm128
			(byte)MemorySize.Packed256_Float32,// EVEX_Vmovups_ymm_k1z_ymmm256
			(byte)MemorySize.Packed512_Float32,// EVEX_Vmovups_zmm_k1z_zmmm512
			(byte)MemorySize.Packed128_Float64,// Movupd_xmm_xmmm128
			(byte)MemorySize.Packed128_Float64,// VEX_Vmovupd_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vmovupd_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// EVEX_Vmovupd_xmm_k1z_xmmm128
			(byte)MemorySize.Packed256_Float64,// EVEX_Vmovupd_ymm_k1z_ymmm256
			(byte)MemorySize.Packed512_Float64,// EVEX_Vmovupd_zmm_k1z_zmmm512
			(byte)MemorySize.Float32,// Movss_xmm_xmmm32
			0,// VEX_Vmovss_xmm_xmm_xmm
			(byte)MemorySize.Float32,// VEX_Vmovss_xmm_m32
			0,// EVEX_Vmovss_xmm_k1z_xmm_xmm
			(byte)MemorySize.Float32,// EVEX_Vmovss_xmm_k1z_m32
			(byte)MemorySize.Float64,// Movsd_xmm_xmmm64
			0,// VEX_Vmovsd_xmm_xmm_xmm
			(byte)MemorySize.Float64,// VEX_Vmovsd_xmm_m64
			0,// EVEX_Vmovsd_xmm_k1z_xmm_xmm
			(byte)MemorySize.Float64,// EVEX_Vmovsd_xmm_k1z_m64
			(byte)MemorySize.Packed128_Float32,// Movups_xmmm128_xmm
			(byte)MemorySize.Packed128_Float32,// VEX_Vmovups_xmmm128_xmm
			(byte)MemorySize.Packed256_Float32,// VEX_Vmovups_ymmm256_ymm
			(byte)MemorySize.Packed128_Float32,// EVEX_Vmovups_xmmm128_k1z_xmm
			(byte)MemorySize.Packed256_Float32,// EVEX_Vmovups_ymmm256_k1z_ymm
			(byte)MemorySize.Packed512_Float32,// EVEX_Vmovups_zmmm512_k1z_zmm
			(byte)MemorySize.Packed128_Float64,// Movupd_xmmm128_xmm
			(byte)MemorySize.Packed128_Float64,// VEX_Vmovupd_xmmm128_xmm
			(byte)MemorySize.Packed256_Float64,// VEX_Vmovupd_ymmm256_ymm
			(byte)MemorySize.Packed128_Float64,// EVEX_Vmovupd_xmmm128_k1z_xmm
			(byte)MemorySize.Packed256_Float64,// EVEX_Vmovupd_ymmm256_k1z_ymm
			(byte)MemorySize.Packed512_Float64,// EVEX_Vmovupd_zmmm512_k1z_zmm
			(byte)MemorySize.Float32,// Movss_xmmm32_xmm
			0,// VEX_Vmovss_xmm_xmm_xmm_0F11
			(byte)MemorySize.Float32,// VEX_Vmovss_m32_xmm
			0,// EVEX_Vmovss_xmm_k1z_xmm_xmm_0F11
			(byte)MemorySize.Float32,// EVEX_Vmovss_m32_k1_xmm
			(byte)MemorySize.Float64,// Movsd_xmmm64_xmm
			0,// VEX_Vmovsd_xmm_xmm_xmm_0F11
			(byte)MemorySize.Float64,// VEX_Vmovsd_m64_xmm
			0,// EVEX_Vmovsd_xmm_k1z_xmm_xmm_0F11
			(byte)MemorySize.Float64,// EVEX_Vmovsd_m64_k1_xmm
			0,// Movhlps_xmm_xmm
			(byte)MemorySize.Packed64_Float32,// Movlps_xmm_m64
			0,// VEX_Vmovhlps_xmm_xmm_xmm
			(byte)MemorySize.Packed64_Float32,// VEX_Vmovlps_xmm_xmm_m64
			0,// EVEX_Vmovhlps_xmm_xmm_xmm
			(byte)MemorySize.Packed64_Float32,// EVEX_Vmovlps_xmm_xmm_m64
			(byte)MemorySize.Float64,// Movlpd_xmm_m64
			(byte)MemorySize.Float64,// VEX_Vmovlpd_xmm_xmm_m64
			(byte)MemorySize.Float64,// EVEX_Vmovlpd_xmm_xmm_m64
			(byte)MemorySize.Packed128_Float32,// Movsldup_xmm_xmmm128
			(byte)MemorySize.Packed128_Float32,// VEX_Vmovsldup_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vmovsldup_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// EVEX_Vmovsldup_xmm_k1z_xmmm128
			(byte)MemorySize.Packed256_Float32,// EVEX_Vmovsldup_ymm_k1z_ymmm256
			(byte)MemorySize.Packed512_Float32,// EVEX_Vmovsldup_zmm_k1z_zmmm512
			(byte)MemorySize.Float64,// Movddup_xmm_xmmm64
			(byte)MemorySize.Float64,// VEX_Vmovddup_xmm_xmmm64
			(byte)MemorySize.Packed256_Float64,// VEX_Vmovddup_ymm_ymmm256
			(byte)MemorySize.Float64,// EVEX_Vmovddup_xmm_k1z_xmmm64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vmovddup_ymm_k1z_ymmm256
			(byte)MemorySize.Packed512_Float64,// EVEX_Vmovddup_zmm_k1z_zmmm512
			(byte)MemorySize.Packed64_Float32,// Movlps_m64_xmm
			(byte)MemorySize.Packed64_Float32,// VEX_Vmovlps_m64_xmm
			(byte)MemorySize.Packed64_Float32,// EVEX_Vmovlps_m64_xmm
			(byte)MemorySize.Float64,// Movlpd_m64_xmm
			(byte)MemorySize.Float64,// VEX_Vmovlpd_m64_xmm
			(byte)MemorySize.Float64,// EVEX_Vmovlpd_m64_xmm
			(byte)MemorySize.Packed128_Float32,// Unpcklps_xmm_xmmm128
			(byte)MemorySize.Packed128_Float32,// VEX_Vunpcklps_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vunpcklps_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// EVEX_Vunpcklps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vunpcklps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vunpcklps_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed128_Float64,// Unpcklpd_xmm_xmmm128
			(byte)MemorySize.Packed128_Float64,// VEX_Vunpcklpd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vunpcklpd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// EVEX_Vunpcklpd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vunpcklpd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vunpcklpd_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.Packed128_Float32,// Unpckhps_xmm_xmmm128
			(byte)MemorySize.Packed128_Float32,// VEX_Vunpckhps_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vunpckhps_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// EVEX_Vunpckhps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vunpckhps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vunpckhps_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed128_Float64,// Unpckhpd_xmm_xmmm128
			(byte)MemorySize.Packed128_Float64,// VEX_Vunpckhpd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vunpckhpd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// EVEX_Vunpckhpd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vunpckhpd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vunpckhpd_zmm_k1z_zmm_zmmm512b64
			0,// Movlhps_xmm_xmm
			0,// VEX_Vmovlhps_xmm_xmm_xmm
			0,// EVEX_Vmovlhps_xmm_xmm_xmm
			(byte)MemorySize.Packed64_Float32,// Movhps_xmm_m64
			(byte)MemorySize.Packed64_Float32,// VEX_Vmovhps_xmm_xmm_m64
			(byte)MemorySize.Packed64_Float32,// EVEX_Vmovhps_xmm_xmm_m64
			(byte)MemorySize.Float64,// Movhpd_xmm_m64
			(byte)MemorySize.Float64,// VEX_Vmovhpd_xmm_xmm_m64
			(byte)MemorySize.Float64,// EVEX_Vmovhpd_xmm_xmm_m64
			(byte)MemorySize.Packed128_Float32,// Movshdup_xmm_xmmm128
			(byte)MemorySize.Packed128_Float32,// VEX_Vmovshdup_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vmovshdup_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// EVEX_Vmovshdup_xmm_k1z_xmmm128
			(byte)MemorySize.Packed256_Float32,// EVEX_Vmovshdup_ymm_k1z_ymmm256
			(byte)MemorySize.Packed512_Float32,// EVEX_Vmovshdup_zmm_k1z_zmmm512
			(byte)MemorySize.Packed64_Float32,// Movhps_m64_xmm
			(byte)MemorySize.Packed64_Float32,// VEX_Vmovhps_m64_xmm
			(byte)MemorySize.Packed64_Float32,// EVEX_Vmovhps_m64_xmm
			(byte)MemorySize.Float64,// Movhpd_m64_xmm
			(byte)MemorySize.Float64,// VEX_Vmovhpd_m64_xmm
			(byte)MemorySize.Float64,// EVEX_Vmovhpd_m64_xmm
			(byte)MemorySize.UInt16,// Reservednop_rm16_r16_0F18
			(byte)MemorySize.UInt32,// Reservednop_rm32_r32_0F18
			(byte)MemorySize.UInt64,// Reservednop_rm64_r64_0F18
			(byte)MemorySize.UInt16,// Reservednop_rm16_r16_0F19
			(byte)MemorySize.UInt32,// Reservednop_rm32_r32_0F19
			(byte)MemorySize.UInt64,// Reservednop_rm64_r64_0F19
			(byte)MemorySize.UInt16,// Reservednop_rm16_r16_0F1A
			(byte)MemorySize.UInt32,// Reservednop_rm32_r32_0F1A
			(byte)MemorySize.UInt64,// Reservednop_rm64_r64_0F1A
			(byte)MemorySize.UInt16,// Reservednop_rm16_r16_0F1B
			(byte)MemorySize.UInt32,// Reservednop_rm32_r32_0F1B
			(byte)MemorySize.UInt64,// Reservednop_rm64_r64_0F1B
			(byte)MemorySize.UInt16,// Reservednop_rm16_r16_0F1C
			(byte)MemorySize.UInt32,// Reservednop_rm32_r32_0F1C
			(byte)MemorySize.UInt64,// Reservednop_rm64_r64_0F1C
			(byte)MemorySize.UInt16,// Reservednop_rm16_r16_0F1D
			(byte)MemorySize.UInt32,// Reservednop_rm32_r32_0F1D
			(byte)MemorySize.UInt64,// Reservednop_rm64_r64_0F1D
			(byte)MemorySize.UInt16,// Reservednop_rm16_r16_0F1E
			(byte)MemorySize.UInt32,// Reservednop_rm32_r32_0F1E
			(byte)MemorySize.UInt64,// Reservednop_rm64_r64_0F1E
			(byte)MemorySize.UInt16,// Reservednop_rm16_r16_0F1F
			(byte)MemorySize.UInt32,// Reservednop_rm32_r32_0F1F
			(byte)MemorySize.UInt64,// Reservednop_rm64_r64_0F1F
			(byte)MemorySize.UInt8,// Prefetchnta_m8
			(byte)MemorySize.UInt8,// Prefetcht0_m8
			(byte)MemorySize.UInt8,// Prefetcht1_m8
			(byte)MemorySize.UInt8,// Prefetcht2_m8
			0,// Bndldx_bnd_mib
			(byte)MemorySize.Bnd32,// Bndmov_bnd_bndm64
			(byte)MemorySize.Bnd64,// Bndmov_bnd_bndm128
			(byte)MemorySize.UInt32,// Bndcl_bnd_rm32
			(byte)MemorySize.UInt64,// Bndcl_bnd_rm64
			(byte)MemorySize.UInt32,// Bndcu_bnd_rm32
			(byte)MemorySize.UInt64,// Bndcu_bnd_rm64
			0,// Bndstx_mib_bnd
			(byte)MemorySize.Bnd32,// Bndmov_bndm64_bnd
			(byte)MemorySize.Bnd64,// Bndmov_bndm128_bnd
			(byte)MemorySize.UInt32,// Bndmk_bnd_m32
			(byte)MemorySize.UInt64,// Bndmk_bnd_m64
			(byte)MemorySize.UInt32,// Bndcn_bnd_rm32
			(byte)MemorySize.UInt64,// Bndcn_bnd_rm64
			(byte)MemorySize.UInt8,// Cldemote_m8
			0,// Rdsspd_r32
			0,// Rdsspq_r64
			0,// Endbr64
			0,// Endbr32
			(byte)MemorySize.UInt16,// Nop_rm16
			(byte)MemorySize.UInt32,// Nop_rm32
			(byte)MemorySize.UInt64,// Nop_rm64
			0,// Mov_r32_cr
			0,// Mov_r64_cr
			0,// Mov_r32_dr
			0,// Mov_r64_dr
			0,// Mov_cr_r32
			0,// Mov_cr_r64
			0,// Mov_dr_r32
			0,// Mov_dr_r64
			0,// Mov_r32_tr
			0,// Mov_tr_r32
			(byte)MemorySize.Packed128_Float32,// Movaps_xmm_xmmm128
			(byte)MemorySize.Packed128_Float32,// VEX_Vmovaps_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vmovaps_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// EVEX_Vmovaps_xmm_k1z_xmmm128
			(byte)MemorySize.Packed256_Float32,// EVEX_Vmovaps_ymm_k1z_ymmm256
			(byte)MemorySize.Packed512_Float32,// EVEX_Vmovaps_zmm_k1z_zmmm512
			(byte)MemorySize.Packed128_Float64,// Movapd_xmm_xmmm128
			(byte)MemorySize.Packed128_Float64,// VEX_Vmovapd_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vmovapd_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// EVEX_Vmovapd_xmm_k1z_xmmm128
			(byte)MemorySize.Packed256_Float64,// EVEX_Vmovapd_ymm_k1z_ymmm256
			(byte)MemorySize.Packed512_Float64,// EVEX_Vmovapd_zmm_k1z_zmmm512
			(byte)MemorySize.Packed128_Float32,// Movaps_xmmm128_xmm
			(byte)MemorySize.Packed128_Float32,// VEX_Vmovaps_xmmm128_xmm
			(byte)MemorySize.Packed256_Float32,// VEX_Vmovaps_ymmm256_ymm
			(byte)MemorySize.Packed128_Float32,// EVEX_Vmovaps_xmmm128_k1z_xmm
			(byte)MemorySize.Packed256_Float32,// EVEX_Vmovaps_ymmm256_k1z_ymm
			(byte)MemorySize.Packed512_Float32,// EVEX_Vmovaps_zmmm512_k1z_zmm
			(byte)MemorySize.Packed128_Float64,// Movapd_xmmm128_xmm
			(byte)MemorySize.Packed128_Float64,// VEX_Vmovapd_xmmm128_xmm
			(byte)MemorySize.Packed256_Float64,// VEX_Vmovapd_ymmm256_ymm
			(byte)MemorySize.Packed128_Float64,// EVEX_Vmovapd_xmmm128_k1z_xmm
			(byte)MemorySize.Packed256_Float64,// EVEX_Vmovapd_ymmm256_k1z_ymm
			(byte)MemorySize.Packed512_Float64,// EVEX_Vmovapd_zmmm512_k1z_zmm
			(byte)MemorySize.Packed64_Int32,// Cvtpi2ps_xmm_mmm64
			(byte)MemorySize.Packed64_Int32,// Cvtpi2pd_xmm_mmm64
			(byte)MemorySize.Int32,// Cvtsi2ss_xmm_rm32
			(byte)MemorySize.Int64,// Cvtsi2ss_xmm_rm64
			(byte)MemorySize.Int32,// VEX_Vcvtsi2ss_xmm_xmm_rm32
			(byte)MemorySize.Int64,// VEX_Vcvtsi2ss_xmm_xmm_rm64
			(byte)MemorySize.Int32,// EVEX_Vcvtsi2ss_xmm_xmm_rm32_er
			(byte)MemorySize.Int64,// EVEX_Vcvtsi2ss_xmm_xmm_rm64_er
			(byte)MemorySize.Int32,// Cvtsi2sd_xmm_rm32
			(byte)MemorySize.Int64,// Cvtsi2sd_xmm_rm64
			(byte)MemorySize.Int32,// VEX_Vcvtsi2sd_xmm_xmm_rm32
			(byte)MemorySize.Int64,// VEX_Vcvtsi2sd_xmm_xmm_rm64
			(byte)MemorySize.Int32,// EVEX_Vcvtsi2sd_xmm_xmm_rm32_er
			(byte)MemorySize.Int64,// EVEX_Vcvtsi2sd_xmm_xmm_rm64_er
			(byte)MemorySize.Packed128_Float32,// Movntps_m128_xmm
			(byte)MemorySize.Packed128_Float32,// VEX_Vmovntps_m128_xmm
			(byte)MemorySize.Packed256_Float32,// VEX_Vmovntps_m256_ymm
			(byte)MemorySize.Packed128_Float32,// EVEX_Vmovntps_m128_xmm
			(byte)MemorySize.Packed256_Float32,// EVEX_Vmovntps_m256_ymm
			(byte)MemorySize.Packed512_Float32,// EVEX_Vmovntps_m512_zmm
			(byte)MemorySize.Packed128_Float64,// Movntpd_m128_xmm
			(byte)MemorySize.Packed128_Float64,// VEX_Vmovntpd_m128_xmm
			(byte)MemorySize.Packed256_Float64,// VEX_Vmovntpd_m256_ymm
			(byte)MemorySize.Packed128_Float64,// EVEX_Vmovntpd_m128_xmm
			(byte)MemorySize.Packed256_Float64,// EVEX_Vmovntpd_m256_ymm
			(byte)MemorySize.Packed512_Float64,// EVEX_Vmovntpd_m512_zmm
			(byte)MemorySize.Float32,// Movntss_m32_xmm
			(byte)MemorySize.Float64,// Movntsd_m64_xmm
			(byte)MemorySize.Packed64_Float32,// Cvttps2pi_mm_xmmm64
			(byte)MemorySize.Packed128_Float64,// Cvttpd2pi_mm_xmmm128
			(byte)MemorySize.Float32,// Cvttss2si_r32_xmmm32
			(byte)MemorySize.Float32,// Cvttss2si_r64_xmmm32
			(byte)MemorySize.Float32,// VEX_Vcvttss2si_r32_xmmm32
			(byte)MemorySize.Float32,// VEX_Vcvttss2si_r64_xmmm32
			(byte)MemorySize.Float32,// EVEX_Vcvttss2si_r32_xmmm32_sae
			(byte)MemorySize.Float32,// EVEX_Vcvttss2si_r64_xmmm32_sae
			(byte)MemorySize.Float64,// Cvttsd2si_r32_xmmm64
			(byte)MemorySize.Float64,// Cvttsd2si_r64_xmmm64
			(byte)MemorySize.Float64,// VEX_Vcvttsd2si_r32_xmmm64
			(byte)MemorySize.Float64,// VEX_Vcvttsd2si_r64_xmmm64
			(byte)MemorySize.Float64,// EVEX_Vcvttsd2si_r32_xmmm64_sae
			(byte)MemorySize.Float64,// EVEX_Vcvttsd2si_r64_xmmm64_sae
			(byte)MemorySize.Packed64_Float32,// Cvtps2pi_mm_xmmm64
			(byte)MemorySize.Packed128_Float64,// Cvtpd2pi_mm_xmmm128
			(byte)MemorySize.Float32,// Cvtss2si_r32_xmmm32
			(byte)MemorySize.Float32,// Cvtss2si_r64_xmmm32
			(byte)MemorySize.Float32,// VEX_Vcvtss2si_r32_xmmm32
			(byte)MemorySize.Float32,// VEX_Vcvtss2si_r64_xmmm32
			(byte)MemorySize.Float32,// EVEX_Vcvtss2si_r32_xmmm32_er
			(byte)MemorySize.Float32,// EVEX_Vcvtss2si_r64_xmmm32_er
			(byte)MemorySize.Float64,// Cvtsd2si_r32_xmmm64
			(byte)MemorySize.Float64,// Cvtsd2si_r64_xmmm64
			(byte)MemorySize.Float64,// VEX_Vcvtsd2si_r32_xmmm64
			(byte)MemorySize.Float64,// VEX_Vcvtsd2si_r64_xmmm64
			(byte)MemorySize.Float64,// EVEX_Vcvtsd2si_r32_xmmm64_er
			(byte)MemorySize.Float64,// EVEX_Vcvtsd2si_r64_xmmm64_er
			(byte)MemorySize.Float32,// Ucomiss_xmm_xmmm32
			(byte)MemorySize.Float32,// VEX_Vucomiss_xmm_xmmm32
			(byte)MemorySize.Float32,// EVEX_Vucomiss_xmm_xmmm32_sae
			(byte)MemorySize.Float64,// Ucomisd_xmm_xmmm64
			(byte)MemorySize.Float64,// VEX_Vucomisd_xmm_xmmm64
			(byte)MemorySize.Float64,// EVEX_Vucomisd_xmm_xmmm64_sae
			(byte)MemorySize.Float32,// Comiss_xmm_xmmm32
			(byte)MemorySize.Float64,// Comisd_xmm_xmmm64
			(byte)MemorySize.Float32,// VEX_Vcomiss_xmm_xmmm32
			(byte)MemorySize.Float64,// VEX_Vcomisd_xmm_xmmm64
			(byte)MemorySize.Float32,// EVEX_Vcomiss_xmm_xmmm32_sae
			(byte)MemorySize.Float64,// EVEX_Vcomisd_xmm_xmmm64_sae
			0,// Wrmsr
			0,// Rdtsc
			0,// Rdmsr
			0,// Rdpmc
			0,// Sysenter
			0,// Sysexitd
			0,// Sysexitq
			0,// Getsecd
			(byte)MemorySize.UInt16,// Cmovo_r16_rm16
			(byte)MemorySize.UInt32,// Cmovo_r32_rm32
			(byte)MemorySize.UInt64,// Cmovo_r64_rm64
			(byte)MemorySize.UInt16,// Cmovno_r16_rm16
			(byte)MemorySize.UInt32,// Cmovno_r32_rm32
			(byte)MemorySize.UInt64,// Cmovno_r64_rm64
			(byte)MemorySize.UInt16,// Cmovb_r16_rm16
			(byte)MemorySize.UInt32,// Cmovb_r32_rm32
			(byte)MemorySize.UInt64,// Cmovb_r64_rm64
			(byte)MemorySize.UInt16,// Cmovae_r16_rm16
			(byte)MemorySize.UInt32,// Cmovae_r32_rm32
			(byte)MemorySize.UInt64,// Cmovae_r64_rm64
			(byte)MemorySize.UInt16,// Cmove_r16_rm16
			(byte)MemorySize.UInt32,// Cmove_r32_rm32
			(byte)MemorySize.UInt64,// Cmove_r64_rm64
			(byte)MemorySize.UInt16,// Cmovne_r16_rm16
			(byte)MemorySize.UInt32,// Cmovne_r32_rm32
			(byte)MemorySize.UInt64,// Cmovne_r64_rm64
			(byte)MemorySize.UInt16,// Cmovbe_r16_rm16
			(byte)MemorySize.UInt32,// Cmovbe_r32_rm32
			(byte)MemorySize.UInt64,// Cmovbe_r64_rm64
			(byte)MemorySize.UInt16,// Cmova_r16_rm16
			(byte)MemorySize.UInt32,// Cmova_r32_rm32
			(byte)MemorySize.UInt64,// Cmova_r64_rm64
			(byte)MemorySize.UInt16,// Cmovs_r16_rm16
			(byte)MemorySize.UInt32,// Cmovs_r32_rm32
			(byte)MemorySize.UInt64,// Cmovs_r64_rm64
			(byte)MemorySize.UInt16,// Cmovns_r16_rm16
			(byte)MemorySize.UInt32,// Cmovns_r32_rm32
			(byte)MemorySize.UInt64,// Cmovns_r64_rm64
			(byte)MemorySize.UInt16,// Cmovp_r16_rm16
			(byte)MemorySize.UInt32,// Cmovp_r32_rm32
			(byte)MemorySize.UInt64,// Cmovp_r64_rm64
			(byte)MemorySize.UInt16,// Cmovnp_r16_rm16
			(byte)MemorySize.UInt32,// Cmovnp_r32_rm32
			(byte)MemorySize.UInt64,// Cmovnp_r64_rm64
			(byte)MemorySize.UInt16,// Cmovl_r16_rm16
			(byte)MemorySize.UInt32,// Cmovl_r32_rm32
			(byte)MemorySize.UInt64,// Cmovl_r64_rm64
			(byte)MemorySize.UInt16,// Cmovge_r16_rm16
			(byte)MemorySize.UInt32,// Cmovge_r32_rm32
			(byte)MemorySize.UInt64,// Cmovge_r64_rm64
			(byte)MemorySize.UInt16,// Cmovle_r16_rm16
			(byte)MemorySize.UInt32,// Cmovle_r32_rm32
			(byte)MemorySize.UInt64,// Cmovle_r64_rm64
			(byte)MemorySize.UInt16,// Cmovg_r16_rm16
			(byte)MemorySize.UInt32,// Cmovg_r32_rm32
			(byte)MemorySize.UInt64,// Cmovg_r64_rm64
			0,// VEX_Kandw_kr_kr_kr
			0,// VEX_Kandq_kr_kr_kr
			0,// VEX_Kandb_kr_kr_kr
			0,// VEX_Kandd_kr_kr_kr
			0,// VEX_Kandnw_kr_kr_kr
			0,// VEX_Kandnq_kr_kr_kr
			0,// VEX_Kandnb_kr_kr_kr
			0,// VEX_Kandnd_kr_kr_kr
			0,// VEX_Knotw_kr_kr
			0,// VEX_Knotq_kr_kr
			0,// VEX_Knotb_kr_kr
			0,// VEX_Knotd_kr_kr
			0,// VEX_Korw_kr_kr_kr
			0,// VEX_Korq_kr_kr_kr
			0,// VEX_Korb_kr_kr_kr
			0,// VEX_Kord_kr_kr_kr
			0,// VEX_Kxnorw_kr_kr_kr
			0,// VEX_Kxnorq_kr_kr_kr
			0,// VEX_Kxnorb_kr_kr_kr
			0,// VEX_Kxnord_kr_kr_kr
			0,// VEX_Kxorw_kr_kr_kr
			0,// VEX_Kxorq_kr_kr_kr
			0,// VEX_Kxorb_kr_kr_kr
			0,// VEX_Kxord_kr_kr_kr
			0,// VEX_Kaddw_kr_kr_kr
			0,// VEX_Kaddq_kr_kr_kr
			0,// VEX_Kaddb_kr_kr_kr
			0,// VEX_Kaddd_kr_kr_kr
			0,// VEX_Kunpckwd_kr_kr_kr
			0,// VEX_Kunpckdq_kr_kr_kr
			0,// VEX_Kunpckbw_kr_kr_kr
			0,// Movmskps_r32_xmm
			0,// Movmskps_r64_xmm
			0,// VEX_Vmovmskps_r32_xmm
			0,// VEX_Vmovmskps_r64_xmm
			0,// VEX_Vmovmskps_r32_ymm
			0,// VEX_Vmovmskps_r64_ymm
			0,// Movmskpd_r32_xmm
			0,// Movmskpd_r64_xmm
			0,// VEX_Vmovmskpd_r32_xmm
			0,// VEX_Vmovmskpd_r64_xmm
			0,// VEX_Vmovmskpd_r32_ymm
			0,// VEX_Vmovmskpd_r64_ymm
			(byte)MemorySize.Packed128_Float32,// Sqrtps_xmm_xmmm128
			(byte)MemorySize.Packed128_Float32,// VEX_Vsqrtps_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vsqrtps_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// EVEX_Vsqrtps_xmm_k1z_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vsqrtps_ymm_k1z_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vsqrtps_zmm_k1z_zmmm512b32_er
			(byte)MemorySize.Packed128_Float64,// Sqrtpd_xmm_xmmm128
			(byte)MemorySize.Packed128_Float64,// VEX_Vsqrtpd_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vsqrtpd_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// EVEX_Vsqrtpd_xmm_k1z_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vsqrtpd_ymm_k1z_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vsqrtpd_zmm_k1z_zmmm512b64_er
			(byte)MemorySize.Float32,// Sqrtss_xmm_xmmm32
			(byte)MemorySize.Float32,// VEX_Vsqrtss_xmm_xmm_xmmm32
			(byte)MemorySize.Float32,// EVEX_Vsqrtss_xmm_k1z_xmm_xmmm32_er
			(byte)MemorySize.Float64,// Sqrtsd_xmm_xmmm64
			(byte)MemorySize.Float64,// VEX_Vsqrtsd_xmm_xmm_xmmm64
			(byte)MemorySize.Float64,// EVEX_Vsqrtsd_xmm_k1z_xmm_xmmm64_er
			(byte)MemorySize.Packed128_Float32,// Rsqrtps_xmm_xmmm128
			(byte)MemorySize.Packed128_Float32,// VEX_Vrsqrtps_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vrsqrtps_ymm_ymmm256
			(byte)MemorySize.Float32,// Rsqrtss_xmm_xmmm32
			(byte)MemorySize.Float32,// VEX_Vrsqrtss_xmm_xmm_xmmm32
			(byte)MemorySize.Packed128_Float32,// Rcpps_xmm_xmmm128
			(byte)MemorySize.Packed128_Float32,// VEX_Vrcpps_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vrcpps_ymm_ymmm256
			(byte)MemorySize.Float32,// Rcpss_xmm_xmmm32
			(byte)MemorySize.Float32,// VEX_Vrcpss_xmm_xmm_xmmm32
			(byte)MemorySize.Packed128_Float32,// Andps_xmm_xmmm128
			(byte)MemorySize.Packed128_Float32,// VEX_Vandps_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vandps_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// EVEX_Vandps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vandps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vandps_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed128_Float64,// Andpd_xmm_xmmm128
			(byte)MemorySize.Packed128_Float64,// VEX_Vandpd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vandpd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// EVEX_Vandpd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vandpd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vandpd_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.Packed128_Float32,// Andnps_xmm_xmmm128
			(byte)MemorySize.Packed128_Float32,// VEX_Vandnps_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vandnps_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// EVEX_Vandnps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vandnps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vandnps_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed128_Float64,// Andnpd_xmm_xmmm128
			(byte)MemorySize.Packed128_Float64,// VEX_Vandnpd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vandnpd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// EVEX_Vandnpd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vandnpd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vandnpd_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.Packed128_Float32,// Orps_xmm_xmmm128
			(byte)MemorySize.Packed128_Float32,// VEX_Vorps_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vorps_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// EVEX_Vorps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vorps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vorps_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed128_Float64,// Orpd_xmm_xmmm128
			(byte)MemorySize.Packed128_Float64,// VEX_Vorpd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vorpd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// EVEX_Vorpd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vorpd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vorpd_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.Packed128_Float32,// Xorps_xmm_xmmm128
			(byte)MemorySize.Packed128_Float32,// VEX_Vxorps_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vxorps_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// EVEX_Vxorps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vxorps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vxorps_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed128_Float64,// Xorpd_xmm_xmmm128
			(byte)MemorySize.Packed128_Float64,// VEX_Vxorpd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vxorpd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// EVEX_Vxorpd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vxorpd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vxorpd_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.Packed128_Float32,// Addps_xmm_xmmm128
			(byte)MemorySize.Packed128_Float32,// VEX_Vaddps_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vaddps_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// EVEX_Vaddps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vaddps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vaddps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Packed128_Float64,// Addpd_xmm_xmmm128
			(byte)MemorySize.Packed128_Float64,// VEX_Vaddpd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vaddpd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// EVEX_Vaddpd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vaddpd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vaddpd_zmm_k1z_zmm_zmmm512b64_er
			(byte)MemorySize.Float32,// Addss_xmm_xmmm32
			(byte)MemorySize.Float32,// VEX_Vaddss_xmm_xmm_xmmm32
			(byte)MemorySize.Float32,// EVEX_Vaddss_xmm_k1z_xmm_xmmm32_er
			(byte)MemorySize.Float64,// Addsd_xmm_xmmm64
			(byte)MemorySize.Float64,// VEX_Vaddsd_xmm_xmm_xmmm64
			(byte)MemorySize.Float64,// EVEX_Vaddsd_xmm_k1z_xmm_xmmm64_er
			(byte)MemorySize.Packed128_Float32,// Mulps_xmm_xmmm128
			(byte)MemorySize.Packed128_Float32,// VEX_Vmulps_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vmulps_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// EVEX_Vmulps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vmulps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vmulps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Packed128_Float64,// Mulpd_xmm_xmmm128
			(byte)MemorySize.Packed128_Float64,// VEX_Vmulpd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vmulpd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// EVEX_Vmulpd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vmulpd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vmulpd_zmm_k1z_zmm_zmmm512b64_er
			(byte)MemorySize.Float32,// Mulss_xmm_xmmm32
			(byte)MemorySize.Float32,// VEX_Vmulss_xmm_xmm_xmmm32
			(byte)MemorySize.Float32,// EVEX_Vmulss_xmm_k1z_xmm_xmmm32_er
			(byte)MemorySize.Float64,// Mulsd_xmm_xmmm64
			(byte)MemorySize.Float64,// VEX_Vmulsd_xmm_xmm_xmmm64
			(byte)MemorySize.Float64,// EVEX_Vmulsd_xmm_k1z_xmm_xmmm64_er
			(byte)MemorySize.Packed64_Float32,// Cvtps2pd_xmm_xmmm64
			(byte)MemorySize.Packed64_Float32,// VEX_Vcvtps2pd_xmm_xmmm64
			(byte)MemorySize.Packed128_Float32,// VEX_Vcvtps2pd_ymm_xmmm128
			(byte)MemorySize.Packed64_Float32,// EVEX_Vcvtps2pd_xmm_k1z_xmmm64b32
			(byte)MemorySize.Packed128_Float32,// EVEX_Vcvtps2pd_ymm_k1z_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vcvtps2pd_zmm_k1z_ymmm256b32_sae
			(byte)MemorySize.Packed128_Float64,// Cvtpd2ps_xmm_xmmm128
			(byte)MemorySize.Packed128_Float64,// VEX_Vcvtpd2ps_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vcvtpd2ps_xmm_ymmm256
			(byte)MemorySize.Packed128_Float64,// EVEX_Vcvtpd2ps_xmm_k1z_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vcvtpd2ps_xmm_k1z_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vcvtpd2ps_ymm_k1z_zmmm512b64_er
			(byte)MemorySize.Float32,// Cvtss2sd_xmm_xmmm32
			(byte)MemorySize.Float32,// VEX_Vcvtss2sd_xmm_xmm_xmmm32
			(byte)MemorySize.Float32,// EVEX_Vcvtss2sd_xmm_k1z_xmm_xmmm32_sae
			(byte)MemorySize.Float64,// Cvtsd2ss_xmm_xmmm64
			(byte)MemorySize.Float64,// VEX_Vcvtsd2ss_xmm_xmm_xmmm64
			(byte)MemorySize.Float64,// EVEX_Vcvtsd2ss_xmm_k1z_xmm_xmmm64_er
			(byte)MemorySize.Packed128_Int32,// Cvtdq2ps_xmm_xmmm128
			(byte)MemorySize.Packed128_Int32,// VEX_Vcvtdq2ps_xmm_xmmm128
			(byte)MemorySize.Packed256_Int32,// VEX_Vcvtdq2ps_ymm_ymmm256
			(byte)MemorySize.Packed128_Int32,// EVEX_Vcvtdq2ps_xmm_k1z_xmmm128b32
			(byte)MemorySize.Packed256_Int32,// EVEX_Vcvtdq2ps_ymm_k1z_ymmm256b32
			(byte)MemorySize.Packed512_Int32,// EVEX_Vcvtdq2ps_zmm_k1z_zmmm512b32_er
			(byte)MemorySize.Packed128_Int64,// EVEX_Vcvtqq2ps_xmm_k1z_xmmm128b64
			(byte)MemorySize.Packed256_Int64,// EVEX_Vcvtqq2ps_xmm_k1z_ymmm256b64
			(byte)MemorySize.Packed512_Int64,// EVEX_Vcvtqq2ps_ymm_k1z_zmmm512b64_er
			(byte)MemorySize.Packed128_Float32,// Cvtps2dq_xmm_xmmm128
			(byte)MemorySize.Packed128_Float32,// VEX_Vcvtps2dq_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vcvtps2dq_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// EVEX_Vcvtps2dq_xmm_k1z_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vcvtps2dq_ymm_k1z_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vcvtps2dq_zmm_k1z_zmmm512b32_er
			(byte)MemorySize.Packed128_Float32,// Cvttps2dq_xmm_xmmm128
			(byte)MemorySize.Packed128_Float32,// VEX_Vcvttps2dq_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vcvttps2dq_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// EVEX_Vcvttps2dq_xmm_k1z_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vcvttps2dq_ymm_k1z_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vcvttps2dq_zmm_k1z_zmmm512b32_sae
			(byte)MemorySize.Packed128_Float32,// Subps_xmm_xmmm128
			(byte)MemorySize.Packed128_Float32,// VEX_Vsubps_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vsubps_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// EVEX_Vsubps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vsubps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vsubps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Packed128_Float64,// Subpd_xmm_xmmm128
			(byte)MemorySize.Packed128_Float64,// VEX_Vsubpd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vsubpd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// EVEX_Vsubpd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vsubpd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vsubpd_zmm_k1z_zmm_zmmm512b64_er
			(byte)MemorySize.Float32,// Subss_xmm_xmmm32
			(byte)MemorySize.Float32,// VEX_Vsubss_xmm_xmm_xmmm32
			(byte)MemorySize.Float32,// EVEX_Vsubss_xmm_k1z_xmm_xmmm32_er
			(byte)MemorySize.Float64,// Subsd_xmm_xmmm64
			(byte)MemorySize.Float64,// VEX_Vsubsd_xmm_xmm_xmmm64
			(byte)MemorySize.Float64,// EVEX_Vsubsd_xmm_k1z_xmm_xmmm64_er
			(byte)MemorySize.Packed128_Float32,// Minps_xmm_xmmm128
			(byte)MemorySize.Packed128_Float32,// VEX_Vminps_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vminps_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// EVEX_Vminps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vminps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vminps_zmm_k1z_zmm_zmmm512b32_sae
			(byte)MemorySize.Packed128_Float64,// Minpd_xmm_xmmm128
			(byte)MemorySize.Packed128_Float64,// VEX_Vminpd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vminpd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// EVEX_Vminpd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vminpd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vminpd_zmm_k1z_zmm_zmmm512b64_sae
			(byte)MemorySize.Float32,// Minss_xmm_xmmm32
			(byte)MemorySize.Float32,// VEX_Vminss_xmm_xmm_xmmm32
			(byte)MemorySize.Float32,// EVEX_Vminss_xmm_k1z_xmm_xmmm32_sae
			(byte)MemorySize.Float64,// Minsd_xmm_xmmm64
			(byte)MemorySize.Float64,// VEX_Vminsd_xmm_xmm_xmmm64
			(byte)MemorySize.Float64,// EVEX_Vminsd_xmm_k1z_xmm_xmmm64_sae
			(byte)MemorySize.Packed128_Float32,// Divps_xmm_xmmm128
			(byte)MemorySize.Packed128_Float32,// VEX_Vdivps_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vdivps_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// EVEX_Vdivps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vdivps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vdivps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Packed128_Float64,// Divpd_xmm_xmmm128
			(byte)MemorySize.Packed128_Float64,// VEX_Vdivpd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vdivpd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// EVEX_Vdivpd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vdivpd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vdivpd_zmm_k1z_zmm_zmmm512b64_er
			(byte)MemorySize.Float32,// Divss_xmm_xmmm32
			(byte)MemorySize.Float32,// VEX_Vdivss_xmm_xmm_xmmm32
			(byte)MemorySize.Float32,// EVEX_Vdivss_xmm_k1z_xmm_xmmm32_er
			(byte)MemorySize.Float64,// Divsd_xmm_xmmm64
			(byte)MemorySize.Float64,// VEX_Vdivsd_xmm_xmm_xmmm64
			(byte)MemorySize.Float64,// EVEX_Vdivsd_xmm_k1z_xmm_xmmm64_er
			(byte)MemorySize.Packed128_Float32,// Maxps_xmm_xmmm128
			(byte)MemorySize.Packed128_Float32,// VEX_Vmaxps_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vmaxps_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// EVEX_Vmaxps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vmaxps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vmaxps_zmm_k1z_zmm_zmmm512b32_sae
			(byte)MemorySize.Packed128_Float64,// Maxpd_xmm_xmmm128
			(byte)MemorySize.Packed128_Float64,// VEX_Vmaxpd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vmaxpd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// EVEX_Vmaxpd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vmaxpd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vmaxpd_zmm_k1z_zmm_zmmm512b64_sae
			(byte)MemorySize.Float32,// Maxss_xmm_xmmm32
			(byte)MemorySize.Float32,// VEX_Vmaxss_xmm_xmm_xmmm32
			(byte)MemorySize.Float32,// EVEX_Vmaxss_xmm_k1z_xmm_xmmm32_sae
			(byte)MemorySize.Float64,// Maxsd_xmm_xmmm64
			(byte)MemorySize.Float64,// VEX_Vmaxsd_xmm_xmm_xmmm64
			(byte)MemorySize.Float64,// EVEX_Vmaxsd_xmm_k1z_xmm_xmmm64_sae
			(byte)MemorySize.Packed32_UInt8,// Punpcklbw_mm_mmm32
			(byte)MemorySize.Packed128_UInt8,// Punpcklbw_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt8,// VEX_Vpunpcklbw_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt8,// VEX_Vpunpcklbw_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt8,// EVEX_Vpunpcklbw_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt8,// EVEX_Vpunpcklbw_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt8,// EVEX_Vpunpcklbw_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Packed32_UInt16,// Punpcklwd_mm_mmm32
			(byte)MemorySize.Packed128_UInt16,// Punpcklwd_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt16,// VEX_Vpunpcklwd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt16,// VEX_Vpunpcklwd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpunpcklwd_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt16,// EVEX_Vpunpcklwd_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt16,// EVEX_Vpunpcklwd_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Int32,// Punpckldq_mm_mmm32
			(byte)MemorySize.Packed128_UInt32,// Punpckldq_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt32,// VEX_Vpunpckldq_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt32,// VEX_Vpunpckldq_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vpunpckldq_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vpunpckldq_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vpunpckldq_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed64_Int16,// Packsswb_mm_mmm64
			(byte)MemorySize.Packed128_Int16,// Packsswb_xmm_xmmm128
			(byte)MemorySize.Packed128_Int16,// VEX_Vpacksswb_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Int16,// VEX_Vpacksswb_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Int16,// EVEX_Vpacksswb_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_Int16,// EVEX_Vpacksswb_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_Int16,// EVEX_Vpacksswb_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Packed64_Int8,// Pcmpgtb_mm_mmm64
			(byte)MemorySize.Packed128_Int8,// Pcmpgtb_xmm_xmmm128
			(byte)MemorySize.Packed128_Int8,// VEX_Vpcmpgtb_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Int8,// VEX_Vpcmpgtb_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Int8,// EVEX_Vpcmpgtb_kr_k1_xmm_xmmm128
			(byte)MemorySize.Packed256_Int8,// EVEX_Vpcmpgtb_kr_k1_ymm_ymmm256
			(byte)MemorySize.Packed512_Int8,// EVEX_Vpcmpgtb_kr_k1_zmm_zmmm512
			(byte)MemorySize.Packed64_Int16,// Pcmpgtw_mm_mmm64
			(byte)MemorySize.Packed128_Int16,// Pcmpgtw_xmm_xmmm128
			(byte)MemorySize.Packed128_Int16,// VEX_Vpcmpgtw_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Int16,// VEX_Vpcmpgtw_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Int16,// EVEX_Vpcmpgtw_kr_k1_xmm_xmmm128
			(byte)MemorySize.Packed256_Int16,// EVEX_Vpcmpgtw_kr_k1_ymm_ymmm256
			(byte)MemorySize.Packed512_Int16,// EVEX_Vpcmpgtw_kr_k1_zmm_zmmm512
			(byte)MemorySize.Packed64_Int32,// Pcmpgtd_mm_mmm64
			(byte)MemorySize.Packed128_Int32,// Pcmpgtd_xmm_xmmm128
			(byte)MemorySize.Packed128_Int32,// VEX_Vpcmpgtd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Int32,// VEX_Vpcmpgtd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Int32,// EVEX_Vpcmpgtd_kr_k1_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Int32,// EVEX_Vpcmpgtd_kr_k1_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Int32,// EVEX_Vpcmpgtd_kr_k1_zmm_zmmm512b32
			(byte)MemorySize.Packed64_Int16,// Packuswb_mm_mmm64
			(byte)MemorySize.Packed128_Int16,// Packuswb_xmm_xmmm128
			(byte)MemorySize.Packed128_Int16,// VEX_Vpackuswb_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Int16,// VEX_Vpackuswb_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Int16,// EVEX_Vpackuswb_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_Int16,// EVEX_Vpackuswb_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_Int16,// EVEX_Vpackuswb_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Packed64_UInt8,// Punpckhbw_mm_mmm64
			(byte)MemorySize.Packed128_UInt8,// Punpckhbw_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt8,// VEX_Vpunpckhbw_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt8,// VEX_Vpunpckhbw_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt8,// EVEX_Vpunpckhbw_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt8,// EVEX_Vpunpckhbw_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt8,// EVEX_Vpunpckhbw_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Packed64_UInt16,// Punpckhwd_mm_mmm64
			(byte)MemorySize.Packed128_UInt16,// Punpckhwd_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt16,// VEX_Vpunpckhwd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt16,// VEX_Vpunpckhwd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpunpckhwd_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt16,// EVEX_Vpunpckhwd_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt16,// EVEX_Vpunpckhwd_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Packed64_UInt32,// Punpckhdq_mm_mmm64
			(byte)MemorySize.Packed128_UInt32,// Punpckhdq_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt32,// VEX_Vpunpckhdq_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt32,// VEX_Vpunpckhdq_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vpunpckhdq_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vpunpckhdq_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vpunpckhdq_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed64_Int32,// Packssdw_mm_mmm64
			(byte)MemorySize.Packed128_Int32,// Packssdw_xmm_xmmm128
			(byte)MemorySize.Packed128_Int32,// VEX_Vpackssdw_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Int32,// VEX_Vpackssdw_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Int32,// EVEX_Vpackssdw_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Int32,// EVEX_Vpackssdw_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Int32,// EVEX_Vpackssdw_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed128_UInt64,// Punpcklqdq_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt64,// VEX_Vpunpcklqdq_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt64,// VEX_Vpunpcklqdq_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vpunpcklqdq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vpunpcklqdq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vpunpcklqdq_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.Packed128_UInt64,// Punpckhqdq_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt64,// VEX_Vpunpckhqdq_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt64,// VEX_Vpunpckhqdq_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vpunpckhqdq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vpunpckhqdq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vpunpckhqdq_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.UInt32,// Movd_mm_rm32
			(byte)MemorySize.UInt64,// Movq_mm_rm64
			(byte)MemorySize.UInt32,// Movd_xmm_rm32
			(byte)MemorySize.UInt64,// Movq_xmm_rm64
			(byte)MemorySize.UInt32,// VEX_Vmovd_xmm_rm32
			(byte)MemorySize.UInt64,// VEX_Vmovq_xmm_rm64
			(byte)MemorySize.UInt32,// EVEX_Vmovd_xmm_rm32
			(byte)MemorySize.UInt64,// EVEX_Vmovq_xmm_rm64
			(byte)MemorySize.UInt64,// Movq_mm_mmm64
			(byte)MemorySize.Packed128_UInt32,// Movdqa_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt32,// VEX_Vmovdqa_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt32,// VEX_Vmovdqa_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vmovdqa32_xmm_k1z_xmmm128
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vmovdqa32_ymm_k1z_ymmm256
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vmovdqa32_zmm_k1z_zmmm512
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vmovdqa64_xmm_k1z_xmmm128
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vmovdqa64_ymm_k1z_ymmm256
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vmovdqa64_zmm_k1z_zmmm512
			(byte)MemorySize.Packed128_UInt32,// Movdqu_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt32,// VEX_Vmovdqu_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt32,// VEX_Vmovdqu_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vmovdqu32_xmm_k1z_xmmm128
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vmovdqu32_ymm_k1z_ymmm256
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vmovdqu32_zmm_k1z_zmmm512
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vmovdqu64_xmm_k1z_xmmm128
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vmovdqu64_ymm_k1z_ymmm256
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vmovdqu64_zmm_k1z_zmmm512
			(byte)MemorySize.Packed128_UInt8,// EVEX_Vmovdqu8_xmm_k1z_xmmm128
			(byte)MemorySize.Packed256_UInt8,// EVEX_Vmovdqu8_ymm_k1z_ymmm256
			(byte)MemorySize.Packed512_UInt8,// EVEX_Vmovdqu8_zmm_k1z_zmmm512
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vmovdqu16_xmm_k1z_xmmm128
			(byte)MemorySize.Packed256_UInt16,// EVEX_Vmovdqu16_ymm_k1z_ymmm256
			(byte)MemorySize.Packed512_UInt16,// EVEX_Vmovdqu16_zmm_k1z_zmmm512
			(byte)MemorySize.Packed64_UInt16,// Pshufw_mm_mmm64_imm8
			(byte)MemorySize.Packed128_UInt32,// Pshufd_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_UInt32,// VEX_Vpshufd_xmm_xmmm128_imm8
			(byte)MemorySize.Packed256_UInt32,// VEX_Vpshufd_ymm_ymmm256_imm8
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vpshufd_xmm_k1z_xmmm128b32_imm8
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vpshufd_ymm_k1z_ymmm256b32_imm8
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vpshufd_zmm_k1z_zmmm512b32_imm8
			(byte)MemorySize.Packed128_UInt16,// Pshufhw_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_UInt16,// VEX_Vpshufhw_xmm_xmmm128_imm8
			(byte)MemorySize.Packed256_UInt16,// VEX_Vpshufhw_ymm_ymmm256_imm8
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpshufhw_xmm_k1z_xmmm128_imm8
			(byte)MemorySize.Packed256_UInt16,// EVEX_Vpshufhw_ymm_k1z_ymmm256_imm8
			(byte)MemorySize.Packed512_UInt16,// EVEX_Vpshufhw_zmm_k1z_zmmm512_imm8
			(byte)MemorySize.Packed128_UInt16,// Pshuflw_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_UInt16,// VEX_Vpshuflw_xmm_xmmm128_imm8
			(byte)MemorySize.Packed256_UInt16,// VEX_Vpshuflw_ymm_ymmm256_imm8
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpshuflw_xmm_k1z_xmmm128_imm8
			(byte)MemorySize.Packed256_UInt16,// EVEX_Vpshuflw_ymm_k1z_ymmm256_imm8
			(byte)MemorySize.Packed512_UInt16,// EVEX_Vpshuflw_zmm_k1z_zmmm512_imm8
			0,// Psrlw_mm_imm8
			0,// Psrlw_xmm_imm8
			0,// VEX_Vpsrlw_xmm_xmm_imm8
			0,// VEX_Vpsrlw_ymm_ymm_imm8
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpsrlw_xmm_k1z_xmmm128_imm8
			(byte)MemorySize.Packed256_UInt16,// EVEX_Vpsrlw_ymm_k1z_ymmm256_imm8
			(byte)MemorySize.Packed512_UInt16,// EVEX_Vpsrlw_zmm_k1z_zmmm512_imm8
			0,// Psraw_mm_imm8
			0,// Psraw_xmm_imm8
			0,// VEX_Vpsraw_xmm_xmm_imm8
			0,// VEX_Vpsraw_ymm_ymm_imm8
			(byte)MemorySize.Packed128_Int16,// EVEX_Vpsraw_xmm_k1z_xmmm128_imm8
			(byte)MemorySize.Packed256_Int16,// EVEX_Vpsraw_ymm_k1z_ymmm256_imm8
			(byte)MemorySize.Packed512_Int16,// EVEX_Vpsraw_zmm_k1z_zmmm512_imm8
			0,// Psllw_mm_imm8
			0,// Psllw_xmm_imm8
			0,// VEX_Vpsllw_xmm_xmm_imm8
			0,// VEX_Vpsllw_ymm_ymm_imm8
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpsllw_xmm_k1z_xmmm128_imm8
			(byte)MemorySize.Packed256_UInt16,// EVEX_Vpsllw_ymm_k1z_ymmm256_imm8
			(byte)MemorySize.Packed512_UInt16,// EVEX_Vpsllw_zmm_k1z_zmmm512_imm8
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vprord_xmm_k1z_xmmm128b32_imm8
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vprord_ymm_k1z_ymmm256b32_imm8
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vprord_zmm_k1z_zmmm512b32_imm8
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vprorq_xmm_k1z_xmmm128b64_imm8
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vprorq_ymm_k1z_ymmm256b64_imm8
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vprorq_zmm_k1z_zmmm512b64_imm8
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vprold_xmm_k1z_xmmm128b32_imm8
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vprold_ymm_k1z_ymmm256b32_imm8
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vprold_zmm_k1z_zmmm512b32_imm8
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vprolq_xmm_k1z_xmmm128b64_imm8
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vprolq_ymm_k1z_ymmm256b64_imm8
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vprolq_zmm_k1z_zmmm512b64_imm8
			0,// Psrld_mm_imm8
			0,// Psrld_xmm_imm8
			0,// VEX_Vpsrld_xmm_xmm_imm8
			0,// VEX_Vpsrld_ymm_ymm_imm8
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vpsrld_xmm_k1z_xmmm128b32_imm8
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vpsrld_ymm_k1z_ymmm256b32_imm8
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vpsrld_zmm_k1z_zmmm512b32_imm8
			0,// Psrad_mm_imm8
			0,// Psrad_xmm_imm8
			0,// VEX_Vpsrad_xmm_xmm_imm8
			0,// VEX_Vpsrad_ymm_ymm_imm8
			(byte)MemorySize.Packed128_Int32,// EVEX_Vpsrad_xmm_k1z_xmmm128b32_imm8
			(byte)MemorySize.Packed256_Int32,// EVEX_Vpsrad_ymm_k1z_ymmm256b32_imm8
			(byte)MemorySize.Packed512_Int32,// EVEX_Vpsrad_zmm_k1z_zmmm512b32_imm8
			(byte)MemorySize.Packed128_Int64,// EVEX_Vpsraq_xmm_k1z_xmmm128b64_imm8
			(byte)MemorySize.Packed256_Int64,// EVEX_Vpsraq_ymm_k1z_ymmm256b64_imm8
			(byte)MemorySize.Packed512_Int64,// EVEX_Vpsraq_zmm_k1z_zmmm512b64_imm8
			0,// Pslld_mm_imm8
			0,// Pslld_xmm_imm8
			0,// VEX_Vpslld_xmm_xmm_imm8
			0,// VEX_Vpslld_ymm_ymm_imm8
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vpslld_xmm_k1z_xmmm128b32_imm8
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vpslld_ymm_k1z_ymmm256b32_imm8
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vpslld_zmm_k1z_zmmm512b32_imm8
			0,// Psrlq_mm_imm8
			0,// Psrlq_xmm_imm8
			0,// VEX_Vpsrlq_xmm_xmm_imm8
			0,// VEX_Vpsrlq_ymm_ymm_imm8
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vpsrlq_xmm_k1z_xmmm128b64_imm8
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vpsrlq_ymm_k1z_ymmm256b64_imm8
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vpsrlq_zmm_k1z_zmmm512b64_imm8
			0,// Psrldq_xmm_imm8
			0,// VEX_Vpsrldq_xmm_xmm_imm8
			0,// VEX_Vpsrldq_ymm_ymm_imm8
			(byte)MemorySize.UInt128,// EVEX_Vpsrldq_xmm_xmmm128_imm8
			(byte)MemorySize.Packed256_UInt128,// EVEX_Vpsrldq_ymm_ymmm256_imm8
			(byte)MemorySize.Packed512_UInt128,// EVEX_Vpsrldq_zmm_zmmm512_imm8
			0,// Psllq_mm_imm8
			0,// Psllq_xmm_imm8
			0,// VEX_Vpsllq_xmm_xmm_imm8
			0,// VEX_Vpsllq_ymm_ymm_imm8
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vpsllq_xmm_k1z_xmmm128b64_imm8
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vpsllq_ymm_k1z_ymmm256b64_imm8
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vpsllq_zmm_k1z_zmmm512b64_imm8
			0,// Pslldq_xmm_imm8
			0,// VEX_Vpslldq_xmm_xmm_imm8
			0,// VEX_Vpslldq_ymm_ymm_imm8
			(byte)MemorySize.UInt128,// EVEX_Vpslldq_xmm_xmmm128_imm8
			(byte)MemorySize.Packed256_UInt128,// EVEX_Vpslldq_ymm_ymmm256_imm8
			(byte)MemorySize.Packed512_UInt128,// EVEX_Vpslldq_zmm_zmmm512_imm8
			(byte)MemorySize.Packed64_UInt8,// Pcmpeqb_mm_mmm64
			(byte)MemorySize.Packed128_UInt8,// Pcmpeqb_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt8,// VEX_Vpcmpeqb_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt8,// VEX_Vpcmpeqb_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt8,// EVEX_Vpcmpeqb_kr_k1_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt8,// EVEX_Vpcmpeqb_kr_k1_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt8,// EVEX_Vpcmpeqb_kr_k1_zmm_zmmm512
			(byte)MemorySize.Packed64_UInt16,// Pcmpeqw_mm_mmm64
			(byte)MemorySize.Packed128_UInt16,// Pcmpeqw_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt16,// VEX_Vpcmpeqw_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt16,// VEX_Vpcmpeqw_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpcmpeqw_kr_k1_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt16,// EVEX_Vpcmpeqw_kr_k1_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt16,// EVEX_Vpcmpeqw_kr_k1_zmm_zmmm512
			(byte)MemorySize.Packed64_UInt32,// Pcmpeqd_mm_mmm64
			(byte)MemorySize.Packed128_UInt32,// Pcmpeqd_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt32,// VEX_Vpcmpeqd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt32,// VEX_Vpcmpeqd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vpcmpeqd_kr_k1_xmm_xmmm128b32
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vpcmpeqd_kr_k1_ymm_ymmm256b32
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vpcmpeqd_kr_k1_zmm_zmmm512b32
			0,// Emms
			0,// VEX_Vzeroupper
			0,// VEX_Vzeroall
			(byte)MemorySize.UInt32,// Vmread_rm32_r32
			(byte)MemorySize.UInt64,// Vmread_rm64_r64
			(byte)MemorySize.Packed128_Float32,// EVEX_Vcvttps2udq_xmm_k1z_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vcvttps2udq_ymm_k1z_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vcvttps2udq_zmm_k1z_zmmm512b32_sae
			(byte)MemorySize.Packed128_Float64,// EVEX_Vcvttpd2udq_xmm_k1z_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vcvttpd2udq_xmm_k1z_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vcvttpd2udq_ymm_k1z_zmmm512b64_sae
			0,// Extrq_xmm_imm8_imm8
			(byte)MemorySize.Packed64_Float32,// EVEX_Vcvttps2uqq_xmm_k1z_xmmm64b32
			(byte)MemorySize.Packed128_Float32,// EVEX_Vcvttps2uqq_ymm_k1z_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vcvttps2uqq_zmm_k1z_ymmm256b32_sae
			(byte)MemorySize.Packed128_Float64,// EVEX_Vcvttpd2uqq_xmm_k1z_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vcvttpd2uqq_ymm_k1z_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vcvttpd2uqq_zmm_k1z_zmmm512b64_sae
			(byte)MemorySize.Float32,// EVEX_Vcvttss2usi_r32_xmmm32_sae
			(byte)MemorySize.Float32,// EVEX_Vcvttss2usi_r64_xmmm32_sae
			0,// Insertq_xmm_xmm_imm8_imm8
			(byte)MemorySize.Float64,// EVEX_Vcvttsd2usi_r32_xmmm64_sae
			(byte)MemorySize.Float64,// EVEX_Vcvttsd2usi_r64_xmmm64_sae
			(byte)MemorySize.UInt32,// Vmwrite_r32_rm32
			(byte)MemorySize.UInt64,// Vmwrite_r64_rm64
			(byte)MemorySize.Packed128_Float32,// EVEX_Vcvtps2udq_xmm_k1z_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vcvtps2udq_ymm_k1z_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vcvtps2udq_zmm_k1z_zmmm512b32_er
			(byte)MemorySize.Packed128_Float64,// EVEX_Vcvtpd2udq_xmm_k1z_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vcvtpd2udq_xmm_k1z_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vcvtpd2udq_ymm_k1z_zmmm512b64_er
			0,// Extrq_xmm_xmm
			(byte)MemorySize.Packed64_Float32,// EVEX_Vcvtps2uqq_xmm_k1z_xmmm64b32
			(byte)MemorySize.Packed128_Float32,// EVEX_Vcvtps2uqq_ymm_k1z_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vcvtps2uqq_zmm_k1z_ymmm256b32_er
			(byte)MemorySize.Packed128_Float64,// EVEX_Vcvtpd2uqq_xmm_k1z_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vcvtpd2uqq_ymm_k1z_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vcvtpd2uqq_zmm_k1z_zmmm512b64_er
			(byte)MemorySize.Float32,// EVEX_Vcvtss2usi_r32_xmmm32_er
			(byte)MemorySize.Float32,// EVEX_Vcvtss2usi_r64_xmmm32_er
			0,// Insertq_xmm_xmm
			(byte)MemorySize.Float64,// EVEX_Vcvtsd2usi_r32_xmmm64_er
			(byte)MemorySize.Float64,// EVEX_Vcvtsd2usi_r64_xmmm64_er
			(byte)MemorySize.Packed64_Float32,// EVEX_Vcvttps2qq_xmm_k1z_xmmm64b32
			(byte)MemorySize.Packed128_Float32,// EVEX_Vcvttps2qq_ymm_k1z_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vcvttps2qq_zmm_k1z_ymmm256b32_sae
			(byte)MemorySize.Packed128_Float64,// EVEX_Vcvttpd2qq_xmm_k1z_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vcvttpd2qq_ymm_k1z_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vcvttpd2qq_zmm_k1z_zmmm512b64_sae
			(byte)MemorySize.Packed64_UInt32,// EVEX_Vcvtudq2pd_xmm_k1z_xmmm64b32
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vcvtudq2pd_ymm_k1z_xmmm128b32
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vcvtudq2pd_zmm_k1z_ymmm256b32_er
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vcvtuqq2pd_xmm_k1z_xmmm128b64
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vcvtuqq2pd_ymm_k1z_ymmm256b64
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vcvtuqq2pd_zmm_k1z_zmmm512b64_er
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vcvtudq2ps_xmm_k1z_xmmm128b32
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vcvtudq2ps_ymm_k1z_ymmm256b32
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vcvtudq2ps_zmm_k1z_zmmm512b32_er
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vcvtuqq2ps_xmm_k1z_xmmm128b64
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vcvtuqq2ps_xmm_k1z_ymmm256b64
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vcvtuqq2ps_ymm_k1z_zmmm512b64_er
			(byte)MemorySize.Packed64_Float32,// EVEX_Vcvtps2qq_xmm_k1z_xmmm64b32
			(byte)MemorySize.Packed128_Float32,// EVEX_Vcvtps2qq_ymm_k1z_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vcvtps2qq_zmm_k1z_ymmm256b32_er
			(byte)MemorySize.Packed128_Float64,// EVEX_Vcvtpd2qq_xmm_k1z_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vcvtpd2qq_ymm_k1z_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vcvtpd2qq_zmm_k1z_zmmm512b64_er
			(byte)MemorySize.UInt32,// EVEX_Vcvtusi2ss_xmm_xmm_rm32_er
			(byte)MemorySize.UInt64,// EVEX_Vcvtusi2ss_xmm_xmm_rm64_er
			(byte)MemorySize.UInt32,// EVEX_Vcvtusi2sd_xmm_xmm_rm32_er
			(byte)MemorySize.UInt64,// EVEX_Vcvtusi2sd_xmm_xmm_rm64_er
			(byte)MemorySize.Packed128_Float64,// Haddpd_xmm_xmmm128
			(byte)MemorySize.Packed128_Float64,// VEX_Vhaddpd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vhaddpd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// Haddps_xmm_xmmm128
			(byte)MemorySize.Packed128_Float32,// VEX_Vhaddps_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vhaddps_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// Hsubpd_xmm_xmmm128
			(byte)MemorySize.Packed128_Float64,// VEX_Vhsubpd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vhsubpd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// Hsubps_xmm_xmmm128
			(byte)MemorySize.Packed128_Float32,// VEX_Vhsubps_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vhsubps_ymm_ymm_ymmm256
			(byte)MemorySize.UInt32,// Movd_rm32_mm
			(byte)MemorySize.UInt64,// Movq_rm64_mm
			(byte)MemorySize.UInt32,// Movd_rm32_xmm
			(byte)MemorySize.UInt64,// Movq_rm64_xmm
			(byte)MemorySize.UInt32,// VEX_Vmovd_rm32_xmm
			(byte)MemorySize.UInt64,// VEX_Vmovq_rm64_xmm
			(byte)MemorySize.UInt32,// EVEX_Vmovd_rm32_xmm
			(byte)MemorySize.UInt64,// EVEX_Vmovq_rm64_xmm
			(byte)MemorySize.UInt64,// Movq_xmm_xmmm64
			(byte)MemorySize.UInt64,// VEX_Vmovq_xmm_xmmm64
			(byte)MemorySize.UInt64,// EVEX_Vmovq_xmm_xmmm64
			(byte)MemorySize.UInt64,// Movq_mmm64_mm
			(byte)MemorySize.Packed128_UInt32,// Movdqa_xmmm128_xmm
			(byte)MemorySize.Packed128_UInt32,// VEX_Vmovdqa_xmmm128_xmm
			(byte)MemorySize.Packed256_UInt32,// VEX_Vmovdqa_ymmm256_ymm
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vmovdqa32_xmmm128_k1z_xmm
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vmovdqa32_ymmm256_k1z_ymm
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vmovdqa32_zmmm512_k1z_zmm
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vmovdqa64_xmmm128_k1z_xmm
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vmovdqa64_ymmm256_k1z_ymm
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vmovdqa64_zmmm512_k1z_zmm
			(byte)MemorySize.Packed128_UInt32,// Movdqu_xmmm128_xmm
			(byte)MemorySize.Packed128_UInt32,// VEX_Vmovdqu_xmmm128_xmm
			(byte)MemorySize.Packed256_UInt32,// VEX_Vmovdqu_ymmm256_ymm
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vmovdqu32_xmmm128_k1z_xmm
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vmovdqu32_ymmm256_k1z_ymm
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vmovdqu32_zmmm512_k1z_zmm
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vmovdqu64_xmmm128_k1z_xmm
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vmovdqu64_ymmm256_k1z_ymm
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vmovdqu64_zmmm512_k1z_zmm
			(byte)MemorySize.Packed128_UInt8,// EVEX_Vmovdqu8_xmmm128_k1z_xmm
			(byte)MemorySize.Packed256_UInt8,// EVEX_Vmovdqu8_ymmm256_k1z_ymm
			(byte)MemorySize.Packed512_UInt8,// EVEX_Vmovdqu8_zmmm512_k1z_zmm
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vmovdqu16_xmmm128_k1z_xmm
			(byte)MemorySize.Packed256_UInt16,// EVEX_Vmovdqu16_ymmm256_k1z_ymm
			(byte)MemorySize.Packed512_UInt16,// EVEX_Vmovdqu16_zmmm512_k1z_zmm
			0,// Jo_rel16
			0,// Jo_rel32_32
			0,// Jo_rel32_64
			0,// Jno_rel16
			0,// Jno_rel32_32
			0,// Jno_rel32_64
			0,// Jb_rel16
			0,// Jb_rel32_32
			0,// Jb_rel32_64
			0,// Jae_rel16
			0,// Jae_rel32_32
			0,// Jae_rel32_64
			0,// Je_rel16
			0,// Je_rel32_32
			0,// Je_rel32_64
			0,// Jne_rel16
			0,// Jne_rel32_32
			0,// Jne_rel32_64
			0,// Jbe_rel16
			0,// Jbe_rel32_32
			0,// Jbe_rel32_64
			0,// Ja_rel16
			0,// Ja_rel32_32
			0,// Ja_rel32_64
			0,// Js_rel16
			0,// Js_rel32_32
			0,// Js_rel32_64
			0,// Jns_rel16
			0,// Jns_rel32_32
			0,// Jns_rel32_64
			0,// Jp_rel16
			0,// Jp_rel32_32
			0,// Jp_rel32_64
			0,// Jnp_rel16
			0,// Jnp_rel32_32
			0,// Jnp_rel32_64
			0,// Jl_rel16
			0,// Jl_rel32_32
			0,// Jl_rel32_64
			0,// Jge_rel16
			0,// Jge_rel32_32
			0,// Jge_rel32_64
			0,// Jle_rel16
			0,// Jle_rel32_32
			0,// Jle_rel32_64
			0,// Jg_rel16
			0,// Jg_rel32_32
			0,// Jg_rel32_64
			(byte)MemorySize.UInt8,// Seto_rm8
			(byte)MemorySize.UInt8,// Setno_rm8
			(byte)MemorySize.UInt8,// Setb_rm8
			(byte)MemorySize.UInt8,// Setae_rm8
			(byte)MemorySize.UInt8,// Sete_rm8
			(byte)MemorySize.UInt8,// Setne_rm8
			(byte)MemorySize.UInt8,// Setbe_rm8
			(byte)MemorySize.UInt8,// Seta_rm8
			(byte)MemorySize.UInt8,// Sets_rm8
			(byte)MemorySize.UInt8,// Setns_rm8
			(byte)MemorySize.UInt8,// Setp_rm8
			(byte)MemorySize.UInt8,// Setnp_rm8
			(byte)MemorySize.UInt8,// Setl_rm8
			(byte)MemorySize.UInt8,// Setge_rm8
			(byte)MemorySize.UInt8,// Setle_rm8
			(byte)MemorySize.UInt8,// Setg_rm8
			(byte)MemorySize.UInt16,// VEX_Kmovw_kr_km16
			(byte)MemorySize.UInt64,// VEX_Kmovq_kr_km64
			(byte)MemorySize.UInt8,// VEX_Kmovb_kr_km8
			(byte)MemorySize.UInt32,// VEX_Kmovd_kr_km32
			(byte)MemorySize.UInt16,// VEX_Kmovw_m16_kr
			(byte)MemorySize.UInt64,// VEX_Kmovq_m64_kr
			(byte)MemorySize.UInt8,// VEX_Kmovb_m8_kr
			(byte)MemorySize.UInt32,// VEX_Kmovd_m32_kr
			0,// VEX_Kmovw_kr_r32
			0,// VEX_Kmovb_kr_r32
			0,// VEX_Kmovd_kr_r32
			0,// VEX_Kmovq_kr_r64
			0,// VEX_Kmovw_r32_kr
			0,// VEX_Kmovb_r32_kr
			0,// VEX_Kmovd_r32_kr
			0,// VEX_Kmovq_r64_kr
			0,// VEX_Kortestw_kr_kr
			0,// VEX_Kortestq_kr_kr
			0,// VEX_Kortestb_kr_kr
			0,// VEX_Kortestd_kr_kr
			0,// VEX_Ktestw_kr_kr
			0,// VEX_Ktestq_kr_kr
			0,// VEX_Ktestb_kr_kr
			0,// VEX_Ktestd_kr_kr
			0,// Pushw_FS
			0,// Pushd_FS
			0,// Pushq_FS
			0,// Popw_FS
			0,// Popd_FS
			0,// Popq_FS
			0,// Cpuid
			(byte)MemorySize.UInt16,// Bt_rm16_r16
			(byte)MemorySize.UInt32,// Bt_rm32_r32
			(byte)MemorySize.UInt64,// Bt_rm64_r64
			(byte)MemorySize.UInt16,// Shld_rm16_r16_imm8
			(byte)MemorySize.UInt32,// Shld_rm32_r32_imm8
			(byte)MemorySize.UInt64,// Shld_rm64_r64_imm8
			(byte)MemorySize.UInt16,// Shld_rm16_r16_CL
			(byte)MemorySize.UInt32,// Shld_rm32_r32_CL
			(byte)MemorySize.UInt64,// Shld_rm64_r64_CL
			0,// Montmul_16
			0,// Montmul_32
			0,// Montmul_64
			0,// Xsha1_16
			0,// Xsha1_32
			0,// Xsha1_64
			0,// Xsha256_16
			0,// Xsha256_32
			0,// Xsha256_64
			(byte)MemorySize.UInt16,// Xbts_r16_rm16
			(byte)MemorySize.UInt32,// Xbts_r32_rm32
			0,// Xstore_16
			0,// Xstore_32
			0,// Xstore_64
			0,// Xcryptecb_16
			0,// Xcryptecb_32
			0,// Xcryptecb_64
			0,// Xcryptcbc_16
			0,// Xcryptcbc_32
			0,// Xcryptcbc_64
			0,// Xcryptctr_16
			0,// Xcryptctr_32
			0,// Xcryptctr_64
			0,// Xcryptcfb_16
			0,// Xcryptcfb_32
			0,// Xcryptcfb_64
			0,// Xcryptofb_16
			0,// Xcryptofb_32
			0,// Xcryptofb_64
			(byte)MemorySize.UInt16,// Ibts_rm16_r16
			(byte)MemorySize.UInt32,// Ibts_rm32_r32
			(byte)MemorySize.UInt8,// Cmpxchg486_rm8_r8
			(byte)MemorySize.UInt16,// Cmpxchg486_rm16_r16
			(byte)MemorySize.UInt32,// Cmpxchg486_rm32_r32
			0,// Pushw_GS
			0,// Pushd_GS
			0,// Pushq_GS
			0,// Popw_GS
			0,// Popd_GS
			0,// Popq_GS
			0,// Rsm
			(byte)MemorySize.UInt16,// Bts_rm16_r16
			(byte)MemorySize.UInt32,// Bts_rm32_r32
			(byte)MemorySize.UInt64,// Bts_rm64_r64
			(byte)MemorySize.UInt16,// Shrd_rm16_r16_imm8
			(byte)MemorySize.UInt32,// Shrd_rm32_r32_imm8
			(byte)MemorySize.UInt64,// Shrd_rm64_r64_imm8
			(byte)MemorySize.UInt16,// Shrd_rm16_r16_CL
			(byte)MemorySize.UInt32,// Shrd_rm32_r32_CL
			(byte)MemorySize.UInt64,// Shrd_rm64_r64_CL
			(byte)MemorySize.Fxsave_512Byte,// Fxsave_m512byte
			(byte)MemorySize.Fxsave64_512Byte,// Fxsave64_m512byte
			0,// Rdfsbase_r32
			0,// Rdfsbase_r64
			(byte)MemorySize.Fxsave_512Byte,// Fxrstor_m512byte
			(byte)MemorySize.Fxsave64_512Byte,// Fxrstor64_m512byte
			0,// Rdgsbase_r32
			0,// Rdgsbase_r64
			(byte)MemorySize.UInt32,// Ldmxcsr_m32
			0,// Wrfsbase_r32
			0,// Wrfsbase_r64
			(byte)MemorySize.UInt32,// VEX_Vldmxcsr_m32
			(byte)MemorySize.UInt32,// Stmxcsr_m32
			0,// Wrgsbase_r32
			0,// Wrgsbase_r64
			(byte)MemorySize.UInt32,// VEX_Vstmxcsr_m32
			(byte)MemorySize.Xsave,// Xsave_mem
			(byte)MemorySize.Xsave64,// Xsave64_mem
			(byte)MemorySize.UInt32,// Ptwrite_rm32
			(byte)MemorySize.UInt64,// Ptwrite_rm64
			(byte)MemorySize.Xsave,// Xrstor_mem
			(byte)MemorySize.Xsave64,// Xrstor64_mem
			0,// Incsspd_r32
			0,// Incsspq_r64
			(byte)MemorySize.Xsave,// Xsaveopt_mem
			(byte)MemorySize.Xsave64,// Xsaveopt64_mem
			(byte)MemorySize.UInt8,// Clwb_m8
			0,// Tpause_r32
			0,// Tpause_r64
			(byte)MemorySize.UInt64,// Clrssbsy_m64
			0,// Umonitor_r16
			0,// Umonitor_r32
			0,// Umonitor_r64
			0,// Umwait_r32
			0,// Umwait_r64
			(byte)MemorySize.UInt8,// Clflush_m8
			(byte)MemorySize.UInt8,// Clflushopt_m8
			0,// Lfence
			0,// Lfence_E9
			0,// Lfence_EA
			0,// Lfence_EB
			0,// Lfence_EC
			0,// Lfence_ED
			0,// Lfence_EE
			0,// Lfence_EF
			0,// Mfence
			0,// Mfence_F1
			0,// Mfence_F2
			0,// Mfence_F3
			0,// Mfence_F4
			0,// Mfence_F5
			0,// Mfence_F6
			0,// Mfence_F7
			0,// Sfence
			0,// Sfence_F9
			0,// Sfence_FA
			0,// Sfence_FB
			0,// Sfence_FC
			0,// Sfence_FD
			0,// Sfence_FE
			0,// Sfence_FF
			0,// Pcommit
			(byte)MemorySize.Int16,// Imul_r16_rm16
			(byte)MemorySize.Int32,// Imul_r32_rm32
			(byte)MemorySize.Int64,// Imul_r64_rm64
			(byte)MemorySize.UInt8,// Cmpxchg_rm8_r8
			(byte)MemorySize.UInt16,// Cmpxchg_rm16_r16
			(byte)MemorySize.UInt32,// Cmpxchg_rm32_r32
			(byte)MemorySize.UInt64,// Cmpxchg_rm64_r64
			(byte)MemorySize.SegPtr16,// Lss_r16_m1616
			(byte)MemorySize.SegPtr32,// Lss_r32_m1632
			(byte)MemorySize.SegPtr64,// Lss_r64_m1664
			(byte)MemorySize.UInt16,// Btr_rm16_r16
			(byte)MemorySize.UInt32,// Btr_rm32_r32
			(byte)MemorySize.UInt64,// Btr_rm64_r64
			(byte)MemorySize.SegPtr16,// Lfs_r16_m1616
			(byte)MemorySize.SegPtr32,// Lfs_r32_m1632
			(byte)MemorySize.SegPtr64,// Lfs_r64_m1664
			(byte)MemorySize.SegPtr16,// Lgs_r16_m1616
			(byte)MemorySize.SegPtr32,// Lgs_r32_m1632
			(byte)MemorySize.SegPtr64,// Lgs_r64_m1664
			(byte)MemorySize.UInt8,// Movzx_r16_rm8
			(byte)MemorySize.UInt8,// Movzx_r32_rm8
			(byte)MemorySize.UInt8,// Movzx_r64_rm8
			(byte)MemorySize.UInt16,// Movzx_r16_rm16
			(byte)MemorySize.UInt16,// Movzx_r32_rm16
			(byte)MemorySize.UInt16,// Movzx_r64_rm16
			0,// Jmpe_disp16
			0,// Jmpe_disp32
			(byte)MemorySize.UInt16,// Popcnt_r16_rm16
			(byte)MemorySize.UInt32,// Popcnt_r32_rm32
			(byte)MemorySize.UInt64,// Popcnt_r64_rm64
			(byte)MemorySize.UInt16,// Ud1_r16_rm16
			(byte)MemorySize.UInt32,// Ud1_r32_rm32
			(byte)MemorySize.UInt64,// Ud1_r64_rm64
			(byte)MemorySize.UInt16,// Bt_rm16_imm8
			(byte)MemorySize.UInt32,// Bt_rm32_imm8
			(byte)MemorySize.UInt64,// Bt_rm64_imm8
			(byte)MemorySize.UInt16,// Bts_rm16_imm8
			(byte)MemorySize.UInt32,// Bts_rm32_imm8
			(byte)MemorySize.UInt64,// Bts_rm64_imm8
			(byte)MemorySize.UInt16,// Btr_rm16_imm8
			(byte)MemorySize.UInt32,// Btr_rm32_imm8
			(byte)MemorySize.UInt64,// Btr_rm64_imm8
			(byte)MemorySize.UInt16,// Btc_rm16_imm8
			(byte)MemorySize.UInt32,// Btc_rm32_imm8
			(byte)MemorySize.UInt64,// Btc_rm64_imm8
			(byte)MemorySize.UInt16,// Btc_rm16_r16
			(byte)MemorySize.UInt32,// Btc_rm32_r32
			(byte)MemorySize.UInt64,// Btc_rm64_r64
			(byte)MemorySize.UInt16,// Bsf_r16_rm16
			(byte)MemorySize.UInt32,// Bsf_r32_rm32
			(byte)MemorySize.UInt64,// Bsf_r64_rm64
			(byte)MemorySize.UInt16,// Tzcnt_r16_rm16
			(byte)MemorySize.UInt32,// Tzcnt_r32_rm32
			(byte)MemorySize.UInt64,// Tzcnt_r64_rm64
			(byte)MemorySize.UInt16,// Bsr_r16_rm16
			(byte)MemorySize.UInt32,// Bsr_r32_rm32
			(byte)MemorySize.UInt64,// Bsr_r64_rm64
			(byte)MemorySize.UInt16,// Lzcnt_r16_rm16
			(byte)MemorySize.UInt32,// Lzcnt_r32_rm32
			(byte)MemorySize.UInt64,// Lzcnt_r64_rm64
			(byte)MemorySize.Int8,// Movsx_r16_rm8
			(byte)MemorySize.Int8,// Movsx_r32_rm8
			(byte)MemorySize.Int8,// Movsx_r64_rm8
			(byte)MemorySize.Int16,// Movsx_r16_rm16
			(byte)MemorySize.Int16,// Movsx_r32_rm16
			(byte)MemorySize.Int16,// Movsx_r64_rm16
			(byte)MemorySize.UInt8,// Xadd_rm8_r8
			(byte)MemorySize.UInt16,// Xadd_rm16_r16
			(byte)MemorySize.UInt32,// Xadd_rm32_r32
			(byte)MemorySize.UInt64,// Xadd_rm64_r64
			(byte)MemorySize.Packed128_Float32,// Cmpps_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_Float32,// VEX_Vcmpps_xmm_xmm_xmmm128_imm8
			(byte)MemorySize.Packed256_Float32,// VEX_Vcmpps_ymm_ymm_ymmm256_imm8
			(byte)MemorySize.Packed128_Float32,// EVEX_Vcmpps_kr_k1_xmm_xmmm128b32_imm8
			(byte)MemorySize.Packed256_Float32,// EVEX_Vcmpps_kr_k1_ymm_ymmm256b32_imm8
			(byte)MemorySize.Packed512_Float32,// EVEX_Vcmpps_kr_k1_zmm_zmmm512b32_imm8_sae
			(byte)MemorySize.Packed128_Float64,// Cmppd_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_Float64,// VEX_Vcmppd_xmm_xmm_xmmm128_imm8
			(byte)MemorySize.Packed256_Float64,// VEX_Vcmppd_ymm_ymm_ymmm256_imm8
			(byte)MemorySize.Packed128_Float64,// EVEX_Vcmppd_kr_k1_xmm_xmmm128b64_imm8
			(byte)MemorySize.Packed256_Float64,// EVEX_Vcmppd_kr_k1_ymm_ymmm256b64_imm8
			(byte)MemorySize.Packed512_Float64,// EVEX_Vcmppd_kr_k1_zmm_zmmm512b64_imm8_sae
			(byte)MemorySize.Float32,// Cmpss_xmm_xmmm32_imm8
			(byte)MemorySize.Float32,// VEX_Vcmpss_xmm_xmm_xmmm32_imm8
			(byte)MemorySize.Float32,// EVEX_Vcmpss_kr_k1_xmm_xmmm32_imm8_sae
			(byte)MemorySize.Float64,// Cmpsd_xmm_xmmm64_imm8
			(byte)MemorySize.Float64,// VEX_Vcmpsd_xmm_xmm_xmmm64_imm8
			(byte)MemorySize.Float64,// EVEX_Vcmpsd_kr_k1_xmm_xmmm64_imm8_sae
			(byte)MemorySize.UInt32,// Movnti_m32_r32
			(byte)MemorySize.UInt64,// Movnti_m64_r64
			(byte)MemorySize.UInt16,// Pinsrw_mm_r32m16_imm8
			(byte)MemorySize.UInt16,// Pinsrw_mm_r64m16_imm8
			(byte)MemorySize.UInt16,// Pinsrw_xmm_r32m16_imm8
			(byte)MemorySize.UInt16,// Pinsrw_xmm_r64m16_imm8
			(byte)MemorySize.UInt16,// VEX_Vpinsrw_xmm_xmm_r32m16_imm8
			(byte)MemorySize.UInt16,// VEX_Vpinsrw_xmm_xmm_r64m16_imm8
			(byte)MemorySize.UInt16,// EVEX_Vpinsrw_xmm_xmm_r32m16_imm8
			(byte)MemorySize.UInt16,// EVEX_Vpinsrw_xmm_xmm_r64m16_imm8
			0,// Pextrw_r32_mm_imm8
			0,// Pextrw_r64_mm_imm8
			0,// Pextrw_r32_xmm_imm8
			0,// Pextrw_r64_xmm_imm8
			0,// VEX_Vpextrw_r32_xmm_imm8
			0,// VEX_Vpextrw_r64_xmm_imm8
			0,// EVEX_Vpextrw_r32_xmm_imm8
			0,// EVEX_Vpextrw_r64_xmm_imm8
			(byte)MemorySize.Packed128_Float32,// Shufps_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_Float32,// VEX_Vshufps_xmm_xmm_xmmm128_imm8
			(byte)MemorySize.Packed256_Float32,// VEX_Vshufps_ymm_ymm_ymmm256_imm8
			(byte)MemorySize.Packed128_Float32,// EVEX_Vshufps_xmm_k1z_xmm_xmmm128b32_imm8
			(byte)MemorySize.Packed256_Float32,// EVEX_Vshufps_ymm_k1z_ymm_ymmm256b32_imm8
			(byte)MemorySize.Packed512_Float32,// EVEX_Vshufps_zmm_k1z_zmm_zmmm512b32_imm8
			(byte)MemorySize.Packed128_Float64,// Shufpd_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_Float64,// VEX_Vshufpd_xmm_xmm_xmmm128_imm8
			(byte)MemorySize.Packed256_Float64,// VEX_Vshufpd_ymm_ymm_ymmm256_imm8
			(byte)MemorySize.Packed128_Float64,// EVEX_Vshufpd_xmm_k1z_xmm_xmmm128b64_imm8
			(byte)MemorySize.Packed256_Float64,// EVEX_Vshufpd_ymm_k1z_ymm_ymmm256b64_imm8
			(byte)MemorySize.Packed512_Float64,// EVEX_Vshufpd_zmm_k1z_zmm_zmmm512b64_imm8
			(byte)MemorySize.UInt64,// Cmpxchg8b_m64
			(byte)MemorySize.UInt128,// Cmpxchg16b_m128
			(byte)MemorySize.Xsave,// Xrstors_mem
			(byte)MemorySize.Xsave64,// Xrstors64_mem
			(byte)MemorySize.Xsave,// Xsavec_mem
			(byte)MemorySize.Xsave64,// Xsavec64_mem
			(byte)MemorySize.Xsave,// Xsaves_mem
			(byte)MemorySize.Xsave64,// Xsaves64_mem
			(byte)MemorySize.UInt64,// Vmptrld_m64
			(byte)MemorySize.UInt64,// Vmclear_m64
			(byte)MemorySize.UInt64,// Vmxon_m64
			0,// Rdrand_r16
			0,// Rdrand_r32
			0,// Rdrand_r64
			(byte)MemorySize.UInt64,// Vmptrst_m64
			0,// Rdseed_r16
			0,// Rdseed_r32
			0,// Rdseed_r64
			0,// Rdpid_r32
			0,// Rdpid_r64
			0,// Bswap_r16
			0,// Bswap_r32
			0,// Bswap_r64
			(byte)MemorySize.Packed128_Float64,// Addsubpd_xmm_xmmm128
			(byte)MemorySize.Packed128_Float64,// VEX_Vaddsubpd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vaddsubpd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// Addsubps_xmm_xmmm128
			(byte)MemorySize.Packed128_Float32,// VEX_Vaddsubps_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vaddsubps_ymm_ymm_ymmm256
			(byte)MemorySize.Packed64_UInt16,// Psrlw_mm_mmm64
			(byte)MemorySize.Packed128_UInt16,// Psrlw_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt16,// VEX_Vpsrlw_xmm_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt16,// VEX_Vpsrlw_ymm_ymm_xmmm128
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpsrlw_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpsrlw_ymm_k1z_ymm_xmmm128
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpsrlw_zmm_k1z_zmm_xmmm128
			(byte)MemorySize.Packed64_UInt32,// Psrld_mm_mmm64
			(byte)MemorySize.Packed128_UInt32,// Psrld_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt32,// VEX_Vpsrld_xmm_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt32,// VEX_Vpsrld_ymm_ymm_xmmm128
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vpsrld_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vpsrld_ymm_k1z_ymm_xmmm128
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vpsrld_zmm_k1z_zmm_xmmm128
			(byte)MemorySize.UInt64,// Psrlq_mm_mmm64
			(byte)MemorySize.Packed128_UInt64,// Psrlq_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt64,// VEX_Vpsrlq_xmm_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt64,// VEX_Vpsrlq_ymm_ymm_xmmm128
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vpsrlq_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vpsrlq_ymm_k1z_ymm_xmmm128
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vpsrlq_zmm_k1z_zmm_xmmm128
			(byte)MemorySize.UInt64,// Paddq_mm_mmm64
			(byte)MemorySize.Packed128_UInt64,// Paddq_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt64,// VEX_Vpaddq_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt64,// VEX_Vpaddq_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vpaddq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vpaddq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vpaddq_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.Packed64_Int16,// Pmullw_mm_mmm64
			(byte)MemorySize.Packed128_Int16,// Pmullw_xmm_xmmm128
			(byte)MemorySize.Packed128_Int16,// VEX_Vpmullw_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Int16,// VEX_Vpmullw_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Int16,// EVEX_Vpmullw_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_Int16,// EVEX_Vpmullw_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_Int16,// EVEX_Vpmullw_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.UInt64,// Movq_xmmm64_xmm
			(byte)MemorySize.UInt64,// VEX_Vmovq_xmmm64_xmm
			(byte)MemorySize.UInt64,// EVEX_Vmovq_xmmm64_xmm
			0,// Movq2dq_xmm_mm
			0,// Movdq2q_mm_xmm
			0,// Pmovmskb_r32_mm
			0,// Pmovmskb_r64_mm
			0,// Pmovmskb_r32_xmm
			0,// Pmovmskb_r64_xmm
			0,// VEX_Vpmovmskb_r32_xmm
			0,// VEX_Vpmovmskb_r64_xmm
			0,// VEX_Vpmovmskb_r32_ymm
			0,// VEX_Vpmovmskb_r64_ymm
			(byte)MemorySize.Packed64_UInt8,// Psubusb_mm_mmm64
			(byte)MemorySize.Packed128_UInt8,// Psubusb_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt8,// VEX_Vpsubusb_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt8,// VEX_Vpsubusb_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt8,// EVEX_Vpsubusb_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt8,// EVEX_Vpsubusb_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt8,// EVEX_Vpsubusb_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Packed64_UInt16,// Psubusw_mm_mmm64
			(byte)MemorySize.Packed128_UInt16,// Psubusw_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt16,// VEX_Vpsubusw_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt16,// VEX_Vpsubusw_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpsubusw_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt16,// EVEX_Vpsubusw_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt16,// EVEX_Vpsubusw_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Packed64_UInt8,// Pminub_mm_mmm64
			(byte)MemorySize.Packed128_UInt8,// Pminub_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt8,// VEX_Vpminub_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt8,// VEX_Vpminub_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt8,// EVEX_Vpminub_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt8,// EVEX_Vpminub_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt8,// EVEX_Vpminub_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.UInt64,// Pand_mm_mmm64
			(byte)MemorySize.UInt128,// Pand_xmm_xmmm128
			(byte)MemorySize.UInt128,// VEX_Vpand_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt128,// VEX_Vpand_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vpandd_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vpandd_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vpandd_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vpandq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vpandq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vpandq_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.Packed64_UInt8,// Paddusb_mm_mmm64
			(byte)MemorySize.Packed128_UInt8,// Paddusb_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt8,// VEX_Vpaddusb_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt8,// VEX_Vpaddusb_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt8,// EVEX_Vpaddusb_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt8,// EVEX_Vpaddusb_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt8,// EVEX_Vpaddusb_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Packed64_UInt16,// Paddusw_mm_mmm64
			(byte)MemorySize.Packed128_UInt16,// Paddusw_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt16,// VEX_Vpaddusw_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt16,// VEX_Vpaddusw_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpaddusw_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt16,// EVEX_Vpaddusw_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt16,// EVEX_Vpaddusw_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Packed64_UInt8,// Pmaxub_mm_mmm64
			(byte)MemorySize.Packed128_UInt8,// Pmaxub_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt8,// VEX_Vpmaxub_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt8,// VEX_Vpmaxub_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt8,// EVEX_Vpmaxub_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt8,// EVEX_Vpmaxub_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt8,// EVEX_Vpmaxub_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.UInt64,// Pandn_mm_mmm64
			(byte)MemorySize.UInt128,// Pandn_xmm_xmmm128
			(byte)MemorySize.UInt128,// VEX_Vpandn_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt128,// VEX_Vpandn_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vpandnd_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vpandnd_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vpandnd_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vpandnq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vpandnq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vpandnq_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.Packed64_UInt8,// Pavgb_mm_mmm64
			(byte)MemorySize.Packed128_UInt8,// Pavgb_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt8,// VEX_Vpavgb_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt8,// VEX_Vpavgb_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt8,// EVEX_Vpavgb_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt8,// EVEX_Vpavgb_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt8,// EVEX_Vpavgb_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Packed64_Int16,// Psraw_mm_mmm64
			(byte)MemorySize.Packed128_Int16,// Psraw_xmm_xmmm128
			(byte)MemorySize.Packed128_Int16,// VEX_Vpsraw_xmm_xmm_xmmm128
			(byte)MemorySize.Packed128_Int16,// VEX_Vpsraw_ymm_ymm_xmmm128
			(byte)MemorySize.Packed128_Int16,// EVEX_Vpsraw_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed128_Int16,// EVEX_Vpsraw_ymm_k1z_ymm_xmmm128
			(byte)MemorySize.Packed128_Int16,// EVEX_Vpsraw_zmm_k1z_zmm_xmmm128
			(byte)MemorySize.Packed64_Int32,// Psrad_mm_mmm64
			(byte)MemorySize.Packed128_Int32,// Psrad_xmm_xmmm128
			(byte)MemorySize.Packed128_Int32,// VEX_Vpsrad_xmm_xmm_xmmm128
			(byte)MemorySize.Packed128_Int32,// VEX_Vpsrad_ymm_ymm_xmmm128
			(byte)MemorySize.Packed128_Int32,// EVEX_Vpsrad_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed128_Int32,// EVEX_Vpsrad_ymm_k1z_ymm_xmmm128
			(byte)MemorySize.Packed128_Int32,// EVEX_Vpsrad_zmm_k1z_zmm_xmmm128
			(byte)MemorySize.Packed128_Int64,// EVEX_Vpsraq_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed128_Int64,// EVEX_Vpsraq_ymm_k1z_ymm_xmmm128
			(byte)MemorySize.Packed128_Int64,// EVEX_Vpsraq_zmm_k1z_zmm_xmmm128
			(byte)MemorySize.Packed64_UInt16,// Pavgw_mm_mmm64
			(byte)MemorySize.Packed128_UInt16,// Pavgw_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt16,// VEX_Vpavgw_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt16,// VEX_Vpavgw_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpavgw_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt16,// EVEX_Vpavgw_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt16,// EVEX_Vpavgw_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Packed64_UInt16,// Pmulhuw_mm_mmm64
			(byte)MemorySize.Packed128_UInt16,// Pmulhuw_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt16,// VEX_Vpmulhuw_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt16,// VEX_Vpmulhuw_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpmulhuw_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt16,// EVEX_Vpmulhuw_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt16,// EVEX_Vpmulhuw_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Packed64_Int16,// Pmulhw_mm_mmm64
			(byte)MemorySize.Packed128_Int16,// Pmulhw_xmm_xmmm128
			(byte)MemorySize.Packed128_Int16,// VEX_Vpmulhw_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Int16,// VEX_Vpmulhw_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Int16,// EVEX_Vpmulhw_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_Int16,// EVEX_Vpmulhw_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_Int16,// EVEX_Vpmulhw_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Packed128_Float64,// Cvttpd2dq_xmm_xmmm128
			(byte)MemorySize.Packed128_Float64,// VEX_Vcvttpd2dq_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vcvttpd2dq_xmm_ymmm256
			(byte)MemorySize.Packed128_Float64,// EVEX_Vcvttpd2dq_xmm_k1z_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vcvttpd2dq_xmm_k1z_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vcvttpd2dq_ymm_k1z_zmmm512b64_sae
			(byte)MemorySize.Packed64_Int32,// Cvtdq2pd_xmm_xmmm64
			(byte)MemorySize.Packed64_Int32,// VEX_Vcvtdq2pd_xmm_xmmm64
			(byte)MemorySize.Packed128_Int32,// VEX_Vcvtdq2pd_ymm_xmmm128
			(byte)MemorySize.Packed64_Int32,// EVEX_Vcvtdq2pd_xmm_k1z_xmmm64b32
			(byte)MemorySize.Packed128_Int32,// EVEX_Vcvtdq2pd_ymm_k1z_xmmm128b32
			(byte)MemorySize.Packed256_Int32,// EVEX_Vcvtdq2pd_zmm_k1z_ymmm256b32_er
			(byte)MemorySize.Packed128_Int64,// EVEX_Vcvtqq2pd_xmm_k1z_xmmm128b64
			(byte)MemorySize.Packed256_Int64,// EVEX_Vcvtqq2pd_ymm_k1z_ymmm256b64
			(byte)MemorySize.Packed512_Int64,// EVEX_Vcvtqq2pd_zmm_k1z_zmmm512b64_er
			(byte)MemorySize.Packed128_Float64,// Cvtpd2dq_xmm_xmmm128
			(byte)MemorySize.Packed128_Float64,// VEX_Vcvtpd2dq_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vcvtpd2dq_xmm_ymmm256
			(byte)MemorySize.Packed128_Float64,// EVEX_Vcvtpd2dq_xmm_k1z_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vcvtpd2dq_xmm_k1z_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vcvtpd2dq_ymm_k1z_zmmm512b64_er
			(byte)MemorySize.Packed64_UInt32,// Movntq_m64_mm
			(byte)MemorySize.Packed128_UInt32,// Movntdq_m128_xmm
			(byte)MemorySize.Packed128_UInt32,// VEX_Vmovntdq_m128_xmm
			(byte)MemorySize.Packed256_UInt32,// VEX_Vmovntdq_m256_ymm
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vmovntdq_m128_xmm
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vmovntdq_m256_ymm
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vmovntdq_m512_zmm
			(byte)MemorySize.Packed64_Int8,// Psubsb_mm_mmm64
			(byte)MemorySize.Packed128_Int8,// Psubsb_xmm_xmmm128
			(byte)MemorySize.Packed128_Int8,// VEX_Vpsubsb_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Int8,// VEX_Vpsubsb_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Int8,// EVEX_Vpsubsb_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_Int8,// EVEX_Vpsubsb_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_Int8,// EVEX_Vpsubsb_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Packed64_Int16,// Psubsw_mm_mmm64
			(byte)MemorySize.Packed128_Int16,// Psubsw_xmm_xmmm128
			(byte)MemorySize.Packed128_Int16,// VEX_Vpsubsw_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Int16,// VEX_Vpsubsw_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Int16,// EVEX_Vpsubsw_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_Int16,// EVEX_Vpsubsw_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_Int16,// EVEX_Vpsubsw_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Packed64_Int16,// Pminsw_mm_mmm64
			(byte)MemorySize.Packed128_Int16,// Pminsw_xmm_xmmm128
			(byte)MemorySize.Packed128_Int16,// VEX_Vpminsw_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Int16,// VEX_Vpminsw_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Int16,// EVEX_Vpminsw_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_Int16,// EVEX_Vpminsw_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_Int16,// EVEX_Vpminsw_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.UInt64,// Por_mm_mmm64
			(byte)MemorySize.UInt128,// Por_xmm_xmmm128
			(byte)MemorySize.UInt128,// VEX_Vpor_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt128,// VEX_Vpor_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vpord_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vpord_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vpord_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vporq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vporq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vporq_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.Packed64_Int8,// Paddsb_mm_mmm64
			(byte)MemorySize.Packed128_Int8,// Paddsb_xmm_xmmm128
			(byte)MemorySize.Packed128_Int8,// VEX_Vpaddsb_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Int8,// VEX_Vpaddsb_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Int8,// EVEX_Vpaddsb_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_Int8,// EVEX_Vpaddsb_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_Int8,// EVEX_Vpaddsb_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Packed64_Int16,// Paddsw_mm_mmm64
			(byte)MemorySize.Packed128_Int16,// Paddsw_xmm_xmmm128
			(byte)MemorySize.Packed128_Int16,// VEX_Vpaddsw_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Int16,// VEX_Vpaddsw_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Int16,// EVEX_Vpaddsw_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_Int16,// EVEX_Vpaddsw_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_Int16,// EVEX_Vpaddsw_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Packed64_Int16,// Pmaxsw_mm_mmm64
			(byte)MemorySize.Packed128_Int16,// Pmaxsw_xmm_xmmm128
			(byte)MemorySize.Packed128_Int16,// VEX_Vpmaxsw_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Int16,// VEX_Vpmaxsw_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Int16,// EVEX_Vpmaxsw_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_Int16,// EVEX_Vpmaxsw_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_Int16,// EVEX_Vpmaxsw_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.UInt64,// Pxor_mm_mmm64
			(byte)MemorySize.UInt128,// Pxor_xmm_xmmm128
			(byte)MemorySize.UInt128,// VEX_Vpxor_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt128,// VEX_Vpxor_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vpxord_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vpxord_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vpxord_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vpxorq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vpxorq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vpxorq_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.UInt128,// Lddqu_xmm_m128
			(byte)MemorySize.UInt128,// VEX_Vlddqu_xmm_m128
			(byte)MemorySize.UInt256,// VEX_Vlddqu_ymm_m256
			(byte)MemorySize.Packed64_UInt16,// Psllw_mm_mmm64
			(byte)MemorySize.Packed128_UInt16,// Psllw_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt16,// VEX_Vpsllw_xmm_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt16,// VEX_Vpsllw_ymm_ymm_xmmm128
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpsllw_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpsllw_ymm_k1z_ymm_xmmm128
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpsllw_zmm_k1z_zmm_xmmm128
			(byte)MemorySize.Packed64_UInt32,// Pslld_mm_mmm64
			(byte)MemorySize.Packed128_UInt32,// Pslld_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt32,// VEX_Vpslld_xmm_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt32,// VEX_Vpslld_ymm_ymm_xmmm128
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vpslld_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vpslld_ymm_k1z_ymm_xmmm128
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vpslld_zmm_k1z_zmm_xmmm128
			(byte)MemorySize.UInt64,// Psllq_mm_mmm64
			(byte)MemorySize.Packed128_UInt64,// Psllq_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt64,// VEX_Vpsllq_xmm_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt64,// VEX_Vpsllq_ymm_ymm_xmmm128
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vpsllq_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vpsllq_ymm_k1z_ymm_xmmm128
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vpsllq_zmm_k1z_zmm_xmmm128
			(byte)MemorySize.Packed64_UInt32,// Pmuludq_mm_mmm64
			(byte)MemorySize.Packed128_UInt32,// Pmuludq_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt32,// VEX_Vpmuludq_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt32,// VEX_Vpmuludq_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vpmuludq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vpmuludq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vpmuludq_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.Packed64_Int16,// Pmaddwd_mm_mmm64
			(byte)MemorySize.Packed128_Int16,// Pmaddwd_xmm_xmmm128
			(byte)MemorySize.Packed128_Int16,// VEX_Vpmaddwd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Int16,// VEX_Vpmaddwd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Int16,// EVEX_Vpmaddwd_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_Int16,// EVEX_Vpmaddwd_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_Int16,// EVEX_Vpmaddwd_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Packed64_UInt8,// Psadbw_mm_mmm64
			(byte)MemorySize.Packed128_UInt8,// Psadbw_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt8,// VEX_Vpsadbw_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt8,// VEX_Vpsadbw_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt8,// EVEX_Vpsadbw_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt8,// EVEX_Vpsadbw_ymm_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt8,// EVEX_Vpsadbw_zmm_zmm_zmmm512
			(byte)MemorySize.UInt64,// Maskmovq_rDI_mm_mm
			(byte)MemorySize.UInt128,// Maskmovdqu_rDI_xmm_xmm
			(byte)MemorySize.UInt128,// VEX_Vmaskmovdqu_rDI_xmm_xmm
			(byte)MemorySize.Packed64_UInt8,// Psubb_mm_mmm64
			(byte)MemorySize.Packed128_UInt8,// Psubb_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt8,// VEX_Vpsubb_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt8,// VEX_Vpsubb_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt8,// EVEX_Vpsubb_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt8,// EVEX_Vpsubb_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt8,// EVEX_Vpsubb_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Packed64_UInt16,// Psubw_mm_mmm64
			(byte)MemorySize.Packed128_UInt16,// Psubw_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt16,// VEX_Vpsubw_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt16,// VEX_Vpsubw_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpsubw_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt16,// EVEX_Vpsubw_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt16,// EVEX_Vpsubw_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Packed64_UInt32,// Psubd_mm_mmm64
			(byte)MemorySize.Packed128_UInt32,// Psubd_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt32,// VEX_Vpsubd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt32,// VEX_Vpsubd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vpsubd_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vpsubd_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vpsubd_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Int64,// Psubq_mm_mmm64
			(byte)MemorySize.Packed128_UInt64,// Psubq_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt64,// VEX_Vpsubq_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt64,// VEX_Vpsubq_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vpsubq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vpsubq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vpsubq_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.Packed64_UInt8,// Paddb_mm_mmm64
			(byte)MemorySize.Packed128_UInt8,// Paddb_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt8,// VEX_Vpaddb_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt8,// VEX_Vpaddb_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt8,// EVEX_Vpaddb_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt8,// EVEX_Vpaddb_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt8,// EVEX_Vpaddb_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Packed64_UInt16,// Paddw_mm_mmm64
			(byte)MemorySize.Packed128_UInt16,// Paddw_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt16,// VEX_Vpaddw_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt16,// VEX_Vpaddw_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpaddw_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt16,// EVEX_Vpaddw_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt16,// EVEX_Vpaddw_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Packed64_UInt32,// Paddd_mm_mmm64
			(byte)MemorySize.Packed128_UInt32,// Paddd_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt32,// VEX_Vpaddd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt32,// VEX_Vpaddd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vpaddd_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vpaddd_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vpaddd_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.UInt16,// Ud0_r16_rm16
			(byte)MemorySize.UInt32,// Ud0_r32_rm32
			(byte)MemorySize.UInt64,// Ud0_r64_rm64
			(byte)MemorySize.Packed64_UInt8,// Pshufb_mm_mmm64
			(byte)MemorySize.Packed128_UInt8,// Pshufb_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt8,// VEX_Vpshufb_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt8,// VEX_Vpshufb_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt8,// EVEX_Vpshufb_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt8,// EVEX_Vpshufb_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt8,// EVEX_Vpshufb_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Packed64_UInt16,// Phaddw_mm_mmm64
			(byte)MemorySize.Packed128_UInt16,// Phaddw_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt16,// VEX_Vphaddw_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt16,// VEX_Vphaddw_ymm_ymm_ymmm256
			(byte)MemorySize.Packed64_UInt32,// Phaddd_mm_mmm64
			(byte)MemorySize.Packed128_UInt32,// Phaddd_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt32,// VEX_Vphaddd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt32,// VEX_Vphaddd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed64_Int16,// Phaddsw_mm_mmm64
			(byte)MemorySize.Packed128_Int16,// Phaddsw_xmm_xmmm128
			(byte)MemorySize.Packed128_Int16,// VEX_Vphaddsw_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Int16,// VEX_Vphaddsw_ymm_ymm_ymmm256
			(byte)MemorySize.Packed64_Int8,// Pmaddubsw_mm_mmm64
			(byte)MemorySize.Packed128_Int8,// Pmaddubsw_xmm_xmmm128
			(byte)MemorySize.Packed128_Int8,// VEX_Vpmaddubsw_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Int8,// VEX_Vpmaddubsw_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Int8,// EVEX_Vpmaddubsw_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_Int8,// EVEX_Vpmaddubsw_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_Int8,// EVEX_Vpmaddubsw_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Packed64_UInt16,// Phsubw_mm_mmm64
			(byte)MemorySize.Packed128_UInt16,// Phsubw_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt16,// VEX_Vphsubw_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt16,// VEX_Vphsubw_ymm_ymm_ymmm256
			(byte)MemorySize.Packed64_UInt32,// Phsubd_mm_mmm64
			(byte)MemorySize.Packed128_UInt32,// Phsubd_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt32,// VEX_Vphsubd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt32,// VEX_Vphsubd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed64_Int16,// Phsubsw_mm_mmm64
			(byte)MemorySize.Packed128_Int16,// Phsubsw_xmm_xmmm128
			(byte)MemorySize.Packed128_Int16,// VEX_Vphsubsw_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Int16,// VEX_Vphsubsw_ymm_ymm_ymmm256
			(byte)MemorySize.Packed64_Int8,// Psignb_mm_mmm64
			(byte)MemorySize.Packed128_Int8,// Psignb_xmm_xmmm128
			(byte)MemorySize.Packed128_Int8,// VEX_Vpsignb_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Int8,// VEX_Vpsignb_ymm_ymm_ymmm256
			(byte)MemorySize.Packed64_Int16,// Psignw_mm_mmm64
			(byte)MemorySize.Packed128_Int16,// Psignw_xmm_xmmm128
			(byte)MemorySize.Packed128_Int16,// VEX_Vpsignw_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Int16,// VEX_Vpsignw_ymm_ymm_ymmm256
			(byte)MemorySize.Packed64_Int32,// Psignd_mm_mmm64
			(byte)MemorySize.Packed128_Int32,// Psignd_xmm_xmmm128
			(byte)MemorySize.Packed128_Int32,// VEX_Vpsignd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Int32,// VEX_Vpsignd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed64_Int16,// Pmulhrsw_mm_mmm64
			(byte)MemorySize.Packed128_Int16,// Pmulhrsw_xmm_xmmm128
			(byte)MemorySize.Packed128_Int16,// VEX_Vpmulhrsw_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Int16,// VEX_Vpmulhrsw_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Int16,// EVEX_Vpmulhrsw_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_Int16,// EVEX_Vpmulhrsw_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_Int16,// EVEX_Vpmulhrsw_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Packed128_Float32,// VEX_Vpermilps_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vpermilps_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// EVEX_Vpermilps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vpermilps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vpermilps_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed128_Float64,// VEX_Vpermilpd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vpermilpd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// EVEX_Vpermilpd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vpermilpd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vpermilpd_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.Packed128_Float32,// VEX_Vtestps_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vtestps_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// VEX_Vtestpd_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vtestpd_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt8,// Pblendvb_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpsrlvw_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt16,// EVEX_Vpsrlvw_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt16,// EVEX_Vpsrlvw_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Packed64_UInt8,// EVEX_Vpmovuswb_xmmm64_k1z_xmm
			(byte)MemorySize.Packed128_UInt8,// EVEX_Vpmovuswb_xmmm128_k1z_ymm
			(byte)MemorySize.Packed256_UInt8,// EVEX_Vpmovuswb_ymmm256_k1z_zmm
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpsravw_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt16,// EVEX_Vpsravw_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt16,// EVEX_Vpsravw_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Packed32_UInt8,// EVEX_Vpmovusdb_xmmm32_k1z_xmm
			(byte)MemorySize.Packed64_UInt8,// EVEX_Vpmovusdb_xmmm64_k1z_ymm
			(byte)MemorySize.Packed128_UInt8,// EVEX_Vpmovusdb_xmmm128_k1z_zmm
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpsllvw_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt16,// EVEX_Vpsllvw_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt16,// EVEX_Vpsllvw_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Packed16_UInt8,// EVEX_Vpmovusqb_xmmm16_k1z_xmm
			(byte)MemorySize.Packed32_UInt8,// EVEX_Vpmovusqb_xmmm32_k1z_ymm
			(byte)MemorySize.Packed64_UInt8,// EVEX_Vpmovusqb_xmmm64_k1z_zmm
			(byte)MemorySize.Packed64_Float16,// VEX_Vcvtph2ps_xmm_xmmm64
			(byte)MemorySize.Packed128_Float16,// VEX_Vcvtph2ps_ymm_xmmm128
			(byte)MemorySize.Packed64_Float16,// EVEX_Vcvtph2ps_xmm_k1z_xmmm64
			(byte)MemorySize.Packed128_Float16,// EVEX_Vcvtph2ps_ymm_k1z_xmmm128
			(byte)MemorySize.Packed256_Float16,// EVEX_Vcvtph2ps_zmm_k1z_ymmm256_sae
			(byte)MemorySize.Packed64_UInt16,// EVEX_Vpmovusdw_xmmm64_k1z_xmm
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpmovusdw_xmmm128_k1z_ymm
			(byte)MemorySize.Packed256_UInt16,// EVEX_Vpmovusdw_ymmm256_k1z_zmm
			(byte)MemorySize.Packed128_Float32,// Blendvps_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vprorvd_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vprorvd_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vprorvd_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vprorvq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vprorvq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vprorvq_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.Packed32_UInt16,// EVEX_Vpmovusqw_xmmm32_k1z_xmm
			(byte)MemorySize.Packed64_UInt16,// EVEX_Vpmovusqw_xmmm64_k1z_ymm
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpmovusqw_xmmm128_k1z_zmm
			(byte)MemorySize.Packed128_Float64,// Blendvpd_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vprolvd_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vprolvd_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vprolvd_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vprolvq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vprolvq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vprolvq_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.Packed64_UInt32,// EVEX_Vpmovusqd_xmmm64_k1z_xmm
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vpmovusqd_xmmm128_k1z_ymm
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vpmovusqd_ymmm256_k1z_zmm
			(byte)MemorySize.Packed256_Float32,// VEX_Vpermps_ymm_ymm_ymmm256
			(byte)MemorySize.Packed256_Float32,// EVEX_Vpermps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vpermps_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed256_Float64,// EVEX_Vpermpd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vpermpd_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.UInt128,// Ptest_xmm_xmmm128
			(byte)MemorySize.UInt128,// VEX_Vptest_xmm_xmmm128
			(byte)MemorySize.UInt256,// VEX_Vptest_ymm_ymmm256
			(byte)MemorySize.Float32,// VEX_Vbroadcastss_xmm_m32
			(byte)MemorySize.Float32,// VEX_Vbroadcastss_ymm_m32
			(byte)MemorySize.Float32,// EVEX_Vbroadcastss_xmm_k1z_xmmm32
			(byte)MemorySize.Float32,// EVEX_Vbroadcastss_ymm_k1z_xmmm32
			(byte)MemorySize.Float32,// EVEX_Vbroadcastss_zmm_k1z_xmmm32
			(byte)MemorySize.Float64,// VEX_Vbroadcastsd_ymm_m64
			(byte)MemorySize.Packed64_Float32,// EVEX_Vbroadcastf32x2_ymm_k1z_xmmm64
			(byte)MemorySize.Packed64_Float32,// EVEX_Vbroadcastf32x2_zmm_k1z_xmmm64
			(byte)MemorySize.Float64,// EVEX_Vbroadcastsd_ymm_k1z_xmmm64
			(byte)MemorySize.Float64,// EVEX_Vbroadcastsd_zmm_k1z_xmmm64
			(byte)MemorySize.Float128,// VEX_Vbroadcastf128_ymm_m128
			(byte)MemorySize.Packed128_Float32,// EVEX_Vbroadcastf32x4_ymm_k1z_m128
			(byte)MemorySize.Packed128_Float32,// EVEX_Vbroadcastf32x4_zmm_k1z_m128
			(byte)MemorySize.Packed128_Float64,// EVEX_Vbroadcastf64x2_ymm_k1z_m128
			(byte)MemorySize.Packed128_Float64,// EVEX_Vbroadcastf64x2_zmm_k1z_m128
			(byte)MemorySize.Packed256_Float32,// EVEX_Vbroadcastf32x8_zmm_k1z_m256
			(byte)MemorySize.Packed256_Float64,// EVEX_Vbroadcastf64x4_zmm_k1z_m256
			(byte)MemorySize.Packed64_Int8,// Pabsb_mm_mmm64
			(byte)MemorySize.Packed128_Int8,// Pabsb_xmm_xmmm128
			(byte)MemorySize.Packed128_Int8,// VEX_Vpabsb_xmm_xmmm128
			(byte)MemorySize.Packed256_Int8,// VEX_Vpabsb_ymm_ymmm256
			(byte)MemorySize.Packed128_Int8,// EVEX_Vpabsb_xmm_k1z_xmmm128
			(byte)MemorySize.Packed256_Int8,// EVEX_Vpabsb_ymm_k1z_ymmm256
			(byte)MemorySize.Packed512_Int8,// EVEX_Vpabsb_zmm_k1z_zmmm512
			(byte)MemorySize.Packed64_Int16,// Pabsw_mm_mmm64
			(byte)MemorySize.Packed128_Int16,// Pabsw_xmm_xmmm128
			(byte)MemorySize.Packed128_Int16,// VEX_Vpabsw_xmm_xmmm128
			(byte)MemorySize.Packed256_Int16,// VEX_Vpabsw_ymm_ymmm256
			(byte)MemorySize.Packed128_Int16,// EVEX_Vpabsw_xmm_k1z_xmmm128
			(byte)MemorySize.Packed256_Int16,// EVEX_Vpabsw_ymm_k1z_ymmm256
			(byte)MemorySize.Packed512_Int16,// EVEX_Vpabsw_zmm_k1z_zmmm512
			(byte)MemorySize.Packed64_Int32,// Pabsd_mm_mmm64
			(byte)MemorySize.Packed128_Int32,// Pabsd_xmm_xmmm128
			(byte)MemorySize.Packed128_Int32,// VEX_Vpabsd_xmm_xmmm128
			(byte)MemorySize.Packed256_Int32,// VEX_Vpabsd_ymm_ymmm256
			(byte)MemorySize.Packed128_Int32,// EVEX_Vpabsd_xmm_k1z_xmmm128b32
			(byte)MemorySize.Packed256_Int32,// EVEX_Vpabsd_ymm_k1z_ymmm256b32
			(byte)MemorySize.Packed512_Int32,// EVEX_Vpabsd_zmm_k1z_zmmm512b32
			(byte)MemorySize.Packed128_Int64,// EVEX_Vpabsq_xmm_k1z_xmmm128b64
			(byte)MemorySize.Packed256_Int64,// EVEX_Vpabsq_ymm_k1z_ymmm256b64
			(byte)MemorySize.Packed512_Int64,// EVEX_Vpabsq_zmm_k1z_zmmm512b64
			(byte)MemorySize.Packed64_Int8,// Pmovsxbw_xmm_xmmm64
			(byte)MemorySize.Packed64_Int8,// VEX_Vpmovsxbw_xmm_xmmm64
			(byte)MemorySize.Packed128_Int8,// VEX_Vpmovsxbw_ymm_xmmm128
			(byte)MemorySize.Packed64_Int8,// EVEX_Vpmovsxbw_xmm_k1z_xmmm64
			(byte)MemorySize.Packed128_Int8,// EVEX_Vpmovsxbw_ymm_k1z_xmmm128
			(byte)MemorySize.Packed256_Int8,// EVEX_Vpmovsxbw_zmm_k1z_ymmm256
			(byte)MemorySize.Packed64_Int8,// EVEX_Vpmovswb_xmmm64_k1z_xmm
			(byte)MemorySize.Packed128_Int8,// EVEX_Vpmovswb_xmmm128_k1z_ymm
			(byte)MemorySize.Packed256_Int8,// EVEX_Vpmovswb_ymmm256_k1z_zmm
			(byte)MemorySize.Packed32_Int8,// Pmovsxbd_xmm_xmmm32
			(byte)MemorySize.Packed32_Int8,// VEX_Vpmovsxbd_xmm_xmmm32
			(byte)MemorySize.Packed64_Int8,// VEX_Vpmovsxbd_ymm_xmmm64
			(byte)MemorySize.Packed32_Int8,// EVEX_Vpmovsxbd_xmm_k1z_xmmm32
			(byte)MemorySize.Packed64_Int8,// EVEX_Vpmovsxbd_ymm_k1z_xmmm64
			(byte)MemorySize.Packed128_Int8,// EVEX_Vpmovsxbd_zmm_k1z_xmmm128
			(byte)MemorySize.Packed32_Int8,// EVEX_Vpmovsdb_xmmm32_k1z_xmm
			(byte)MemorySize.Packed64_Int8,// EVEX_Vpmovsdb_xmmm64_k1z_ymm
			(byte)MemorySize.Packed128_Int8,// EVEX_Vpmovsdb_xmmm128_k1z_zmm
			(byte)MemorySize.Packed16_Int8,// Pmovsxbq_xmm_xmmm16
			(byte)MemorySize.Packed16_Int8,// VEX_Vpmovsxbq_xmm_xmmm16
			(byte)MemorySize.Packed32_Int8,// VEX_Vpmovsxbq_ymm_xmmm32
			(byte)MemorySize.Packed16_Int8,// EVEX_Vpmovsxbq_xmm_k1z_xmmm16
			(byte)MemorySize.Packed32_Int8,// EVEX_Vpmovsxbq_ymm_k1z_xmmm32
			(byte)MemorySize.Packed64_Int8,// EVEX_Vpmovsxbq_zmm_k1z_xmmm64
			(byte)MemorySize.Packed16_Int8,// EVEX_Vpmovsqb_xmmm16_k1z_xmm
			(byte)MemorySize.Packed32_Int8,// EVEX_Vpmovsqb_xmmm32_k1z_ymm
			(byte)MemorySize.Packed64_Int8,// EVEX_Vpmovsqb_xmmm64_k1z_zmm
			(byte)MemorySize.Packed64_Int16,// Pmovsxwd_xmm_xmmm64
			(byte)MemorySize.Packed64_Int16,// VEX_Vpmovsxwd_xmm_xmmm64
			(byte)MemorySize.Packed128_Int16,// VEX_Vpmovsxwd_ymm_xmmm128
			(byte)MemorySize.Packed64_Int16,// EVEX_Vpmovsxwd_xmm_k1z_xmmm64
			(byte)MemorySize.Packed128_Int16,// EVEX_Vpmovsxwd_ymm_k1z_xmmm128
			(byte)MemorySize.Packed256_Int16,// EVEX_Vpmovsxwd_zmm_k1z_ymmm256
			(byte)MemorySize.Packed64_Int16,// EVEX_Vpmovsdw_xmmm64_k1z_xmm
			(byte)MemorySize.Packed128_Int16,// EVEX_Vpmovsdw_xmmm128_k1z_ymm
			(byte)MemorySize.Packed256_Int16,// EVEX_Vpmovsdw_ymmm256_k1z_zmm
			(byte)MemorySize.Packed32_Int16,// Pmovsxwq_xmm_xmmm32
			(byte)MemorySize.Packed32_Int16,// VEX_Vpmovsxwq_xmm_xmmm32
			(byte)MemorySize.Packed64_Int16,// VEX_Vpmovsxwq_ymm_xmmm64
			(byte)MemorySize.Packed32_Int16,// EVEX_Vpmovsxwq_xmm_k1z_xmmm32
			(byte)MemorySize.Packed64_Int16,// EVEX_Vpmovsxwq_ymm_k1z_xmmm64
			(byte)MemorySize.Packed128_Int16,// EVEX_Vpmovsxwq_zmm_k1z_xmmm128
			(byte)MemorySize.Packed32_Int16,// EVEX_Vpmovsqw_xmmm32_k1z_xmm
			(byte)MemorySize.Packed64_Int16,// EVEX_Vpmovsqw_xmmm64_k1z_ymm
			(byte)MemorySize.Packed128_Int16,// EVEX_Vpmovsqw_xmmm128_k1z_zmm
			(byte)MemorySize.Packed64_Int32,// Pmovsxdq_xmm_xmmm64
			(byte)MemorySize.Packed64_Int32,// VEX_Vpmovsxdq_xmm_xmmm64
			(byte)MemorySize.Packed128_Int32,// VEX_Vpmovsxdq_ymm_xmmm128
			(byte)MemorySize.Packed64_Int32,// EVEX_Vpmovsxdq_xmm_k1z_xmmm64
			(byte)MemorySize.Packed128_Int32,// EVEX_Vpmovsxdq_ymm_k1z_xmmm128
			(byte)MemorySize.Packed256_Int32,// EVEX_Vpmovsxdq_zmm_k1z_ymmm256
			(byte)MemorySize.Packed64_Int32,// EVEX_Vpmovsqd_xmmm64_k1z_xmm
			(byte)MemorySize.Packed128_Int32,// EVEX_Vpmovsqd_xmmm128_k1z_ymm
			(byte)MemorySize.Packed256_Int32,// EVEX_Vpmovsqd_ymmm256_k1z_zmm
			(byte)MemorySize.Packed128_UInt8,// EVEX_Vptestmb_kr_k1_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt8,// EVEX_Vptestmb_kr_k1_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt8,// EVEX_Vptestmb_kr_k1_zmm_zmmm512
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vptestmw_kr_k1_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt16,// EVEX_Vptestmw_kr_k1_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt16,// EVEX_Vptestmw_kr_k1_zmm_zmmm512
			(byte)MemorySize.Packed128_UInt8,// EVEX_Vptestnmb_kr_k1_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt8,// EVEX_Vptestnmb_kr_k1_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt8,// EVEX_Vptestnmb_kr_k1_zmm_zmmm512
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vptestnmw_kr_k1_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt16,// EVEX_Vptestnmw_kr_k1_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt16,// EVEX_Vptestnmw_kr_k1_zmm_zmmm512
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vptestmd_kr_k1_xmm_xmmm128b32
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vptestmd_kr_k1_ymm_ymmm256b32
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vptestmd_kr_k1_zmm_zmmm512b32
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vptestmq_kr_k1_xmm_xmmm128b64
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vptestmq_kr_k1_ymm_ymmm256b64
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vptestmq_kr_k1_zmm_zmmm512b64
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vptestnmd_kr_k1_xmm_xmmm128b32
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vptestnmd_kr_k1_ymm_ymmm256b32
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vptestnmd_kr_k1_zmm_zmmm512b32
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vptestnmq_kr_k1_xmm_xmmm128b64
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vptestnmq_kr_k1_ymm_ymmm256b64
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vptestnmq_kr_k1_zmm_zmmm512b64
			(byte)MemorySize.Packed128_Int32,// Pmuldq_xmm_xmmm128
			(byte)MemorySize.Packed128_Int32,// VEX_Vpmuldq_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Int32,// VEX_Vpmuldq_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Int32,// EVEX_Vpmuldq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_Int32,// EVEX_Vpmuldq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Int32,// EVEX_Vpmuldq_zmm_k1z_zmm_zmmm512b64
			0,// EVEX_Vpmovm2b_xmm_kr
			0,// EVEX_Vpmovm2b_ymm_kr
			0,// EVEX_Vpmovm2b_zmm_kr
			0,// EVEX_Vpmovm2w_xmm_kr
			0,// EVEX_Vpmovm2w_ymm_kr
			0,// EVEX_Vpmovm2w_zmm_kr
			(byte)MemorySize.Packed128_UInt64,// Pcmpeqq_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt64,// VEX_Vpcmpeqq_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt64,// VEX_Vpcmpeqq_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vpcmpeqq_kr_k1_xmm_xmmm128b64
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vpcmpeqq_kr_k1_ymm_ymmm256b64
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vpcmpeqq_kr_k1_zmm_zmmm512b64
			0,// EVEX_Vpmovb2m_kr_xmm
			0,// EVEX_Vpmovb2m_kr_ymm
			0,// EVEX_Vpmovb2m_kr_zmm
			0,// EVEX_Vpmovw2m_kr_xmm
			0,// EVEX_Vpmovw2m_kr_ymm
			0,// EVEX_Vpmovw2m_kr_zmm
			(byte)MemorySize.UInt128,// Movntdqa_xmm_m128
			(byte)MemorySize.UInt128,// VEX_Vmovntdqa_xmm_m128
			(byte)MemorySize.UInt256,// VEX_Vmovntdqa_ymm_m256
			(byte)MemorySize.UInt128,// EVEX_Vmovntdqa_xmm_m128
			(byte)MemorySize.UInt256,// EVEX_Vmovntdqa_ymm_m256
			(byte)MemorySize.UInt512,// EVEX_Vmovntdqa_zmm_m512
			0,// EVEX_Vpbroadcastmb2q_xmm_kr
			0,// EVEX_Vpbroadcastmb2q_ymm_kr
			0,// EVEX_Vpbroadcastmb2q_zmm_kr
			(byte)MemorySize.Packed128_Int32,// Packusdw_xmm_xmmm128
			(byte)MemorySize.Packed128_Int32,// VEX_Vpackusdw_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Int32,// VEX_Vpackusdw_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Int32,// EVEX_Vpackusdw_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Int32,// EVEX_Vpackusdw_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Int32,// EVEX_Vpackusdw_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed128_Float32,// VEX_Vmaskmovps_xmm_xmm_m128
			(byte)MemorySize.Packed256_Float32,// VEX_Vmaskmovps_ymm_ymm_m256
			(byte)MemorySize.Packed128_Float32,// EVEX_Vscalefps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vscalefps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vscalefps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Packed128_Float64,// EVEX_Vscalefpd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vscalefpd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vscalefpd_zmm_k1z_zmm_zmmm512b64_er
			(byte)MemorySize.Packed128_Float64,// VEX_Vmaskmovpd_xmm_xmm_m128
			(byte)MemorySize.Packed256_Float64,// VEX_Vmaskmovpd_ymm_ymm_m256
			(byte)MemorySize.Float32,// EVEX_Vscalefss_xmm_k1z_xmm_xmmm32_er
			(byte)MemorySize.Float64,// EVEX_Vscalefsd_xmm_k1z_xmm_xmmm64_er
			(byte)MemorySize.Packed128_Float32,// VEX_Vmaskmovps_m128_xmm_xmm
			(byte)MemorySize.Packed256_Float32,// VEX_Vmaskmovps_m256_ymm_ymm
			(byte)MemorySize.Packed128_Float64,// VEX_Vmaskmovpd_m128_xmm_xmm
			(byte)MemorySize.Packed256_Float64,// VEX_Vmaskmovpd_m256_ymm_ymm
			(byte)MemorySize.Packed64_UInt8,// Pmovzxbw_xmm_xmmm64
			(byte)MemorySize.Packed64_UInt8,// VEX_Vpmovzxbw_xmm_xmmm64
			(byte)MemorySize.Packed128_UInt8,// VEX_Vpmovzxbw_ymm_xmmm128
			(byte)MemorySize.Packed64_UInt8,// EVEX_Vpmovzxbw_xmm_k1z_xmmm64
			(byte)MemorySize.Packed128_UInt8,// EVEX_Vpmovzxbw_ymm_k1z_xmmm128
			(byte)MemorySize.Packed256_UInt8,// EVEX_Vpmovzxbw_zmm_k1z_ymmm256
			(byte)MemorySize.Packed64_UInt8,// EVEX_Vpmovwb_xmmm64_k1z_xmm
			(byte)MemorySize.Packed128_UInt8,// EVEX_Vpmovwb_xmmm128_k1z_ymm
			(byte)MemorySize.Packed256_UInt8,// EVEX_Vpmovwb_ymmm256_k1z_zmm
			(byte)MemorySize.Packed32_UInt8,// Pmovzxbd_xmm_xmmm32
			(byte)MemorySize.Packed32_UInt8,// VEX_Vpmovzxbd_xmm_xmmm32
			(byte)MemorySize.Packed64_UInt8,// VEX_Vpmovzxbd_ymm_xmmm64
			(byte)MemorySize.Packed32_UInt8,// EVEX_Vpmovzxbd_xmm_k1z_xmmm32
			(byte)MemorySize.Packed64_UInt8,// EVEX_Vpmovzxbd_ymm_k1z_xmmm64
			(byte)MemorySize.Packed128_UInt8,// EVEX_Vpmovzxbd_zmm_k1z_xmmm128
			(byte)MemorySize.Packed32_UInt8,// EVEX_Vpmovdb_xmmm32_k1z_xmm
			(byte)MemorySize.Packed64_UInt8,// EVEX_Vpmovdb_xmmm64_k1z_ymm
			(byte)MemorySize.Packed128_UInt8,// EVEX_Vpmovdb_xmmm128_k1z_zmm
			(byte)MemorySize.Packed16_UInt8,// Pmovzxbq_xmm_xmmm16
			(byte)MemorySize.Packed16_UInt8,// VEX_Vpmovzxbq_xmm_xmmm16
			(byte)MemorySize.Packed32_UInt8,// VEX_Vpmovzxbq_ymm_xmmm32
			(byte)MemorySize.Packed16_UInt8,// EVEX_Vpmovzxbq_xmm_k1z_xmmm16
			(byte)MemorySize.Packed32_UInt8,// EVEX_Vpmovzxbq_ymm_k1z_xmmm32
			(byte)MemorySize.Packed64_UInt8,// EVEX_Vpmovzxbq_zmm_k1z_xmmm64
			(byte)MemorySize.Packed16_UInt8,// EVEX_Vpmovqb_xmmm16_k1z_xmm
			(byte)MemorySize.Packed32_UInt8,// EVEX_Vpmovqb_xmmm32_k1z_ymm
			(byte)MemorySize.Packed64_UInt8,// EVEX_Vpmovqb_xmmm64_k1z_zmm
			(byte)MemorySize.Packed64_UInt16,// Pmovzxwd_xmm_xmmm64
			(byte)MemorySize.Packed64_UInt16,// VEX_Vpmovzxwd_xmm_xmmm64
			(byte)MemorySize.Packed128_UInt16,// VEX_Vpmovzxwd_ymm_xmmm128
			(byte)MemorySize.Packed64_UInt16,// EVEX_Vpmovzxwd_xmm_k1z_xmmm64
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpmovzxwd_ymm_k1z_xmmm128
			(byte)MemorySize.Packed256_UInt16,// EVEX_Vpmovzxwd_zmm_k1z_ymmm256
			(byte)MemorySize.Packed64_UInt16,// EVEX_Vpmovdw_xmmm64_k1z_xmm
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpmovdw_xmmm128_k1z_ymm
			(byte)MemorySize.Packed256_UInt16,// EVEX_Vpmovdw_ymmm256_k1z_zmm
			(byte)MemorySize.Packed32_UInt16,// Pmovzxwq_xmm_xmmm32
			(byte)MemorySize.Packed32_UInt16,// VEX_Vpmovzxwq_xmm_xmmm32
			(byte)MemorySize.Packed64_UInt16,// VEX_Vpmovzxwq_ymm_xmmm64
			(byte)MemorySize.Packed32_UInt16,// EVEX_Vpmovzxwq_xmm_k1z_xmmm32
			(byte)MemorySize.Packed64_UInt16,// EVEX_Vpmovzxwq_ymm_k1z_xmmm64
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpmovzxwq_zmm_k1z_xmmm128
			(byte)MemorySize.Packed32_UInt16,// EVEX_Vpmovqw_xmmm32_k1z_xmm
			(byte)MemorySize.Packed64_UInt16,// EVEX_Vpmovqw_xmmm64_k1z_ymm
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpmovqw_xmmm128_k1z_zmm
			(byte)MemorySize.Packed64_UInt32,// Pmovzxdq_xmm_xmmm64
			(byte)MemorySize.Packed64_UInt32,// VEX_Vpmovzxdq_xmm_xmmm64
			(byte)MemorySize.Packed128_UInt32,// VEX_Vpmovzxdq_ymm_xmmm128
			(byte)MemorySize.Packed64_UInt32,// EVEX_Vpmovzxdq_xmm_k1z_xmmm64
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vpmovzxdq_ymm_k1z_xmmm128
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vpmovzxdq_zmm_k1z_ymmm256
			(byte)MemorySize.Packed64_UInt32,// EVEX_Vpmovqd_xmmm64_k1z_xmm
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vpmovqd_xmmm128_k1z_ymm
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vpmovqd_ymmm256_k1z_zmm
			(byte)MemorySize.Packed256_UInt32,// VEX_Vpermd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vpermd_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vpermd_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vpermq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vpermq_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.Packed128_Int64,// Pcmpgtq_xmm_xmmm128
			(byte)MemorySize.Packed128_Int64,// VEX_Vpcmpgtq_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Int64,// VEX_Vpcmpgtq_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Int64,// EVEX_Vpcmpgtq_kr_k1_xmm_xmmm128b64
			(byte)MemorySize.Packed256_Int64,// EVEX_Vpcmpgtq_kr_k1_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Int64,// EVEX_Vpcmpgtq_kr_k1_zmm_zmmm512b64
			(byte)MemorySize.Packed128_Int8,// Pminsb_xmm_xmmm128
			(byte)MemorySize.Packed128_Int8,// VEX_Vpminsb_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Int8,// VEX_Vpminsb_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Int8,// EVEX_Vpminsb_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_Int8,// EVEX_Vpminsb_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_Int8,// EVEX_Vpminsb_zmm_k1z_zmm_zmmm512
			0,// EVEX_Vpmovm2d_xmm_kr
			0,// EVEX_Vpmovm2d_ymm_kr
			0,// EVEX_Vpmovm2d_zmm_kr
			0,// EVEX_Vpmovm2q_xmm_kr
			0,// EVEX_Vpmovm2q_ymm_kr
			0,// EVEX_Vpmovm2q_zmm_kr
			(byte)MemorySize.Packed128_Int32,// Pminsd_xmm_xmmm128
			(byte)MemorySize.Packed128_Int32,// VEX_Vpminsd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Int32,// VEX_Vpminsd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Int32,// EVEX_Vpminsd_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Int32,// EVEX_Vpminsd_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Int32,// EVEX_Vpminsd_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed128_Int64,// EVEX_Vpminsq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_Int64,// EVEX_Vpminsq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Int64,// EVEX_Vpminsq_zmm_k1z_zmm_zmmm512b64
			0,// EVEX_Vpmovd2m_kr_xmm
			0,// EVEX_Vpmovd2m_kr_ymm
			0,// EVEX_Vpmovd2m_kr_zmm
			0,// EVEX_Vpmovq2m_kr_xmm
			0,// EVEX_Vpmovq2m_kr_ymm
			0,// EVEX_Vpmovq2m_kr_zmm
			(byte)MemorySize.Packed128_UInt16,// Pminuw_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt16,// VEX_Vpminuw_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt16,// VEX_Vpminuw_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpminuw_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt16,// EVEX_Vpminuw_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt16,// EVEX_Vpminuw_zmm_k1z_zmm_zmmm512
			0,// EVEX_Vpbroadcastmw2d_xmm_kr
			0,// EVEX_Vpbroadcastmw2d_ymm_kr
			0,// EVEX_Vpbroadcastmw2d_zmm_kr
			(byte)MemorySize.Packed128_UInt32,// Pminud_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt32,// VEX_Vpminud_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt32,// VEX_Vpminud_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vpminud_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vpminud_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vpminud_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vpminuq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vpminuq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vpminuq_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.Packed128_Int8,// Pmaxsb_xmm_xmmm128
			(byte)MemorySize.Packed128_Int8,// VEX_Vpmaxsb_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Int8,// VEX_Vpmaxsb_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Int8,// EVEX_Vpmaxsb_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_Int8,// EVEX_Vpmaxsb_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_Int8,// EVEX_Vpmaxsb_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Packed128_Int32,// Pmaxsd_xmm_xmmm128
			(byte)MemorySize.Packed128_Int32,// VEX_Vpmaxsd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Int32,// VEX_Vpmaxsd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Int32,// EVEX_Vpmaxsd_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Int32,// EVEX_Vpmaxsd_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Int32,// EVEX_Vpmaxsd_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed128_Int64,// EVEX_Vpmaxsq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_Int64,// EVEX_Vpmaxsq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Int64,// EVEX_Vpmaxsq_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.Packed128_UInt16,// Pmaxuw_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt16,// VEX_Vpmaxuw_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt16,// VEX_Vpmaxuw_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpmaxuw_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt16,// EVEX_Vpmaxuw_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt16,// EVEX_Vpmaxuw_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Packed128_UInt32,// Pmaxud_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt32,// VEX_Vpmaxud_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt32,// VEX_Vpmaxud_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vpmaxud_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vpmaxud_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vpmaxud_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vpmaxuq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vpmaxuq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vpmaxuq_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.Packed128_Int32,// Pmulld_xmm_xmmm128
			(byte)MemorySize.Packed128_Int32,// VEX_Vpmulld_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Int32,// VEX_Vpmulld_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Int32,// EVEX_Vpmulld_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Int32,// EVEX_Vpmulld_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Int32,// EVEX_Vpmulld_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed128_Int64,// EVEX_Vpmullq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_Int64,// EVEX_Vpmullq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Int64,// EVEX_Vpmullq_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.Packed128_UInt16,// Phminposuw_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt16,// VEX_Vphminposuw_xmm_xmmm128
			(byte)MemorySize.Packed128_Float32,// EVEX_Vgetexpps_xmm_k1z_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vgetexpps_ymm_k1z_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vgetexpps_zmm_k1z_zmmm512b32_sae
			(byte)MemorySize.Packed128_Float64,// EVEX_Vgetexppd_xmm_k1z_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vgetexppd_ymm_k1z_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vgetexppd_zmm_k1z_zmmm512b64_sae
			(byte)MemorySize.Float32,// EVEX_Vgetexpss_xmm_k1z_xmm_xmmm32_sae
			(byte)MemorySize.Float64,// EVEX_Vgetexpsd_xmm_k1z_xmm_xmmm64_sae
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vplzcntd_xmm_k1z_xmmm128b32
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vplzcntd_ymm_k1z_ymmm256b32
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vplzcntd_zmm_k1z_zmmm512b32
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vplzcntq_xmm_k1z_xmmm128b64
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vplzcntq_ymm_k1z_ymmm256b64
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vplzcntq_zmm_k1z_zmmm512b64
			(byte)MemorySize.Packed128_UInt32,// VEX_Vpsrlvd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt32,// VEX_Vpsrlvd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt64,// VEX_Vpsrlvq_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt64,// VEX_Vpsrlvq_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vpsrlvd_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vpsrlvd_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vpsrlvd_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vpsrlvq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vpsrlvq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vpsrlvq_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.Packed128_UInt32,// VEX_Vpsravd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt32,// VEX_Vpsravd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vpsravd_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vpsravd_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vpsravd_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vpsravq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vpsravq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vpsravq_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.Packed128_UInt32,// VEX_Vpsllvd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt32,// VEX_Vpsllvd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt64,// VEX_Vpsllvq_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt64,// VEX_Vpsllvq_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vpsllvd_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vpsllvd_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vpsllvd_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vpsllvq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vpsllvq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vpsllvq_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.Packed128_Float32,// EVEX_Vrcp14ps_xmm_k1z_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vrcp14ps_ymm_k1z_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vrcp14ps_zmm_k1z_zmmm512b32
			(byte)MemorySize.Packed128_Float64,// EVEX_Vrcp14pd_xmm_k1z_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vrcp14pd_ymm_k1z_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vrcp14pd_zmm_k1z_zmmm512b64
			(byte)MemorySize.Float32,// EVEX_Vrcp14ss_xmm_k1z_xmm_xmmm32
			(byte)MemorySize.Float64,// EVEX_Vrcp14sd_xmm_k1z_xmm_xmmm64
			(byte)MemorySize.Packed128_Float32,// EVEX_Vrsqrt14ps_xmm_k1z_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vrsqrt14ps_ymm_k1z_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vrsqrt14ps_zmm_k1z_zmmm512b32
			(byte)MemorySize.Packed128_Float64,// EVEX_Vrsqrt14pd_xmm_k1z_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vrsqrt14pd_ymm_k1z_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vrsqrt14pd_zmm_k1z_zmmm512b64
			(byte)MemorySize.Float32,// EVEX_Vrsqrt14ss_xmm_k1z_xmm_xmmm32
			(byte)MemorySize.Float64,// EVEX_Vrsqrt14sd_xmm_k1z_xmm_xmmm64
			(byte)MemorySize.Packed128_Int8,// EVEX_Vpdpbusd_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Int8,// EVEX_Vpdpbusd_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Int8,// EVEX_Vpdpbusd_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed128_Int8,// EVEX_Vpdpbusds_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Int8,// EVEX_Vpdpbusds_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Int8,// EVEX_Vpdpbusds_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed128_Int16,// EVEX_Vpdpwssd_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Int16,// EVEX_Vpdpwssd_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Int16,// EVEX_Vpdpwssd_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed128_2xBFloat16,// EVEX_Vdpbf16ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_2xBFloat16,// EVEX_Vdpbf16ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_2xBFloat16,// EVEX_Vdpbf16ps_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed128_Int16,// EVEX_Vp4dpwssd_zmm_k1z_zmmp3_m128
			(byte)MemorySize.Packed128_Int16,// EVEX_Vpdpwssds_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Int16,// EVEX_Vpdpwssds_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Int16,// EVEX_Vpdpwssds_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed128_Int16,// EVEX_Vp4dpwssds_zmm_k1z_zmmp3_m128
			(byte)MemorySize.Packed128_UInt8,// EVEX_Vpopcntb_xmm_k1z_xmmm128
			(byte)MemorySize.Packed256_UInt8,// EVEX_Vpopcntb_ymm_k1z_ymmm256
			(byte)MemorySize.Packed512_UInt8,// EVEX_Vpopcntb_zmm_k1z_zmmm512
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpopcntw_xmm_k1z_xmmm128
			(byte)MemorySize.Packed256_UInt16,// EVEX_Vpopcntw_ymm_k1z_ymmm256
			(byte)MemorySize.Packed512_UInt16,// EVEX_Vpopcntw_zmm_k1z_zmmm512
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vpopcntd_xmm_k1z_xmmm128b32
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vpopcntd_ymm_k1z_ymmm256b32
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vpopcntd_zmm_k1z_zmmm512b32
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vpopcntq_xmm_k1z_xmmm128b64
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vpopcntq_ymm_k1z_ymmm256b64
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vpopcntq_zmm_k1z_zmmm512b64
			(byte)MemorySize.Int32,// VEX_Vpbroadcastd_xmm_xmmm32
			(byte)MemorySize.Int32,// VEX_Vpbroadcastd_ymm_xmmm32
			(byte)MemorySize.Int32,// EVEX_Vpbroadcastd_xmm_k1z_xmmm32
			(byte)MemorySize.Int32,// EVEX_Vpbroadcastd_ymm_k1z_xmmm32
			(byte)MemorySize.Int32,// EVEX_Vpbroadcastd_zmm_k1z_xmmm32
			(byte)MemorySize.Int64,// VEX_Vpbroadcastq_xmm_xmmm64
			(byte)MemorySize.Int64,// VEX_Vpbroadcastq_ymm_xmmm64
			(byte)MemorySize.Packed64_UInt32,// EVEX_Vbroadcasti32x2_xmm_k1z_xmmm64
			(byte)MemorySize.Packed64_UInt32,// EVEX_Vbroadcasti32x2_ymm_k1z_xmmm64
			(byte)MemorySize.Packed64_UInt32,// EVEX_Vbroadcasti32x2_zmm_k1z_xmmm64
			(byte)MemorySize.Int64,// EVEX_Vpbroadcastq_xmm_k1z_xmmm64
			(byte)MemorySize.Int64,// EVEX_Vpbroadcastq_ymm_k1z_xmmm64
			(byte)MemorySize.Int64,// EVEX_Vpbroadcastq_zmm_k1z_xmmm64
			(byte)MemorySize.Int128,// VEX_Vbroadcasti128_ymm_m128
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vbroadcasti32x4_ymm_k1z_m128
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vbroadcasti32x4_zmm_k1z_m128
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vbroadcasti64x2_ymm_k1z_m128
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vbroadcasti64x2_zmm_k1z_m128
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vbroadcasti32x8_zmm_k1z_m256
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vbroadcasti64x4_zmm_k1z_m256
			(byte)MemorySize.Packed128_UInt8,// EVEX_Vpexpandb_xmm_k1z_xmmm128
			(byte)MemorySize.Packed256_UInt8,// EVEX_Vpexpandb_ymm_k1z_ymmm256
			(byte)MemorySize.Packed512_UInt8,// EVEX_Vpexpandb_zmm_k1z_zmmm512
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpexpandw_xmm_k1z_xmmm128
			(byte)MemorySize.Packed256_UInt16,// EVEX_Vpexpandw_ymm_k1z_ymmm256
			(byte)MemorySize.Packed512_UInt16,// EVEX_Vpexpandw_zmm_k1z_zmmm512
			(byte)MemorySize.Packed128_UInt8,// EVEX_Vpcompressb_xmmm128_k1z_xmm
			(byte)MemorySize.Packed256_UInt8,// EVEX_Vpcompressb_ymmm256_k1z_ymm
			(byte)MemorySize.Packed512_UInt8,// EVEX_Vpcompressb_zmmm512_k1z_zmm
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpcompressw_xmmm128_k1z_xmm
			(byte)MemorySize.Packed256_UInt16,// EVEX_Vpcompressw_ymmm256_k1z_ymm
			(byte)MemorySize.Packed512_UInt16,// EVEX_Vpcompressw_zmmm512_k1z_zmm
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vpblendmd_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vpblendmd_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vpblendmd_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vpblendmq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vpblendmq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vpblendmq_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.Packed128_Float32,// EVEX_Vblendmps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vblendmps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vblendmps_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed128_Float64,// EVEX_Vblendmpd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vblendmpd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vblendmpd_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.Packed128_UInt8,// EVEX_Vpblendmb_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt8,// EVEX_Vpblendmb_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt8,// EVEX_Vpblendmb_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpblendmw_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt16,// EVEX_Vpblendmw_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt16,// EVEX_Vpblendmw_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vp2intersectd_kp1_xmm_xmmm128b32
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vp2intersectd_kp1_ymm_ymmm256b32
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vp2intersectd_kp1_zmm_zmmm512b32
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vp2intersectq_kp1_xmm_xmmm128b64
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vp2intersectq_kp1_ymm_ymmm256b64
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vp2intersectq_kp1_zmm_zmmm512b64
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpshldvw_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt16,// EVEX_Vpshldvw_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt16,// EVEX_Vpshldvw_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vpshldvd_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vpshldvd_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vpshldvd_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vpshldvq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vpshldvq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vpshldvq_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpshrdvw_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt16,// EVEX_Vpshrdvw_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt16,// EVEX_Vpshrdvw_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Packed128_Float32,// EVEX_Vcvtneps2bf16_xmm_k1z_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vcvtneps2bf16_xmm_k1z_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vcvtneps2bf16_ymm_k1z_zmmm512b32
			(byte)MemorySize.Packed128_Float32,// EVEX_Vcvtne2ps2bf16_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vcvtne2ps2bf16_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vcvtne2ps2bf16_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vpshrdvd_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vpshrdvd_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vpshrdvd_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vpshrdvq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vpshrdvq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vpshrdvq_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.Packed128_UInt8,// EVEX_Vpermi2b_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt8,// EVEX_Vpermi2b_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt8,// EVEX_Vpermi2b_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpermi2w_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt16,// EVEX_Vpermi2w_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt16,// EVEX_Vpermi2w_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vpermi2d_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vpermi2d_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vpermi2d_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vpermi2q_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vpermi2q_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vpermi2q_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.Packed128_Float32,// EVEX_Vpermi2ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vpermi2ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vpermi2ps_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed128_Float64,// EVEX_Vpermi2pd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vpermi2pd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vpermi2pd_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.Int8,// VEX_Vpbroadcastb_xmm_xmmm8
			(byte)MemorySize.Int8,// VEX_Vpbroadcastb_ymm_xmmm8
			(byte)MemorySize.Int8,// EVEX_Vpbroadcastb_xmm_k1z_xmmm8
			(byte)MemorySize.Int8,// EVEX_Vpbroadcastb_ymm_k1z_xmmm8
			(byte)MemorySize.Int8,// EVEX_Vpbroadcastb_zmm_k1z_xmmm8
			(byte)MemorySize.Int16,// VEX_Vpbroadcastw_xmm_xmmm16
			(byte)MemorySize.Int16,// VEX_Vpbroadcastw_ymm_xmmm16
			(byte)MemorySize.Int16,// EVEX_Vpbroadcastw_xmm_k1z_xmmm16
			(byte)MemorySize.Int16,// EVEX_Vpbroadcastw_ymm_k1z_xmmm16
			(byte)MemorySize.Int16,// EVEX_Vpbroadcastw_zmm_k1z_xmmm16
			0,// EVEX_Vpbroadcastb_xmm_k1z_r32
			0,// EVEX_Vpbroadcastb_ymm_k1z_r32
			0,// EVEX_Vpbroadcastb_zmm_k1z_r32
			0,// EVEX_Vpbroadcastw_xmm_k1z_r32
			0,// EVEX_Vpbroadcastw_ymm_k1z_r32
			0,// EVEX_Vpbroadcastw_zmm_k1z_r32
			0,// EVEX_Vpbroadcastd_xmm_k1z_r32
			0,// EVEX_Vpbroadcastd_ymm_k1z_r32
			0,// EVEX_Vpbroadcastd_zmm_k1z_r32
			0,// EVEX_Vpbroadcastq_xmm_k1z_r64
			0,// EVEX_Vpbroadcastq_ymm_k1z_r64
			0,// EVEX_Vpbroadcastq_zmm_k1z_r64
			(byte)MemorySize.Packed128_UInt8,// EVEX_Vpermt2b_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt8,// EVEX_Vpermt2b_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt8,// EVEX_Vpermt2b_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpermt2w_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt16,// EVEX_Vpermt2w_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt16,// EVEX_Vpermt2w_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vpermt2d_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vpermt2d_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vpermt2d_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vpermt2q_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vpermt2q_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vpermt2q_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.Packed128_Float32,// EVEX_Vpermt2ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vpermt2ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vpermt2ps_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Packed128_Float64,// EVEX_Vpermt2pd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vpermt2pd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vpermt2pd_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.UInt128,// Invept_r32_m128
			(byte)MemorySize.UInt128,// Invept_r64_m128
			(byte)MemorySize.UInt128,// Invvpid_r32_m128
			(byte)MemorySize.UInt128,// Invvpid_r64_m128
			(byte)MemorySize.UInt128,// Invpcid_r32_m128
			(byte)MemorySize.UInt128,// Invpcid_r64_m128
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vpmultishiftqb_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vpmultishiftqb_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vpmultishiftqb_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.Packed128_Float32,// EVEX_Vexpandps_xmm_k1z_xmmm128
			(byte)MemorySize.Packed256_Float32,// EVEX_Vexpandps_ymm_k1z_ymmm256
			(byte)MemorySize.Packed512_Float32,// EVEX_Vexpandps_zmm_k1z_zmmm512
			(byte)MemorySize.Packed128_Float64,// EVEX_Vexpandpd_xmm_k1z_xmmm128
			(byte)MemorySize.Packed256_Float64,// EVEX_Vexpandpd_ymm_k1z_ymmm256
			(byte)MemorySize.Packed512_Float64,// EVEX_Vexpandpd_zmm_k1z_zmmm512
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vpexpandd_xmm_k1z_xmmm128
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vpexpandd_ymm_k1z_ymmm256
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vpexpandd_zmm_k1z_zmmm512
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vpexpandq_xmm_k1z_xmmm128
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vpexpandq_ymm_k1z_ymmm256
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vpexpandq_zmm_k1z_zmmm512
			(byte)MemorySize.Packed128_Float32,// EVEX_Vcompressps_xmmm128_k1z_xmm
			(byte)MemorySize.Packed256_Float32,// EVEX_Vcompressps_ymmm256_k1z_ymm
			(byte)MemorySize.Packed512_Float32,// EVEX_Vcompressps_zmmm512_k1z_zmm
			(byte)MemorySize.Packed128_Float64,// EVEX_Vcompresspd_xmmm128_k1z_xmm
			(byte)MemorySize.Packed256_Float64,// EVEX_Vcompresspd_ymmm256_k1z_ymm
			(byte)MemorySize.Packed512_Float64,// EVEX_Vcompresspd_zmmm512_k1z_zmm
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vpcompressd_xmmm128_k1z_xmm
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vpcompressd_ymmm256_k1z_ymm
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vpcompressd_zmmm512_k1z_zmm
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vpcompressq_xmmm128_k1z_xmm
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vpcompressq_ymmm256_k1z_ymm
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vpcompressq_zmmm512_k1z_zmm
			(byte)MemorySize.Packed128_UInt32,// VEX_Vpmaskmovd_xmm_xmm_m128
			(byte)MemorySize.Packed256_UInt32,// VEX_Vpmaskmovd_ymm_ymm_m256
			(byte)MemorySize.Packed128_UInt64,// VEX_Vpmaskmovq_xmm_xmm_m128
			(byte)MemorySize.Packed256_UInt64,// VEX_Vpmaskmovq_ymm_ymm_m256
			(byte)MemorySize.Packed128_UInt8,// EVEX_Vpermb_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt8,// EVEX_Vpermb_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt8,// EVEX_Vpermb_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpermw_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt16,// EVEX_Vpermw_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt16,// EVEX_Vpermw_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Packed128_UInt32,// VEX_Vpmaskmovd_m128_xmm_xmm
			(byte)MemorySize.Packed256_UInt32,// VEX_Vpmaskmovd_m256_ymm_ymm
			(byte)MemorySize.Packed128_UInt64,// VEX_Vpmaskmovq_m128_xmm_xmm
			(byte)MemorySize.Packed256_UInt64,// VEX_Vpmaskmovq_m256_ymm_ymm
			(byte)MemorySize.Packed128_UInt8,// EVEX_Vpshufbitqmb_kr_k1_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt8,// EVEX_Vpshufbitqmb_kr_k1_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt8,// EVEX_Vpshufbitqmb_kr_k1_zmm_zmmm512
			(byte)MemorySize.Int32,// VEX_Vpgatherdd_xmm_vm32x_xmm
			(byte)MemorySize.Int32,// VEX_Vpgatherdd_ymm_vm32y_ymm
			(byte)MemorySize.Int64,// VEX_Vpgatherdq_xmm_vm32x_xmm
			(byte)MemorySize.Int64,// VEX_Vpgatherdq_ymm_vm32x_ymm
			(byte)MemorySize.Int32,// EVEX_Vpgatherdd_xmm_k1_vm32x
			(byte)MemorySize.Int32,// EVEX_Vpgatherdd_ymm_k1_vm32y
			(byte)MemorySize.Int32,// EVEX_Vpgatherdd_zmm_k1_vm32z
			(byte)MemorySize.Int64,// EVEX_Vpgatherdq_xmm_k1_vm32x
			(byte)MemorySize.Int64,// EVEX_Vpgatherdq_ymm_k1_vm32x
			(byte)MemorySize.Int64,// EVEX_Vpgatherdq_zmm_k1_vm32y
			(byte)MemorySize.Int32,// VEX_Vpgatherqd_xmm_vm64x_xmm
			(byte)MemorySize.Int32,// VEX_Vpgatherqd_xmm_vm64y_xmm
			(byte)MemorySize.Int64,// VEX_Vpgatherqq_xmm_vm64x_xmm
			(byte)MemorySize.Int64,// VEX_Vpgatherqq_ymm_vm64y_ymm
			(byte)MemorySize.Int32,// EVEX_Vpgatherqd_xmm_k1_vm64x
			(byte)MemorySize.Int32,// EVEX_Vpgatherqd_xmm_k1_vm64y
			(byte)MemorySize.Int32,// EVEX_Vpgatherqd_ymm_k1_vm64z
			(byte)MemorySize.Int64,// EVEX_Vpgatherqq_xmm_k1_vm64x
			(byte)MemorySize.Int64,// EVEX_Vpgatherqq_ymm_k1_vm64y
			(byte)MemorySize.Int64,// EVEX_Vpgatherqq_zmm_k1_vm64z
			(byte)MemorySize.Float32,// VEX_Vgatherdps_xmm_vm32x_xmm
			(byte)MemorySize.Float32,// VEX_Vgatherdps_ymm_vm32y_ymm
			(byte)MemorySize.Float64,// VEX_Vgatherdpd_xmm_vm32x_xmm
			(byte)MemorySize.Float64,// VEX_Vgatherdpd_ymm_vm32x_ymm
			(byte)MemorySize.Float32,// EVEX_Vgatherdps_xmm_k1_vm32x
			(byte)MemorySize.Float32,// EVEX_Vgatherdps_ymm_k1_vm32y
			(byte)MemorySize.Float32,// EVEX_Vgatherdps_zmm_k1_vm32z
			(byte)MemorySize.Float64,// EVEX_Vgatherdpd_xmm_k1_vm32x
			(byte)MemorySize.Float64,// EVEX_Vgatherdpd_ymm_k1_vm32x
			(byte)MemorySize.Float64,// EVEX_Vgatherdpd_zmm_k1_vm32y
			(byte)MemorySize.Float32,// VEX_Vgatherqps_xmm_vm64x_xmm
			(byte)MemorySize.Float32,// VEX_Vgatherqps_xmm_vm64y_xmm
			(byte)MemorySize.Float64,// VEX_Vgatherqpd_xmm_vm64x_xmm
			(byte)MemorySize.Float64,// VEX_Vgatherqpd_ymm_vm64y_ymm
			(byte)MemorySize.Float32,// EVEX_Vgatherqps_xmm_k1_vm64x
			(byte)MemorySize.Float32,// EVEX_Vgatherqps_xmm_k1_vm64y
			(byte)MemorySize.Float32,// EVEX_Vgatherqps_ymm_k1_vm64z
			(byte)MemorySize.Float64,// EVEX_Vgatherqpd_xmm_k1_vm64x
			(byte)MemorySize.Float64,// EVEX_Vgatherqpd_ymm_k1_vm64y
			(byte)MemorySize.Float64,// EVEX_Vgatherqpd_zmm_k1_vm64z
			(byte)MemorySize.Packed128_Float32,// VEX_Vfmaddsub132ps_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vfmaddsub132ps_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// VEX_Vfmaddsub132pd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vfmaddsub132pd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// EVEX_Vfmaddsub132ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vfmaddsub132ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vfmaddsub132ps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Packed128_Float64,// EVEX_Vfmaddsub132pd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vfmaddsub132pd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vfmaddsub132pd_zmm_k1z_zmm_zmmm512b64_er
			(byte)MemorySize.Packed128_Float32,// VEX_Vfmsubadd132ps_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vfmsubadd132ps_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// VEX_Vfmsubadd132pd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vfmsubadd132pd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// EVEX_Vfmsubadd132ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vfmsubadd132ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vfmsubadd132ps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Packed128_Float64,// EVEX_Vfmsubadd132pd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vfmsubadd132pd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vfmsubadd132pd_zmm_k1z_zmm_zmmm512b64_er
			(byte)MemorySize.Packed128_Float32,// VEX_Vfmadd132ps_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vfmadd132ps_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// VEX_Vfmadd132pd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vfmadd132pd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// EVEX_Vfmadd132ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vfmadd132ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vfmadd132ps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Packed128_Float64,// EVEX_Vfmadd132pd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vfmadd132pd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vfmadd132pd_zmm_k1z_zmm_zmmm512b64_er
			(byte)MemorySize.Float32,// VEX_Vfmadd132ss_xmm_xmm_xmmm32
			(byte)MemorySize.Float64,// VEX_Vfmadd132sd_xmm_xmm_xmmm64
			(byte)MemorySize.Float32,// EVEX_Vfmadd132ss_xmm_k1z_xmm_xmmm32_er
			(byte)MemorySize.Float64,// EVEX_Vfmadd132sd_xmm_k1z_xmm_xmmm64_er
			(byte)MemorySize.Packed128_Float32,// VEX_Vfmsub132ps_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vfmsub132ps_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// VEX_Vfmsub132pd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vfmsub132pd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// EVEX_Vfmsub132ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vfmsub132ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vfmsub132ps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Packed128_Float64,// EVEX_Vfmsub132pd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vfmsub132pd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vfmsub132pd_zmm_k1z_zmm_zmmm512b64_er
			(byte)MemorySize.Packed128_Float32,// EVEX_V4fmaddps_zmm_k1z_zmmp3_m128
			(byte)MemorySize.Float32,// VEX_Vfmsub132ss_xmm_xmm_xmmm32
			(byte)MemorySize.Float64,// VEX_Vfmsub132sd_xmm_xmm_xmmm64
			(byte)MemorySize.Float32,// EVEX_Vfmsub132ss_xmm_k1z_xmm_xmmm32_er
			(byte)MemorySize.Float64,// EVEX_Vfmsub132sd_xmm_k1z_xmm_xmmm64_er
			(byte)MemorySize.Packed128_Float32,// EVEX_V4fmaddss_xmm_k1z_xmmp3_m128
			(byte)MemorySize.Packed128_Float32,// VEX_Vfnmadd132ps_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vfnmadd132ps_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// VEX_Vfnmadd132pd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vfnmadd132pd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// EVEX_Vfnmadd132ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vfnmadd132ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vfnmadd132ps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Packed128_Float64,// EVEX_Vfnmadd132pd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vfnmadd132pd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vfnmadd132pd_zmm_k1z_zmm_zmmm512b64_er
			(byte)MemorySize.Float32,// VEX_Vfnmadd132ss_xmm_xmm_xmmm32
			(byte)MemorySize.Float64,// VEX_Vfnmadd132sd_xmm_xmm_xmmm64
			(byte)MemorySize.Float32,// EVEX_Vfnmadd132ss_xmm_k1z_xmm_xmmm32_er
			(byte)MemorySize.Float64,// EVEX_Vfnmadd132sd_xmm_k1z_xmm_xmmm64_er
			(byte)MemorySize.Packed128_Float32,// VEX_Vfnmsub132ps_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vfnmsub132ps_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// VEX_Vfnmsub132pd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vfnmsub132pd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// EVEX_Vfnmsub132ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vfnmsub132ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vfnmsub132ps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Packed128_Float64,// EVEX_Vfnmsub132pd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vfnmsub132pd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vfnmsub132pd_zmm_k1z_zmm_zmmm512b64_er
			(byte)MemorySize.Float32,// VEX_Vfnmsub132ss_xmm_xmm_xmmm32
			(byte)MemorySize.Float64,// VEX_Vfnmsub132sd_xmm_xmm_xmmm64
			(byte)MemorySize.Float32,// EVEX_Vfnmsub132ss_xmm_k1z_xmm_xmmm32_er
			(byte)MemorySize.Float64,// EVEX_Vfnmsub132sd_xmm_k1z_xmm_xmmm64_er
			(byte)MemorySize.Int32,// EVEX_Vpscatterdd_vm32x_k1_xmm
			(byte)MemorySize.Int32,// EVEX_Vpscatterdd_vm32y_k1_ymm
			(byte)MemorySize.Int32,// EVEX_Vpscatterdd_vm32z_k1_zmm
			(byte)MemorySize.Int64,// EVEX_Vpscatterdq_vm32x_k1_xmm
			(byte)MemorySize.Int64,// EVEX_Vpscatterdq_vm32x_k1_ymm
			(byte)MemorySize.Int64,// EVEX_Vpscatterdq_vm32y_k1_zmm
			(byte)MemorySize.Int32,// EVEX_Vpscatterqd_vm64x_k1_xmm
			(byte)MemorySize.Int32,// EVEX_Vpscatterqd_vm64y_k1_xmm
			(byte)MemorySize.Int32,// EVEX_Vpscatterqd_vm64z_k1_ymm
			(byte)MemorySize.Int64,// EVEX_Vpscatterqq_vm64x_k1_xmm
			(byte)MemorySize.Int64,// EVEX_Vpscatterqq_vm64y_k1_ymm
			(byte)MemorySize.Int64,// EVEX_Vpscatterqq_vm64z_k1_zmm
			(byte)MemorySize.Float32,// EVEX_Vscatterdps_vm32x_k1_xmm
			(byte)MemorySize.Float32,// EVEX_Vscatterdps_vm32y_k1_ymm
			(byte)MemorySize.Float32,// EVEX_Vscatterdps_vm32z_k1_zmm
			(byte)MemorySize.Float64,// EVEX_Vscatterdpd_vm32x_k1_xmm
			(byte)MemorySize.Float64,// EVEX_Vscatterdpd_vm32x_k1_ymm
			(byte)MemorySize.Float64,// EVEX_Vscatterdpd_vm32y_k1_zmm
			(byte)MemorySize.Float32,// EVEX_Vscatterqps_vm64x_k1_xmm
			(byte)MemorySize.Float32,// EVEX_Vscatterqps_vm64y_k1_xmm
			(byte)MemorySize.Float32,// EVEX_Vscatterqps_vm64z_k1_ymm
			(byte)MemorySize.Float64,// EVEX_Vscatterqpd_vm64x_k1_xmm
			(byte)MemorySize.Float64,// EVEX_Vscatterqpd_vm64y_k1_ymm
			(byte)MemorySize.Float64,// EVEX_Vscatterqpd_vm64z_k1_zmm
			(byte)MemorySize.Packed128_Float32,// VEX_Vfmaddsub213ps_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vfmaddsub213ps_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// VEX_Vfmaddsub213pd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vfmaddsub213pd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// EVEX_Vfmaddsub213ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vfmaddsub213ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vfmaddsub213ps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Packed128_Float64,// EVEX_Vfmaddsub213pd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vfmaddsub213pd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vfmaddsub213pd_zmm_k1z_zmm_zmmm512b64_er
			(byte)MemorySize.Packed128_Float32,// VEX_Vfmsubadd213ps_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vfmsubadd213ps_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// VEX_Vfmsubadd213pd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vfmsubadd213pd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// EVEX_Vfmsubadd213ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vfmsubadd213ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vfmsubadd213ps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Packed128_Float64,// EVEX_Vfmsubadd213pd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vfmsubadd213pd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vfmsubadd213pd_zmm_k1z_zmm_zmmm512b64_er
			(byte)MemorySize.Packed128_Float32,// VEX_Vfmadd213ps_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vfmadd213ps_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// VEX_Vfmadd213pd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vfmadd213pd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// EVEX_Vfmadd213ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vfmadd213ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vfmadd213ps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Packed128_Float64,// EVEX_Vfmadd213pd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vfmadd213pd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vfmadd213pd_zmm_k1z_zmm_zmmm512b64_er
			(byte)MemorySize.Float32,// VEX_Vfmadd213ss_xmm_xmm_xmmm32
			(byte)MemorySize.Float64,// VEX_Vfmadd213sd_xmm_xmm_xmmm64
			(byte)MemorySize.Float32,// EVEX_Vfmadd213ss_xmm_k1z_xmm_xmmm32_er
			(byte)MemorySize.Float64,// EVEX_Vfmadd213sd_xmm_k1z_xmm_xmmm64_er
			(byte)MemorySize.Packed128_Float32,// VEX_Vfmsub213ps_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vfmsub213ps_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// VEX_Vfmsub213pd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vfmsub213pd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// EVEX_Vfmsub213ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vfmsub213ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vfmsub213ps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Packed128_Float64,// EVEX_Vfmsub213pd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vfmsub213pd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vfmsub213pd_zmm_k1z_zmm_zmmm512b64_er
			(byte)MemorySize.Packed128_Float32,// EVEX_V4fnmaddps_zmm_k1z_zmmp3_m128
			(byte)MemorySize.Float32,// VEX_Vfmsub213ss_xmm_xmm_xmmm32
			(byte)MemorySize.Float64,// VEX_Vfmsub213sd_xmm_xmm_xmmm64
			(byte)MemorySize.Float32,// EVEX_Vfmsub213ss_xmm_k1z_xmm_xmmm32_er
			(byte)MemorySize.Float64,// EVEX_Vfmsub213sd_xmm_k1z_xmm_xmmm64_er
			(byte)MemorySize.Packed128_Float32,// EVEX_V4fnmaddss_xmm_k1z_xmmp3_m128
			(byte)MemorySize.Packed128_Float32,// VEX_Vfnmadd213ps_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vfnmadd213ps_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// VEX_Vfnmadd213pd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vfnmadd213pd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// EVEX_Vfnmadd213ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vfnmadd213ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vfnmadd213ps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Packed128_Float64,// EVEX_Vfnmadd213pd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vfnmadd213pd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vfnmadd213pd_zmm_k1z_zmm_zmmm512b64_er
			(byte)MemorySize.Float32,// VEX_Vfnmadd213ss_xmm_xmm_xmmm32
			(byte)MemorySize.Float64,// VEX_Vfnmadd213sd_xmm_xmm_xmmm64
			(byte)MemorySize.Float32,// EVEX_Vfnmadd213ss_xmm_k1z_xmm_xmmm32_er
			(byte)MemorySize.Float64,// EVEX_Vfnmadd213sd_xmm_k1z_xmm_xmmm64_er
			(byte)MemorySize.Packed128_Float32,// VEX_Vfnmsub213ps_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vfnmsub213ps_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// VEX_Vfnmsub213pd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vfnmsub213pd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// EVEX_Vfnmsub213ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vfnmsub213ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vfnmsub213ps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Packed128_Float64,// EVEX_Vfnmsub213pd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vfnmsub213pd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vfnmsub213pd_zmm_k1z_zmm_zmmm512b64_er
			(byte)MemorySize.Float32,// VEX_Vfnmsub213ss_xmm_xmm_xmmm32
			(byte)MemorySize.Float64,// VEX_Vfnmsub213sd_xmm_xmm_xmmm64
			(byte)MemorySize.Float32,// EVEX_Vfnmsub213ss_xmm_k1z_xmm_xmmm32_er
			(byte)MemorySize.Float64,// EVEX_Vfnmsub213sd_xmm_k1z_xmm_xmmm64_er
			(byte)MemorySize.Packed128_UInt52,// EVEX_Vpmadd52luq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_UInt52,// EVEX_Vpmadd52luq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_UInt52,// EVEX_Vpmadd52luq_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.Packed128_UInt52,// EVEX_Vpmadd52huq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_UInt52,// EVEX_Vpmadd52huq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_UInt52,// EVEX_Vpmadd52huq_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.Packed128_Float32,// VEX_Vfmaddsub231ps_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vfmaddsub231ps_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// VEX_Vfmaddsub231pd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vfmaddsub231pd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// EVEX_Vfmaddsub231ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vfmaddsub231ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vfmaddsub231ps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Packed128_Float64,// EVEX_Vfmaddsub231pd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vfmaddsub231pd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vfmaddsub231pd_zmm_k1z_zmm_zmmm512b64_er
			(byte)MemorySize.Packed128_Float32,// VEX_Vfmsubadd231ps_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vfmsubadd231ps_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// VEX_Vfmsubadd231pd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vfmsubadd231pd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// EVEX_Vfmsubadd231ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vfmsubadd231ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vfmsubadd231ps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Packed128_Float64,// EVEX_Vfmsubadd231pd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vfmsubadd231pd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vfmsubadd231pd_zmm_k1z_zmm_zmmm512b64_er
			(byte)MemorySize.Packed128_Float32,// VEX_Vfmadd231ps_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vfmadd231ps_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// VEX_Vfmadd231pd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vfmadd231pd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// EVEX_Vfmadd231ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vfmadd231ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vfmadd231ps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Packed128_Float64,// EVEX_Vfmadd231pd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vfmadd231pd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vfmadd231pd_zmm_k1z_zmm_zmmm512b64_er
			(byte)MemorySize.Float32,// VEX_Vfmadd231ss_xmm_xmm_xmmm32
			(byte)MemorySize.Float64,// VEX_Vfmadd231sd_xmm_xmm_xmmm64
			(byte)MemorySize.Float32,// EVEX_Vfmadd231ss_xmm_k1z_xmm_xmmm32_er
			(byte)MemorySize.Float64,// EVEX_Vfmadd231sd_xmm_k1z_xmm_xmmm64_er
			(byte)MemorySize.Packed128_Float32,// VEX_Vfmsub231ps_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vfmsub231ps_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// VEX_Vfmsub231pd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vfmsub231pd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// EVEX_Vfmsub231ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vfmsub231ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vfmsub231ps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Packed128_Float64,// EVEX_Vfmsub231pd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vfmsub231pd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vfmsub231pd_zmm_k1z_zmm_zmmm512b64_er
			(byte)MemorySize.Float32,// VEX_Vfmsub231ss_xmm_xmm_xmmm32
			(byte)MemorySize.Float64,// VEX_Vfmsub231sd_xmm_xmm_xmmm64
			(byte)MemorySize.Float32,// EVEX_Vfmsub231ss_xmm_k1z_xmm_xmmm32_er
			(byte)MemorySize.Float64,// EVEX_Vfmsub231sd_xmm_k1z_xmm_xmmm64_er
			(byte)MemorySize.Packed128_Float32,// VEX_Vfnmadd231ps_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vfnmadd231ps_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// VEX_Vfnmadd231pd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vfnmadd231pd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// EVEX_Vfnmadd231ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vfnmadd231ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vfnmadd231ps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Packed128_Float64,// EVEX_Vfnmadd231pd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vfnmadd231pd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vfnmadd231pd_zmm_k1z_zmm_zmmm512b64_er
			(byte)MemorySize.Float32,// VEX_Vfnmadd231ss_xmm_xmm_xmmm32
			(byte)MemorySize.Float64,// VEX_Vfnmadd231sd_xmm_xmm_xmmm64
			(byte)MemorySize.Float32,// EVEX_Vfnmadd231ss_xmm_k1z_xmm_xmmm32_er
			(byte)MemorySize.Float64,// EVEX_Vfnmadd231sd_xmm_k1z_xmm_xmmm64_er
			(byte)MemorySize.Packed128_Float32,// VEX_Vfnmsub231ps_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vfnmsub231ps_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// VEX_Vfnmsub231pd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vfnmsub231pd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// EVEX_Vfnmsub231ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vfnmsub231ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vfnmsub231ps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Packed128_Float64,// EVEX_Vfnmsub231pd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vfnmsub231pd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vfnmsub231pd_zmm_k1z_zmm_zmmm512b64_er
			(byte)MemorySize.Float32,// VEX_Vfnmsub231ss_xmm_xmm_xmmm32
			(byte)MemorySize.Float64,// VEX_Vfnmsub231sd_xmm_xmm_xmmm64
			(byte)MemorySize.Float32,// EVEX_Vfnmsub231ss_xmm_k1z_xmm_xmmm32_er
			(byte)MemorySize.Float64,// EVEX_Vfnmsub231sd_xmm_k1z_xmm_xmmm64_er
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vpconflictd_xmm_k1z_xmmm128b32
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vpconflictd_ymm_k1z_ymmm256b32
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vpconflictd_zmm_k1z_zmmm512b32
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vpconflictq_xmm_k1z_xmmm128b64
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vpconflictq_ymm_k1z_ymmm256b64
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vpconflictq_zmm_k1z_zmmm512b64
			(byte)MemorySize.Float32,// EVEX_Vgatherpf0dps_vm32z_k1
			(byte)MemorySize.Float64,// EVEX_Vgatherpf0dpd_vm32y_k1
			(byte)MemorySize.Float32,// EVEX_Vgatherpf1dps_vm32z_k1
			(byte)MemorySize.Float64,// EVEX_Vgatherpf1dpd_vm32y_k1
			(byte)MemorySize.Float32,// EVEX_Vscatterpf0dps_vm32z_k1
			(byte)MemorySize.Float64,// EVEX_Vscatterpf0dpd_vm32y_k1
			(byte)MemorySize.Float32,// EVEX_Vscatterpf1dps_vm32z_k1
			(byte)MemorySize.Float64,// EVEX_Vscatterpf1dpd_vm32y_k1
			(byte)MemorySize.Float32,// EVEX_Vgatherpf0qps_vm64z_k1
			(byte)MemorySize.Float64,// EVEX_Vgatherpf0qpd_vm64z_k1
			(byte)MemorySize.Float32,// EVEX_Vgatherpf1qps_vm64z_k1
			(byte)MemorySize.Float64,// EVEX_Vgatherpf1qpd_vm64z_k1
			(byte)MemorySize.Float32,// EVEX_Vscatterpf0qps_vm64z_k1
			(byte)MemorySize.Float64,// EVEX_Vscatterpf0qpd_vm64z_k1
			(byte)MemorySize.Float32,// EVEX_Vscatterpf1qps_vm64z_k1
			(byte)MemorySize.Float64,// EVEX_Vscatterpf1qpd_vm64z_k1
			(byte)MemorySize.Packed128_UInt32,// Sha1nexte_xmm_xmmm128
			(byte)MemorySize.Packed512_Float32,// EVEX_Vexp2ps_zmm_k1z_zmmm512b32_sae
			(byte)MemorySize.Packed512_Float64,// EVEX_Vexp2pd_zmm_k1z_zmmm512b64_sae
			(byte)MemorySize.Packed128_UInt32,// Sha1msg1_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt32,// Sha1msg2_xmm_xmmm128
			(byte)MemorySize.Packed512_Float32,// EVEX_Vrcp28ps_zmm_k1z_zmmm512b32_sae
			(byte)MemorySize.Packed512_Float64,// EVEX_Vrcp28pd_zmm_k1z_zmmm512b64_sae
			(byte)MemorySize.Packed128_UInt32,// Sha256rnds2_xmm_xmmm128
			(byte)MemorySize.Float32,// EVEX_Vrcp28ss_xmm_k1z_xmm_xmmm32_sae
			(byte)MemorySize.Float64,// EVEX_Vrcp28sd_xmm_k1z_xmm_xmmm64_sae
			(byte)MemorySize.Packed128_UInt32,// Sha256msg1_xmm_xmmm128
			(byte)MemorySize.Packed512_Float32,// EVEX_Vrsqrt28ps_zmm_k1z_zmmm512b32_sae
			(byte)MemorySize.Packed512_Float64,// EVEX_Vrsqrt28pd_zmm_k1z_zmmm512b64_sae
			(byte)MemorySize.Packed128_UInt32,// Sha256msg2_xmm_xmmm128
			(byte)MemorySize.Float32,// EVEX_Vrsqrt28ss_xmm_k1z_xmm_xmmm32_sae
			(byte)MemorySize.Float64,// EVEX_Vrsqrt28sd_xmm_k1z_xmm_xmmm64_sae
			(byte)MemorySize.Packed128_UInt8,// Gf2p8mulb_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt8,// VEX_Vgf2p8mulb_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt8,// VEX_Vgf2p8mulb_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt8,// EVEX_Vgf2p8mulb_xmm_k1z_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt8,// EVEX_Vgf2p8mulb_ymm_k1z_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt8,// EVEX_Vgf2p8mulb_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.UInt128,// Aesimc_xmm_xmmm128
			(byte)MemorySize.UInt128,// VEX_Vaesimc_xmm_xmmm128
			(byte)MemorySize.UInt128,// Aesenc_xmm_xmmm128
			(byte)MemorySize.UInt128,// VEX_Vaesenc_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt128,// VEX_Vaesenc_ymm_ymm_ymmm256
			(byte)MemorySize.UInt128,// EVEX_Vaesenc_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt128,// EVEX_Vaesenc_ymm_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt128,// EVEX_Vaesenc_zmm_zmm_zmmm512
			(byte)MemorySize.UInt128,// Aesenclast_xmm_xmmm128
			(byte)MemorySize.UInt128,// VEX_Vaesenclast_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt128,// VEX_Vaesenclast_ymm_ymm_ymmm256
			(byte)MemorySize.UInt128,// EVEX_Vaesenclast_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt128,// EVEX_Vaesenclast_ymm_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt128,// EVEX_Vaesenclast_zmm_zmm_zmmm512
			(byte)MemorySize.UInt128,// Aesdec_xmm_xmmm128
			(byte)MemorySize.UInt128,// VEX_Vaesdec_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt128,// VEX_Vaesdec_ymm_ymm_ymmm256
			(byte)MemorySize.UInt128,// EVEX_Vaesdec_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt128,// EVEX_Vaesdec_ymm_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt128,// EVEX_Vaesdec_zmm_zmm_zmmm512
			(byte)MemorySize.UInt128,// Aesdeclast_xmm_xmmm128
			(byte)MemorySize.UInt128,// VEX_Vaesdeclast_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt128,// VEX_Vaesdeclast_ymm_ymm_ymmm256
			(byte)MemorySize.UInt128,// EVEX_Vaesdeclast_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_UInt128,// EVEX_Vaesdeclast_ymm_ymm_ymmm256
			(byte)MemorySize.Packed512_UInt128,// EVEX_Vaesdeclast_zmm_zmm_zmmm512
			(byte)MemorySize.UInt16,// Movbe_r16_m16
			(byte)MemorySize.UInt32,// Movbe_r32_m32
			(byte)MemorySize.UInt64,// Movbe_r64_m64
			(byte)MemorySize.UInt8,// Crc32_r32_rm8
			(byte)MemorySize.UInt8,// Crc32_r64_rm8
			(byte)MemorySize.UInt16,// Movbe_m16_r16
			(byte)MemorySize.UInt32,// Movbe_m32_r32
			(byte)MemorySize.UInt64,// Movbe_m64_r64
			(byte)MemorySize.UInt16,// Crc32_r32_rm16
			(byte)MemorySize.UInt32,// Crc32_r32_rm32
			(byte)MemorySize.UInt64,// Crc32_r64_rm64
			(byte)MemorySize.UInt32,// VEX_Andn_r32_r32_rm32
			(byte)MemorySize.UInt64,// VEX_Andn_r64_r64_rm64
			(byte)MemorySize.UInt32,// VEX_Blsr_r32_rm32
			(byte)MemorySize.UInt64,// VEX_Blsr_r64_rm64
			(byte)MemorySize.UInt32,// VEX_Blsmsk_r32_rm32
			(byte)MemorySize.UInt64,// VEX_Blsmsk_r64_rm64
			(byte)MemorySize.UInt32,// VEX_Blsi_r32_rm32
			(byte)MemorySize.UInt64,// VEX_Blsi_r64_rm64
			(byte)MemorySize.UInt32,// VEX_Bzhi_r32_rm32_r32
			(byte)MemorySize.UInt64,// VEX_Bzhi_r64_rm64_r64
			(byte)MemorySize.UInt32,// Wrussd_m32_r32
			(byte)MemorySize.UInt64,// Wrussq_m64_r64
			(byte)MemorySize.UInt32,// VEX_Pext_r32_r32_rm32
			(byte)MemorySize.UInt64,// VEX_Pext_r64_r64_rm64
			(byte)MemorySize.UInt32,// VEX_Pdep_r32_r32_rm32
			(byte)MemorySize.UInt64,// VEX_Pdep_r64_r64_rm64
			(byte)MemorySize.UInt32,// Wrssd_m32_r32
			(byte)MemorySize.UInt64,// Wrssq_m64_r64
			(byte)MemorySize.UInt32,// Adcx_r32_rm32
			(byte)MemorySize.UInt64,// Adcx_r64_rm64
			(byte)MemorySize.UInt32,// Adox_r32_rm32
			(byte)MemorySize.UInt64,// Adox_r64_rm64
			(byte)MemorySize.UInt32,// VEX_Mulx_r32_r32_rm32
			(byte)MemorySize.UInt64,// VEX_Mulx_r64_r64_rm64
			(byte)MemorySize.UInt32,// VEX_Bextr_r32_rm32_r32
			(byte)MemorySize.UInt64,// VEX_Bextr_r64_rm64_r64
			(byte)MemorySize.UInt32,// VEX_Shlx_r32_rm32_r32
			(byte)MemorySize.UInt64,// VEX_Shlx_r64_rm64_r64
			(byte)MemorySize.Int32,// VEX_Sarx_r32_rm32_r32
			(byte)MemorySize.Int64,// VEX_Sarx_r64_rm64_r64
			(byte)MemorySize.UInt32,// VEX_Shrx_r32_rm32_r32
			(byte)MemorySize.UInt64,// VEX_Shrx_r64_rm64_r64
			(byte)MemorySize.UInt512,// Movdir64b_r16_m512
			(byte)MemorySize.UInt512,// Movdir64b_r32_m512
			(byte)MemorySize.UInt512,// Movdir64b_r64_m512
			(byte)MemorySize.UInt512,// Enqcmds_r16_m512
			(byte)MemorySize.UInt512,// Enqcmds_r32_m512
			(byte)MemorySize.UInt512,// Enqcmds_r64_m512
			(byte)MemorySize.UInt512,// Enqcmd_r16_m512
			(byte)MemorySize.UInt512,// Enqcmd_r32_m512
			(byte)MemorySize.UInt512,// Enqcmd_r64_m512
			(byte)MemorySize.UInt32,// Movdiri_m32_r32
			(byte)MemorySize.UInt64,// Movdiri_m64_r64
			(byte)MemorySize.Packed256_UInt64,// VEX_Vpermq_ymm_ymmm256_imm8
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vpermq_ymm_k1z_ymmm256b64_imm8
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vpermq_zmm_k1z_zmmm512b64_imm8
			(byte)MemorySize.Packed256_Float64,// VEX_Vpermpd_ymm_ymmm256_imm8
			(byte)MemorySize.Packed256_Float64,// EVEX_Vpermpd_ymm_k1z_ymmm256b64_imm8
			(byte)MemorySize.Packed512_Float64,// EVEX_Vpermpd_zmm_k1z_zmmm512b64_imm8
			(byte)MemorySize.Packed128_UInt32,// VEX_Vpblendd_xmm_xmm_xmmm128_imm8
			(byte)MemorySize.Packed256_UInt32,// VEX_Vpblendd_ymm_ymm_ymmm256_imm8
			(byte)MemorySize.Packed128_UInt32,// EVEX_Valignd_xmm_k1z_xmm_xmmm128b32_imm8
			(byte)MemorySize.Packed256_UInt32,// EVEX_Valignd_ymm_k1z_ymm_ymmm256b32_imm8
			(byte)MemorySize.Packed512_UInt32,// EVEX_Valignd_zmm_k1z_zmm_zmmm512b32_imm8
			(byte)MemorySize.Packed128_UInt64,// EVEX_Valignq_xmm_k1z_xmm_xmmm128b64_imm8
			(byte)MemorySize.Packed256_UInt64,// EVEX_Valignq_ymm_k1z_ymm_ymmm256b64_imm8
			(byte)MemorySize.Packed512_UInt64,// EVEX_Valignq_zmm_k1z_zmm_zmmm512b64_imm8
			(byte)MemorySize.Packed128_Float32,// VEX_Vpermilps_xmm_xmmm128_imm8
			(byte)MemorySize.Packed256_Float32,// VEX_Vpermilps_ymm_ymmm256_imm8
			(byte)MemorySize.Packed128_Float32,// EVEX_Vpermilps_xmm_k1z_xmmm128b32_imm8
			(byte)MemorySize.Packed256_Float32,// EVEX_Vpermilps_ymm_k1z_ymmm256b32_imm8
			(byte)MemorySize.Packed512_Float32,// EVEX_Vpermilps_zmm_k1z_zmmm512b32_imm8
			(byte)MemorySize.Packed128_Float64,// VEX_Vpermilpd_xmm_xmmm128_imm8
			(byte)MemorySize.Packed256_Float64,// VEX_Vpermilpd_ymm_ymmm256_imm8
			(byte)MemorySize.Packed128_Float64,// EVEX_Vpermilpd_xmm_k1z_xmmm128b64_imm8
			(byte)MemorySize.Packed256_Float64,// EVEX_Vpermilpd_ymm_k1z_ymmm256b64_imm8
			(byte)MemorySize.Packed512_Float64,// EVEX_Vpermilpd_zmm_k1z_zmmm512b64_imm8
			(byte)MemorySize.Packed256_Float128,// VEX_Vperm2f128_ymm_ymm_ymmm256_imm8
			(byte)MemorySize.Packed128_Float32,// Roundps_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_Float32,// VEX_Vroundps_xmm_xmmm128_imm8
			(byte)MemorySize.Packed256_Float32,// VEX_Vroundps_ymm_ymmm256_imm8
			(byte)MemorySize.Packed128_Float32,// EVEX_Vrndscaleps_xmm_k1z_xmmm128b32_imm8
			(byte)MemorySize.Packed256_Float32,// EVEX_Vrndscaleps_ymm_k1z_ymmm256b32_imm8
			(byte)MemorySize.Packed512_Float32,// EVEX_Vrndscaleps_zmm_k1z_zmmm512b32_imm8_sae
			(byte)MemorySize.Packed128_Float64,// Roundpd_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_Float64,// VEX_Vroundpd_xmm_xmmm128_imm8
			(byte)MemorySize.Packed256_Float64,// VEX_Vroundpd_ymm_ymmm256_imm8
			(byte)MemorySize.Packed128_Float64,// EVEX_Vrndscalepd_xmm_k1z_xmmm128b64_imm8
			(byte)MemorySize.Packed256_Float64,// EVEX_Vrndscalepd_ymm_k1z_ymmm256b64_imm8
			(byte)MemorySize.Packed512_Float64,// EVEX_Vrndscalepd_zmm_k1z_zmmm512b64_imm8_sae
			(byte)MemorySize.Float32,// Roundss_xmm_xmmm32_imm8
			(byte)MemorySize.Float32,// VEX_Vroundss_xmm_xmm_xmmm32_imm8
			(byte)MemorySize.Float32,// EVEX_Vrndscaless_xmm_k1z_xmm_xmmm32_imm8_sae
			(byte)MemorySize.Float64,// Roundsd_xmm_xmmm64_imm8
			(byte)MemorySize.Float64,// VEX_Vroundsd_xmm_xmm_xmmm64_imm8
			(byte)MemorySize.Float64,// EVEX_Vrndscalesd_xmm_k1z_xmm_xmmm64_imm8_sae
			(byte)MemorySize.Packed128_Float32,// Blendps_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_Float32,// VEX_Vblendps_xmm_xmm_xmmm128_imm8
			(byte)MemorySize.Packed256_Float32,// VEX_Vblendps_ymm_ymm_ymmm256_imm8
			(byte)MemorySize.Packed128_Float64,// Blendpd_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_Float64,// VEX_Vblendpd_xmm_xmm_xmmm128_imm8
			(byte)MemorySize.Packed256_Float64,// VEX_Vblendpd_ymm_ymm_ymmm256_imm8
			(byte)MemorySize.Packed128_UInt16,// Pblendw_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_UInt16,// VEX_Vpblendw_xmm_xmm_xmmm128_imm8
			(byte)MemorySize.Packed256_UInt16,// VEX_Vpblendw_ymm_ymm_ymmm256_imm8
			(byte)MemorySize.Packed64_UInt8,// Palignr_mm_mmm64_imm8
			(byte)MemorySize.Packed128_UInt8,// Palignr_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_UInt8,// VEX_Vpalignr_xmm_xmm_xmmm128_imm8
			(byte)MemorySize.Packed256_UInt8,// VEX_Vpalignr_ymm_ymm_ymmm256_imm8
			(byte)MemorySize.Packed128_UInt8,// EVEX_Vpalignr_xmm_k1z_xmm_xmmm128_imm8
			(byte)MemorySize.Packed256_UInt8,// EVEX_Vpalignr_ymm_k1z_ymm_ymmm256_imm8
			(byte)MemorySize.Packed512_UInt8,// EVEX_Vpalignr_zmm_k1z_zmm_zmmm512_imm8
			(byte)MemorySize.UInt8,// Pextrb_r32m8_xmm_imm8
			(byte)MemorySize.UInt8,// Pextrb_r64m8_xmm_imm8
			(byte)MemorySize.UInt8,// VEX_Vpextrb_r32m8_xmm_imm8
			(byte)MemorySize.UInt8,// VEX_Vpextrb_r64m8_xmm_imm8
			(byte)MemorySize.UInt8,// EVEX_Vpextrb_r32m8_xmm_imm8
			(byte)MemorySize.UInt8,// EVEX_Vpextrb_r64m8_xmm_imm8
			(byte)MemorySize.UInt16,// Pextrw_r32m16_xmm_imm8
			(byte)MemorySize.UInt16,// Pextrw_r64m16_xmm_imm8
			(byte)MemorySize.UInt16,// VEX_Vpextrw_r32m16_xmm_imm8
			(byte)MemorySize.UInt16,// VEX_Vpextrw_r64m16_xmm_imm8
			(byte)MemorySize.UInt16,// EVEX_Vpextrw_r32m16_xmm_imm8
			(byte)MemorySize.UInt16,// EVEX_Vpextrw_r64m16_xmm_imm8
			(byte)MemorySize.UInt32,// Pextrd_rm32_xmm_imm8
			(byte)MemorySize.UInt64,// Pextrq_rm64_xmm_imm8
			(byte)MemorySize.UInt32,// VEX_Vpextrd_rm32_xmm_imm8
			(byte)MemorySize.UInt64,// VEX_Vpextrq_rm64_xmm_imm8
			(byte)MemorySize.UInt32,// EVEX_Vpextrd_rm32_xmm_imm8
			(byte)MemorySize.UInt64,// EVEX_Vpextrq_rm64_xmm_imm8
			(byte)MemorySize.Float32,// Extractps_rm32_xmm_imm8
			(byte)MemorySize.Float32,// Extractps_r64m32_xmm_imm8
			(byte)MemorySize.Float32,// VEX_Vextractps_rm32_xmm_imm8
			(byte)MemorySize.Float32,// VEX_Vextractps_r64m32_xmm_imm8
			(byte)MemorySize.Float32,// EVEX_Vextractps_rm32_xmm_imm8
			(byte)MemorySize.Float32,// EVEX_Vextractps_r64m32_xmm_imm8
			(byte)MemorySize.Float128,// VEX_Vinsertf128_ymm_ymm_xmmm128_imm8
			(byte)MemorySize.Packed128_Float32,// EVEX_Vinsertf32x4_ymm_k1z_ymm_xmmm128_imm8
			(byte)MemorySize.Packed128_Float32,// EVEX_Vinsertf32x4_zmm_k1z_zmm_xmmm128_imm8
			(byte)MemorySize.Packed128_Float64,// EVEX_Vinsertf64x2_ymm_k1z_ymm_xmmm128_imm8
			(byte)MemorySize.Packed128_Float64,// EVEX_Vinsertf64x2_zmm_k1z_zmm_xmmm128_imm8
			(byte)MemorySize.Float128,// VEX_Vextractf128_xmmm128_ymm_imm8
			(byte)MemorySize.Packed128_Float32,// EVEX_Vextractf32x4_xmmm128_k1z_ymm_imm8
			(byte)MemorySize.Packed128_Float32,// EVEX_Vextractf32x4_xmmm128_k1z_zmm_imm8
			(byte)MemorySize.Packed128_Float64,// EVEX_Vextractf64x2_xmmm128_k1z_ymm_imm8
			(byte)MemorySize.Packed128_Float64,// EVEX_Vextractf64x2_xmmm128_k1z_zmm_imm8
			(byte)MemorySize.Packed256_Float32,// EVEX_Vinsertf32x8_zmm_k1z_zmm_ymmm256_imm8
			(byte)MemorySize.Packed256_Float64,// EVEX_Vinsertf64x4_zmm_k1z_zmm_ymmm256_imm8
			(byte)MemorySize.Packed256_Float32,// EVEX_Vextractf32x8_ymmm256_k1z_zmm_imm8
			(byte)MemorySize.Packed256_Float64,// EVEX_Vextractf64x4_ymmm256_k1z_zmm_imm8
			(byte)MemorySize.Packed64_Float16,// VEX_Vcvtps2ph_xmmm64_xmm_imm8
			(byte)MemorySize.Packed128_Float16,// VEX_Vcvtps2ph_xmmm128_ymm_imm8
			(byte)MemorySize.Packed64_Float16,// EVEX_Vcvtps2ph_xmmm64_k1z_xmm_imm8
			(byte)MemorySize.Packed128_Float16,// EVEX_Vcvtps2ph_xmmm128_k1z_ymm_imm8
			(byte)MemorySize.Packed256_Float16,// EVEX_Vcvtps2ph_ymmm256_k1z_zmm_imm8_sae
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vpcmpud_kr_k1_xmm_xmmm128b32_imm8
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vpcmpud_kr_k1_ymm_ymmm256b32_imm8
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vpcmpud_kr_k1_zmm_zmmm512b32_imm8
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vpcmpuq_kr_k1_xmm_xmmm128b64_imm8
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vpcmpuq_kr_k1_ymm_ymmm256b64_imm8
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vpcmpuq_kr_k1_zmm_zmmm512b64_imm8
			(byte)MemorySize.Packed128_Int32,// EVEX_Vpcmpd_kr_k1_xmm_xmmm128b32_imm8
			(byte)MemorySize.Packed256_Int32,// EVEX_Vpcmpd_kr_k1_ymm_ymmm256b32_imm8
			(byte)MemorySize.Packed512_Int32,// EVEX_Vpcmpd_kr_k1_zmm_zmmm512b32_imm8
			(byte)MemorySize.Packed128_Int64,// EVEX_Vpcmpq_kr_k1_xmm_xmmm128b64_imm8
			(byte)MemorySize.Packed256_Int64,// EVEX_Vpcmpq_kr_k1_ymm_ymmm256b64_imm8
			(byte)MemorySize.Packed512_Int64,// EVEX_Vpcmpq_kr_k1_zmm_zmmm512b64_imm8
			(byte)MemorySize.UInt8,// Pinsrb_xmm_r32m8_imm8
			(byte)MemorySize.UInt8,// Pinsrb_xmm_r64m8_imm8
			(byte)MemorySize.UInt8,// VEX_Vpinsrb_xmm_xmm_r32m8_imm8
			(byte)MemorySize.UInt8,// VEX_Vpinsrb_xmm_xmm_r64m8_imm8
			(byte)MemorySize.UInt8,// EVEX_Vpinsrb_xmm_xmm_r32m8_imm8
			(byte)MemorySize.UInt8,// EVEX_Vpinsrb_xmm_xmm_r64m8_imm8
			(byte)MemorySize.Float32,// Insertps_xmm_xmmm32_imm8
			(byte)MemorySize.Float32,// VEX_Vinsertps_xmm_xmm_xmmm32_imm8
			(byte)MemorySize.Float32,// EVEX_Vinsertps_xmm_xmm_xmmm32_imm8
			(byte)MemorySize.UInt32,// Pinsrd_xmm_rm32_imm8
			(byte)MemorySize.UInt64,// Pinsrq_xmm_rm64_imm8
			(byte)MemorySize.UInt32,// VEX_Vpinsrd_xmm_xmm_rm32_imm8
			(byte)MemorySize.UInt64,// VEX_Vpinsrq_xmm_xmm_rm64_imm8
			(byte)MemorySize.UInt32,// EVEX_Vpinsrd_xmm_xmm_rm32_imm8
			(byte)MemorySize.UInt64,// EVEX_Vpinsrq_xmm_xmm_rm64_imm8
			(byte)MemorySize.Packed256_Float32,// EVEX_Vshuff32x4_ymm_k1z_ymm_ymmm256b32_imm8
			(byte)MemorySize.Packed512_Float32,// EVEX_Vshuff32x4_zmm_k1z_zmm_zmmm512b32_imm8
			(byte)MemorySize.Packed256_Float64,// EVEX_Vshuff64x2_ymm_k1z_ymm_ymmm256b64_imm8
			(byte)MemorySize.Packed512_Float64,// EVEX_Vshuff64x2_zmm_k1z_zmm_zmmm512b64_imm8
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vpternlogd_xmm_k1z_xmm_xmmm128b32_imm8
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vpternlogd_ymm_k1z_ymm_ymmm256b32_imm8
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vpternlogd_zmm_k1z_zmm_zmmm512b32_imm8
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vpternlogq_xmm_k1z_xmm_xmmm128b64_imm8
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vpternlogq_ymm_k1z_ymm_ymmm256b64_imm8
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vpternlogq_zmm_k1z_zmm_zmmm512b64_imm8
			(byte)MemorySize.Packed128_Float32,// EVEX_Vgetmantps_xmm_k1z_xmmm128b32_imm8
			(byte)MemorySize.Packed256_Float32,// EVEX_Vgetmantps_ymm_k1z_ymmm256b32_imm8
			(byte)MemorySize.Packed512_Float32,// EVEX_Vgetmantps_zmm_k1z_zmmm512b32_imm8_sae
			(byte)MemorySize.Packed128_Float64,// EVEX_Vgetmantpd_xmm_k1z_xmmm128b64_imm8
			(byte)MemorySize.Packed256_Float64,// EVEX_Vgetmantpd_ymm_k1z_ymmm256b64_imm8
			(byte)MemorySize.Packed512_Float64,// EVEX_Vgetmantpd_zmm_k1z_zmmm512b64_imm8_sae
			(byte)MemorySize.Float32,// EVEX_Vgetmantss_xmm_k1z_xmm_xmmm32_imm8_sae
			(byte)MemorySize.Float64,// EVEX_Vgetmantsd_xmm_k1z_xmm_xmmm64_imm8_sae
			0,// VEX_Kshiftrb_kr_kr_imm8
			0,// VEX_Kshiftrw_kr_kr_imm8
			0,// VEX_Kshiftrd_kr_kr_imm8
			0,// VEX_Kshiftrq_kr_kr_imm8
			0,// VEX_Kshiftlb_kr_kr_imm8
			0,// VEX_Kshiftlw_kr_kr_imm8
			0,// VEX_Kshiftld_kr_kr_imm8
			0,// VEX_Kshiftlq_kr_kr_imm8
			(byte)MemorySize.Int128,// VEX_Vinserti128_ymm_ymm_xmmm128_imm8
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vinserti32x4_ymm_k1z_ymm_xmmm128_imm8
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vinserti32x4_zmm_k1z_zmm_xmmm128_imm8
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vinserti64x2_ymm_k1z_ymm_xmmm128_imm8
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vinserti64x2_zmm_k1z_zmm_xmmm128_imm8
			(byte)MemorySize.Int128,// VEX_Vextracti128_xmmm128_ymm_imm8
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vextracti32x4_xmmm128_k1z_ymm_imm8
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vextracti32x4_xmmm128_k1z_zmm_imm8
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vextracti64x2_xmmm128_k1z_ymm_imm8
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vextracti64x2_xmmm128_k1z_zmm_imm8
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vinserti32x8_zmm_k1z_zmm_ymmm256_imm8
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vinserti64x4_zmm_k1z_zmm_ymmm256_imm8
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vextracti32x8_ymmm256_k1z_zmm_imm8
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vextracti64x4_ymmm256_k1z_zmm_imm8
			(byte)MemorySize.Packed128_UInt8,// EVEX_Vpcmpub_kr_k1_xmm_xmmm128_imm8
			(byte)MemorySize.Packed256_UInt8,// EVEX_Vpcmpub_kr_k1_ymm_ymmm256_imm8
			(byte)MemorySize.Packed512_UInt8,// EVEX_Vpcmpub_kr_k1_zmm_zmmm512_imm8
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpcmpuw_kr_k1_xmm_xmmm128_imm8
			(byte)MemorySize.Packed256_UInt16,// EVEX_Vpcmpuw_kr_k1_ymm_ymmm256_imm8
			(byte)MemorySize.Packed512_UInt16,// EVEX_Vpcmpuw_kr_k1_zmm_zmmm512_imm8
			(byte)MemorySize.Packed128_Int8,// EVEX_Vpcmpb_kr_k1_xmm_xmmm128_imm8
			(byte)MemorySize.Packed256_Int8,// EVEX_Vpcmpb_kr_k1_ymm_ymmm256_imm8
			(byte)MemorySize.Packed512_Int8,// EVEX_Vpcmpb_kr_k1_zmm_zmmm512_imm8
			(byte)MemorySize.Packed128_Int16,// EVEX_Vpcmpw_kr_k1_xmm_xmmm128_imm8
			(byte)MemorySize.Packed256_Int16,// EVEX_Vpcmpw_kr_k1_ymm_ymmm256_imm8
			(byte)MemorySize.Packed512_Int16,// EVEX_Vpcmpw_kr_k1_zmm_zmmm512_imm8
			(byte)MemorySize.Packed128_Float32,// Dpps_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_Float32,// VEX_Vdpps_xmm_xmm_xmmm128_imm8
			(byte)MemorySize.Packed256_Float32,// VEX_Vdpps_ymm_ymm_ymmm256_imm8
			(byte)MemorySize.Packed128_Float64,// Dppd_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_Float64,// VEX_Vdppd_xmm_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_UInt8,// Mpsadbw_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_UInt8,// VEX_Vmpsadbw_xmm_xmm_xmmm128_imm8
			(byte)MemorySize.Packed256_UInt8,// VEX_Vmpsadbw_ymm_ymm_ymmm256_imm8
			(byte)MemorySize.Packed128_UInt8,// EVEX_Vdbpsadbw_xmm_k1z_xmm_xmmm128_imm8
			(byte)MemorySize.Packed256_UInt8,// EVEX_Vdbpsadbw_ymm_k1z_ymm_ymmm256_imm8
			(byte)MemorySize.Packed512_UInt8,// EVEX_Vdbpsadbw_zmm_k1z_zmm_zmmm512_imm8
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vshufi32x4_ymm_k1z_ymm_ymmm256b32_imm8
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vshufi32x4_zmm_k1z_zmm_zmmm512b32_imm8
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vshufi64x2_ymm_k1z_ymm_ymmm256b64_imm8
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vshufi64x2_zmm_k1z_zmm_zmmm512b64_imm8
			(byte)MemorySize.Packed128_UInt64,// Pclmulqdq_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_UInt64,// VEX_Vpclmulqdq_xmm_xmm_xmmm128_imm8
			(byte)MemorySize.Packed256_UInt64,// VEX_Vpclmulqdq_ymm_ymm_ymmm256_imm8
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vpclmulqdq_xmm_xmm_xmmm128_imm8
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vpclmulqdq_ymm_ymm_ymmm256_imm8
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vpclmulqdq_zmm_zmm_zmmm512_imm8
			(byte)MemorySize.Packed256_UInt128,// VEX_Vperm2i128_ymm_ymm_ymmm256_imm8
			(byte)MemorySize.Packed128_Float32,// VEX_Vpermil2ps_xmm_xmm_xmmm128_xmm_imm4
			(byte)MemorySize.Packed256_Float32,// VEX_Vpermil2ps_ymm_ymm_ymmm256_ymm_imm4
			(byte)MemorySize.Packed128_Float32,// VEX_Vpermil2ps_xmm_xmm_xmm_xmmm128_imm4
			(byte)MemorySize.Packed256_Float32,// VEX_Vpermil2ps_ymm_ymm_ymm_ymmm256_imm4
			(byte)MemorySize.Packed128_Float64,// VEX_Vpermil2pd_xmm_xmm_xmmm128_xmm_imm4
			(byte)MemorySize.Packed256_Float64,// VEX_Vpermil2pd_ymm_ymm_ymmm256_ymm_imm4
			(byte)MemorySize.Packed128_Float64,// VEX_Vpermil2pd_xmm_xmm_xmm_xmmm128_imm4
			(byte)MemorySize.Packed256_Float64,// VEX_Vpermil2pd_ymm_ymm_ymm_ymmm256_imm4
			(byte)MemorySize.Packed128_Float32,// VEX_Vblendvps_xmm_xmm_xmmm128_xmm
			(byte)MemorySize.Packed256_Float32,// VEX_Vblendvps_ymm_ymm_ymmm256_ymm
			(byte)MemorySize.Packed128_Float64,// VEX_Vblendvpd_xmm_xmm_xmmm128_xmm
			(byte)MemorySize.Packed256_Float64,// VEX_Vblendvpd_ymm_ymm_ymmm256_ymm
			(byte)MemorySize.Packed128_UInt8,// VEX_Vpblendvb_xmm_xmm_xmmm128_xmm
			(byte)MemorySize.Packed256_UInt8,// VEX_Vpblendvb_ymm_ymm_ymmm256_ymm
			(byte)MemorySize.Packed128_Float32,// EVEX_Vrangeps_xmm_k1z_xmm_xmmm128b32_imm8
			(byte)MemorySize.Packed256_Float32,// EVEX_Vrangeps_ymm_k1z_ymm_ymmm256b32_imm8
			(byte)MemorySize.Packed512_Float32,// EVEX_Vrangeps_zmm_k1z_zmm_zmmm512b32_imm8_sae
			(byte)MemorySize.Packed128_Float64,// EVEX_Vrangepd_xmm_k1z_xmm_xmmm128b64_imm8
			(byte)MemorySize.Packed256_Float64,// EVEX_Vrangepd_ymm_k1z_ymm_ymmm256b64_imm8
			(byte)MemorySize.Packed512_Float64,// EVEX_Vrangepd_zmm_k1z_zmm_zmmm512b64_imm8_sae
			(byte)MemorySize.Float32,// EVEX_Vrangess_xmm_k1z_xmm_xmmm32_imm8_sae
			(byte)MemorySize.Float64,// EVEX_Vrangesd_xmm_k1z_xmm_xmmm64_imm8_sae
			(byte)MemorySize.Packed128_Float32,// EVEX_Vfixupimmps_xmm_k1z_xmm_xmmm128b32_imm8
			(byte)MemorySize.Packed256_Float32,// EVEX_Vfixupimmps_ymm_k1z_ymm_ymmm256b32_imm8
			(byte)MemorySize.Packed512_Float32,// EVEX_Vfixupimmps_zmm_k1z_zmm_zmmm512b32_imm8_sae
			(byte)MemorySize.Packed128_Float64,// EVEX_Vfixupimmpd_xmm_k1z_xmm_xmmm128b64_imm8
			(byte)MemorySize.Packed256_Float64,// EVEX_Vfixupimmpd_ymm_k1z_ymm_ymmm256b64_imm8
			(byte)MemorySize.Packed512_Float64,// EVEX_Vfixupimmpd_zmm_k1z_zmm_zmmm512b64_imm8_sae
			(byte)MemorySize.Float32,// EVEX_Vfixupimmss_xmm_k1z_xmm_xmmm32_imm8_sae
			(byte)MemorySize.Float64,// EVEX_Vfixupimmsd_xmm_k1z_xmm_xmmm64_imm8_sae
			(byte)MemorySize.Packed128_Float32,// EVEX_Vreduceps_xmm_k1z_xmmm128b32_imm8
			(byte)MemorySize.Packed256_Float32,// EVEX_Vreduceps_ymm_k1z_ymmm256b32_imm8
			(byte)MemorySize.Packed512_Float32,// EVEX_Vreduceps_zmm_k1z_zmmm512b32_imm8_sae
			(byte)MemorySize.Packed128_Float64,// EVEX_Vreducepd_xmm_k1z_xmmm128b64_imm8
			(byte)MemorySize.Packed256_Float64,// EVEX_Vreducepd_ymm_k1z_ymmm256b64_imm8
			(byte)MemorySize.Packed512_Float64,// EVEX_Vreducepd_zmm_k1z_zmmm512b64_imm8_sae
			(byte)MemorySize.Float32,// EVEX_Vreducess_xmm_k1z_xmm_xmmm32_imm8_sae
			(byte)MemorySize.Float64,// EVEX_Vreducesd_xmm_k1z_xmm_xmmm64_imm8_sae
			(byte)MemorySize.Packed128_Float32,// VEX_Vfmaddsubps_xmm_xmm_xmmm128_xmm
			(byte)MemorySize.Packed256_Float32,// VEX_Vfmaddsubps_ymm_ymm_ymmm256_ymm
			(byte)MemorySize.Packed128_Float32,// VEX_Vfmaddsubps_xmm_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vfmaddsubps_ymm_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// VEX_Vfmaddsubpd_xmm_xmm_xmmm128_xmm
			(byte)MemorySize.Packed256_Float64,// VEX_Vfmaddsubpd_ymm_ymm_ymmm256_ymm
			(byte)MemorySize.Packed128_Float64,// VEX_Vfmaddsubpd_xmm_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vfmaddsubpd_ymm_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float32,// VEX_Vfmsubaddps_xmm_xmm_xmmm128_xmm
			(byte)MemorySize.Packed256_Float32,// VEX_Vfmsubaddps_ymm_ymm_ymmm256_ymm
			(byte)MemorySize.Packed128_Float32,// VEX_Vfmsubaddps_xmm_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vfmsubaddps_ymm_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// VEX_Vfmsubaddpd_xmm_xmm_xmmm128_xmm
			(byte)MemorySize.Packed256_Float64,// VEX_Vfmsubaddpd_ymm_ymm_ymmm256_ymm
			(byte)MemorySize.Packed128_Float64,// VEX_Vfmsubaddpd_xmm_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vfmsubaddpd_ymm_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt8,// Pcmpestrm_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_UInt8,// Pcmpestrm64_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_UInt8,// VEX_Vpcmpestrm_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_UInt8,// VEX_Vpcmpestrm64_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_UInt8,// Pcmpestri_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_UInt8,// Pcmpestri64_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_UInt8,// VEX_Vpcmpestri_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_UInt8,// VEX_Vpcmpestri64_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_UInt8,// Pcmpistrm_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_UInt8,// VEX_Vpcmpistrm_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_UInt8,// Pcmpistri_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_UInt8,// VEX_Vpcmpistri_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_Float32,// EVEX_Vfpclassps_kr_k1_xmmm128b32_imm8
			(byte)MemorySize.Packed256_Float32,// EVEX_Vfpclassps_kr_k1_ymmm256b32_imm8
			(byte)MemorySize.Packed512_Float32,// EVEX_Vfpclassps_kr_k1_zmmm512b32_imm8
			(byte)MemorySize.Packed128_Float64,// EVEX_Vfpclasspd_kr_k1_xmmm128b64_imm8
			(byte)MemorySize.Packed256_Float64,// EVEX_Vfpclasspd_kr_k1_ymmm256b64_imm8
			(byte)MemorySize.Packed512_Float64,// EVEX_Vfpclasspd_kr_k1_zmmm512b64_imm8
			(byte)MemorySize.Float32,// EVEX_Vfpclassss_kr_k1_xmmm32_imm8
			(byte)MemorySize.Float64,// EVEX_Vfpclasssd_kr_k1_xmmm64_imm8
			(byte)MemorySize.Packed128_Float32,// VEX_Vfmaddps_xmm_xmm_xmmm128_xmm
			(byte)MemorySize.Packed256_Float32,// VEX_Vfmaddps_ymm_ymm_ymmm256_ymm
			(byte)MemorySize.Packed128_Float32,// VEX_Vfmaddps_xmm_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vfmaddps_ymm_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// VEX_Vfmaddpd_xmm_xmm_xmmm128_xmm
			(byte)MemorySize.Packed256_Float64,// VEX_Vfmaddpd_ymm_ymm_ymmm256_ymm
			(byte)MemorySize.Packed128_Float64,// VEX_Vfmaddpd_xmm_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vfmaddpd_ymm_ymm_ymm_ymmm256
			(byte)MemorySize.Float32,// VEX_Vfmaddss_xmm_xmm_xmmm32_xmm
			(byte)MemorySize.Float32,// VEX_Vfmaddss_xmm_xmm_xmm_xmmm32
			(byte)MemorySize.Float64,// VEX_Vfmaddsd_xmm_xmm_xmmm64_xmm
			(byte)MemorySize.Float64,// VEX_Vfmaddsd_xmm_xmm_xmm_xmmm64
			(byte)MemorySize.Packed128_Float32,// VEX_Vfmsubps_xmm_xmm_xmmm128_xmm
			(byte)MemorySize.Packed256_Float32,// VEX_Vfmsubps_ymm_ymm_ymmm256_ymm
			(byte)MemorySize.Packed128_Float32,// VEX_Vfmsubps_xmm_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vfmsubps_ymm_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// VEX_Vfmsubpd_xmm_xmm_xmmm128_xmm
			(byte)MemorySize.Packed256_Float64,// VEX_Vfmsubpd_ymm_ymm_ymmm256_ymm
			(byte)MemorySize.Packed128_Float64,// VEX_Vfmsubpd_xmm_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vfmsubpd_ymm_ymm_ymm_ymmm256
			(byte)MemorySize.Float32,// VEX_Vfmsubss_xmm_xmm_xmmm32_xmm
			(byte)MemorySize.Float32,// VEX_Vfmsubss_xmm_xmm_xmm_xmmm32
			(byte)MemorySize.Float64,// VEX_Vfmsubsd_xmm_xmm_xmmm64_xmm
			(byte)MemorySize.Float64,// VEX_Vfmsubsd_xmm_xmm_xmm_xmmm64
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpshldw_xmm_k1z_xmm_xmmm128_imm8
			(byte)MemorySize.Packed256_UInt16,// EVEX_Vpshldw_ymm_k1z_ymm_ymmm256_imm8
			(byte)MemorySize.Packed512_UInt16,// EVEX_Vpshldw_zmm_k1z_zmm_zmmm512_imm8
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vpshldd_xmm_k1z_xmm_xmmm128b32_imm8
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vpshldd_ymm_k1z_ymm_ymmm256b32_imm8
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vpshldd_zmm_k1z_zmm_zmmm512b32_imm8
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vpshldq_xmm_k1z_xmm_xmmm128b64_imm8
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vpshldq_ymm_k1z_ymm_ymmm256b64_imm8
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vpshldq_zmm_k1z_zmm_zmmm512b64_imm8
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vpshrdw_xmm_k1z_xmm_xmmm128_imm8
			(byte)MemorySize.Packed256_UInt16,// EVEX_Vpshrdw_ymm_k1z_ymm_ymmm256_imm8
			(byte)MemorySize.Packed512_UInt16,// EVEX_Vpshrdw_zmm_k1z_zmm_zmmm512_imm8
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vpshrdd_xmm_k1z_xmm_xmmm128b32_imm8
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vpshrdd_ymm_k1z_ymm_ymmm256b32_imm8
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vpshrdd_zmm_k1z_zmm_zmmm512b32_imm8
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vpshrdq_xmm_k1z_xmm_xmmm128b64_imm8
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vpshrdq_ymm_k1z_ymm_ymmm256b64_imm8
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vpshrdq_zmm_k1z_zmm_zmmm512b64_imm8
			(byte)MemorySize.Packed128_Float32,// VEX_Vfnmaddps_xmm_xmm_xmmm128_xmm
			(byte)MemorySize.Packed256_Float32,// VEX_Vfnmaddps_ymm_ymm_ymmm256_ymm
			(byte)MemorySize.Packed128_Float32,// VEX_Vfnmaddps_xmm_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vfnmaddps_ymm_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// VEX_Vfnmaddpd_xmm_xmm_xmmm128_xmm
			(byte)MemorySize.Packed256_Float64,// VEX_Vfnmaddpd_ymm_ymm_ymmm256_ymm
			(byte)MemorySize.Packed128_Float64,// VEX_Vfnmaddpd_xmm_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vfnmaddpd_ymm_ymm_ymm_ymmm256
			(byte)MemorySize.Float32,// VEX_Vfnmaddss_xmm_xmm_xmmm32_xmm
			(byte)MemorySize.Float32,// VEX_Vfnmaddss_xmm_xmm_xmm_xmmm32
			(byte)MemorySize.Float64,// VEX_Vfnmaddsd_xmm_xmm_xmmm64_xmm
			(byte)MemorySize.Float64,// VEX_Vfnmaddsd_xmm_xmm_xmm_xmmm64
			(byte)MemorySize.Packed128_Float32,// VEX_Vfnmsubps_xmm_xmm_xmmm128_xmm
			(byte)MemorySize.Packed256_Float32,// VEX_Vfnmsubps_ymm_ymm_ymmm256_ymm
			(byte)MemorySize.Packed128_Float32,// VEX_Vfnmsubps_xmm_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// VEX_Vfnmsubps_ymm_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// VEX_Vfnmsubpd_xmm_xmm_xmmm128_xmm
			(byte)MemorySize.Packed256_Float64,// VEX_Vfnmsubpd_ymm_ymm_ymmm256_ymm
			(byte)MemorySize.Packed128_Float64,// VEX_Vfnmsubpd_xmm_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// VEX_Vfnmsubpd_ymm_ymm_ymm_ymmm256
			(byte)MemorySize.Float32,// VEX_Vfnmsubss_xmm_xmm_xmmm32_xmm
			(byte)MemorySize.Float32,// VEX_Vfnmsubss_xmm_xmm_xmm_xmmm32
			(byte)MemorySize.Float64,// VEX_Vfnmsubsd_xmm_xmm_xmmm64_xmm
			(byte)MemorySize.Float64,// VEX_Vfnmsubsd_xmm_xmm_xmm_xmmm64
			(byte)MemorySize.Packed128_UInt32,// Sha1rnds4_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_UInt8,// Gf2p8affineqb_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_UInt8,// VEX_Vgf2p8affineqb_xmm_xmm_xmmm128_imm8
			(byte)MemorySize.Packed256_UInt8,// VEX_Vgf2p8affineqb_ymm_ymm_ymmm256_imm8
			(byte)MemorySize.Packed128_UInt8,// EVEX_Vgf2p8affineqb_xmm_k1z_xmm_xmmm128b64_imm8
			(byte)MemorySize.Packed256_UInt8,// EVEX_Vgf2p8affineqb_ymm_k1z_ymm_ymmm256b64_imm8
			(byte)MemorySize.Packed512_UInt8,// EVEX_Vgf2p8affineqb_zmm_k1z_zmm_zmmm512b64_imm8
			(byte)MemorySize.Packed128_UInt8,// Gf2p8affineinvqb_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_UInt8,// VEX_Vgf2p8affineinvqb_xmm_xmm_xmmm128_imm8
			(byte)MemorySize.Packed256_UInt8,// VEX_Vgf2p8affineinvqb_ymm_ymm_ymmm256_imm8
			(byte)MemorySize.Packed128_UInt8,// EVEX_Vgf2p8affineinvqb_xmm_k1z_xmm_xmmm128b64_imm8
			(byte)MemorySize.Packed256_UInt8,// EVEX_Vgf2p8affineinvqb_ymm_k1z_ymm_ymmm256b64_imm8
			(byte)MemorySize.Packed512_UInt8,// EVEX_Vgf2p8affineinvqb_zmm_k1z_zmm_zmmm512b64_imm8
			(byte)MemorySize.UInt128,// Aeskeygenassist_xmm_xmmm128_imm8
			(byte)MemorySize.UInt128,// VEX_Vaeskeygenassist_xmm_xmmm128_imm8
			(byte)MemorySize.UInt32,// VEX_Rorx_r32_rm32_imm8
			(byte)MemorySize.UInt64,// VEX_Rorx_r64_rm64_imm8
			(byte)MemorySize.Packed128_Int16,// XOP_Vpmacssww_xmm_xmm_xmmm128_xmm
			(byte)MemorySize.Packed128_Int16,// XOP_Vpmacsswd_xmm_xmm_xmmm128_xmm
			(byte)MemorySize.Packed128_Int32,// XOP_Vpmacssdql_xmm_xmm_xmmm128_xmm
			(byte)MemorySize.Packed128_Int32,// XOP_Vpmacssdd_xmm_xmm_xmmm128_xmm
			(byte)MemorySize.Packed128_Int32,// XOP_Vpmacssdqh_xmm_xmm_xmmm128_xmm
			(byte)MemorySize.Packed128_Int16,// XOP_Vpmacsww_xmm_xmm_xmmm128_xmm
			(byte)MemorySize.Packed128_Int16,// XOP_Vpmacswd_xmm_xmm_xmmm128_xmm
			(byte)MemorySize.Packed128_Int32,// XOP_Vpmacsdql_xmm_xmm_xmmm128_xmm
			(byte)MemorySize.Packed128_Int32,// XOP_Vpmacsdd_xmm_xmm_xmmm128_xmm
			(byte)MemorySize.Packed128_Int32,// XOP_Vpmacsdqh_xmm_xmm_xmmm128_xmm
			(byte)MemorySize.UInt128,// XOP_Vpcmov_xmm_xmm_xmmm128_xmm
			(byte)MemorySize.UInt256,// XOP_Vpcmov_ymm_ymm_ymmm256_ymm
			(byte)MemorySize.UInt128,// XOP_Vpcmov_xmm_xmm_xmm_xmmm128
			(byte)MemorySize.UInt256,// XOP_Vpcmov_ymm_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_UInt8,// XOP_Vpperm_xmm_xmm_xmmm128_xmm
			(byte)MemorySize.Packed128_UInt8,// XOP_Vpperm_xmm_xmm_xmm_xmmm128
			(byte)MemorySize.Packed128_Int16,// XOP_Vpmadcsswd_xmm_xmm_xmmm128_xmm
			(byte)MemorySize.Packed128_Int16,// XOP_Vpmadcswd_xmm_xmm_xmmm128_xmm
			(byte)MemorySize.Packed128_UInt8,// XOP_Vprotb_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_UInt16,// XOP_Vprotw_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_UInt32,// XOP_Vprotd_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_UInt64,// XOP_Vprotq_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_Int8,// XOP_Vpcomb_xmm_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_Int16,// XOP_Vpcomw_xmm_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_Int32,// XOP_Vpcomd_xmm_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_Int64,// XOP_Vpcomq_xmm_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_UInt8,// XOP_Vpcomub_xmm_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_UInt16,// XOP_Vpcomuw_xmm_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_UInt32,// XOP_Vpcomud_xmm_xmm_xmmm128_imm8
			(byte)MemorySize.Packed128_UInt64,// XOP_Vpcomuq_xmm_xmm_xmmm128_imm8
			(byte)MemorySize.UInt32,// XOP_Blcfill_r32_rm32
			(byte)MemorySize.UInt64,// XOP_Blcfill_r64_rm64
			(byte)MemorySize.UInt32,// XOP_Blsfill_r32_rm32
			(byte)MemorySize.UInt64,// XOP_Blsfill_r64_rm64
			(byte)MemorySize.UInt32,// XOP_Blcs_r32_rm32
			(byte)MemorySize.UInt64,// XOP_Blcs_r64_rm64
			(byte)MemorySize.UInt32,// XOP_Tzmsk_r32_rm32
			(byte)MemorySize.UInt64,// XOP_Tzmsk_r64_rm64
			(byte)MemorySize.UInt32,// XOP_Blcic_r32_rm32
			(byte)MemorySize.UInt64,// XOP_Blcic_r64_rm64
			(byte)MemorySize.UInt32,// XOP_Blsic_r32_rm32
			(byte)MemorySize.UInt64,// XOP_Blsic_r64_rm64
			(byte)MemorySize.UInt32,// XOP_T1mskc_r32_rm32
			(byte)MemorySize.UInt64,// XOP_T1mskc_r64_rm64
			(byte)MemorySize.UInt32,// XOP_Blcmsk_r32_rm32
			(byte)MemorySize.UInt64,// XOP_Blcmsk_r64_rm64
			(byte)MemorySize.UInt32,// XOP_Blci_r32_rm32
			(byte)MemorySize.UInt64,// XOP_Blci_r64_rm64
			0,// XOP_Llwpcb_r32
			0,// XOP_Llwpcb_r64
			0,// XOP_Slwpcb_r32
			0,// XOP_Slwpcb_r64
			(byte)MemorySize.Packed128_Float32,// XOP_Vfrczps_xmm_xmmm128
			(byte)MemorySize.Packed256_Float32,// XOP_Vfrczps_ymm_ymmm256
			(byte)MemorySize.Packed128_Float64,// XOP_Vfrczpd_xmm_xmmm128
			(byte)MemorySize.Packed256_Float64,// XOP_Vfrczpd_ymm_ymmm256
			(byte)MemorySize.Float32,// XOP_Vfrczss_xmm_xmmm32
			(byte)MemorySize.Float64,// XOP_Vfrczsd_xmm_xmmm64
			(byte)MemorySize.Packed128_UInt8,// XOP_Vprotb_xmm_xmmm128_xmm
			(byte)MemorySize.Packed128_UInt8,// XOP_Vprotb_xmm_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt16,// XOP_Vprotw_xmm_xmmm128_xmm
			(byte)MemorySize.Packed128_UInt16,// XOP_Vprotw_xmm_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt32,// XOP_Vprotd_xmm_xmmm128_xmm
			(byte)MemorySize.Packed128_UInt32,// XOP_Vprotd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt64,// XOP_Vprotq_xmm_xmmm128_xmm
			(byte)MemorySize.Packed128_UInt64,// XOP_Vprotq_xmm_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt8,// XOP_Vpshlb_xmm_xmmm128_xmm
			(byte)MemorySize.Packed128_UInt8,// XOP_Vpshlb_xmm_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt16,// XOP_Vpshlw_xmm_xmmm128_xmm
			(byte)MemorySize.Packed128_UInt16,// XOP_Vpshlw_xmm_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt32,// XOP_Vpshld_xmm_xmmm128_xmm
			(byte)MemorySize.Packed128_UInt32,// XOP_Vpshld_xmm_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt64,// XOP_Vpshlq_xmm_xmmm128_xmm
			(byte)MemorySize.Packed128_UInt64,// XOP_Vpshlq_xmm_xmm_xmmm128
			(byte)MemorySize.Packed128_Int8,// XOP_Vpshab_xmm_xmmm128_xmm
			(byte)MemorySize.Packed128_Int8,// XOP_Vpshab_xmm_xmm_xmmm128
			(byte)MemorySize.Packed128_Int16,// XOP_Vpshaw_xmm_xmmm128_xmm
			(byte)MemorySize.Packed128_Int16,// XOP_Vpshaw_xmm_xmm_xmmm128
			(byte)MemorySize.Packed128_Int32,// XOP_Vpshad_xmm_xmmm128_xmm
			(byte)MemorySize.Packed128_Int32,// XOP_Vpshad_xmm_xmm_xmmm128
			(byte)MemorySize.Packed128_Int64,// XOP_Vpshaq_xmm_xmmm128_xmm
			(byte)MemorySize.Packed128_Int64,// XOP_Vpshaq_xmm_xmm_xmmm128
			(byte)MemorySize.Packed128_Int8,// XOP_Vphaddbw_xmm_xmmm128
			(byte)MemorySize.Packed128_Int8,// XOP_Vphaddbd_xmm_xmmm128
			(byte)MemorySize.Packed128_Int8,// XOP_Vphaddbq_xmm_xmmm128
			(byte)MemorySize.Packed128_Int16,// XOP_Vphaddwd_xmm_xmmm128
			(byte)MemorySize.Packed128_Int16,// XOP_Vphaddwq_xmm_xmmm128
			(byte)MemorySize.Packed128_Int32,// XOP_Vphadddq_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt8,// XOP_Vphaddubw_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt8,// XOP_Vphaddubd_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt8,// XOP_Vphaddubq_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt16,// XOP_Vphadduwd_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt16,// XOP_Vphadduwq_xmm_xmmm128
			(byte)MemorySize.Packed128_UInt32,// XOP_Vphaddudq_xmm_xmmm128
			(byte)MemorySize.Packed128_Int8,// XOP_Vphsubbw_xmm_xmmm128
			(byte)MemorySize.Packed128_Int16,// XOP_Vphsubwd_xmm_xmmm128
			(byte)MemorySize.Packed128_Int32,// XOP_Vphsubdq_xmm_xmmm128
			(byte)MemorySize.UInt32,// XOP_Bextr_r32_rm32_imm32
			(byte)MemorySize.UInt64,// XOP_Bextr_r64_rm64_imm32
			(byte)MemorySize.UInt32,// XOP_Lwpins_r32_rm32_imm32
			(byte)MemorySize.UInt32,// XOP_Lwpins_r64_rm32_imm32
			(byte)MemorySize.UInt32,// XOP_Lwpval_r32_rm32_imm32
			(byte)MemorySize.UInt32,// XOP_Lwpval_r64_rm32_imm32
			(byte)MemorySize.Packed64_Int16,// D3NOW_Pi2fw_mm_mmm64
			(byte)MemorySize.Packed64_Int32,// D3NOW_Pi2fd_mm_mmm64
			(byte)MemorySize.Packed64_Float32,// D3NOW_Pf2iw_mm_mmm64
			(byte)MemorySize.Packed64_Float32,// D3NOW_Pf2id_mm_mmm64
			(byte)MemorySize.Packed64_Float32,// D3NOW_Pfrcpv_mm_mmm64
			(byte)MemorySize.Packed64_Float32,// D3NOW_Pfrsqrtv_mm_mmm64
			(byte)MemorySize.Packed64_Float32,// D3NOW_Pfnacc_mm_mmm64
			(byte)MemorySize.Packed64_Float32,// D3NOW_Pfpnacc_mm_mmm64
			(byte)MemorySize.Packed64_Float32,// D3NOW_Pfcmpge_mm_mmm64
			(byte)MemorySize.Packed64_Float32,// D3NOW_Pfmin_mm_mmm64
			(byte)MemorySize.Packed64_Float32,// D3NOW_Pfrcp_mm_mmm64
			(byte)MemorySize.Packed64_Float32,// D3NOW_Pfrsqrt_mm_mmm64
			(byte)MemorySize.Packed64_Float32,// D3NOW_Pfsub_mm_mmm64
			(byte)MemorySize.Packed64_Float32,// D3NOW_Pfadd_mm_mmm64
			(byte)MemorySize.Packed64_Float32,// D3NOW_Pfcmpgt_mm_mmm64
			(byte)MemorySize.Packed64_Float32,// D3NOW_Pfmax_mm_mmm64
			(byte)MemorySize.Packed64_Float32,// D3NOW_Pfrcpit1_mm_mmm64
			(byte)MemorySize.Packed64_Float32,// D3NOW_Pfrsqit1_mm_mmm64
			(byte)MemorySize.Packed64_Float32,// D3NOW_Pfsubr_mm_mmm64
			(byte)MemorySize.Packed64_Float32,// D3NOW_Pfacc_mm_mmm64
			(byte)MemorySize.Packed64_Float32,// D3NOW_Pfcmpeq_mm_mmm64
			(byte)MemorySize.Packed64_Float32,// D3NOW_Pfmul_mm_mmm64
			(byte)MemorySize.Packed64_Float32,// D3NOW_Pfrcpit2_mm_mmm64
			(byte)MemorySize.Packed64_Int16,// D3NOW_Pmulhrw_mm_mmm64
			(byte)MemorySize.Packed64_UInt32,// D3NOW_Pswapd_mm_mmm64
			(byte)MemorySize.Packed64_UInt8,// D3NOW_Pavgusb_mm_mmm64
			0,// Rmpadjust
			0,// Rmpupdate
			0,// Psmash
			0,// Pvalidatew
			0,// Pvalidated
			0,// Pvalidateq
			0,// Serialize
			0,// Xsusldtrk
			0,// Xresldtrk
			0,// Invlpgbw
			0,// Invlpgbd
			0,// Invlpgbq
			0,// Tlbsync
			(byte)MemorySize.UInt8,// Prefetchreserved3_m8
			(byte)MemorySize.UInt8,// Prefetchreserved4_m8
			(byte)MemorySize.UInt8,// Prefetchreserved5_m8
			(byte)MemorySize.UInt8,// Prefetchreserved6_m8
			(byte)MemorySize.UInt8,// Prefetchreserved7_m8
			0,// Ud0
			0,// Vmgexit
			0,// Getsecq
			(byte)MemorySize.Tilecfg,// VEX_Ldtilecfg_m512
			0,// VEX_Tilerelease
			(byte)MemorySize.Tilecfg,// VEX_Sttilecfg_m512
			0,// VEX_Tilezero_tmm
			(byte)MemorySize.Tile,// VEX_Tileloaddt1_tmm_sibmem
			(byte)MemorySize.Tile,// VEX_Tilestored_sibmem_tmm
			(byte)MemorySize.Tile,// VEX_Tileloadd_tmm_sibmem
			0,// VEX_Tdpbf16ps_tmm_tmm_tmm
			0,// VEX_Tdpbuud_tmm_tmm_tmm
			0,// VEX_Tdpbusd_tmm_tmm_tmm
			0,// VEX_Tdpbsud_tmm_tmm_tmm
			0,// VEX_Tdpbssd_tmm_tmm_tmm
			0,// Fnstdw_AX
			0,// Fnstsg_AX
			(byte)MemorySize.UInt32,// Rdshr_rm32
			(byte)MemorySize.UInt32,// Wrshr_rm32
			0,// Smint
			0,// Dmint
			0,// Rdm
			(byte)MemorySize.SegmentDescSelector,// Svdc_m80_Sreg
			(byte)MemorySize.SegmentDescSelector,// Rsdc_Sreg_m80
			(byte)MemorySize.SegmentDescSelector,// Svldt_m80
			(byte)MemorySize.SegmentDescSelector,// Rsldt_m80
			(byte)MemorySize.SegmentDescSelector,// Svts_m80
			(byte)MemorySize.SegmentDescSelector,// Rsts_m80
			0,// Smint_0F7E
			0,// Bb0_reset
			0,// Bb1_reset
			0,// Cpu_write
			0,// Cpu_read
			0,// Altinst
			(byte)MemorySize.Packed64_UInt8,// Paveb_mm_mmm64
			(byte)MemorySize.Packed64_Int16,// Paddsiw_mm_mmm64
			(byte)MemorySize.Packed64_UInt16,// Pmagw_mm_mmm64
			(byte)MemorySize.Packed64_UInt8,// Pdistib_mm_m64
			(byte)MemorySize.Packed64_Int16,// Psubsiw_mm_mmm64
			(byte)MemorySize.Packed64_UInt8,// Pmvzb_mm_m64
			(byte)MemorySize.Packed64_Int16,// Pmulhrw_mm_mmm64
			(byte)MemorySize.Packed64_UInt8,// Pmvnzb_mm_m64
			(byte)MemorySize.Packed64_Int8,// Pmvlzb_mm_m64
			(byte)MemorySize.Packed64_Int8,// Pmvgezb_mm_m64
			(byte)MemorySize.Packed64_Int16,// Pmulhriw_mm_mmm64
			(byte)MemorySize.Packed64_UInt16,// Pmachriw_mm_m64
			0,// Cyrix_D9D7
			0,// Cyrix_D9E2
			0,// Ftstp
			0,// Cyrix_D9E7
			0,// Frint2
			0,// Frichop
			0,// Cyrix_DED8
			0,// Cyrix_DEDA
			0,// Cyrix_DEDC
			0,// Cyrix_DEDD
			0,// Cyrix_DEDE
			0,// Frinear
			0,// Tdcall
			0,// Seamret
			0,// Seamops
			0,// Seamcall
			(byte)MemorySize.KLHandleAes128,// Aesencwide128kl_m384
			(byte)MemorySize.KLHandleAes128,// Aesdecwide128kl_m384
			(byte)MemorySize.KLHandleAes256,// Aesencwide256kl_m512
			(byte)MemorySize.KLHandleAes256,// Aesdecwide256kl_m512
			0,// Loadiwkey_xmm_xmm
			(byte)MemorySize.KLHandleAes128,// Aesenc128kl_xmm_m384
			(byte)MemorySize.KLHandleAes128,// Aesdec128kl_xmm_m384
			(byte)MemorySize.KLHandleAes256,// Aesenc256kl_xmm_m512
			(byte)MemorySize.KLHandleAes256,// Aesdec256kl_xmm_m512
			0,// Encodekey128_r32_r32
			0,// Encodekey256_r32_r32
			0,// VEX_Vbroadcastss_xmm_xmm
			0,// VEX_Vbroadcastss_ymm_xmm
			0,// VEX_Vbroadcastsd_ymm_xmm
			0,// Vmgexit_F2
			0,// Uiret
			0,// Testui
			0,// Clui
			0,// Stui
			0,// Senduipi_r64
			0,// Hreset_imm8
			(byte)MemorySize.Packed128_Int8,// VEX_Vpdpbusd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Int8,// VEX_Vpdpbusd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Int8,// VEX_Vpdpbusds_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Int8,// VEX_Vpdpbusds_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Int16,// VEX_Vpdpwssd_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Int16,// VEX_Vpdpwssd_ymm_ymm_ymmm256
			(byte)MemorySize.Packed128_Int16,// VEX_Vpdpwssds_xmm_xmm_xmmm128
			(byte)MemorySize.Packed256_Int16,// VEX_Vpdpwssds_ymm_ymm_ymmm256
			0,// Ccs_hash_16
			0,// Ccs_hash_32
			0,// Ccs_hash_64
			0,// Ccs_encrypt_16
			0,// Ccs_encrypt_32
			0,// Ccs_encrypt_64
			(byte)MemorySize.UInt16,// Lkgs_rm16
			(byte)MemorySize.UInt16,// Lkgs_r32m16
			(byte)MemorySize.UInt16,// Lkgs_r64m16
			0,// Eretu
			0,// Erets
			(byte)MemorySize.Packed128_Float16,// EVEX_Vaddph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Packed256_Float16,// EVEX_Vaddph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Packed512_Float16,// EVEX_Vaddph_zmm_k1z_zmm_zmmm512b16_er
			(byte)MemorySize.Float16,// EVEX_Vaddsh_xmm_k1z_xmm_xmmm16_er
			(byte)MemorySize.Packed128_Float16,// EVEX_Vcmpph_kr_k1_xmm_xmmm128b16_imm8
			(byte)MemorySize.Packed256_Float16,// EVEX_Vcmpph_kr_k1_ymm_ymmm256b16_imm8
			(byte)MemorySize.Packed512_Float16,// EVEX_Vcmpph_kr_k1_zmm_zmmm512b16_imm8_sae
			(byte)MemorySize.Float16,// EVEX_Vcmpsh_kr_k1_xmm_xmmm16_imm8_sae
			(byte)MemorySize.Float16,// EVEX_Vcomish_xmm_xmmm16_sae
			(byte)MemorySize.Packed128_Int32,// EVEX_Vcvtdq2ph_xmm_k1z_xmmm128b32
			(byte)MemorySize.Packed256_Int32,// EVEX_Vcvtdq2ph_xmm_k1z_ymmm256b32
			(byte)MemorySize.Packed512_Int32,// EVEX_Vcvtdq2ph_ymm_k1z_zmmm512b32_er
			(byte)MemorySize.Packed128_Float64,// EVEX_Vcvtpd2ph_xmm_k1z_xmmm128b64
			(byte)MemorySize.Packed256_Float64,// EVEX_Vcvtpd2ph_xmm_k1z_ymmm256b64
			(byte)MemorySize.Packed512_Float64,// EVEX_Vcvtpd2ph_xmm_k1z_zmmm512b64_er
			(byte)MemorySize.Packed64_Float16,// EVEX_Vcvtph2dq_xmm_k1z_xmmm64b16
			(byte)MemorySize.Packed128_Float16,// EVEX_Vcvtph2dq_ymm_k1z_xmmm128b16
			(byte)MemorySize.Packed256_Float16,// EVEX_Vcvtph2dq_zmm_k1z_ymmm256b16_er
			(byte)MemorySize.Packed32_Float16,// EVEX_Vcvtph2pd_xmm_k1z_xmmm32b16
			(byte)MemorySize.Packed64_Float16,// EVEX_Vcvtph2pd_ymm_k1z_xmmm64b16
			(byte)MemorySize.Packed128_Float16,// EVEX_Vcvtph2pd_zmm_k1z_xmmm128b16_sae
			(byte)MemorySize.Packed64_Float16,// EVEX_Vcvtph2psx_xmm_k1z_xmmm64b16
			(byte)MemorySize.Packed128_Float16,// EVEX_Vcvtph2psx_ymm_k1z_xmmm128b16
			(byte)MemorySize.Packed256_Float16,// EVEX_Vcvtph2psx_zmm_k1z_ymmm256b16_sae
			(byte)MemorySize.Packed32_Float16,// EVEX_Vcvtph2qq_xmm_k1z_xmmm32b16
			(byte)MemorySize.Packed64_Float16,// EVEX_Vcvtph2qq_ymm_k1z_xmmm64b16
			(byte)MemorySize.Packed128_Float16,// EVEX_Vcvtph2qq_zmm_k1z_xmmm128b16_er
			(byte)MemorySize.Packed64_Float16,// EVEX_Vcvtph2udq_xmm_k1z_xmmm64b16
			(byte)MemorySize.Packed128_Float16,// EVEX_Vcvtph2udq_ymm_k1z_xmmm128b16
			(byte)MemorySize.Packed256_Float16,// EVEX_Vcvtph2udq_zmm_k1z_ymmm256b16_er
			(byte)MemorySize.Packed32_Float16,// EVEX_Vcvtph2uqq_xmm_k1z_xmmm32b16
			(byte)MemorySize.Packed64_Float16,// EVEX_Vcvtph2uqq_ymm_k1z_xmmm64b16
			(byte)MemorySize.Packed128_Float16,// EVEX_Vcvtph2uqq_zmm_k1z_xmmm128b16_er
			(byte)MemorySize.Packed128_Float16,// EVEX_Vcvtph2uw_xmm_k1z_xmmm128b16
			(byte)MemorySize.Packed256_Float16,// EVEX_Vcvtph2uw_ymm_k1z_ymmm256b16
			(byte)MemorySize.Packed512_Float16,// EVEX_Vcvtph2uw_zmm_k1z_zmmm512b16_er
			(byte)MemorySize.Packed128_Float16,// EVEX_Vcvtph2w_xmm_k1z_xmmm128b16
			(byte)MemorySize.Packed256_Float16,// EVEX_Vcvtph2w_ymm_k1z_ymmm256b16
			(byte)MemorySize.Packed512_Float16,// EVEX_Vcvtph2w_zmm_k1z_zmmm512b16_er
			(byte)MemorySize.Packed128_Float32,// EVEX_Vcvtps2phx_xmm_k1z_xmmm128b32
			(byte)MemorySize.Packed256_Float32,// EVEX_Vcvtps2phx_xmm_k1z_ymmm256b32
			(byte)MemorySize.Packed512_Float32,// EVEX_Vcvtps2phx_ymm_k1z_zmmm512b32_er
			(byte)MemorySize.Packed128_Int64,// EVEX_Vcvtqq2ph_xmm_k1z_xmmm128b64
			(byte)MemorySize.Packed256_Int64,// EVEX_Vcvtqq2ph_xmm_k1z_ymmm256b64
			(byte)MemorySize.Packed512_Int64,// EVEX_Vcvtqq2ph_xmm_k1z_zmmm512b64_er
			(byte)MemorySize.Float64,// EVEX_Vcvtsd2sh_xmm_k1z_xmm_xmmm64_er
			(byte)MemorySize.Float16,// EVEX_Vcvtsh2sd_xmm_k1z_xmm_xmmm16_sae
			(byte)MemorySize.Float16,// EVEX_Vcvtsh2si_r32_xmmm16_er
			(byte)MemorySize.Float16,// EVEX_Vcvtsh2si_r64_xmmm16_er
			(byte)MemorySize.Float16,// EVEX_Vcvtsh2ss_xmm_k1z_xmm_xmmm16_sae
			(byte)MemorySize.Float16,// EVEX_Vcvtsh2usi_r32_xmmm16_er
			(byte)MemorySize.Float16,// EVEX_Vcvtsh2usi_r64_xmmm16_er
			(byte)MemorySize.Int32,// EVEX_Vcvtsi2sh_xmm_xmm_rm32_er
			(byte)MemorySize.Int64,// EVEX_Vcvtsi2sh_xmm_xmm_rm64_er
			(byte)MemorySize.Float32,// EVEX_Vcvtss2sh_xmm_k1z_xmm_xmmm32_er
			(byte)MemorySize.Packed64_Float16,// EVEX_Vcvttph2dq_xmm_k1z_xmmm64b16
			(byte)MemorySize.Packed128_Float16,// EVEX_Vcvttph2dq_ymm_k1z_xmmm128b16
			(byte)MemorySize.Packed256_Float16,// EVEX_Vcvttph2dq_zmm_k1z_ymmm256b16_sae
			(byte)MemorySize.Packed32_Float16,// EVEX_Vcvttph2qq_xmm_k1z_xmmm32b16
			(byte)MemorySize.Packed64_Float16,// EVEX_Vcvttph2qq_ymm_k1z_xmmm64b16
			(byte)MemorySize.Packed128_Float16,// EVEX_Vcvttph2qq_zmm_k1z_xmmm128b16_sae
			(byte)MemorySize.Packed64_Float16,// EVEX_Vcvttph2udq_xmm_k1z_xmmm64b16
			(byte)MemorySize.Packed128_Float16,// EVEX_Vcvttph2udq_ymm_k1z_xmmm128b16
			(byte)MemorySize.Packed256_Float16,// EVEX_Vcvttph2udq_zmm_k1z_ymmm256b16_sae
			(byte)MemorySize.Packed32_Float16,// EVEX_Vcvttph2uqq_xmm_k1z_xmmm32b16
			(byte)MemorySize.Packed64_Float16,// EVEX_Vcvttph2uqq_ymm_k1z_xmmm64b16
			(byte)MemorySize.Packed128_Float16,// EVEX_Vcvttph2uqq_zmm_k1z_xmmm128b16_sae
			(byte)MemorySize.Packed128_Float16,// EVEX_Vcvttph2uw_xmm_k1z_xmmm128b16
			(byte)MemorySize.Packed256_Float16,// EVEX_Vcvttph2uw_ymm_k1z_ymmm256b16
			(byte)MemorySize.Packed512_Float16,// EVEX_Vcvttph2uw_zmm_k1z_zmmm512b16_sae
			(byte)MemorySize.Packed128_Float16,// EVEX_Vcvttph2w_xmm_k1z_xmmm128b16
			(byte)MemorySize.Packed256_Float16,// EVEX_Vcvttph2w_ymm_k1z_ymmm256b16
			(byte)MemorySize.Packed512_Float16,// EVEX_Vcvttph2w_zmm_k1z_zmmm512b16_sae
			(byte)MemorySize.Float16,// EVEX_Vcvttsh2si_r32_xmmm16_sae
			(byte)MemorySize.Float16,// EVEX_Vcvttsh2si_r64_xmmm16_sae
			(byte)MemorySize.Float16,// EVEX_Vcvttsh2usi_r32_xmmm16_sae
			(byte)MemorySize.Float16,// EVEX_Vcvttsh2usi_r64_xmmm16_sae
			(byte)MemorySize.Packed128_UInt32,// EVEX_Vcvtudq2ph_xmm_k1z_xmmm128b32
			(byte)MemorySize.Packed256_UInt32,// EVEX_Vcvtudq2ph_xmm_k1z_ymmm256b32
			(byte)MemorySize.Packed512_UInt32,// EVEX_Vcvtudq2ph_ymm_k1z_zmmm512b32_er
			(byte)MemorySize.Packed128_UInt64,// EVEX_Vcvtuqq2ph_xmm_k1z_xmmm128b64
			(byte)MemorySize.Packed256_UInt64,// EVEX_Vcvtuqq2ph_xmm_k1z_ymmm256b64
			(byte)MemorySize.Packed512_UInt64,// EVEX_Vcvtuqq2ph_xmm_k1z_zmmm512b64_er
			(byte)MemorySize.UInt32,// EVEX_Vcvtusi2sh_xmm_xmm_rm32_er
			(byte)MemorySize.UInt64,// EVEX_Vcvtusi2sh_xmm_xmm_rm64_er
			(byte)MemorySize.Packed128_UInt16,// EVEX_Vcvtuw2ph_xmm_k1z_xmmm128b16
			(byte)MemorySize.Packed256_UInt16,// EVEX_Vcvtuw2ph_ymm_k1z_ymmm256b16
			(byte)MemorySize.Packed512_UInt16,// EVEX_Vcvtuw2ph_zmm_k1z_zmmm512b16_er
			(byte)MemorySize.Packed128_Int16,// EVEX_Vcvtw2ph_xmm_k1z_xmmm128b16
			(byte)MemorySize.Packed256_Int16,// EVEX_Vcvtw2ph_ymm_k1z_ymmm256b16
			(byte)MemorySize.Packed512_Int16,// EVEX_Vcvtw2ph_zmm_k1z_zmmm512b16_er
			(byte)MemorySize.Packed128_Float16,// EVEX_Vdivph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Packed256_Float16,// EVEX_Vdivph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Packed512_Float16,// EVEX_Vdivph_zmm_k1z_zmm_zmmm512b16_er
			(byte)MemorySize.Float16,// EVEX_Vdivsh_xmm_k1z_xmm_xmmm16_er
			(byte)MemorySize.Packed128_2xFloat16,// EVEX_Vfcmaddcph_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_2xFloat16,// EVEX_Vfcmaddcph_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_2xFloat16,// EVEX_Vfcmaddcph_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Packed128_2xFloat16,// EVEX_Vfmaddcph_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_2xFloat16,// EVEX_Vfmaddcph_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_2xFloat16,// EVEX_Vfmaddcph_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Packed32_Float16,// EVEX_Vfcmaddcsh_xmm_k1z_xmm_xmmm32_er
			(byte)MemorySize.Packed32_Float16,// EVEX_Vfmaddcsh_xmm_k1z_xmm_xmmm32_er
			(byte)MemorySize.Packed128_2xFloat16,// EVEX_Vfcmulcph_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_2xFloat16,// EVEX_Vfcmulcph_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_2xFloat16,// EVEX_Vfcmulcph_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Packed128_2xFloat16,// EVEX_Vfmulcph_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Packed256_2xFloat16,// EVEX_Vfmulcph_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Packed512_2xFloat16,// EVEX_Vfmulcph_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Packed32_Float16,// EVEX_Vfcmulcsh_xmm_k1z_xmm_xmmm32_er
			(byte)MemorySize.Packed32_Float16,// EVEX_Vfmulcsh_xmm_k1z_xmm_xmmm32_er
			(byte)MemorySize.Packed128_Float16,// EVEX_Vfmaddsub132ph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Packed256_Float16,// EVEX_Vfmaddsub132ph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Packed512_Float16,// EVEX_Vfmaddsub132ph_zmm_k1z_zmm_zmmm512b16_er
			(byte)MemorySize.Packed128_Float16,// EVEX_Vfmaddsub213ph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Packed256_Float16,// EVEX_Vfmaddsub213ph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Packed512_Float16,// EVEX_Vfmaddsub213ph_zmm_k1z_zmm_zmmm512b16_er
			(byte)MemorySize.Packed128_Float16,// EVEX_Vfmaddsub231ph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Packed256_Float16,// EVEX_Vfmaddsub231ph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Packed512_Float16,// EVEX_Vfmaddsub231ph_zmm_k1z_zmm_zmmm512b16_er
			(byte)MemorySize.Packed128_Float16,// EVEX_Vfmsubadd132ph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Packed256_Float16,// EVEX_Vfmsubadd132ph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Packed512_Float16,// EVEX_Vfmsubadd132ph_zmm_k1z_zmm_zmmm512b16_er
			(byte)MemorySize.Packed128_Float16,// EVEX_Vfmsubadd213ph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Packed256_Float16,// EVEX_Vfmsubadd213ph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Packed512_Float16,// EVEX_Vfmsubadd213ph_zmm_k1z_zmm_zmmm512b16_er
			(byte)MemorySize.Packed128_Float16,// EVEX_Vfmsubadd231ph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Packed256_Float16,// EVEX_Vfmsubadd231ph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Packed512_Float16,// EVEX_Vfmsubadd231ph_zmm_k1z_zmm_zmmm512b16_er
			(byte)MemorySize.Packed128_Float16,// EVEX_Vfmadd132ph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Packed256_Float16,// EVEX_Vfmadd132ph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Packed512_Float16,// EVEX_Vfmadd132ph_zmm_k1z_zmm_zmmm512b16_er
			(byte)MemorySize.Packed128_Float16,// EVEX_Vfmadd213ph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Packed256_Float16,// EVEX_Vfmadd213ph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Packed512_Float16,// EVEX_Vfmadd213ph_zmm_k1z_zmm_zmmm512b16_er
			(byte)MemorySize.Packed128_Float16,// EVEX_Vfmadd231ph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Packed256_Float16,// EVEX_Vfmadd231ph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Packed512_Float16,// EVEX_Vfmadd231ph_zmm_k1z_zmm_zmmm512b16_er
			(byte)MemorySize.Packed128_Float16,// EVEX_Vfnmadd132ph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Packed256_Float16,// EVEX_Vfnmadd132ph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Packed512_Float16,// EVEX_Vfnmadd132ph_zmm_k1z_zmm_zmmm512b16_er
			(byte)MemorySize.Packed128_Float16,// EVEX_Vfnmadd213ph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Packed256_Float16,// EVEX_Vfnmadd213ph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Packed512_Float16,// EVEX_Vfnmadd213ph_zmm_k1z_zmm_zmmm512b16_er
			(byte)MemorySize.Packed128_Float16,// EVEX_Vfnmadd231ph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Packed256_Float16,// EVEX_Vfnmadd231ph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Packed512_Float16,// EVEX_Vfnmadd231ph_zmm_k1z_zmm_zmmm512b16_er
			(byte)MemorySize.Float16,// EVEX_Vfmadd132sh_xmm_k1z_xmm_xmmm16_er
			(byte)MemorySize.Float16,// EVEX_Vfmadd213sh_xmm_k1z_xmm_xmmm16_er
			(byte)MemorySize.Float16,// EVEX_Vfmadd231sh_xmm_k1z_xmm_xmmm16_er
			(byte)MemorySize.Float16,// EVEX_Vfnmadd132sh_xmm_k1z_xmm_xmmm16_er
			(byte)MemorySize.Float16,// EVEX_Vfnmadd213sh_xmm_k1z_xmm_xmmm16_er
			(byte)MemorySize.Float16,// EVEX_Vfnmadd231sh_xmm_k1z_xmm_xmmm16_er
			(byte)MemorySize.Packed128_Float16,// EVEX_Vfmsub132ph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Packed256_Float16,// EVEX_Vfmsub132ph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Packed512_Float16,// EVEX_Vfmsub132ph_zmm_k1z_zmm_zmmm512b16_er
			(byte)MemorySize.Packed128_Float16,// EVEX_Vfmsub213ph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Packed256_Float16,// EVEX_Vfmsub213ph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Packed512_Float16,// EVEX_Vfmsub213ph_zmm_k1z_zmm_zmmm512b16_er
			(byte)MemorySize.Packed128_Float16,// EVEX_Vfmsub231ph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Packed256_Float16,// EVEX_Vfmsub231ph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Packed512_Float16,// EVEX_Vfmsub231ph_zmm_k1z_zmm_zmmm512b16_er
			(byte)MemorySize.Packed128_Float16,// EVEX_Vfnmsub132ph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Packed256_Float16,// EVEX_Vfnmsub132ph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Packed512_Float16,// EVEX_Vfnmsub132ph_zmm_k1z_zmm_zmmm512b16_er
			(byte)MemorySize.Packed128_Float16,// EVEX_Vfnmsub213ph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Packed256_Float16,// EVEX_Vfnmsub213ph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Packed512_Float16,// EVEX_Vfnmsub213ph_zmm_k1z_zmm_zmmm512b16_er
			(byte)MemorySize.Packed128_Float16,// EVEX_Vfnmsub231ph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Packed256_Float16,// EVEX_Vfnmsub231ph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Packed512_Float16,// EVEX_Vfnmsub231ph_zmm_k1z_zmm_zmmm512b16_er
			(byte)MemorySize.Float16,// EVEX_Vfmsub132sh_xmm_k1z_xmm_xmmm16_er
			(byte)MemorySize.Float16,// EVEX_Vfmsub213sh_xmm_k1z_xmm_xmmm16_er
			(byte)MemorySize.Float16,// EVEX_Vfmsub231sh_xmm_k1z_xmm_xmmm16_er
			(byte)MemorySize.Float16,// EVEX_Vfnmsub132sh_xmm_k1z_xmm_xmmm16_er
			(byte)MemorySize.Float16,// EVEX_Vfnmsub213sh_xmm_k1z_xmm_xmmm16_er
			(byte)MemorySize.Float16,// EVEX_Vfnmsub231sh_xmm_k1z_xmm_xmmm16_er
			(byte)MemorySize.Packed128_Float16,// EVEX_Vfpclassph_kr_k1_xmmm128b16_imm8
			(byte)MemorySize.Packed256_Float16,// EVEX_Vfpclassph_kr_k1_ymmm256b16_imm8
			(byte)MemorySize.Packed512_Float16,// EVEX_Vfpclassph_kr_k1_zmmm512b16_imm8
			(byte)MemorySize.Float16,// EVEX_Vfpclasssh_kr_k1_xmmm16_imm8
			(byte)MemorySize.Packed128_Float16,// EVEX_Vgetexpph_xmm_k1z_xmmm128b16
			(byte)MemorySize.Packed256_Float16,// EVEX_Vgetexpph_ymm_k1z_ymmm256b16
			(byte)MemorySize.Packed512_Float16,// EVEX_Vgetexpph_zmm_k1z_zmmm512b16_sae
			(byte)MemorySize.Float16,// EVEX_Vgetexpsh_xmm_k1z_xmm_xmmm16_sae
			(byte)MemorySize.Packed128_Float16,// EVEX_Vgetmantph_xmm_k1z_xmmm128b16_imm8
			(byte)MemorySize.Packed256_Float16,// EVEX_Vgetmantph_ymm_k1z_ymmm256b16_imm8
			(byte)MemorySize.Packed512_Float16,// EVEX_Vgetmantph_zmm_k1z_zmmm512b16_imm8_sae
			(byte)MemorySize.Float16,// EVEX_Vgetmantsh_xmm_k1z_xmm_xmmm16_imm8_sae
			(byte)MemorySize.Packed128_Float16,// EVEX_Vmaxph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Packed256_Float16,// EVEX_Vmaxph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Packed512_Float16,// EVEX_Vmaxph_zmm_k1z_zmm_zmmm512b16_sae
			(byte)MemorySize.Float16,// EVEX_Vmaxsh_xmm_k1z_xmm_xmmm16_sae
			(byte)MemorySize.Packed128_Float16,// EVEX_Vminph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Packed256_Float16,// EVEX_Vminph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Packed512_Float16,// EVEX_Vminph_zmm_k1z_zmm_zmmm512b16_sae
			(byte)MemorySize.Float16,// EVEX_Vminsh_xmm_k1z_xmm_xmmm16_sae
			(byte)MemorySize.Float16,// EVEX_Vmovsh_xmm_k1z_m16
			(byte)MemorySize.Float16,// EVEX_Vmovsh_m16_k1_xmm
			0,// EVEX_Vmovsh_xmm_k1z_xmm_xmm
			0,// EVEX_Vmovsh_xmm_k1z_xmm_xmm_MAP5_11
			(byte)MemorySize.UInt16,// EVEX_Vmovw_xmm_r32m16
			(byte)MemorySize.UInt16,// EVEX_Vmovw_xmm_r64m16
			(byte)MemorySize.UInt16,// EVEX_Vmovw_r32m16_xmm
			(byte)MemorySize.UInt16,// EVEX_Vmovw_r64m16_xmm
			(byte)MemorySize.Packed128_Float16,// EVEX_Vmulph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Packed256_Float16,// EVEX_Vmulph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Packed512_Float16,// EVEX_Vmulph_zmm_k1z_zmm_zmmm512b16_er
			(byte)MemorySize.Float16,// EVEX_Vmulsh_xmm_k1z_xmm_xmmm16_er
			(byte)MemorySize.Packed128_Float16,// EVEX_Vrcpph_xmm_k1z_xmmm128b16
			(byte)MemorySize.Packed256_Float16,// EVEX_Vrcpph_ymm_k1z_ymmm256b16
			(byte)MemorySize.Packed512_Float16,// EVEX_Vrcpph_zmm_k1z_zmmm512b16
			(byte)MemorySize.Float16,// EVEX_Vrcpsh_xmm_k1z_xmm_xmmm16
			(byte)MemorySize.Packed128_Float16,// EVEX_Vreduceph_xmm_k1z_xmmm128b16_imm8
			(byte)MemorySize.Packed256_Float16,// EVEX_Vreduceph_ymm_k1z_ymmm256b16_imm8
			(byte)MemorySize.Packed512_Float16,// EVEX_Vreduceph_zmm_k1z_zmmm512b16_imm8_sae
			(byte)MemorySize.Float16,// EVEX_Vreducesh_xmm_k1z_xmm_xmmm16_imm8_sae
			(byte)MemorySize.Packed128_Float16,// EVEX_Vrndscaleph_xmm_k1z_xmmm128b16_imm8
			(byte)MemorySize.Packed256_Float16,// EVEX_Vrndscaleph_ymm_k1z_ymmm256b16_imm8
			(byte)MemorySize.Packed512_Float16,// EVEX_Vrndscaleph_zmm_k1z_zmmm512b16_imm8_sae
			(byte)MemorySize.Float16,// EVEX_Vrndscalesh_xmm_k1z_xmm_xmmm16_imm8_sae
			(byte)MemorySize.Packed128_Float16,// EVEX_Vrsqrtph_xmm_k1z_xmmm128b16
			(byte)MemorySize.Packed256_Float16,// EVEX_Vrsqrtph_ymm_k1z_ymmm256b16
			(byte)MemorySize.Packed512_Float16,// EVEX_Vrsqrtph_zmm_k1z_zmmm512b16
			(byte)MemorySize.Float16,// EVEX_Vrsqrtsh_xmm_k1z_xmm_xmmm16
			(byte)MemorySize.Packed128_Float16,// EVEX_Vscalefph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Packed256_Float16,// EVEX_Vscalefph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Packed512_Float16,// EVEX_Vscalefph_zmm_k1z_zmm_zmmm512b16_er
			(byte)MemorySize.Float16,// EVEX_Vscalefsh_xmm_k1z_xmm_xmmm16_er
			(byte)MemorySize.Packed128_Float16,// EVEX_Vsqrtph_xmm_k1z_xmmm128b16
			(byte)MemorySize.Packed256_Float16,// EVEX_Vsqrtph_ymm_k1z_ymmm256b16
			(byte)MemorySize.Packed512_Float16,// EVEX_Vsqrtph_zmm_k1z_zmmm512b16_er
			(byte)MemorySize.Float16,// EVEX_Vsqrtsh_xmm_k1z_xmm_xmmm16_er
			(byte)MemorySize.Packed128_Float16,// EVEX_Vsubph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Packed256_Float16,// EVEX_Vsubph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Packed512_Float16,// EVEX_Vsubph_zmm_k1z_zmm_zmmm512b16_er
			(byte)MemorySize.Float16,// EVEX_Vsubsh_xmm_k1z_xmm_xmmm16_er
			(byte)MemorySize.Float16,// EVEX_Vucomish_xmm_xmmm16_sae
			0,// Rdudbg
			0,// Wrudbg
		};

#if HAS_SPAN
		internal static System.ReadOnlySpan<byte> SizesBcst => new byte[IcedConstants.CodeEnumCount] {
#else
		internal static readonly byte[] SizesBcst = new byte[IcedConstants.CodeEnumCount] {
#endif
			0,// INVALID
			0,// DeclareByte
			0,// DeclareWord
			0,// DeclareDword
			0,// DeclareQword
			0,// Add_rm8_r8
			0,// Add_rm16_r16
			0,// Add_rm32_r32
			0,// Add_rm64_r64
			0,// Add_r8_rm8
			0,// Add_r16_rm16
			0,// Add_r32_rm32
			0,// Add_r64_rm64
			0,// Add_AL_imm8
			0,// Add_AX_imm16
			0,// Add_EAX_imm32
			0,// Add_RAX_imm32
			0,// Pushw_ES
			0,// Pushd_ES
			0,// Popw_ES
			0,// Popd_ES
			0,// Or_rm8_r8
			0,// Or_rm16_r16
			0,// Or_rm32_r32
			0,// Or_rm64_r64
			0,// Or_r8_rm8
			0,// Or_r16_rm16
			0,// Or_r32_rm32
			0,// Or_r64_rm64
			0,// Or_AL_imm8
			0,// Or_AX_imm16
			0,// Or_EAX_imm32
			0,// Or_RAX_imm32
			0,// Pushw_CS
			0,// Pushd_CS
			0,// Popw_CS
			0,// Adc_rm8_r8
			0,// Adc_rm16_r16
			0,// Adc_rm32_r32
			0,// Adc_rm64_r64
			0,// Adc_r8_rm8
			0,// Adc_r16_rm16
			0,// Adc_r32_rm32
			0,// Adc_r64_rm64
			0,// Adc_AL_imm8
			0,// Adc_AX_imm16
			0,// Adc_EAX_imm32
			0,// Adc_RAX_imm32
			0,// Pushw_SS
			0,// Pushd_SS
			0,// Popw_SS
			0,// Popd_SS
			0,// Sbb_rm8_r8
			0,// Sbb_rm16_r16
			0,// Sbb_rm32_r32
			0,// Sbb_rm64_r64
			0,// Sbb_r8_rm8
			0,// Sbb_r16_rm16
			0,// Sbb_r32_rm32
			0,// Sbb_r64_rm64
			0,// Sbb_AL_imm8
			0,// Sbb_AX_imm16
			0,// Sbb_EAX_imm32
			0,// Sbb_RAX_imm32
			0,// Pushw_DS
			0,// Pushd_DS
			0,// Popw_DS
			0,// Popd_DS
			0,// And_rm8_r8
			0,// And_rm16_r16
			0,// And_rm32_r32
			0,// And_rm64_r64
			0,// And_r8_rm8
			0,// And_r16_rm16
			0,// And_r32_rm32
			0,// And_r64_rm64
			0,// And_AL_imm8
			0,// And_AX_imm16
			0,// And_EAX_imm32
			0,// And_RAX_imm32
			0,// Daa
			0,// Sub_rm8_r8
			0,// Sub_rm16_r16
			0,// Sub_rm32_r32
			0,// Sub_rm64_r64
			0,// Sub_r8_rm8
			0,// Sub_r16_rm16
			0,// Sub_r32_rm32
			0,// Sub_r64_rm64
			0,// Sub_AL_imm8
			0,// Sub_AX_imm16
			0,// Sub_EAX_imm32
			0,// Sub_RAX_imm32
			0,// Das
			0,// Xor_rm8_r8
			0,// Xor_rm16_r16
			0,// Xor_rm32_r32
			0,// Xor_rm64_r64
			0,// Xor_r8_rm8
			0,// Xor_r16_rm16
			0,// Xor_r32_rm32
			0,// Xor_r64_rm64
			0,// Xor_AL_imm8
			0,// Xor_AX_imm16
			0,// Xor_EAX_imm32
			0,// Xor_RAX_imm32
			0,// Aaa
			0,// Cmp_rm8_r8
			0,// Cmp_rm16_r16
			0,// Cmp_rm32_r32
			0,// Cmp_rm64_r64
			0,// Cmp_r8_rm8
			0,// Cmp_r16_rm16
			0,// Cmp_r32_rm32
			0,// Cmp_r64_rm64
			0,// Cmp_AL_imm8
			0,// Cmp_AX_imm16
			0,// Cmp_EAX_imm32
			0,// Cmp_RAX_imm32
			0,// Aas
			0,// Inc_r16
			0,// Inc_r32
			0,// Dec_r16
			0,// Dec_r32
			0,// Push_r16
			0,// Push_r32
			0,// Push_r64
			0,// Pop_r16
			0,// Pop_r32
			0,// Pop_r64
			0,// Pushaw
			0,// Pushad
			0,// Popaw
			0,// Popad
			0,// Bound_r16_m1616
			0,// Bound_r32_m3232
			0,// Arpl_rm16_r16
			0,// Arpl_r32m16_r32
			0,// Movsxd_r16_rm16
			0,// Movsxd_r32_rm32
			0,// Movsxd_r64_rm32
			0,// Push_imm16
			0,// Pushd_imm32
			0,// Pushq_imm32
			0,// Imul_r16_rm16_imm16
			0,// Imul_r32_rm32_imm32
			0,// Imul_r64_rm64_imm32
			0,// Pushw_imm8
			0,// Pushd_imm8
			0,// Pushq_imm8
			0,// Imul_r16_rm16_imm8
			0,// Imul_r32_rm32_imm8
			0,// Imul_r64_rm64_imm8
			0,// Insb_m8_DX
			0,// Insw_m16_DX
			0,// Insd_m32_DX
			0,// Outsb_DX_m8
			0,// Outsw_DX_m16
			0,// Outsd_DX_m32
			0,// Jo_rel8_16
			0,// Jo_rel8_32
			0,// Jo_rel8_64
			0,// Jno_rel8_16
			0,// Jno_rel8_32
			0,// Jno_rel8_64
			0,// Jb_rel8_16
			0,// Jb_rel8_32
			0,// Jb_rel8_64
			0,// Jae_rel8_16
			0,// Jae_rel8_32
			0,// Jae_rel8_64
			0,// Je_rel8_16
			0,// Je_rel8_32
			0,// Je_rel8_64
			0,// Jne_rel8_16
			0,// Jne_rel8_32
			0,// Jne_rel8_64
			0,// Jbe_rel8_16
			0,// Jbe_rel8_32
			0,// Jbe_rel8_64
			0,// Ja_rel8_16
			0,// Ja_rel8_32
			0,// Ja_rel8_64
			0,// Js_rel8_16
			0,// Js_rel8_32
			0,// Js_rel8_64
			0,// Jns_rel8_16
			0,// Jns_rel8_32
			0,// Jns_rel8_64
			0,// Jp_rel8_16
			0,// Jp_rel8_32
			0,// Jp_rel8_64
			0,// Jnp_rel8_16
			0,// Jnp_rel8_32
			0,// Jnp_rel8_64
			0,// Jl_rel8_16
			0,// Jl_rel8_32
			0,// Jl_rel8_64
			0,// Jge_rel8_16
			0,// Jge_rel8_32
			0,// Jge_rel8_64
			0,// Jle_rel8_16
			0,// Jle_rel8_32
			0,// Jle_rel8_64
			0,// Jg_rel8_16
			0,// Jg_rel8_32
			0,// Jg_rel8_64
			0,// Add_rm8_imm8
			0,// Or_rm8_imm8
			0,// Adc_rm8_imm8
			0,// Sbb_rm8_imm8
			0,// And_rm8_imm8
			0,// Sub_rm8_imm8
			0,// Xor_rm8_imm8
			0,// Cmp_rm8_imm8
			0,// Add_rm16_imm16
			0,// Add_rm32_imm32
			0,// Add_rm64_imm32
			0,// Or_rm16_imm16
			0,// Or_rm32_imm32
			0,// Or_rm64_imm32
			0,// Adc_rm16_imm16
			0,// Adc_rm32_imm32
			0,// Adc_rm64_imm32
			0,// Sbb_rm16_imm16
			0,// Sbb_rm32_imm32
			0,// Sbb_rm64_imm32
			0,// And_rm16_imm16
			0,// And_rm32_imm32
			0,// And_rm64_imm32
			0,// Sub_rm16_imm16
			0,// Sub_rm32_imm32
			0,// Sub_rm64_imm32
			0,// Xor_rm16_imm16
			0,// Xor_rm32_imm32
			0,// Xor_rm64_imm32
			0,// Cmp_rm16_imm16
			0,// Cmp_rm32_imm32
			0,// Cmp_rm64_imm32
			0,// Add_rm8_imm8_82
			0,// Or_rm8_imm8_82
			0,// Adc_rm8_imm8_82
			0,// Sbb_rm8_imm8_82
			0,// And_rm8_imm8_82
			0,// Sub_rm8_imm8_82
			0,// Xor_rm8_imm8_82
			0,// Cmp_rm8_imm8_82
			0,// Add_rm16_imm8
			0,// Add_rm32_imm8
			0,// Add_rm64_imm8
			0,// Or_rm16_imm8
			0,// Or_rm32_imm8
			0,// Or_rm64_imm8
			0,// Adc_rm16_imm8
			0,// Adc_rm32_imm8
			0,// Adc_rm64_imm8
			0,// Sbb_rm16_imm8
			0,// Sbb_rm32_imm8
			0,// Sbb_rm64_imm8
			0,// And_rm16_imm8
			0,// And_rm32_imm8
			0,// And_rm64_imm8
			0,// Sub_rm16_imm8
			0,// Sub_rm32_imm8
			0,// Sub_rm64_imm8
			0,// Xor_rm16_imm8
			0,// Xor_rm32_imm8
			0,// Xor_rm64_imm8
			0,// Cmp_rm16_imm8
			0,// Cmp_rm32_imm8
			0,// Cmp_rm64_imm8
			0,// Test_rm8_r8
			0,// Test_rm16_r16
			0,// Test_rm32_r32
			0,// Test_rm64_r64
			0,// Xchg_rm8_r8
			0,// Xchg_rm16_r16
			0,// Xchg_rm32_r32
			0,// Xchg_rm64_r64
			0,// Mov_rm8_r8
			0,// Mov_rm16_r16
			0,// Mov_rm32_r32
			0,// Mov_rm64_r64
			0,// Mov_r8_rm8
			0,// Mov_r16_rm16
			0,// Mov_r32_rm32
			0,// Mov_r64_rm64
			0,// Mov_rm16_Sreg
			0,// Mov_r32m16_Sreg
			0,// Mov_r64m16_Sreg
			0,// Lea_r16_m
			0,// Lea_r32_m
			0,// Lea_r64_m
			0,// Mov_Sreg_rm16
			0,// Mov_Sreg_r32m16
			0,// Mov_Sreg_r64m16
			0,// Pop_rm16
			0,// Pop_rm32
			0,// Pop_rm64
			0,// Nopw
			0,// Nopd
			0,// Nopq
			0,// Xchg_r16_AX
			0,// Xchg_r32_EAX
			0,// Xchg_r64_RAX
			0,// Pause
			0,// Cbw
			0,// Cwde
			0,// Cdqe
			0,// Cwd
			0,// Cdq
			0,// Cqo
			0,// Call_ptr1616
			0,// Call_ptr1632
			0,// Wait
			0,// Pushfw
			0,// Pushfd
			0,// Pushfq
			0,// Popfw
			0,// Popfd
			0,// Popfq
			0,// Sahf
			0,// Lahf
			0,// Mov_AL_moffs8
			0,// Mov_AX_moffs16
			0,// Mov_EAX_moffs32
			0,// Mov_RAX_moffs64
			0,// Mov_moffs8_AL
			0,// Mov_moffs16_AX
			0,// Mov_moffs32_EAX
			0,// Mov_moffs64_RAX
			0,// Movsb_m8_m8
			0,// Movsw_m16_m16
			0,// Movsd_m32_m32
			0,// Movsq_m64_m64
			0,// Cmpsb_m8_m8
			0,// Cmpsw_m16_m16
			0,// Cmpsd_m32_m32
			0,// Cmpsq_m64_m64
			0,// Test_AL_imm8
			0,// Test_AX_imm16
			0,// Test_EAX_imm32
			0,// Test_RAX_imm32
			0,// Stosb_m8_AL
			0,// Stosw_m16_AX
			0,// Stosd_m32_EAX
			0,// Stosq_m64_RAX
			0,// Lodsb_AL_m8
			0,// Lodsw_AX_m16
			0,// Lodsd_EAX_m32
			0,// Lodsq_RAX_m64
			0,// Scasb_AL_m8
			0,// Scasw_AX_m16
			0,// Scasd_EAX_m32
			0,// Scasq_RAX_m64
			0,// Mov_r8_imm8
			0,// Mov_r16_imm16
			0,// Mov_r32_imm32
			0,// Mov_r64_imm64
			0,// Rol_rm8_imm8
			0,// Ror_rm8_imm8
			0,// Rcl_rm8_imm8
			0,// Rcr_rm8_imm8
			0,// Shl_rm8_imm8
			0,// Shr_rm8_imm8
			0,// Sal_rm8_imm8
			0,// Sar_rm8_imm8
			0,// Rol_rm16_imm8
			0,// Rol_rm32_imm8
			0,// Rol_rm64_imm8
			0,// Ror_rm16_imm8
			0,// Ror_rm32_imm8
			0,// Ror_rm64_imm8
			0,// Rcl_rm16_imm8
			0,// Rcl_rm32_imm8
			0,// Rcl_rm64_imm8
			0,// Rcr_rm16_imm8
			0,// Rcr_rm32_imm8
			0,// Rcr_rm64_imm8
			0,// Shl_rm16_imm8
			0,// Shl_rm32_imm8
			0,// Shl_rm64_imm8
			0,// Shr_rm16_imm8
			0,// Shr_rm32_imm8
			0,// Shr_rm64_imm8
			0,// Sal_rm16_imm8
			0,// Sal_rm32_imm8
			0,// Sal_rm64_imm8
			0,// Sar_rm16_imm8
			0,// Sar_rm32_imm8
			0,// Sar_rm64_imm8
			0,// Retnw_imm16
			0,// Retnd_imm16
			0,// Retnq_imm16
			0,// Retnw
			0,// Retnd
			0,// Retnq
			0,// Les_r16_m1616
			0,// Les_r32_m1632
			0,// Lds_r16_m1616
			0,// Lds_r32_m1632
			0,// Mov_rm8_imm8
			0,// Xabort_imm8
			0,// Mov_rm16_imm16
			0,// Mov_rm32_imm32
			0,// Mov_rm64_imm32
			0,// Xbegin_rel16
			0,// Xbegin_rel32
			0,// Enterw_imm16_imm8
			0,// Enterd_imm16_imm8
			0,// Enterq_imm16_imm8
			0,// Leavew
			0,// Leaved
			0,// Leaveq
			0,// Retfw_imm16
			0,// Retfd_imm16
			0,// Retfq_imm16
			0,// Retfw
			0,// Retfd
			0,// Retfq
			0,// Int3
			0,// Int_imm8
			0,// Into
			0,// Iretw
			0,// Iretd
			0,// Iretq
			0,// Rol_rm8_1
			0,// Ror_rm8_1
			0,// Rcl_rm8_1
			0,// Rcr_rm8_1
			0,// Shl_rm8_1
			0,// Shr_rm8_1
			0,// Sal_rm8_1
			0,// Sar_rm8_1
			0,// Rol_rm16_1
			0,// Rol_rm32_1
			0,// Rol_rm64_1
			0,// Ror_rm16_1
			0,// Ror_rm32_1
			0,// Ror_rm64_1
			0,// Rcl_rm16_1
			0,// Rcl_rm32_1
			0,// Rcl_rm64_1
			0,// Rcr_rm16_1
			0,// Rcr_rm32_1
			0,// Rcr_rm64_1
			0,// Shl_rm16_1
			0,// Shl_rm32_1
			0,// Shl_rm64_1
			0,// Shr_rm16_1
			0,// Shr_rm32_1
			0,// Shr_rm64_1
			0,// Sal_rm16_1
			0,// Sal_rm32_1
			0,// Sal_rm64_1
			0,// Sar_rm16_1
			0,// Sar_rm32_1
			0,// Sar_rm64_1
			0,// Rol_rm8_CL
			0,// Ror_rm8_CL
			0,// Rcl_rm8_CL
			0,// Rcr_rm8_CL
			0,// Shl_rm8_CL
			0,// Shr_rm8_CL
			0,// Sal_rm8_CL
			0,// Sar_rm8_CL
			0,// Rol_rm16_CL
			0,// Rol_rm32_CL
			0,// Rol_rm64_CL
			0,// Ror_rm16_CL
			0,// Ror_rm32_CL
			0,// Ror_rm64_CL
			0,// Rcl_rm16_CL
			0,// Rcl_rm32_CL
			0,// Rcl_rm64_CL
			0,// Rcr_rm16_CL
			0,// Rcr_rm32_CL
			0,// Rcr_rm64_CL
			0,// Shl_rm16_CL
			0,// Shl_rm32_CL
			0,// Shl_rm64_CL
			0,// Shr_rm16_CL
			0,// Shr_rm32_CL
			0,// Shr_rm64_CL
			0,// Sal_rm16_CL
			0,// Sal_rm32_CL
			0,// Sal_rm64_CL
			0,// Sar_rm16_CL
			0,// Sar_rm32_CL
			0,// Sar_rm64_CL
			0,// Aam_imm8
			0,// Aad_imm8
			0,// Salc
			0,// Xlat_m8
			0,// Fadd_m32fp
			0,// Fmul_m32fp
			0,// Fcom_m32fp
			0,// Fcomp_m32fp
			0,// Fsub_m32fp
			0,// Fsubr_m32fp
			0,// Fdiv_m32fp
			0,// Fdivr_m32fp
			0,// Fadd_st0_sti
			0,// Fmul_st0_sti
			0,// Fcom_st0_sti
			0,// Fcomp_st0_sti
			0,// Fsub_st0_sti
			0,// Fsubr_st0_sti
			0,// Fdiv_st0_sti
			0,// Fdivr_st0_sti
			0,// Fld_m32fp
			0,// Fst_m32fp
			0,// Fstp_m32fp
			0,// Fldenv_m14byte
			0,// Fldenv_m28byte
			0,// Fldcw_m2byte
			0,// Fnstenv_m14byte
			0,// Fstenv_m14byte
			0,// Fnstenv_m28byte
			0,// Fstenv_m28byte
			0,// Fnstcw_m2byte
			0,// Fstcw_m2byte
			0,// Fld_sti
			0,// Fxch_st0_sti
			0,// Fnop
			0,// Fstpnce_sti
			0,// Fchs
			0,// Fabs
			0,// Ftst
			0,// Fxam
			0,// Fld1
			0,// Fldl2t
			0,// Fldl2e
			0,// Fldpi
			0,// Fldlg2
			0,// Fldln2
			0,// Fldz
			0,// F2xm1
			0,// Fyl2x
			0,// Fptan
			0,// Fpatan
			0,// Fxtract
			0,// Fprem1
			0,// Fdecstp
			0,// Fincstp
			0,// Fprem
			0,// Fyl2xp1
			0,// Fsqrt
			0,// Fsincos
			0,// Frndint
			0,// Fscale
			0,// Fsin
			0,// Fcos
			0,// Fiadd_m32int
			0,// Fimul_m32int
			0,// Ficom_m32int
			0,// Ficomp_m32int
			0,// Fisub_m32int
			0,// Fisubr_m32int
			0,// Fidiv_m32int
			0,// Fidivr_m32int
			0,// Fcmovb_st0_sti
			0,// Fcmove_st0_sti
			0,// Fcmovbe_st0_sti
			0,// Fcmovu_st0_sti
			0,// Fucompp
			0,// Fild_m32int
			0,// Fisttp_m32int
			0,// Fist_m32int
			0,// Fistp_m32int
			0,// Fld_m80fp
			0,// Fstp_m80fp
			0,// Fcmovnb_st0_sti
			0,// Fcmovne_st0_sti
			0,// Fcmovnbe_st0_sti
			0,// Fcmovnu_st0_sti
			0,// Fneni
			0,// Feni
			0,// Fndisi
			0,// Fdisi
			0,// Fnclex
			0,// Fclex
			0,// Fninit
			0,// Finit
			0,// Fnsetpm
			0,// Fsetpm
			0,// Frstpm
			0,// Fucomi_st0_sti
			0,// Fcomi_st0_sti
			0,// Fadd_m64fp
			0,// Fmul_m64fp
			0,// Fcom_m64fp
			0,// Fcomp_m64fp
			0,// Fsub_m64fp
			0,// Fsubr_m64fp
			0,// Fdiv_m64fp
			0,// Fdivr_m64fp
			0,// Fadd_sti_st0
			0,// Fmul_sti_st0
			0,// Fcom_st0_sti_DCD0
			0,// Fcomp_st0_sti_DCD8
			0,// Fsubr_sti_st0
			0,// Fsub_sti_st0
			0,// Fdivr_sti_st0
			0,// Fdiv_sti_st0
			0,// Fld_m64fp
			0,// Fisttp_m64int
			0,// Fst_m64fp
			0,// Fstp_m64fp
			0,// Frstor_m94byte
			0,// Frstor_m108byte
			0,// Fnsave_m94byte
			0,// Fsave_m94byte
			0,// Fnsave_m108byte
			0,// Fsave_m108byte
			0,// Fnstsw_m2byte
			0,// Fstsw_m2byte
			0,// Ffree_sti
			0,// Fxch_st0_sti_DDC8
			0,// Fst_sti
			0,// Fstp_sti
			0,// Fucom_st0_sti
			0,// Fucomp_st0_sti
			0,// Fiadd_m16int
			0,// Fimul_m16int
			0,// Ficom_m16int
			0,// Ficomp_m16int
			0,// Fisub_m16int
			0,// Fisubr_m16int
			0,// Fidiv_m16int
			0,// Fidivr_m16int
			0,// Faddp_sti_st0
			0,// Fmulp_sti_st0
			0,// Fcomp_st0_sti_DED0
			0,// Fcompp
			0,// Fsubrp_sti_st0
			0,// Fsubp_sti_st0
			0,// Fdivrp_sti_st0
			0,// Fdivp_sti_st0
			0,// Fild_m16int
			0,// Fisttp_m16int
			0,// Fist_m16int
			0,// Fistp_m16int
			0,// Fbld_m80bcd
			0,// Fild_m64int
			0,// Fbstp_m80bcd
			0,// Fistp_m64int
			0,// Ffreep_sti
			0,// Fxch_st0_sti_DFC8
			0,// Fstp_sti_DFD0
			0,// Fstp_sti_DFD8
			0,// Fnstsw_AX
			0,// Fstsw_AX
			0,// Fstdw_AX
			0,// Fstsg_AX
			0,// Fucomip_st0_sti
			0,// Fcomip_st0_sti
			0,// Loopne_rel8_16_CX
			0,// Loopne_rel8_32_CX
			0,// Loopne_rel8_16_ECX
			0,// Loopne_rel8_32_ECX
			0,// Loopne_rel8_64_ECX
			0,// Loopne_rel8_16_RCX
			0,// Loopne_rel8_64_RCX
			0,// Loope_rel8_16_CX
			0,// Loope_rel8_32_CX
			0,// Loope_rel8_16_ECX
			0,// Loope_rel8_32_ECX
			0,// Loope_rel8_64_ECX
			0,// Loope_rel8_16_RCX
			0,// Loope_rel8_64_RCX
			0,// Loop_rel8_16_CX
			0,// Loop_rel8_32_CX
			0,// Loop_rel8_16_ECX
			0,// Loop_rel8_32_ECX
			0,// Loop_rel8_64_ECX
			0,// Loop_rel8_16_RCX
			0,// Loop_rel8_64_RCX
			0,// Jcxz_rel8_16
			0,// Jcxz_rel8_32
			0,// Jecxz_rel8_16
			0,// Jecxz_rel8_32
			0,// Jecxz_rel8_64
			0,// Jrcxz_rel8_16
			0,// Jrcxz_rel8_64
			0,// In_AL_imm8
			0,// In_AX_imm8
			0,// In_EAX_imm8
			0,// Out_imm8_AL
			0,// Out_imm8_AX
			0,// Out_imm8_EAX
			0,// Call_rel16
			0,// Call_rel32_32
			0,// Call_rel32_64
			0,// Jmp_rel16
			0,// Jmp_rel32_32
			0,// Jmp_rel32_64
			0,// Jmp_ptr1616
			0,// Jmp_ptr1632
			0,// Jmp_rel8_16
			0,// Jmp_rel8_32
			0,// Jmp_rel8_64
			0,// In_AL_DX
			0,// In_AX_DX
			0,// In_EAX_DX
			0,// Out_DX_AL
			0,// Out_DX_AX
			0,// Out_DX_EAX
			0,// Int1
			0,// Hlt
			0,// Cmc
			0,// Test_rm8_imm8
			0,// Test_rm8_imm8_F6r1
			0,// Not_rm8
			0,// Neg_rm8
			0,// Mul_rm8
			0,// Imul_rm8
			0,// Div_rm8
			0,// Idiv_rm8
			0,// Test_rm16_imm16
			0,// Test_rm32_imm32
			0,// Test_rm64_imm32
			0,// Test_rm16_imm16_F7r1
			0,// Test_rm32_imm32_F7r1
			0,// Test_rm64_imm32_F7r1
			0,// Not_rm16
			0,// Not_rm32
			0,// Not_rm64
			0,// Neg_rm16
			0,// Neg_rm32
			0,// Neg_rm64
			0,// Mul_rm16
			0,// Mul_rm32
			0,// Mul_rm64
			0,// Imul_rm16
			0,// Imul_rm32
			0,// Imul_rm64
			0,// Div_rm16
			0,// Div_rm32
			0,// Div_rm64
			0,// Idiv_rm16
			0,// Idiv_rm32
			0,// Idiv_rm64
			0,// Clc
			0,// Stc
			0,// Cli
			0,// Sti
			0,// Cld
			0,// Std
			0,// Inc_rm8
			0,// Dec_rm8
			0,// Inc_rm16
			0,// Inc_rm32
			0,// Inc_rm64
			0,// Dec_rm16
			0,// Dec_rm32
			0,// Dec_rm64
			0,// Call_rm16
			0,// Call_rm32
			0,// Call_rm64
			0,// Call_m1616
			0,// Call_m1632
			0,// Call_m1664
			0,// Jmp_rm16
			0,// Jmp_rm32
			0,// Jmp_rm64
			0,// Jmp_m1616
			0,// Jmp_m1632
			0,// Jmp_m1664
			0,// Push_rm16
			0,// Push_rm32
			0,// Push_rm64
			0,// Sldt_rm16
			0,// Sldt_r32m16
			0,// Sldt_r64m16
			0,// Str_rm16
			0,// Str_r32m16
			0,// Str_r64m16
			0,// Lldt_rm16
			0,// Lldt_r32m16
			0,// Lldt_r64m16
			0,// Ltr_rm16
			0,// Ltr_r32m16
			0,// Ltr_r64m16
			0,// Verr_rm16
			0,// Verr_r32m16
			0,// Verr_r64m16
			0,// Verw_rm16
			0,// Verw_r32m16
			0,// Verw_r64m16
			0,// Jmpe_rm16
			0,// Jmpe_rm32
			0,// Sgdt_m1632_16
			0,// Sgdt_m1632
			0,// Sgdt_m1664
			0,// Sidt_m1632_16
			0,// Sidt_m1632
			0,// Sidt_m1664
			0,// Lgdt_m1632_16
			0,// Lgdt_m1632
			0,// Lgdt_m1664
			0,// Lidt_m1632_16
			0,// Lidt_m1632
			0,// Lidt_m1664
			0,// Smsw_rm16
			0,// Smsw_r32m16
			0,// Smsw_r64m16
			0,// Rstorssp_m64
			0,// Lmsw_rm16
			0,// Lmsw_r32m16
			0,// Lmsw_r64m16
			0,// Invlpg_m
			0,// Enclv
			0,// Vmcall
			0,// Vmlaunch
			0,// Vmresume
			0,// Vmxoff
			0,// Pconfig
			0,// Monitorw
			0,// Monitord
			0,// Monitorq
			0,// Mwait
			0,// Clac
			0,// Stac
			0,// Encls
			0,// Xgetbv
			0,// Xsetbv
			0,// Vmfunc
			0,// Xend
			0,// Xtest
			0,// Enclu
			0,// Vmrunw
			0,// Vmrund
			0,// Vmrunq
			0,// Vmmcall
			0,// Vmloadw
			0,// Vmloadd
			0,// Vmloadq
			0,// Vmsavew
			0,// Vmsaved
			0,// Vmsaveq
			0,// Stgi
			0,// Clgi
			0,// Skinit
			0,// Invlpgaw
			0,// Invlpgad
			0,// Invlpgaq
			0,// Setssbsy
			0,// Saveprevssp
			0,// Rdpkru
			0,// Wrpkru
			0,// Swapgs
			0,// Rdtscp
			0,// Monitorxw
			0,// Monitorxd
			0,// Monitorxq
			0,// Mcommit
			0,// Mwaitx
			0,// Clzerow
			0,// Clzerod
			0,// Clzeroq
			0,// Rdpru
			0,// Lar_r16_rm16
			0,// Lar_r32_r32m16
			0,// Lar_r64_r64m16
			0,// Lsl_r16_rm16
			0,// Lsl_r32_r32m16
			0,// Lsl_r64_r64m16
			0,// Storeall
			0,// Loadall286
			0,// Syscall
			0,// Clts
			0,// Loadall386
			0,// Sysretd
			0,// Sysretq
			0,// Invd
			0,// Wbinvd
			0,// Wbnoinvd
			0,// Cl1invmb
			0,// Ud2
			0,// Reservednop_rm16_r16_0F0D
			0,// Reservednop_rm32_r32_0F0D
			0,// Reservednop_rm64_r64_0F0D
			0,// Prefetch_m8
			0,// Prefetchw_m8
			0,// Prefetchwt1_m8
			0,// Femms
			0,// Umov_rm8_r8
			0,// Umov_rm16_r16
			0,// Umov_rm32_r32
			0,// Umov_r8_rm8
			0,// Umov_r16_rm16
			0,// Umov_r32_rm32
			0,// Movups_xmm_xmmm128
			0,// VEX_Vmovups_xmm_xmmm128
			0,// VEX_Vmovups_ymm_ymmm256
			0,// EVEX_Vmovups_xmm_k1z_xmmm128
			0,// EVEX_Vmovups_ymm_k1z_ymmm256
			0,// EVEX_Vmovups_zmm_k1z_zmmm512
			0,// Movupd_xmm_xmmm128
			0,// VEX_Vmovupd_xmm_xmmm128
			0,// VEX_Vmovupd_ymm_ymmm256
			0,// EVEX_Vmovupd_xmm_k1z_xmmm128
			0,// EVEX_Vmovupd_ymm_k1z_ymmm256
			0,// EVEX_Vmovupd_zmm_k1z_zmmm512
			0,// Movss_xmm_xmmm32
			0,// VEX_Vmovss_xmm_xmm_xmm
			0,// VEX_Vmovss_xmm_m32
			0,// EVEX_Vmovss_xmm_k1z_xmm_xmm
			0,// EVEX_Vmovss_xmm_k1z_m32
			0,// Movsd_xmm_xmmm64
			0,// VEX_Vmovsd_xmm_xmm_xmm
			0,// VEX_Vmovsd_xmm_m64
			0,// EVEX_Vmovsd_xmm_k1z_xmm_xmm
			0,// EVEX_Vmovsd_xmm_k1z_m64
			0,// Movups_xmmm128_xmm
			0,// VEX_Vmovups_xmmm128_xmm
			0,// VEX_Vmovups_ymmm256_ymm
			0,// EVEX_Vmovups_xmmm128_k1z_xmm
			0,// EVEX_Vmovups_ymmm256_k1z_ymm
			0,// EVEX_Vmovups_zmmm512_k1z_zmm
			0,// Movupd_xmmm128_xmm
			0,// VEX_Vmovupd_xmmm128_xmm
			0,// VEX_Vmovupd_ymmm256_ymm
			0,// EVEX_Vmovupd_xmmm128_k1z_xmm
			0,// EVEX_Vmovupd_ymmm256_k1z_ymm
			0,// EVEX_Vmovupd_zmmm512_k1z_zmm
			0,// Movss_xmmm32_xmm
			0,// VEX_Vmovss_xmm_xmm_xmm_0F11
			0,// VEX_Vmovss_m32_xmm
			0,// EVEX_Vmovss_xmm_k1z_xmm_xmm_0F11
			0,// EVEX_Vmovss_m32_k1_xmm
			0,// Movsd_xmmm64_xmm
			0,// VEX_Vmovsd_xmm_xmm_xmm_0F11
			0,// VEX_Vmovsd_m64_xmm
			0,// EVEX_Vmovsd_xmm_k1z_xmm_xmm_0F11
			0,// EVEX_Vmovsd_m64_k1_xmm
			0,// Movhlps_xmm_xmm
			0,// Movlps_xmm_m64
			0,// VEX_Vmovhlps_xmm_xmm_xmm
			0,// VEX_Vmovlps_xmm_xmm_m64
			0,// EVEX_Vmovhlps_xmm_xmm_xmm
			0,// EVEX_Vmovlps_xmm_xmm_m64
			0,// Movlpd_xmm_m64
			0,// VEX_Vmovlpd_xmm_xmm_m64
			0,// EVEX_Vmovlpd_xmm_xmm_m64
			0,// Movsldup_xmm_xmmm128
			0,// VEX_Vmovsldup_xmm_xmmm128
			0,// VEX_Vmovsldup_ymm_ymmm256
			0,// EVEX_Vmovsldup_xmm_k1z_xmmm128
			0,// EVEX_Vmovsldup_ymm_k1z_ymmm256
			0,// EVEX_Vmovsldup_zmm_k1z_zmmm512
			0,// Movddup_xmm_xmmm64
			0,// VEX_Vmovddup_xmm_xmmm64
			0,// VEX_Vmovddup_ymm_ymmm256
			0,// EVEX_Vmovddup_xmm_k1z_xmmm64
			0,// EVEX_Vmovddup_ymm_k1z_ymmm256
			0,// EVEX_Vmovddup_zmm_k1z_zmmm512
			0,// Movlps_m64_xmm
			0,// VEX_Vmovlps_m64_xmm
			0,// EVEX_Vmovlps_m64_xmm
			0,// Movlpd_m64_xmm
			0,// VEX_Vmovlpd_m64_xmm
			0,// EVEX_Vmovlpd_m64_xmm
			0,// Unpcklps_xmm_xmmm128
			0,// VEX_Vunpcklps_xmm_xmm_xmmm128
			0,// VEX_Vunpcklps_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vunpcklps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vunpcklps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vunpcklps_zmm_k1z_zmm_zmmm512b32
			0,// Unpcklpd_xmm_xmmm128
			0,// VEX_Vunpcklpd_xmm_xmm_xmmm128
			0,// VEX_Vunpcklpd_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vunpcklpd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vunpcklpd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vunpcklpd_zmm_k1z_zmm_zmmm512b64
			0,// Unpckhps_xmm_xmmm128
			0,// VEX_Vunpckhps_xmm_xmm_xmmm128
			0,// VEX_Vunpckhps_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vunpckhps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vunpckhps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vunpckhps_zmm_k1z_zmm_zmmm512b32
			0,// Unpckhpd_xmm_xmmm128
			0,// VEX_Vunpckhpd_xmm_xmm_xmmm128
			0,// VEX_Vunpckhpd_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vunpckhpd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vunpckhpd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vunpckhpd_zmm_k1z_zmm_zmmm512b64
			0,// Movlhps_xmm_xmm
			0,// VEX_Vmovlhps_xmm_xmm_xmm
			0,// EVEX_Vmovlhps_xmm_xmm_xmm
			0,// Movhps_xmm_m64
			0,// VEX_Vmovhps_xmm_xmm_m64
			0,// EVEX_Vmovhps_xmm_xmm_m64
			0,// Movhpd_xmm_m64
			0,// VEX_Vmovhpd_xmm_xmm_m64
			0,// EVEX_Vmovhpd_xmm_xmm_m64
			0,// Movshdup_xmm_xmmm128
			0,// VEX_Vmovshdup_xmm_xmmm128
			0,// VEX_Vmovshdup_ymm_ymmm256
			0,// EVEX_Vmovshdup_xmm_k1z_xmmm128
			0,// EVEX_Vmovshdup_ymm_k1z_ymmm256
			0,// EVEX_Vmovshdup_zmm_k1z_zmmm512
			0,// Movhps_m64_xmm
			0,// VEX_Vmovhps_m64_xmm
			0,// EVEX_Vmovhps_m64_xmm
			0,// Movhpd_m64_xmm
			0,// VEX_Vmovhpd_m64_xmm
			0,// EVEX_Vmovhpd_m64_xmm
			0,// Reservednop_rm16_r16_0F18
			0,// Reservednop_rm32_r32_0F18
			0,// Reservednop_rm64_r64_0F18
			0,// Reservednop_rm16_r16_0F19
			0,// Reservednop_rm32_r32_0F19
			0,// Reservednop_rm64_r64_0F19
			0,// Reservednop_rm16_r16_0F1A
			0,// Reservednop_rm32_r32_0F1A
			0,// Reservednop_rm64_r64_0F1A
			0,// Reservednop_rm16_r16_0F1B
			0,// Reservednop_rm32_r32_0F1B
			0,// Reservednop_rm64_r64_0F1B
			0,// Reservednop_rm16_r16_0F1C
			0,// Reservednop_rm32_r32_0F1C
			0,// Reservednop_rm64_r64_0F1C
			0,// Reservednop_rm16_r16_0F1D
			0,// Reservednop_rm32_r32_0F1D
			0,// Reservednop_rm64_r64_0F1D
			0,// Reservednop_rm16_r16_0F1E
			0,// Reservednop_rm32_r32_0F1E
			0,// Reservednop_rm64_r64_0F1E
			0,// Reservednop_rm16_r16_0F1F
			0,// Reservednop_rm32_r32_0F1F
			0,// Reservednop_rm64_r64_0F1F
			0,// Prefetchnta_m8
			0,// Prefetcht0_m8
			0,// Prefetcht1_m8
			0,// Prefetcht2_m8
			0,// Bndldx_bnd_mib
			0,// Bndmov_bnd_bndm64
			0,// Bndmov_bnd_bndm128
			0,// Bndcl_bnd_rm32
			0,// Bndcl_bnd_rm64
			0,// Bndcu_bnd_rm32
			0,// Bndcu_bnd_rm64
			0,// Bndstx_mib_bnd
			0,// Bndmov_bndm64_bnd
			0,// Bndmov_bndm128_bnd
			0,// Bndmk_bnd_m32
			0,// Bndmk_bnd_m64
			0,// Bndcn_bnd_rm32
			0,// Bndcn_bnd_rm64
			0,// Cldemote_m8
			0,// Rdsspd_r32
			0,// Rdsspq_r64
			0,// Endbr64
			0,// Endbr32
			0,// Nop_rm16
			0,// Nop_rm32
			0,// Nop_rm64
			0,// Mov_r32_cr
			0,// Mov_r64_cr
			0,// Mov_r32_dr
			0,// Mov_r64_dr
			0,// Mov_cr_r32
			0,// Mov_cr_r64
			0,// Mov_dr_r32
			0,// Mov_dr_r64
			0,// Mov_r32_tr
			0,// Mov_tr_r32
			0,// Movaps_xmm_xmmm128
			0,// VEX_Vmovaps_xmm_xmmm128
			0,// VEX_Vmovaps_ymm_ymmm256
			0,// EVEX_Vmovaps_xmm_k1z_xmmm128
			0,// EVEX_Vmovaps_ymm_k1z_ymmm256
			0,// EVEX_Vmovaps_zmm_k1z_zmmm512
			0,// Movapd_xmm_xmmm128
			0,// VEX_Vmovapd_xmm_xmmm128
			0,// VEX_Vmovapd_ymm_ymmm256
			0,// EVEX_Vmovapd_xmm_k1z_xmmm128
			0,// EVEX_Vmovapd_ymm_k1z_ymmm256
			0,// EVEX_Vmovapd_zmm_k1z_zmmm512
			0,// Movaps_xmmm128_xmm
			0,// VEX_Vmovaps_xmmm128_xmm
			0,// VEX_Vmovaps_ymmm256_ymm
			0,// EVEX_Vmovaps_xmmm128_k1z_xmm
			0,// EVEX_Vmovaps_ymmm256_k1z_ymm
			0,// EVEX_Vmovaps_zmmm512_k1z_zmm
			0,// Movapd_xmmm128_xmm
			0,// VEX_Vmovapd_xmmm128_xmm
			0,// VEX_Vmovapd_ymmm256_ymm
			0,// EVEX_Vmovapd_xmmm128_k1z_xmm
			0,// EVEX_Vmovapd_ymmm256_k1z_ymm
			0,// EVEX_Vmovapd_zmmm512_k1z_zmm
			0,// Cvtpi2ps_xmm_mmm64
			0,// Cvtpi2pd_xmm_mmm64
			0,// Cvtsi2ss_xmm_rm32
			0,// Cvtsi2ss_xmm_rm64
			0,// VEX_Vcvtsi2ss_xmm_xmm_rm32
			0,// VEX_Vcvtsi2ss_xmm_xmm_rm64
			0,// EVEX_Vcvtsi2ss_xmm_xmm_rm32_er
			0,// EVEX_Vcvtsi2ss_xmm_xmm_rm64_er
			0,// Cvtsi2sd_xmm_rm32
			0,// Cvtsi2sd_xmm_rm64
			0,// VEX_Vcvtsi2sd_xmm_xmm_rm32
			0,// VEX_Vcvtsi2sd_xmm_xmm_rm64
			0,// EVEX_Vcvtsi2sd_xmm_xmm_rm32_er
			0,// EVEX_Vcvtsi2sd_xmm_xmm_rm64_er
			0,// Movntps_m128_xmm
			0,// VEX_Vmovntps_m128_xmm
			0,// VEX_Vmovntps_m256_ymm
			0,// EVEX_Vmovntps_m128_xmm
			0,// EVEX_Vmovntps_m256_ymm
			0,// EVEX_Vmovntps_m512_zmm
			0,// Movntpd_m128_xmm
			0,// VEX_Vmovntpd_m128_xmm
			0,// VEX_Vmovntpd_m256_ymm
			0,// EVEX_Vmovntpd_m128_xmm
			0,// EVEX_Vmovntpd_m256_ymm
			0,// EVEX_Vmovntpd_m512_zmm
			0,// Movntss_m32_xmm
			0,// Movntsd_m64_xmm
			0,// Cvttps2pi_mm_xmmm64
			0,// Cvttpd2pi_mm_xmmm128
			0,// Cvttss2si_r32_xmmm32
			0,// Cvttss2si_r64_xmmm32
			0,// VEX_Vcvttss2si_r32_xmmm32
			0,// VEX_Vcvttss2si_r64_xmmm32
			0,// EVEX_Vcvttss2si_r32_xmmm32_sae
			0,// EVEX_Vcvttss2si_r64_xmmm32_sae
			0,// Cvttsd2si_r32_xmmm64
			0,// Cvttsd2si_r64_xmmm64
			0,// VEX_Vcvttsd2si_r32_xmmm64
			0,// VEX_Vcvttsd2si_r64_xmmm64
			0,// EVEX_Vcvttsd2si_r32_xmmm64_sae
			0,// EVEX_Vcvttsd2si_r64_xmmm64_sae
			0,// Cvtps2pi_mm_xmmm64
			0,// Cvtpd2pi_mm_xmmm128
			0,// Cvtss2si_r32_xmmm32
			0,// Cvtss2si_r64_xmmm32
			0,// VEX_Vcvtss2si_r32_xmmm32
			0,// VEX_Vcvtss2si_r64_xmmm32
			0,// EVEX_Vcvtss2si_r32_xmmm32_er
			0,// EVEX_Vcvtss2si_r64_xmmm32_er
			0,// Cvtsd2si_r32_xmmm64
			0,// Cvtsd2si_r64_xmmm64
			0,// VEX_Vcvtsd2si_r32_xmmm64
			0,// VEX_Vcvtsd2si_r64_xmmm64
			0,// EVEX_Vcvtsd2si_r32_xmmm64_er
			0,// EVEX_Vcvtsd2si_r64_xmmm64_er
			0,// Ucomiss_xmm_xmmm32
			0,// VEX_Vucomiss_xmm_xmmm32
			0,// EVEX_Vucomiss_xmm_xmmm32_sae
			0,// Ucomisd_xmm_xmmm64
			0,// VEX_Vucomisd_xmm_xmmm64
			0,// EVEX_Vucomisd_xmm_xmmm64_sae
			0,// Comiss_xmm_xmmm32
			0,// Comisd_xmm_xmmm64
			0,// VEX_Vcomiss_xmm_xmmm32
			0,// VEX_Vcomisd_xmm_xmmm64
			0,// EVEX_Vcomiss_xmm_xmmm32_sae
			0,// EVEX_Vcomisd_xmm_xmmm64_sae
			0,// Wrmsr
			0,// Rdtsc
			0,// Rdmsr
			0,// Rdpmc
			0,// Sysenter
			0,// Sysexitd
			0,// Sysexitq
			0,// Getsecd
			0,// Cmovo_r16_rm16
			0,// Cmovo_r32_rm32
			0,// Cmovo_r64_rm64
			0,// Cmovno_r16_rm16
			0,// Cmovno_r32_rm32
			0,// Cmovno_r64_rm64
			0,// Cmovb_r16_rm16
			0,// Cmovb_r32_rm32
			0,// Cmovb_r64_rm64
			0,// Cmovae_r16_rm16
			0,// Cmovae_r32_rm32
			0,// Cmovae_r64_rm64
			0,// Cmove_r16_rm16
			0,// Cmove_r32_rm32
			0,// Cmove_r64_rm64
			0,// Cmovne_r16_rm16
			0,// Cmovne_r32_rm32
			0,// Cmovne_r64_rm64
			0,// Cmovbe_r16_rm16
			0,// Cmovbe_r32_rm32
			0,// Cmovbe_r64_rm64
			0,// Cmova_r16_rm16
			0,// Cmova_r32_rm32
			0,// Cmova_r64_rm64
			0,// Cmovs_r16_rm16
			0,// Cmovs_r32_rm32
			0,// Cmovs_r64_rm64
			0,// Cmovns_r16_rm16
			0,// Cmovns_r32_rm32
			0,// Cmovns_r64_rm64
			0,// Cmovp_r16_rm16
			0,// Cmovp_r32_rm32
			0,// Cmovp_r64_rm64
			0,// Cmovnp_r16_rm16
			0,// Cmovnp_r32_rm32
			0,// Cmovnp_r64_rm64
			0,// Cmovl_r16_rm16
			0,// Cmovl_r32_rm32
			0,// Cmovl_r64_rm64
			0,// Cmovge_r16_rm16
			0,// Cmovge_r32_rm32
			0,// Cmovge_r64_rm64
			0,// Cmovle_r16_rm16
			0,// Cmovle_r32_rm32
			0,// Cmovle_r64_rm64
			0,// Cmovg_r16_rm16
			0,// Cmovg_r32_rm32
			0,// Cmovg_r64_rm64
			0,// VEX_Kandw_kr_kr_kr
			0,// VEX_Kandq_kr_kr_kr
			0,// VEX_Kandb_kr_kr_kr
			0,// VEX_Kandd_kr_kr_kr
			0,// VEX_Kandnw_kr_kr_kr
			0,// VEX_Kandnq_kr_kr_kr
			0,// VEX_Kandnb_kr_kr_kr
			0,// VEX_Kandnd_kr_kr_kr
			0,// VEX_Knotw_kr_kr
			0,// VEX_Knotq_kr_kr
			0,// VEX_Knotb_kr_kr
			0,// VEX_Knotd_kr_kr
			0,// VEX_Korw_kr_kr_kr
			0,// VEX_Korq_kr_kr_kr
			0,// VEX_Korb_kr_kr_kr
			0,// VEX_Kord_kr_kr_kr
			0,// VEX_Kxnorw_kr_kr_kr
			0,// VEX_Kxnorq_kr_kr_kr
			0,// VEX_Kxnorb_kr_kr_kr
			0,// VEX_Kxnord_kr_kr_kr
			0,// VEX_Kxorw_kr_kr_kr
			0,// VEX_Kxorq_kr_kr_kr
			0,// VEX_Kxorb_kr_kr_kr
			0,// VEX_Kxord_kr_kr_kr
			0,// VEX_Kaddw_kr_kr_kr
			0,// VEX_Kaddq_kr_kr_kr
			0,// VEX_Kaddb_kr_kr_kr
			0,// VEX_Kaddd_kr_kr_kr
			0,// VEX_Kunpckwd_kr_kr_kr
			0,// VEX_Kunpckdq_kr_kr_kr
			0,// VEX_Kunpckbw_kr_kr_kr
			0,// Movmskps_r32_xmm
			0,// Movmskps_r64_xmm
			0,// VEX_Vmovmskps_r32_xmm
			0,// VEX_Vmovmskps_r64_xmm
			0,// VEX_Vmovmskps_r32_ymm
			0,// VEX_Vmovmskps_r64_ymm
			0,// Movmskpd_r32_xmm
			0,// Movmskpd_r64_xmm
			0,// VEX_Vmovmskpd_r32_xmm
			0,// VEX_Vmovmskpd_r64_xmm
			0,// VEX_Vmovmskpd_r32_ymm
			0,// VEX_Vmovmskpd_r64_ymm
			0,// Sqrtps_xmm_xmmm128
			0,// VEX_Vsqrtps_xmm_xmmm128
			0,// VEX_Vsqrtps_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vsqrtps_xmm_k1z_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vsqrtps_ymm_k1z_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vsqrtps_zmm_k1z_zmmm512b32_er
			0,// Sqrtpd_xmm_xmmm128
			0,// VEX_Vsqrtpd_xmm_xmmm128
			0,// VEX_Vsqrtpd_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vsqrtpd_xmm_k1z_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vsqrtpd_ymm_k1z_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vsqrtpd_zmm_k1z_zmmm512b64_er
			0,// Sqrtss_xmm_xmmm32
			0,// VEX_Vsqrtss_xmm_xmm_xmmm32
			0,// EVEX_Vsqrtss_xmm_k1z_xmm_xmmm32_er
			0,// Sqrtsd_xmm_xmmm64
			0,// VEX_Vsqrtsd_xmm_xmm_xmmm64
			0,// EVEX_Vsqrtsd_xmm_k1z_xmm_xmmm64_er
			0,// Rsqrtps_xmm_xmmm128
			0,// VEX_Vrsqrtps_xmm_xmmm128
			0,// VEX_Vrsqrtps_ymm_ymmm256
			0,// Rsqrtss_xmm_xmmm32
			0,// VEX_Vrsqrtss_xmm_xmm_xmmm32
			0,// Rcpps_xmm_xmmm128
			0,// VEX_Vrcpps_xmm_xmmm128
			0,// VEX_Vrcpps_ymm_ymmm256
			0,// Rcpss_xmm_xmmm32
			0,// VEX_Vrcpss_xmm_xmm_xmmm32
			0,// Andps_xmm_xmmm128
			0,// VEX_Vandps_xmm_xmm_xmmm128
			0,// VEX_Vandps_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vandps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vandps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vandps_zmm_k1z_zmm_zmmm512b32
			0,// Andpd_xmm_xmmm128
			0,// VEX_Vandpd_xmm_xmm_xmmm128
			0,// VEX_Vandpd_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vandpd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vandpd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vandpd_zmm_k1z_zmm_zmmm512b64
			0,// Andnps_xmm_xmmm128
			0,// VEX_Vandnps_xmm_xmm_xmmm128
			0,// VEX_Vandnps_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vandnps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vandnps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vandnps_zmm_k1z_zmm_zmmm512b32
			0,// Andnpd_xmm_xmmm128
			0,// VEX_Vandnpd_xmm_xmm_xmmm128
			0,// VEX_Vandnpd_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vandnpd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vandnpd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vandnpd_zmm_k1z_zmm_zmmm512b64
			0,// Orps_xmm_xmmm128
			0,// VEX_Vorps_xmm_xmm_xmmm128
			0,// VEX_Vorps_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vorps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vorps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vorps_zmm_k1z_zmm_zmmm512b32
			0,// Orpd_xmm_xmmm128
			0,// VEX_Vorpd_xmm_xmm_xmmm128
			0,// VEX_Vorpd_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vorpd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vorpd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vorpd_zmm_k1z_zmm_zmmm512b64
			0,// Xorps_xmm_xmmm128
			0,// VEX_Vxorps_xmm_xmm_xmmm128
			0,// VEX_Vxorps_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vxorps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vxorps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vxorps_zmm_k1z_zmm_zmmm512b32
			0,// Xorpd_xmm_xmmm128
			0,// VEX_Vxorpd_xmm_xmm_xmmm128
			0,// VEX_Vxorpd_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vxorpd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vxorpd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vxorpd_zmm_k1z_zmm_zmmm512b64
			0,// Addps_xmm_xmmm128
			0,// VEX_Vaddps_xmm_xmm_xmmm128
			0,// VEX_Vaddps_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vaddps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vaddps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vaddps_zmm_k1z_zmm_zmmm512b32_er
			0,// Addpd_xmm_xmmm128
			0,// VEX_Vaddpd_xmm_xmm_xmmm128
			0,// VEX_Vaddpd_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vaddpd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vaddpd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vaddpd_zmm_k1z_zmm_zmmm512b64_er
			0,// Addss_xmm_xmmm32
			0,// VEX_Vaddss_xmm_xmm_xmmm32
			0,// EVEX_Vaddss_xmm_k1z_xmm_xmmm32_er
			0,// Addsd_xmm_xmmm64
			0,// VEX_Vaddsd_xmm_xmm_xmmm64
			0,// EVEX_Vaddsd_xmm_k1z_xmm_xmmm64_er
			0,// Mulps_xmm_xmmm128
			0,// VEX_Vmulps_xmm_xmm_xmmm128
			0,// VEX_Vmulps_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vmulps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vmulps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vmulps_zmm_k1z_zmm_zmmm512b32_er
			0,// Mulpd_xmm_xmmm128
			0,// VEX_Vmulpd_xmm_xmm_xmmm128
			0,// VEX_Vmulpd_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vmulpd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vmulpd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vmulpd_zmm_k1z_zmm_zmmm512b64_er
			0,// Mulss_xmm_xmmm32
			0,// VEX_Vmulss_xmm_xmm_xmmm32
			0,// EVEX_Vmulss_xmm_k1z_xmm_xmmm32_er
			0,// Mulsd_xmm_xmmm64
			0,// VEX_Vmulsd_xmm_xmm_xmmm64
			0,// EVEX_Vmulsd_xmm_k1z_xmm_xmmm64_er
			0,// Cvtps2pd_xmm_xmmm64
			0,// VEX_Vcvtps2pd_xmm_xmmm64
			0,// VEX_Vcvtps2pd_ymm_xmmm128
			(byte)MemorySize.Broadcast64_Float32,// EVEX_Vcvtps2pd_xmm_k1z_xmmm64b32
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vcvtps2pd_ymm_k1z_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vcvtps2pd_zmm_k1z_ymmm256b32_sae
			0,// Cvtpd2ps_xmm_xmmm128
			0,// VEX_Vcvtpd2ps_xmm_xmmm128
			0,// VEX_Vcvtpd2ps_xmm_ymmm256
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vcvtpd2ps_xmm_k1z_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vcvtpd2ps_xmm_k1z_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vcvtpd2ps_ymm_k1z_zmmm512b64_er
			0,// Cvtss2sd_xmm_xmmm32
			0,// VEX_Vcvtss2sd_xmm_xmm_xmmm32
			0,// EVEX_Vcvtss2sd_xmm_k1z_xmm_xmmm32_sae
			0,// Cvtsd2ss_xmm_xmmm64
			0,// VEX_Vcvtsd2ss_xmm_xmm_xmmm64
			0,// EVEX_Vcvtsd2ss_xmm_k1z_xmm_xmmm64_er
			0,// Cvtdq2ps_xmm_xmmm128
			0,// VEX_Vcvtdq2ps_xmm_xmmm128
			0,// VEX_Vcvtdq2ps_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Int32,// EVEX_Vcvtdq2ps_xmm_k1z_xmmm128b32
			(byte)MemorySize.Broadcast256_Int32,// EVEX_Vcvtdq2ps_ymm_k1z_ymmm256b32
			(byte)MemorySize.Broadcast512_Int32,// EVEX_Vcvtdq2ps_zmm_k1z_zmmm512b32_er
			(byte)MemorySize.Broadcast128_Int64,// EVEX_Vcvtqq2ps_xmm_k1z_xmmm128b64
			(byte)MemorySize.Broadcast256_Int64,// EVEX_Vcvtqq2ps_xmm_k1z_ymmm256b64
			(byte)MemorySize.Broadcast512_Int64,// EVEX_Vcvtqq2ps_ymm_k1z_zmmm512b64_er
			0,// Cvtps2dq_xmm_xmmm128
			0,// VEX_Vcvtps2dq_xmm_xmmm128
			0,// VEX_Vcvtps2dq_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vcvtps2dq_xmm_k1z_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vcvtps2dq_ymm_k1z_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vcvtps2dq_zmm_k1z_zmmm512b32_er
			0,// Cvttps2dq_xmm_xmmm128
			0,// VEX_Vcvttps2dq_xmm_xmmm128
			0,// VEX_Vcvttps2dq_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vcvttps2dq_xmm_k1z_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vcvttps2dq_ymm_k1z_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vcvttps2dq_zmm_k1z_zmmm512b32_sae
			0,// Subps_xmm_xmmm128
			0,// VEX_Vsubps_xmm_xmm_xmmm128
			0,// VEX_Vsubps_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vsubps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vsubps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vsubps_zmm_k1z_zmm_zmmm512b32_er
			0,// Subpd_xmm_xmmm128
			0,// VEX_Vsubpd_xmm_xmm_xmmm128
			0,// VEX_Vsubpd_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vsubpd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vsubpd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vsubpd_zmm_k1z_zmm_zmmm512b64_er
			0,// Subss_xmm_xmmm32
			0,// VEX_Vsubss_xmm_xmm_xmmm32
			0,// EVEX_Vsubss_xmm_k1z_xmm_xmmm32_er
			0,// Subsd_xmm_xmmm64
			0,// VEX_Vsubsd_xmm_xmm_xmmm64
			0,// EVEX_Vsubsd_xmm_k1z_xmm_xmmm64_er
			0,// Minps_xmm_xmmm128
			0,// VEX_Vminps_xmm_xmm_xmmm128
			0,// VEX_Vminps_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vminps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vminps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vminps_zmm_k1z_zmm_zmmm512b32_sae
			0,// Minpd_xmm_xmmm128
			0,// VEX_Vminpd_xmm_xmm_xmmm128
			0,// VEX_Vminpd_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vminpd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vminpd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vminpd_zmm_k1z_zmm_zmmm512b64_sae
			0,// Minss_xmm_xmmm32
			0,// VEX_Vminss_xmm_xmm_xmmm32
			0,// EVEX_Vminss_xmm_k1z_xmm_xmmm32_sae
			0,// Minsd_xmm_xmmm64
			0,// VEX_Vminsd_xmm_xmm_xmmm64
			0,// EVEX_Vminsd_xmm_k1z_xmm_xmmm64_sae
			0,// Divps_xmm_xmmm128
			0,// VEX_Vdivps_xmm_xmm_xmmm128
			0,// VEX_Vdivps_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vdivps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vdivps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vdivps_zmm_k1z_zmm_zmmm512b32_er
			0,// Divpd_xmm_xmmm128
			0,// VEX_Vdivpd_xmm_xmm_xmmm128
			0,// VEX_Vdivpd_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vdivpd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vdivpd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vdivpd_zmm_k1z_zmm_zmmm512b64_er
			0,// Divss_xmm_xmmm32
			0,// VEX_Vdivss_xmm_xmm_xmmm32
			0,// EVEX_Vdivss_xmm_k1z_xmm_xmmm32_er
			0,// Divsd_xmm_xmmm64
			0,// VEX_Vdivsd_xmm_xmm_xmmm64
			0,// EVEX_Vdivsd_xmm_k1z_xmm_xmmm64_er
			0,// Maxps_xmm_xmmm128
			0,// VEX_Vmaxps_xmm_xmm_xmmm128
			0,// VEX_Vmaxps_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vmaxps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vmaxps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vmaxps_zmm_k1z_zmm_zmmm512b32_sae
			0,// Maxpd_xmm_xmmm128
			0,// VEX_Vmaxpd_xmm_xmm_xmmm128
			0,// VEX_Vmaxpd_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vmaxpd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vmaxpd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vmaxpd_zmm_k1z_zmm_zmmm512b64_sae
			0,// Maxss_xmm_xmmm32
			0,// VEX_Vmaxss_xmm_xmm_xmmm32
			0,// EVEX_Vmaxss_xmm_k1z_xmm_xmmm32_sae
			0,// Maxsd_xmm_xmmm64
			0,// VEX_Vmaxsd_xmm_xmm_xmmm64
			0,// EVEX_Vmaxsd_xmm_k1z_xmm_xmmm64_sae
			0,// Punpcklbw_mm_mmm32
			0,// Punpcklbw_xmm_xmmm128
			0,// VEX_Vpunpcklbw_xmm_xmm_xmmm128
			0,// VEX_Vpunpcklbw_ymm_ymm_ymmm256
			0,// EVEX_Vpunpcklbw_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpunpcklbw_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpunpcklbw_zmm_k1z_zmm_zmmm512
			0,// Punpcklwd_mm_mmm32
			0,// Punpcklwd_xmm_xmmm128
			0,// VEX_Vpunpcklwd_xmm_xmm_xmmm128
			0,// VEX_Vpunpcklwd_ymm_ymm_ymmm256
			0,// EVEX_Vpunpcklwd_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpunpcklwd_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpunpcklwd_zmm_k1z_zmm_zmmm512
			0,// Punpckldq_mm_mmm32
			0,// Punpckldq_xmm_xmmm128
			0,// VEX_Vpunpckldq_xmm_xmm_xmmm128
			0,// VEX_Vpunpckldq_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vpunpckldq_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vpunpckldq_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vpunpckldq_zmm_k1z_zmm_zmmm512b32
			0,// Packsswb_mm_mmm64
			0,// Packsswb_xmm_xmmm128
			0,// VEX_Vpacksswb_xmm_xmm_xmmm128
			0,// VEX_Vpacksswb_ymm_ymm_ymmm256
			0,// EVEX_Vpacksswb_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpacksswb_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpacksswb_zmm_k1z_zmm_zmmm512
			0,// Pcmpgtb_mm_mmm64
			0,// Pcmpgtb_xmm_xmmm128
			0,// VEX_Vpcmpgtb_xmm_xmm_xmmm128
			0,// VEX_Vpcmpgtb_ymm_ymm_ymmm256
			0,// EVEX_Vpcmpgtb_kr_k1_xmm_xmmm128
			0,// EVEX_Vpcmpgtb_kr_k1_ymm_ymmm256
			0,// EVEX_Vpcmpgtb_kr_k1_zmm_zmmm512
			0,// Pcmpgtw_mm_mmm64
			0,// Pcmpgtw_xmm_xmmm128
			0,// VEX_Vpcmpgtw_xmm_xmm_xmmm128
			0,// VEX_Vpcmpgtw_ymm_ymm_ymmm256
			0,// EVEX_Vpcmpgtw_kr_k1_xmm_xmmm128
			0,// EVEX_Vpcmpgtw_kr_k1_ymm_ymmm256
			0,// EVEX_Vpcmpgtw_kr_k1_zmm_zmmm512
			0,// Pcmpgtd_mm_mmm64
			0,// Pcmpgtd_xmm_xmmm128
			0,// VEX_Vpcmpgtd_xmm_xmm_xmmm128
			0,// VEX_Vpcmpgtd_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Int32,// EVEX_Vpcmpgtd_kr_k1_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Int32,// EVEX_Vpcmpgtd_kr_k1_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Int32,// EVEX_Vpcmpgtd_kr_k1_zmm_zmmm512b32
			0,// Packuswb_mm_mmm64
			0,// Packuswb_xmm_xmmm128
			0,// VEX_Vpackuswb_xmm_xmm_xmmm128
			0,// VEX_Vpackuswb_ymm_ymm_ymmm256
			0,// EVEX_Vpackuswb_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpackuswb_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpackuswb_zmm_k1z_zmm_zmmm512
			0,// Punpckhbw_mm_mmm64
			0,// Punpckhbw_xmm_xmmm128
			0,// VEX_Vpunpckhbw_xmm_xmm_xmmm128
			0,// VEX_Vpunpckhbw_ymm_ymm_ymmm256
			0,// EVEX_Vpunpckhbw_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpunpckhbw_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpunpckhbw_zmm_k1z_zmm_zmmm512
			0,// Punpckhwd_mm_mmm64
			0,// Punpckhwd_xmm_xmmm128
			0,// VEX_Vpunpckhwd_xmm_xmm_xmmm128
			0,// VEX_Vpunpckhwd_ymm_ymm_ymmm256
			0,// EVEX_Vpunpckhwd_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpunpckhwd_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpunpckhwd_zmm_k1z_zmm_zmmm512
			0,// Punpckhdq_mm_mmm64
			0,// Punpckhdq_xmm_xmmm128
			0,// VEX_Vpunpckhdq_xmm_xmm_xmmm128
			0,// VEX_Vpunpckhdq_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vpunpckhdq_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vpunpckhdq_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vpunpckhdq_zmm_k1z_zmm_zmmm512b32
			0,// Packssdw_mm_mmm64
			0,// Packssdw_xmm_xmmm128
			0,// VEX_Vpackssdw_xmm_xmm_xmmm128
			0,// VEX_Vpackssdw_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Int32,// EVEX_Vpackssdw_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Int32,// EVEX_Vpackssdw_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Int32,// EVEX_Vpackssdw_zmm_k1z_zmm_zmmm512b32
			0,// Punpcklqdq_xmm_xmmm128
			0,// VEX_Vpunpcklqdq_xmm_xmm_xmmm128
			0,// VEX_Vpunpcklqdq_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vpunpcklqdq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vpunpcklqdq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vpunpcklqdq_zmm_k1z_zmm_zmmm512b64
			0,// Punpckhqdq_xmm_xmmm128
			0,// VEX_Vpunpckhqdq_xmm_xmm_xmmm128
			0,// VEX_Vpunpckhqdq_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vpunpckhqdq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vpunpckhqdq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vpunpckhqdq_zmm_k1z_zmm_zmmm512b64
			0,// Movd_mm_rm32
			0,// Movq_mm_rm64
			0,// Movd_xmm_rm32
			0,// Movq_xmm_rm64
			0,// VEX_Vmovd_xmm_rm32
			0,// VEX_Vmovq_xmm_rm64
			0,// EVEX_Vmovd_xmm_rm32
			0,// EVEX_Vmovq_xmm_rm64
			0,// Movq_mm_mmm64
			0,// Movdqa_xmm_xmmm128
			0,// VEX_Vmovdqa_xmm_xmmm128
			0,// VEX_Vmovdqa_ymm_ymmm256
			0,// EVEX_Vmovdqa32_xmm_k1z_xmmm128
			0,// EVEX_Vmovdqa32_ymm_k1z_ymmm256
			0,// EVEX_Vmovdqa32_zmm_k1z_zmmm512
			0,// EVEX_Vmovdqa64_xmm_k1z_xmmm128
			0,// EVEX_Vmovdqa64_ymm_k1z_ymmm256
			0,// EVEX_Vmovdqa64_zmm_k1z_zmmm512
			0,// Movdqu_xmm_xmmm128
			0,// VEX_Vmovdqu_xmm_xmmm128
			0,// VEX_Vmovdqu_ymm_ymmm256
			0,// EVEX_Vmovdqu32_xmm_k1z_xmmm128
			0,// EVEX_Vmovdqu32_ymm_k1z_ymmm256
			0,// EVEX_Vmovdqu32_zmm_k1z_zmmm512
			0,// EVEX_Vmovdqu64_xmm_k1z_xmmm128
			0,// EVEX_Vmovdqu64_ymm_k1z_ymmm256
			0,// EVEX_Vmovdqu64_zmm_k1z_zmmm512
			0,// EVEX_Vmovdqu8_xmm_k1z_xmmm128
			0,// EVEX_Vmovdqu8_ymm_k1z_ymmm256
			0,// EVEX_Vmovdqu8_zmm_k1z_zmmm512
			0,// EVEX_Vmovdqu16_xmm_k1z_xmmm128
			0,// EVEX_Vmovdqu16_ymm_k1z_ymmm256
			0,// EVEX_Vmovdqu16_zmm_k1z_zmmm512
			0,// Pshufw_mm_mmm64_imm8
			0,// Pshufd_xmm_xmmm128_imm8
			0,// VEX_Vpshufd_xmm_xmmm128_imm8
			0,// VEX_Vpshufd_ymm_ymmm256_imm8
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vpshufd_xmm_k1z_xmmm128b32_imm8
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vpshufd_ymm_k1z_ymmm256b32_imm8
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vpshufd_zmm_k1z_zmmm512b32_imm8
			0,// Pshufhw_xmm_xmmm128_imm8
			0,// VEX_Vpshufhw_xmm_xmmm128_imm8
			0,// VEX_Vpshufhw_ymm_ymmm256_imm8
			0,// EVEX_Vpshufhw_xmm_k1z_xmmm128_imm8
			0,// EVEX_Vpshufhw_ymm_k1z_ymmm256_imm8
			0,// EVEX_Vpshufhw_zmm_k1z_zmmm512_imm8
			0,// Pshuflw_xmm_xmmm128_imm8
			0,// VEX_Vpshuflw_xmm_xmmm128_imm8
			0,// VEX_Vpshuflw_ymm_ymmm256_imm8
			0,// EVEX_Vpshuflw_xmm_k1z_xmmm128_imm8
			0,// EVEX_Vpshuflw_ymm_k1z_ymmm256_imm8
			0,// EVEX_Vpshuflw_zmm_k1z_zmmm512_imm8
			0,// Psrlw_mm_imm8
			0,// Psrlw_xmm_imm8
			0,// VEX_Vpsrlw_xmm_xmm_imm8
			0,// VEX_Vpsrlw_ymm_ymm_imm8
			0,// EVEX_Vpsrlw_xmm_k1z_xmmm128_imm8
			0,// EVEX_Vpsrlw_ymm_k1z_ymmm256_imm8
			0,// EVEX_Vpsrlw_zmm_k1z_zmmm512_imm8
			0,// Psraw_mm_imm8
			0,// Psraw_xmm_imm8
			0,// VEX_Vpsraw_xmm_xmm_imm8
			0,// VEX_Vpsraw_ymm_ymm_imm8
			0,// EVEX_Vpsraw_xmm_k1z_xmmm128_imm8
			0,// EVEX_Vpsraw_ymm_k1z_ymmm256_imm8
			0,// EVEX_Vpsraw_zmm_k1z_zmmm512_imm8
			0,// Psllw_mm_imm8
			0,// Psllw_xmm_imm8
			0,// VEX_Vpsllw_xmm_xmm_imm8
			0,// VEX_Vpsllw_ymm_ymm_imm8
			0,// EVEX_Vpsllw_xmm_k1z_xmmm128_imm8
			0,// EVEX_Vpsllw_ymm_k1z_ymmm256_imm8
			0,// EVEX_Vpsllw_zmm_k1z_zmmm512_imm8
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vprord_xmm_k1z_xmmm128b32_imm8
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vprord_ymm_k1z_ymmm256b32_imm8
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vprord_zmm_k1z_zmmm512b32_imm8
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vprorq_xmm_k1z_xmmm128b64_imm8
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vprorq_ymm_k1z_ymmm256b64_imm8
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vprorq_zmm_k1z_zmmm512b64_imm8
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vprold_xmm_k1z_xmmm128b32_imm8
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vprold_ymm_k1z_ymmm256b32_imm8
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vprold_zmm_k1z_zmmm512b32_imm8
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vprolq_xmm_k1z_xmmm128b64_imm8
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vprolq_ymm_k1z_ymmm256b64_imm8
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vprolq_zmm_k1z_zmmm512b64_imm8
			0,// Psrld_mm_imm8
			0,// Psrld_xmm_imm8
			0,// VEX_Vpsrld_xmm_xmm_imm8
			0,// VEX_Vpsrld_ymm_ymm_imm8
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vpsrld_xmm_k1z_xmmm128b32_imm8
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vpsrld_ymm_k1z_ymmm256b32_imm8
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vpsrld_zmm_k1z_zmmm512b32_imm8
			0,// Psrad_mm_imm8
			0,// Psrad_xmm_imm8
			0,// VEX_Vpsrad_xmm_xmm_imm8
			0,// VEX_Vpsrad_ymm_ymm_imm8
			(byte)MemorySize.Broadcast128_Int32,// EVEX_Vpsrad_xmm_k1z_xmmm128b32_imm8
			(byte)MemorySize.Broadcast256_Int32,// EVEX_Vpsrad_ymm_k1z_ymmm256b32_imm8
			(byte)MemorySize.Broadcast512_Int32,// EVEX_Vpsrad_zmm_k1z_zmmm512b32_imm8
			(byte)MemorySize.Broadcast128_Int64,// EVEX_Vpsraq_xmm_k1z_xmmm128b64_imm8
			(byte)MemorySize.Broadcast256_Int64,// EVEX_Vpsraq_ymm_k1z_ymmm256b64_imm8
			(byte)MemorySize.Broadcast512_Int64,// EVEX_Vpsraq_zmm_k1z_zmmm512b64_imm8
			0,// Pslld_mm_imm8
			0,// Pslld_xmm_imm8
			0,// VEX_Vpslld_xmm_xmm_imm8
			0,// VEX_Vpslld_ymm_ymm_imm8
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vpslld_xmm_k1z_xmmm128b32_imm8
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vpslld_ymm_k1z_ymmm256b32_imm8
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vpslld_zmm_k1z_zmmm512b32_imm8
			0,// Psrlq_mm_imm8
			0,// Psrlq_xmm_imm8
			0,// VEX_Vpsrlq_xmm_xmm_imm8
			0,// VEX_Vpsrlq_ymm_ymm_imm8
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vpsrlq_xmm_k1z_xmmm128b64_imm8
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vpsrlq_ymm_k1z_ymmm256b64_imm8
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vpsrlq_zmm_k1z_zmmm512b64_imm8
			0,// Psrldq_xmm_imm8
			0,// VEX_Vpsrldq_xmm_xmm_imm8
			0,// VEX_Vpsrldq_ymm_ymm_imm8
			0,// EVEX_Vpsrldq_xmm_xmmm128_imm8
			0,// EVEX_Vpsrldq_ymm_ymmm256_imm8
			0,// EVEX_Vpsrldq_zmm_zmmm512_imm8
			0,// Psllq_mm_imm8
			0,// Psllq_xmm_imm8
			0,// VEX_Vpsllq_xmm_xmm_imm8
			0,// VEX_Vpsllq_ymm_ymm_imm8
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vpsllq_xmm_k1z_xmmm128b64_imm8
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vpsllq_ymm_k1z_ymmm256b64_imm8
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vpsllq_zmm_k1z_zmmm512b64_imm8
			0,// Pslldq_xmm_imm8
			0,// VEX_Vpslldq_xmm_xmm_imm8
			0,// VEX_Vpslldq_ymm_ymm_imm8
			0,// EVEX_Vpslldq_xmm_xmmm128_imm8
			0,// EVEX_Vpslldq_ymm_ymmm256_imm8
			0,// EVEX_Vpslldq_zmm_zmmm512_imm8
			0,// Pcmpeqb_mm_mmm64
			0,// Pcmpeqb_xmm_xmmm128
			0,// VEX_Vpcmpeqb_xmm_xmm_xmmm128
			0,// VEX_Vpcmpeqb_ymm_ymm_ymmm256
			0,// EVEX_Vpcmpeqb_kr_k1_xmm_xmmm128
			0,// EVEX_Vpcmpeqb_kr_k1_ymm_ymmm256
			0,// EVEX_Vpcmpeqb_kr_k1_zmm_zmmm512
			0,// Pcmpeqw_mm_mmm64
			0,// Pcmpeqw_xmm_xmmm128
			0,// VEX_Vpcmpeqw_xmm_xmm_xmmm128
			0,// VEX_Vpcmpeqw_ymm_ymm_ymmm256
			0,// EVEX_Vpcmpeqw_kr_k1_xmm_xmmm128
			0,// EVEX_Vpcmpeqw_kr_k1_ymm_ymmm256
			0,// EVEX_Vpcmpeqw_kr_k1_zmm_zmmm512
			0,// Pcmpeqd_mm_mmm64
			0,// Pcmpeqd_xmm_xmmm128
			0,// VEX_Vpcmpeqd_xmm_xmm_xmmm128
			0,// VEX_Vpcmpeqd_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vpcmpeqd_kr_k1_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vpcmpeqd_kr_k1_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vpcmpeqd_kr_k1_zmm_zmmm512b32
			0,// Emms
			0,// VEX_Vzeroupper
			0,// VEX_Vzeroall
			0,// Vmread_rm32_r32
			0,// Vmread_rm64_r64
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vcvttps2udq_xmm_k1z_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vcvttps2udq_ymm_k1z_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vcvttps2udq_zmm_k1z_zmmm512b32_sae
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vcvttpd2udq_xmm_k1z_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vcvttpd2udq_xmm_k1z_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vcvttpd2udq_ymm_k1z_zmmm512b64_sae
			0,// Extrq_xmm_imm8_imm8
			(byte)MemorySize.Broadcast64_Float32,// EVEX_Vcvttps2uqq_xmm_k1z_xmmm64b32
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vcvttps2uqq_ymm_k1z_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vcvttps2uqq_zmm_k1z_ymmm256b32_sae
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vcvttpd2uqq_xmm_k1z_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vcvttpd2uqq_ymm_k1z_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vcvttpd2uqq_zmm_k1z_zmmm512b64_sae
			0,// EVEX_Vcvttss2usi_r32_xmmm32_sae
			0,// EVEX_Vcvttss2usi_r64_xmmm32_sae
			0,// Insertq_xmm_xmm_imm8_imm8
			0,// EVEX_Vcvttsd2usi_r32_xmmm64_sae
			0,// EVEX_Vcvttsd2usi_r64_xmmm64_sae
			0,// Vmwrite_r32_rm32
			0,// Vmwrite_r64_rm64
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vcvtps2udq_xmm_k1z_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vcvtps2udq_ymm_k1z_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vcvtps2udq_zmm_k1z_zmmm512b32_er
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vcvtpd2udq_xmm_k1z_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vcvtpd2udq_xmm_k1z_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vcvtpd2udq_ymm_k1z_zmmm512b64_er
			0,// Extrq_xmm_xmm
			(byte)MemorySize.Broadcast64_Float32,// EVEX_Vcvtps2uqq_xmm_k1z_xmmm64b32
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vcvtps2uqq_ymm_k1z_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vcvtps2uqq_zmm_k1z_ymmm256b32_er
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vcvtpd2uqq_xmm_k1z_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vcvtpd2uqq_ymm_k1z_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vcvtpd2uqq_zmm_k1z_zmmm512b64_er
			0,// EVEX_Vcvtss2usi_r32_xmmm32_er
			0,// EVEX_Vcvtss2usi_r64_xmmm32_er
			0,// Insertq_xmm_xmm
			0,// EVEX_Vcvtsd2usi_r32_xmmm64_er
			0,// EVEX_Vcvtsd2usi_r64_xmmm64_er
			(byte)MemorySize.Broadcast64_Float32,// EVEX_Vcvttps2qq_xmm_k1z_xmmm64b32
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vcvttps2qq_ymm_k1z_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vcvttps2qq_zmm_k1z_ymmm256b32_sae
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vcvttpd2qq_xmm_k1z_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vcvttpd2qq_ymm_k1z_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vcvttpd2qq_zmm_k1z_zmmm512b64_sae
			(byte)MemorySize.Broadcast64_UInt32,// EVEX_Vcvtudq2pd_xmm_k1z_xmmm64b32
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vcvtudq2pd_ymm_k1z_xmmm128b32
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vcvtudq2pd_zmm_k1z_ymmm256b32_er
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vcvtuqq2pd_xmm_k1z_xmmm128b64
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vcvtuqq2pd_ymm_k1z_ymmm256b64
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vcvtuqq2pd_zmm_k1z_zmmm512b64_er
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vcvtudq2ps_xmm_k1z_xmmm128b32
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vcvtudq2ps_ymm_k1z_ymmm256b32
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vcvtudq2ps_zmm_k1z_zmmm512b32_er
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vcvtuqq2ps_xmm_k1z_xmmm128b64
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vcvtuqq2ps_xmm_k1z_ymmm256b64
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vcvtuqq2ps_ymm_k1z_zmmm512b64_er
			(byte)MemorySize.Broadcast64_Float32,// EVEX_Vcvtps2qq_xmm_k1z_xmmm64b32
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vcvtps2qq_ymm_k1z_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vcvtps2qq_zmm_k1z_ymmm256b32_er
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vcvtpd2qq_xmm_k1z_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vcvtpd2qq_ymm_k1z_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vcvtpd2qq_zmm_k1z_zmmm512b64_er
			0,// EVEX_Vcvtusi2ss_xmm_xmm_rm32_er
			0,// EVEX_Vcvtusi2ss_xmm_xmm_rm64_er
			0,// EVEX_Vcvtusi2sd_xmm_xmm_rm32_er
			0,// EVEX_Vcvtusi2sd_xmm_xmm_rm64_er
			0,// Haddpd_xmm_xmmm128
			0,// VEX_Vhaddpd_xmm_xmm_xmmm128
			0,// VEX_Vhaddpd_ymm_ymm_ymmm256
			0,// Haddps_xmm_xmmm128
			0,// VEX_Vhaddps_xmm_xmm_xmmm128
			0,// VEX_Vhaddps_ymm_ymm_ymmm256
			0,// Hsubpd_xmm_xmmm128
			0,// VEX_Vhsubpd_xmm_xmm_xmmm128
			0,// VEX_Vhsubpd_ymm_ymm_ymmm256
			0,// Hsubps_xmm_xmmm128
			0,// VEX_Vhsubps_xmm_xmm_xmmm128
			0,// VEX_Vhsubps_ymm_ymm_ymmm256
			0,// Movd_rm32_mm
			0,// Movq_rm64_mm
			0,// Movd_rm32_xmm
			0,// Movq_rm64_xmm
			0,// VEX_Vmovd_rm32_xmm
			0,// VEX_Vmovq_rm64_xmm
			0,// EVEX_Vmovd_rm32_xmm
			0,// EVEX_Vmovq_rm64_xmm
			0,// Movq_xmm_xmmm64
			0,// VEX_Vmovq_xmm_xmmm64
			0,// EVEX_Vmovq_xmm_xmmm64
			0,// Movq_mmm64_mm
			0,// Movdqa_xmmm128_xmm
			0,// VEX_Vmovdqa_xmmm128_xmm
			0,// VEX_Vmovdqa_ymmm256_ymm
			0,// EVEX_Vmovdqa32_xmmm128_k1z_xmm
			0,// EVEX_Vmovdqa32_ymmm256_k1z_ymm
			0,// EVEX_Vmovdqa32_zmmm512_k1z_zmm
			0,// EVEX_Vmovdqa64_xmmm128_k1z_xmm
			0,// EVEX_Vmovdqa64_ymmm256_k1z_ymm
			0,// EVEX_Vmovdqa64_zmmm512_k1z_zmm
			0,// Movdqu_xmmm128_xmm
			0,// VEX_Vmovdqu_xmmm128_xmm
			0,// VEX_Vmovdqu_ymmm256_ymm
			0,// EVEX_Vmovdqu32_xmmm128_k1z_xmm
			0,// EVEX_Vmovdqu32_ymmm256_k1z_ymm
			0,// EVEX_Vmovdqu32_zmmm512_k1z_zmm
			0,// EVEX_Vmovdqu64_xmmm128_k1z_xmm
			0,// EVEX_Vmovdqu64_ymmm256_k1z_ymm
			0,// EVEX_Vmovdqu64_zmmm512_k1z_zmm
			0,// EVEX_Vmovdqu8_xmmm128_k1z_xmm
			0,// EVEX_Vmovdqu8_ymmm256_k1z_ymm
			0,// EVEX_Vmovdqu8_zmmm512_k1z_zmm
			0,// EVEX_Vmovdqu16_xmmm128_k1z_xmm
			0,// EVEX_Vmovdqu16_ymmm256_k1z_ymm
			0,// EVEX_Vmovdqu16_zmmm512_k1z_zmm
			0,// Jo_rel16
			0,// Jo_rel32_32
			0,// Jo_rel32_64
			0,// Jno_rel16
			0,// Jno_rel32_32
			0,// Jno_rel32_64
			0,// Jb_rel16
			0,// Jb_rel32_32
			0,// Jb_rel32_64
			0,// Jae_rel16
			0,// Jae_rel32_32
			0,// Jae_rel32_64
			0,// Je_rel16
			0,// Je_rel32_32
			0,// Je_rel32_64
			0,// Jne_rel16
			0,// Jne_rel32_32
			0,// Jne_rel32_64
			0,// Jbe_rel16
			0,// Jbe_rel32_32
			0,// Jbe_rel32_64
			0,// Ja_rel16
			0,// Ja_rel32_32
			0,// Ja_rel32_64
			0,// Js_rel16
			0,// Js_rel32_32
			0,// Js_rel32_64
			0,// Jns_rel16
			0,// Jns_rel32_32
			0,// Jns_rel32_64
			0,// Jp_rel16
			0,// Jp_rel32_32
			0,// Jp_rel32_64
			0,// Jnp_rel16
			0,// Jnp_rel32_32
			0,// Jnp_rel32_64
			0,// Jl_rel16
			0,// Jl_rel32_32
			0,// Jl_rel32_64
			0,// Jge_rel16
			0,// Jge_rel32_32
			0,// Jge_rel32_64
			0,// Jle_rel16
			0,// Jle_rel32_32
			0,// Jle_rel32_64
			0,// Jg_rel16
			0,// Jg_rel32_32
			0,// Jg_rel32_64
			0,// Seto_rm8
			0,// Setno_rm8
			0,// Setb_rm8
			0,// Setae_rm8
			0,// Sete_rm8
			0,// Setne_rm8
			0,// Setbe_rm8
			0,// Seta_rm8
			0,// Sets_rm8
			0,// Setns_rm8
			0,// Setp_rm8
			0,// Setnp_rm8
			0,// Setl_rm8
			0,// Setge_rm8
			0,// Setle_rm8
			0,// Setg_rm8
			0,// VEX_Kmovw_kr_km16
			0,// VEX_Kmovq_kr_km64
			0,// VEX_Kmovb_kr_km8
			0,// VEX_Kmovd_kr_km32
			0,// VEX_Kmovw_m16_kr
			0,// VEX_Kmovq_m64_kr
			0,// VEX_Kmovb_m8_kr
			0,// VEX_Kmovd_m32_kr
			0,// VEX_Kmovw_kr_r32
			0,// VEX_Kmovb_kr_r32
			0,// VEX_Kmovd_kr_r32
			0,// VEX_Kmovq_kr_r64
			0,// VEX_Kmovw_r32_kr
			0,// VEX_Kmovb_r32_kr
			0,// VEX_Kmovd_r32_kr
			0,// VEX_Kmovq_r64_kr
			0,// VEX_Kortestw_kr_kr
			0,// VEX_Kortestq_kr_kr
			0,// VEX_Kortestb_kr_kr
			0,// VEX_Kortestd_kr_kr
			0,// VEX_Ktestw_kr_kr
			0,// VEX_Ktestq_kr_kr
			0,// VEX_Ktestb_kr_kr
			0,// VEX_Ktestd_kr_kr
			0,// Pushw_FS
			0,// Pushd_FS
			0,// Pushq_FS
			0,// Popw_FS
			0,// Popd_FS
			0,// Popq_FS
			0,// Cpuid
			0,// Bt_rm16_r16
			0,// Bt_rm32_r32
			0,// Bt_rm64_r64
			0,// Shld_rm16_r16_imm8
			0,// Shld_rm32_r32_imm8
			0,// Shld_rm64_r64_imm8
			0,// Shld_rm16_r16_CL
			0,// Shld_rm32_r32_CL
			0,// Shld_rm64_r64_CL
			0,// Montmul_16
			0,// Montmul_32
			0,// Montmul_64
			0,// Xsha1_16
			0,// Xsha1_32
			0,// Xsha1_64
			0,// Xsha256_16
			0,// Xsha256_32
			0,// Xsha256_64
			0,// Xbts_r16_rm16
			0,// Xbts_r32_rm32
			0,// Xstore_16
			0,// Xstore_32
			0,// Xstore_64
			0,// Xcryptecb_16
			0,// Xcryptecb_32
			0,// Xcryptecb_64
			0,// Xcryptcbc_16
			0,// Xcryptcbc_32
			0,// Xcryptcbc_64
			0,// Xcryptctr_16
			0,// Xcryptctr_32
			0,// Xcryptctr_64
			0,// Xcryptcfb_16
			0,// Xcryptcfb_32
			0,// Xcryptcfb_64
			0,// Xcryptofb_16
			0,// Xcryptofb_32
			0,// Xcryptofb_64
			0,// Ibts_rm16_r16
			0,// Ibts_rm32_r32
			0,// Cmpxchg486_rm8_r8
			0,// Cmpxchg486_rm16_r16
			0,// Cmpxchg486_rm32_r32
			0,// Pushw_GS
			0,// Pushd_GS
			0,// Pushq_GS
			0,// Popw_GS
			0,// Popd_GS
			0,// Popq_GS
			0,// Rsm
			0,// Bts_rm16_r16
			0,// Bts_rm32_r32
			0,// Bts_rm64_r64
			0,// Shrd_rm16_r16_imm8
			0,// Shrd_rm32_r32_imm8
			0,// Shrd_rm64_r64_imm8
			0,// Shrd_rm16_r16_CL
			0,// Shrd_rm32_r32_CL
			0,// Shrd_rm64_r64_CL
			0,// Fxsave_m512byte
			0,// Fxsave64_m512byte
			0,// Rdfsbase_r32
			0,// Rdfsbase_r64
			0,// Fxrstor_m512byte
			0,// Fxrstor64_m512byte
			0,// Rdgsbase_r32
			0,// Rdgsbase_r64
			0,// Ldmxcsr_m32
			0,// Wrfsbase_r32
			0,// Wrfsbase_r64
			0,// VEX_Vldmxcsr_m32
			0,// Stmxcsr_m32
			0,// Wrgsbase_r32
			0,// Wrgsbase_r64
			0,// VEX_Vstmxcsr_m32
			0,// Xsave_mem
			0,// Xsave64_mem
			0,// Ptwrite_rm32
			0,// Ptwrite_rm64
			0,// Xrstor_mem
			0,// Xrstor64_mem
			0,// Incsspd_r32
			0,// Incsspq_r64
			0,// Xsaveopt_mem
			0,// Xsaveopt64_mem
			0,// Clwb_m8
			0,// Tpause_r32
			0,// Tpause_r64
			0,// Clrssbsy_m64
			0,// Umonitor_r16
			0,// Umonitor_r32
			0,// Umonitor_r64
			0,// Umwait_r32
			0,// Umwait_r64
			0,// Clflush_m8
			0,// Clflushopt_m8
			0,// Lfence
			0,// Lfence_E9
			0,// Lfence_EA
			0,// Lfence_EB
			0,// Lfence_EC
			0,// Lfence_ED
			0,// Lfence_EE
			0,// Lfence_EF
			0,// Mfence
			0,// Mfence_F1
			0,// Mfence_F2
			0,// Mfence_F3
			0,// Mfence_F4
			0,// Mfence_F5
			0,// Mfence_F6
			0,// Mfence_F7
			0,// Sfence
			0,// Sfence_F9
			0,// Sfence_FA
			0,// Sfence_FB
			0,// Sfence_FC
			0,// Sfence_FD
			0,// Sfence_FE
			0,// Sfence_FF
			0,// Pcommit
			0,// Imul_r16_rm16
			0,// Imul_r32_rm32
			0,// Imul_r64_rm64
			0,// Cmpxchg_rm8_r8
			0,// Cmpxchg_rm16_r16
			0,// Cmpxchg_rm32_r32
			0,// Cmpxchg_rm64_r64
			0,// Lss_r16_m1616
			0,// Lss_r32_m1632
			0,// Lss_r64_m1664
			0,// Btr_rm16_r16
			0,// Btr_rm32_r32
			0,// Btr_rm64_r64
			0,// Lfs_r16_m1616
			0,// Lfs_r32_m1632
			0,// Lfs_r64_m1664
			0,// Lgs_r16_m1616
			0,// Lgs_r32_m1632
			0,// Lgs_r64_m1664
			0,// Movzx_r16_rm8
			0,// Movzx_r32_rm8
			0,// Movzx_r64_rm8
			0,// Movzx_r16_rm16
			0,// Movzx_r32_rm16
			0,// Movzx_r64_rm16
			0,// Jmpe_disp16
			0,// Jmpe_disp32
			0,// Popcnt_r16_rm16
			0,// Popcnt_r32_rm32
			0,// Popcnt_r64_rm64
			0,// Ud1_r16_rm16
			0,// Ud1_r32_rm32
			0,// Ud1_r64_rm64
			0,// Bt_rm16_imm8
			0,// Bt_rm32_imm8
			0,// Bt_rm64_imm8
			0,// Bts_rm16_imm8
			0,// Bts_rm32_imm8
			0,// Bts_rm64_imm8
			0,// Btr_rm16_imm8
			0,// Btr_rm32_imm8
			0,// Btr_rm64_imm8
			0,// Btc_rm16_imm8
			0,// Btc_rm32_imm8
			0,// Btc_rm64_imm8
			0,// Btc_rm16_r16
			0,// Btc_rm32_r32
			0,// Btc_rm64_r64
			0,// Bsf_r16_rm16
			0,// Bsf_r32_rm32
			0,// Bsf_r64_rm64
			0,// Tzcnt_r16_rm16
			0,// Tzcnt_r32_rm32
			0,// Tzcnt_r64_rm64
			0,// Bsr_r16_rm16
			0,// Bsr_r32_rm32
			0,// Bsr_r64_rm64
			0,// Lzcnt_r16_rm16
			0,// Lzcnt_r32_rm32
			0,// Lzcnt_r64_rm64
			0,// Movsx_r16_rm8
			0,// Movsx_r32_rm8
			0,// Movsx_r64_rm8
			0,// Movsx_r16_rm16
			0,// Movsx_r32_rm16
			0,// Movsx_r64_rm16
			0,// Xadd_rm8_r8
			0,// Xadd_rm16_r16
			0,// Xadd_rm32_r32
			0,// Xadd_rm64_r64
			0,// Cmpps_xmm_xmmm128_imm8
			0,// VEX_Vcmpps_xmm_xmm_xmmm128_imm8
			0,// VEX_Vcmpps_ymm_ymm_ymmm256_imm8
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vcmpps_kr_k1_xmm_xmmm128b32_imm8
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vcmpps_kr_k1_ymm_ymmm256b32_imm8
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vcmpps_kr_k1_zmm_zmmm512b32_imm8_sae
			0,// Cmppd_xmm_xmmm128_imm8
			0,// VEX_Vcmppd_xmm_xmm_xmmm128_imm8
			0,// VEX_Vcmppd_ymm_ymm_ymmm256_imm8
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vcmppd_kr_k1_xmm_xmmm128b64_imm8
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vcmppd_kr_k1_ymm_ymmm256b64_imm8
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vcmppd_kr_k1_zmm_zmmm512b64_imm8_sae
			0,// Cmpss_xmm_xmmm32_imm8
			0,// VEX_Vcmpss_xmm_xmm_xmmm32_imm8
			0,// EVEX_Vcmpss_kr_k1_xmm_xmmm32_imm8_sae
			0,// Cmpsd_xmm_xmmm64_imm8
			0,// VEX_Vcmpsd_xmm_xmm_xmmm64_imm8
			0,// EVEX_Vcmpsd_kr_k1_xmm_xmmm64_imm8_sae
			0,// Movnti_m32_r32
			0,// Movnti_m64_r64
			0,// Pinsrw_mm_r32m16_imm8
			0,// Pinsrw_mm_r64m16_imm8
			0,// Pinsrw_xmm_r32m16_imm8
			0,// Pinsrw_xmm_r64m16_imm8
			0,// VEX_Vpinsrw_xmm_xmm_r32m16_imm8
			0,// VEX_Vpinsrw_xmm_xmm_r64m16_imm8
			0,// EVEX_Vpinsrw_xmm_xmm_r32m16_imm8
			0,// EVEX_Vpinsrw_xmm_xmm_r64m16_imm8
			0,// Pextrw_r32_mm_imm8
			0,// Pextrw_r64_mm_imm8
			0,// Pextrw_r32_xmm_imm8
			0,// Pextrw_r64_xmm_imm8
			0,// VEX_Vpextrw_r32_xmm_imm8
			0,// VEX_Vpextrw_r64_xmm_imm8
			0,// EVEX_Vpextrw_r32_xmm_imm8
			0,// EVEX_Vpextrw_r64_xmm_imm8
			0,// Shufps_xmm_xmmm128_imm8
			0,// VEX_Vshufps_xmm_xmm_xmmm128_imm8
			0,// VEX_Vshufps_ymm_ymm_ymmm256_imm8
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vshufps_xmm_k1z_xmm_xmmm128b32_imm8
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vshufps_ymm_k1z_ymm_ymmm256b32_imm8
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vshufps_zmm_k1z_zmm_zmmm512b32_imm8
			0,// Shufpd_xmm_xmmm128_imm8
			0,// VEX_Vshufpd_xmm_xmm_xmmm128_imm8
			0,// VEX_Vshufpd_ymm_ymm_ymmm256_imm8
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vshufpd_xmm_k1z_xmm_xmmm128b64_imm8
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vshufpd_ymm_k1z_ymm_ymmm256b64_imm8
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vshufpd_zmm_k1z_zmm_zmmm512b64_imm8
			0,// Cmpxchg8b_m64
			0,// Cmpxchg16b_m128
			0,// Xrstors_mem
			0,// Xrstors64_mem
			0,// Xsavec_mem
			0,// Xsavec64_mem
			0,// Xsaves_mem
			0,// Xsaves64_mem
			0,// Vmptrld_m64
			0,// Vmclear_m64
			0,// Vmxon_m64
			0,// Rdrand_r16
			0,// Rdrand_r32
			0,// Rdrand_r64
			0,// Vmptrst_m64
			0,// Rdseed_r16
			0,// Rdseed_r32
			0,// Rdseed_r64
			0,// Rdpid_r32
			0,// Rdpid_r64
			0,// Bswap_r16
			0,// Bswap_r32
			0,// Bswap_r64
			0,// Addsubpd_xmm_xmmm128
			0,// VEX_Vaddsubpd_xmm_xmm_xmmm128
			0,// VEX_Vaddsubpd_ymm_ymm_ymmm256
			0,// Addsubps_xmm_xmmm128
			0,// VEX_Vaddsubps_xmm_xmm_xmmm128
			0,// VEX_Vaddsubps_ymm_ymm_ymmm256
			0,// Psrlw_mm_mmm64
			0,// Psrlw_xmm_xmmm128
			0,// VEX_Vpsrlw_xmm_xmm_xmmm128
			0,// VEX_Vpsrlw_ymm_ymm_xmmm128
			0,// EVEX_Vpsrlw_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpsrlw_ymm_k1z_ymm_xmmm128
			0,// EVEX_Vpsrlw_zmm_k1z_zmm_xmmm128
			0,// Psrld_mm_mmm64
			0,// Psrld_xmm_xmmm128
			0,// VEX_Vpsrld_xmm_xmm_xmmm128
			0,// VEX_Vpsrld_ymm_ymm_xmmm128
			0,// EVEX_Vpsrld_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpsrld_ymm_k1z_ymm_xmmm128
			0,// EVEX_Vpsrld_zmm_k1z_zmm_xmmm128
			0,// Psrlq_mm_mmm64
			0,// Psrlq_xmm_xmmm128
			0,// VEX_Vpsrlq_xmm_xmm_xmmm128
			0,// VEX_Vpsrlq_ymm_ymm_xmmm128
			0,// EVEX_Vpsrlq_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpsrlq_ymm_k1z_ymm_xmmm128
			0,// EVEX_Vpsrlq_zmm_k1z_zmm_xmmm128
			0,// Paddq_mm_mmm64
			0,// Paddq_xmm_xmmm128
			0,// VEX_Vpaddq_xmm_xmm_xmmm128
			0,// VEX_Vpaddq_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vpaddq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vpaddq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vpaddq_zmm_k1z_zmm_zmmm512b64
			0,// Pmullw_mm_mmm64
			0,// Pmullw_xmm_xmmm128
			0,// VEX_Vpmullw_xmm_xmm_xmmm128
			0,// VEX_Vpmullw_ymm_ymm_ymmm256
			0,// EVEX_Vpmullw_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpmullw_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpmullw_zmm_k1z_zmm_zmmm512
			0,// Movq_xmmm64_xmm
			0,// VEX_Vmovq_xmmm64_xmm
			0,// EVEX_Vmovq_xmmm64_xmm
			0,// Movq2dq_xmm_mm
			0,// Movdq2q_mm_xmm
			0,// Pmovmskb_r32_mm
			0,// Pmovmskb_r64_mm
			0,// Pmovmskb_r32_xmm
			0,// Pmovmskb_r64_xmm
			0,// VEX_Vpmovmskb_r32_xmm
			0,// VEX_Vpmovmskb_r64_xmm
			0,// VEX_Vpmovmskb_r32_ymm
			0,// VEX_Vpmovmskb_r64_ymm
			0,// Psubusb_mm_mmm64
			0,// Psubusb_xmm_xmmm128
			0,// VEX_Vpsubusb_xmm_xmm_xmmm128
			0,// VEX_Vpsubusb_ymm_ymm_ymmm256
			0,// EVEX_Vpsubusb_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpsubusb_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpsubusb_zmm_k1z_zmm_zmmm512
			0,// Psubusw_mm_mmm64
			0,// Psubusw_xmm_xmmm128
			0,// VEX_Vpsubusw_xmm_xmm_xmmm128
			0,// VEX_Vpsubusw_ymm_ymm_ymmm256
			0,// EVEX_Vpsubusw_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpsubusw_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpsubusw_zmm_k1z_zmm_zmmm512
			0,// Pminub_mm_mmm64
			0,// Pminub_xmm_xmmm128
			0,// VEX_Vpminub_xmm_xmm_xmmm128
			0,// VEX_Vpminub_ymm_ymm_ymmm256
			0,// EVEX_Vpminub_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpminub_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpminub_zmm_k1z_zmm_zmmm512
			0,// Pand_mm_mmm64
			0,// Pand_xmm_xmmm128
			0,// VEX_Vpand_xmm_xmm_xmmm128
			0,// VEX_Vpand_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vpandd_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vpandd_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vpandd_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vpandq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vpandq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vpandq_zmm_k1z_zmm_zmmm512b64
			0,// Paddusb_mm_mmm64
			0,// Paddusb_xmm_xmmm128
			0,// VEX_Vpaddusb_xmm_xmm_xmmm128
			0,// VEX_Vpaddusb_ymm_ymm_ymmm256
			0,// EVEX_Vpaddusb_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpaddusb_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpaddusb_zmm_k1z_zmm_zmmm512
			0,// Paddusw_mm_mmm64
			0,// Paddusw_xmm_xmmm128
			0,// VEX_Vpaddusw_xmm_xmm_xmmm128
			0,// VEX_Vpaddusw_ymm_ymm_ymmm256
			0,// EVEX_Vpaddusw_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpaddusw_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpaddusw_zmm_k1z_zmm_zmmm512
			0,// Pmaxub_mm_mmm64
			0,// Pmaxub_xmm_xmmm128
			0,// VEX_Vpmaxub_xmm_xmm_xmmm128
			0,// VEX_Vpmaxub_ymm_ymm_ymmm256
			0,// EVEX_Vpmaxub_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpmaxub_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpmaxub_zmm_k1z_zmm_zmmm512
			0,// Pandn_mm_mmm64
			0,// Pandn_xmm_xmmm128
			0,// VEX_Vpandn_xmm_xmm_xmmm128
			0,// VEX_Vpandn_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vpandnd_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vpandnd_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vpandnd_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vpandnq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vpandnq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vpandnq_zmm_k1z_zmm_zmmm512b64
			0,// Pavgb_mm_mmm64
			0,// Pavgb_xmm_xmmm128
			0,// VEX_Vpavgb_xmm_xmm_xmmm128
			0,// VEX_Vpavgb_ymm_ymm_ymmm256
			0,// EVEX_Vpavgb_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpavgb_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpavgb_zmm_k1z_zmm_zmmm512
			0,// Psraw_mm_mmm64
			0,// Psraw_xmm_xmmm128
			0,// VEX_Vpsraw_xmm_xmm_xmmm128
			0,// VEX_Vpsraw_ymm_ymm_xmmm128
			0,// EVEX_Vpsraw_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpsraw_ymm_k1z_ymm_xmmm128
			0,// EVEX_Vpsraw_zmm_k1z_zmm_xmmm128
			0,// Psrad_mm_mmm64
			0,// Psrad_xmm_xmmm128
			0,// VEX_Vpsrad_xmm_xmm_xmmm128
			0,// VEX_Vpsrad_ymm_ymm_xmmm128
			0,// EVEX_Vpsrad_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpsrad_ymm_k1z_ymm_xmmm128
			0,// EVEX_Vpsrad_zmm_k1z_zmm_xmmm128
			0,// EVEX_Vpsraq_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpsraq_ymm_k1z_ymm_xmmm128
			0,// EVEX_Vpsraq_zmm_k1z_zmm_xmmm128
			0,// Pavgw_mm_mmm64
			0,// Pavgw_xmm_xmmm128
			0,// VEX_Vpavgw_xmm_xmm_xmmm128
			0,// VEX_Vpavgw_ymm_ymm_ymmm256
			0,// EVEX_Vpavgw_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpavgw_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpavgw_zmm_k1z_zmm_zmmm512
			0,// Pmulhuw_mm_mmm64
			0,// Pmulhuw_xmm_xmmm128
			0,// VEX_Vpmulhuw_xmm_xmm_xmmm128
			0,// VEX_Vpmulhuw_ymm_ymm_ymmm256
			0,// EVEX_Vpmulhuw_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpmulhuw_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpmulhuw_zmm_k1z_zmm_zmmm512
			0,// Pmulhw_mm_mmm64
			0,// Pmulhw_xmm_xmmm128
			0,// VEX_Vpmulhw_xmm_xmm_xmmm128
			0,// VEX_Vpmulhw_ymm_ymm_ymmm256
			0,// EVEX_Vpmulhw_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpmulhw_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpmulhw_zmm_k1z_zmm_zmmm512
			0,// Cvttpd2dq_xmm_xmmm128
			0,// VEX_Vcvttpd2dq_xmm_xmmm128
			0,// VEX_Vcvttpd2dq_xmm_ymmm256
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vcvttpd2dq_xmm_k1z_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vcvttpd2dq_xmm_k1z_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vcvttpd2dq_ymm_k1z_zmmm512b64_sae
			0,// Cvtdq2pd_xmm_xmmm64
			0,// VEX_Vcvtdq2pd_xmm_xmmm64
			0,// VEX_Vcvtdq2pd_ymm_xmmm128
			(byte)MemorySize.Broadcast64_Int32,// EVEX_Vcvtdq2pd_xmm_k1z_xmmm64b32
			(byte)MemorySize.Broadcast128_Int32,// EVEX_Vcvtdq2pd_ymm_k1z_xmmm128b32
			(byte)MemorySize.Broadcast256_Int32,// EVEX_Vcvtdq2pd_zmm_k1z_ymmm256b32_er
			(byte)MemorySize.Broadcast128_Int64,// EVEX_Vcvtqq2pd_xmm_k1z_xmmm128b64
			(byte)MemorySize.Broadcast256_Int64,// EVEX_Vcvtqq2pd_ymm_k1z_ymmm256b64
			(byte)MemorySize.Broadcast512_Int64,// EVEX_Vcvtqq2pd_zmm_k1z_zmmm512b64_er
			0,// Cvtpd2dq_xmm_xmmm128
			0,// VEX_Vcvtpd2dq_xmm_xmmm128
			0,// VEX_Vcvtpd2dq_xmm_ymmm256
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vcvtpd2dq_xmm_k1z_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vcvtpd2dq_xmm_k1z_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vcvtpd2dq_ymm_k1z_zmmm512b64_er
			0,// Movntq_m64_mm
			0,// Movntdq_m128_xmm
			0,// VEX_Vmovntdq_m128_xmm
			0,// VEX_Vmovntdq_m256_ymm
			0,// EVEX_Vmovntdq_m128_xmm
			0,// EVEX_Vmovntdq_m256_ymm
			0,// EVEX_Vmovntdq_m512_zmm
			0,// Psubsb_mm_mmm64
			0,// Psubsb_xmm_xmmm128
			0,// VEX_Vpsubsb_xmm_xmm_xmmm128
			0,// VEX_Vpsubsb_ymm_ymm_ymmm256
			0,// EVEX_Vpsubsb_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpsubsb_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpsubsb_zmm_k1z_zmm_zmmm512
			0,// Psubsw_mm_mmm64
			0,// Psubsw_xmm_xmmm128
			0,// VEX_Vpsubsw_xmm_xmm_xmmm128
			0,// VEX_Vpsubsw_ymm_ymm_ymmm256
			0,// EVEX_Vpsubsw_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpsubsw_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpsubsw_zmm_k1z_zmm_zmmm512
			0,// Pminsw_mm_mmm64
			0,// Pminsw_xmm_xmmm128
			0,// VEX_Vpminsw_xmm_xmm_xmmm128
			0,// VEX_Vpminsw_ymm_ymm_ymmm256
			0,// EVEX_Vpminsw_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpminsw_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpminsw_zmm_k1z_zmm_zmmm512
			0,// Por_mm_mmm64
			0,// Por_xmm_xmmm128
			0,// VEX_Vpor_xmm_xmm_xmmm128
			0,// VEX_Vpor_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vpord_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vpord_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vpord_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vporq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vporq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vporq_zmm_k1z_zmm_zmmm512b64
			0,// Paddsb_mm_mmm64
			0,// Paddsb_xmm_xmmm128
			0,// VEX_Vpaddsb_xmm_xmm_xmmm128
			0,// VEX_Vpaddsb_ymm_ymm_ymmm256
			0,// EVEX_Vpaddsb_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpaddsb_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpaddsb_zmm_k1z_zmm_zmmm512
			0,// Paddsw_mm_mmm64
			0,// Paddsw_xmm_xmmm128
			0,// VEX_Vpaddsw_xmm_xmm_xmmm128
			0,// VEX_Vpaddsw_ymm_ymm_ymmm256
			0,// EVEX_Vpaddsw_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpaddsw_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpaddsw_zmm_k1z_zmm_zmmm512
			0,// Pmaxsw_mm_mmm64
			0,// Pmaxsw_xmm_xmmm128
			0,// VEX_Vpmaxsw_xmm_xmm_xmmm128
			0,// VEX_Vpmaxsw_ymm_ymm_ymmm256
			0,// EVEX_Vpmaxsw_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpmaxsw_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpmaxsw_zmm_k1z_zmm_zmmm512
			0,// Pxor_mm_mmm64
			0,// Pxor_xmm_xmmm128
			0,// VEX_Vpxor_xmm_xmm_xmmm128
			0,// VEX_Vpxor_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vpxord_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vpxord_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vpxord_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vpxorq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vpxorq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vpxorq_zmm_k1z_zmm_zmmm512b64
			0,// Lddqu_xmm_m128
			0,// VEX_Vlddqu_xmm_m128
			0,// VEX_Vlddqu_ymm_m256
			0,// Psllw_mm_mmm64
			0,// Psllw_xmm_xmmm128
			0,// VEX_Vpsllw_xmm_xmm_xmmm128
			0,// VEX_Vpsllw_ymm_ymm_xmmm128
			0,// EVEX_Vpsllw_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpsllw_ymm_k1z_ymm_xmmm128
			0,// EVEX_Vpsllw_zmm_k1z_zmm_xmmm128
			0,// Pslld_mm_mmm64
			0,// Pslld_xmm_xmmm128
			0,// VEX_Vpslld_xmm_xmm_xmmm128
			0,// VEX_Vpslld_ymm_ymm_xmmm128
			0,// EVEX_Vpslld_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpslld_ymm_k1z_ymm_xmmm128
			0,// EVEX_Vpslld_zmm_k1z_zmm_xmmm128
			0,// Psllq_mm_mmm64
			0,// Psllq_xmm_xmmm128
			0,// VEX_Vpsllq_xmm_xmm_xmmm128
			0,// VEX_Vpsllq_ymm_ymm_xmmm128
			0,// EVEX_Vpsllq_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpsllq_ymm_k1z_ymm_xmmm128
			0,// EVEX_Vpsllq_zmm_k1z_zmm_xmmm128
			0,// Pmuludq_mm_mmm64
			0,// Pmuludq_xmm_xmmm128
			0,// VEX_Vpmuludq_xmm_xmm_xmmm128
			0,// VEX_Vpmuludq_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_2xUInt32,// EVEX_Vpmuludq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_2xUInt32,// EVEX_Vpmuludq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_2xUInt32,// EVEX_Vpmuludq_zmm_k1z_zmm_zmmm512b64
			0,// Pmaddwd_mm_mmm64
			0,// Pmaddwd_xmm_xmmm128
			0,// VEX_Vpmaddwd_xmm_xmm_xmmm128
			0,// VEX_Vpmaddwd_ymm_ymm_ymmm256
			0,// EVEX_Vpmaddwd_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpmaddwd_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpmaddwd_zmm_k1z_zmm_zmmm512
			0,// Psadbw_mm_mmm64
			0,// Psadbw_xmm_xmmm128
			0,// VEX_Vpsadbw_xmm_xmm_xmmm128
			0,// VEX_Vpsadbw_ymm_ymm_ymmm256
			0,// EVEX_Vpsadbw_xmm_xmm_xmmm128
			0,// EVEX_Vpsadbw_ymm_ymm_ymmm256
			0,// EVEX_Vpsadbw_zmm_zmm_zmmm512
			0,// Maskmovq_rDI_mm_mm
			0,// Maskmovdqu_rDI_xmm_xmm
			0,// VEX_Vmaskmovdqu_rDI_xmm_xmm
			0,// Psubb_mm_mmm64
			0,// Psubb_xmm_xmmm128
			0,// VEX_Vpsubb_xmm_xmm_xmmm128
			0,// VEX_Vpsubb_ymm_ymm_ymmm256
			0,// EVEX_Vpsubb_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpsubb_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpsubb_zmm_k1z_zmm_zmmm512
			0,// Psubw_mm_mmm64
			0,// Psubw_xmm_xmmm128
			0,// VEX_Vpsubw_xmm_xmm_xmmm128
			0,// VEX_Vpsubw_ymm_ymm_ymmm256
			0,// EVEX_Vpsubw_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpsubw_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpsubw_zmm_k1z_zmm_zmmm512
			0,// Psubd_mm_mmm64
			0,// Psubd_xmm_xmmm128
			0,// VEX_Vpsubd_xmm_xmm_xmmm128
			0,// VEX_Vpsubd_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vpsubd_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vpsubd_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vpsubd_zmm_k1z_zmm_zmmm512b32
			0,// Psubq_mm_mmm64
			0,// Psubq_xmm_xmmm128
			0,// VEX_Vpsubq_xmm_xmm_xmmm128
			0,// VEX_Vpsubq_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vpsubq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vpsubq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vpsubq_zmm_k1z_zmm_zmmm512b64
			0,// Paddb_mm_mmm64
			0,// Paddb_xmm_xmmm128
			0,// VEX_Vpaddb_xmm_xmm_xmmm128
			0,// VEX_Vpaddb_ymm_ymm_ymmm256
			0,// EVEX_Vpaddb_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpaddb_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpaddb_zmm_k1z_zmm_zmmm512
			0,// Paddw_mm_mmm64
			0,// Paddw_xmm_xmmm128
			0,// VEX_Vpaddw_xmm_xmm_xmmm128
			0,// VEX_Vpaddw_ymm_ymm_ymmm256
			0,// EVEX_Vpaddw_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpaddw_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpaddw_zmm_k1z_zmm_zmmm512
			0,// Paddd_mm_mmm64
			0,// Paddd_xmm_xmmm128
			0,// VEX_Vpaddd_xmm_xmm_xmmm128
			0,// VEX_Vpaddd_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vpaddd_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vpaddd_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vpaddd_zmm_k1z_zmm_zmmm512b32
			0,// Ud0_r16_rm16
			0,// Ud0_r32_rm32
			0,// Ud0_r64_rm64
			0,// Pshufb_mm_mmm64
			0,// Pshufb_xmm_xmmm128
			0,// VEX_Vpshufb_xmm_xmm_xmmm128
			0,// VEX_Vpshufb_ymm_ymm_ymmm256
			0,// EVEX_Vpshufb_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpshufb_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpshufb_zmm_k1z_zmm_zmmm512
			0,// Phaddw_mm_mmm64
			0,// Phaddw_xmm_xmmm128
			0,// VEX_Vphaddw_xmm_xmm_xmmm128
			0,// VEX_Vphaddw_ymm_ymm_ymmm256
			0,// Phaddd_mm_mmm64
			0,// Phaddd_xmm_xmmm128
			0,// VEX_Vphaddd_xmm_xmm_xmmm128
			0,// VEX_Vphaddd_ymm_ymm_ymmm256
			0,// Phaddsw_mm_mmm64
			0,// Phaddsw_xmm_xmmm128
			0,// VEX_Vphaddsw_xmm_xmm_xmmm128
			0,// VEX_Vphaddsw_ymm_ymm_ymmm256
			0,// Pmaddubsw_mm_mmm64
			0,// Pmaddubsw_xmm_xmmm128
			0,// VEX_Vpmaddubsw_xmm_xmm_xmmm128
			0,// VEX_Vpmaddubsw_ymm_ymm_ymmm256
			0,// EVEX_Vpmaddubsw_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpmaddubsw_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpmaddubsw_zmm_k1z_zmm_zmmm512
			0,// Phsubw_mm_mmm64
			0,// Phsubw_xmm_xmmm128
			0,// VEX_Vphsubw_xmm_xmm_xmmm128
			0,// VEX_Vphsubw_ymm_ymm_ymmm256
			0,// Phsubd_mm_mmm64
			0,// Phsubd_xmm_xmmm128
			0,// VEX_Vphsubd_xmm_xmm_xmmm128
			0,// VEX_Vphsubd_ymm_ymm_ymmm256
			0,// Phsubsw_mm_mmm64
			0,// Phsubsw_xmm_xmmm128
			0,// VEX_Vphsubsw_xmm_xmm_xmmm128
			0,// VEX_Vphsubsw_ymm_ymm_ymmm256
			0,// Psignb_mm_mmm64
			0,// Psignb_xmm_xmmm128
			0,// VEX_Vpsignb_xmm_xmm_xmmm128
			0,// VEX_Vpsignb_ymm_ymm_ymmm256
			0,// Psignw_mm_mmm64
			0,// Psignw_xmm_xmmm128
			0,// VEX_Vpsignw_xmm_xmm_xmmm128
			0,// VEX_Vpsignw_ymm_ymm_ymmm256
			0,// Psignd_mm_mmm64
			0,// Psignd_xmm_xmmm128
			0,// VEX_Vpsignd_xmm_xmm_xmmm128
			0,// VEX_Vpsignd_ymm_ymm_ymmm256
			0,// Pmulhrsw_mm_mmm64
			0,// Pmulhrsw_xmm_xmmm128
			0,// VEX_Vpmulhrsw_xmm_xmm_xmmm128
			0,// VEX_Vpmulhrsw_ymm_ymm_ymmm256
			0,// EVEX_Vpmulhrsw_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpmulhrsw_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpmulhrsw_zmm_k1z_zmm_zmmm512
			0,// VEX_Vpermilps_xmm_xmm_xmmm128
			0,// VEX_Vpermilps_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vpermilps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vpermilps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vpermilps_zmm_k1z_zmm_zmmm512b32
			0,// VEX_Vpermilpd_xmm_xmm_xmmm128
			0,// VEX_Vpermilpd_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vpermilpd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vpermilpd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vpermilpd_zmm_k1z_zmm_zmmm512b64
			0,// VEX_Vtestps_xmm_xmmm128
			0,// VEX_Vtestps_ymm_ymmm256
			0,// VEX_Vtestpd_xmm_xmmm128
			0,// VEX_Vtestpd_ymm_ymmm256
			0,// Pblendvb_xmm_xmmm128
			0,// EVEX_Vpsrlvw_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpsrlvw_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpsrlvw_zmm_k1z_zmm_zmmm512
			0,// EVEX_Vpmovuswb_xmmm64_k1z_xmm
			0,// EVEX_Vpmovuswb_xmmm128_k1z_ymm
			0,// EVEX_Vpmovuswb_ymmm256_k1z_zmm
			0,// EVEX_Vpsravw_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpsravw_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpsravw_zmm_k1z_zmm_zmmm512
			0,// EVEX_Vpmovusdb_xmmm32_k1z_xmm
			0,// EVEX_Vpmovusdb_xmmm64_k1z_ymm
			0,// EVEX_Vpmovusdb_xmmm128_k1z_zmm
			0,// EVEX_Vpsllvw_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpsllvw_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpsllvw_zmm_k1z_zmm_zmmm512
			0,// EVEX_Vpmovusqb_xmmm16_k1z_xmm
			0,// EVEX_Vpmovusqb_xmmm32_k1z_ymm
			0,// EVEX_Vpmovusqb_xmmm64_k1z_zmm
			0,// VEX_Vcvtph2ps_xmm_xmmm64
			0,// VEX_Vcvtph2ps_ymm_xmmm128
			0,// EVEX_Vcvtph2ps_xmm_k1z_xmmm64
			0,// EVEX_Vcvtph2ps_ymm_k1z_xmmm128
			0,// EVEX_Vcvtph2ps_zmm_k1z_ymmm256_sae
			0,// EVEX_Vpmovusdw_xmmm64_k1z_xmm
			0,// EVEX_Vpmovusdw_xmmm128_k1z_ymm
			0,// EVEX_Vpmovusdw_ymmm256_k1z_zmm
			0,// Blendvps_xmm_xmmm128
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vprorvd_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vprorvd_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vprorvd_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vprorvq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vprorvq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vprorvq_zmm_k1z_zmm_zmmm512b64
			0,// EVEX_Vpmovusqw_xmmm32_k1z_xmm
			0,// EVEX_Vpmovusqw_xmmm64_k1z_ymm
			0,// EVEX_Vpmovusqw_xmmm128_k1z_zmm
			0,// Blendvpd_xmm_xmmm128
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vprolvd_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vprolvd_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vprolvd_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vprolvq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vprolvq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vprolvq_zmm_k1z_zmm_zmmm512b64
			0,// EVEX_Vpmovusqd_xmmm64_k1z_xmm
			0,// EVEX_Vpmovusqd_xmmm128_k1z_ymm
			0,// EVEX_Vpmovusqd_ymmm256_k1z_zmm
			0,// VEX_Vpermps_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vpermps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vpermps_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vpermpd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vpermpd_zmm_k1z_zmm_zmmm512b64
			0,// Ptest_xmm_xmmm128
			0,// VEX_Vptest_xmm_xmmm128
			0,// VEX_Vptest_ymm_ymmm256
			0,// VEX_Vbroadcastss_xmm_m32
			0,// VEX_Vbroadcastss_ymm_m32
			0,// EVEX_Vbroadcastss_xmm_k1z_xmmm32
			0,// EVEX_Vbroadcastss_ymm_k1z_xmmm32
			0,// EVEX_Vbroadcastss_zmm_k1z_xmmm32
			0,// VEX_Vbroadcastsd_ymm_m64
			0,// EVEX_Vbroadcastf32x2_ymm_k1z_xmmm64
			0,// EVEX_Vbroadcastf32x2_zmm_k1z_xmmm64
			0,// EVEX_Vbroadcastsd_ymm_k1z_xmmm64
			0,// EVEX_Vbroadcastsd_zmm_k1z_xmmm64
			0,// VEX_Vbroadcastf128_ymm_m128
			0,// EVEX_Vbroadcastf32x4_ymm_k1z_m128
			0,// EVEX_Vbroadcastf32x4_zmm_k1z_m128
			0,// EVEX_Vbroadcastf64x2_ymm_k1z_m128
			0,// EVEX_Vbroadcastf64x2_zmm_k1z_m128
			0,// EVEX_Vbroadcastf32x8_zmm_k1z_m256
			0,// EVEX_Vbroadcastf64x4_zmm_k1z_m256
			0,// Pabsb_mm_mmm64
			0,// Pabsb_xmm_xmmm128
			0,// VEX_Vpabsb_xmm_xmmm128
			0,// VEX_Vpabsb_ymm_ymmm256
			0,// EVEX_Vpabsb_xmm_k1z_xmmm128
			0,// EVEX_Vpabsb_ymm_k1z_ymmm256
			0,// EVEX_Vpabsb_zmm_k1z_zmmm512
			0,// Pabsw_mm_mmm64
			0,// Pabsw_xmm_xmmm128
			0,// VEX_Vpabsw_xmm_xmmm128
			0,// VEX_Vpabsw_ymm_ymmm256
			0,// EVEX_Vpabsw_xmm_k1z_xmmm128
			0,// EVEX_Vpabsw_ymm_k1z_ymmm256
			0,// EVEX_Vpabsw_zmm_k1z_zmmm512
			0,// Pabsd_mm_mmm64
			0,// Pabsd_xmm_xmmm128
			0,// VEX_Vpabsd_xmm_xmmm128
			0,// VEX_Vpabsd_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Int32,// EVEX_Vpabsd_xmm_k1z_xmmm128b32
			(byte)MemorySize.Broadcast256_Int32,// EVEX_Vpabsd_ymm_k1z_ymmm256b32
			(byte)MemorySize.Broadcast512_Int32,// EVEX_Vpabsd_zmm_k1z_zmmm512b32
			(byte)MemorySize.Broadcast128_Int64,// EVEX_Vpabsq_xmm_k1z_xmmm128b64
			(byte)MemorySize.Broadcast256_Int64,// EVEX_Vpabsq_ymm_k1z_ymmm256b64
			(byte)MemorySize.Broadcast512_Int64,// EVEX_Vpabsq_zmm_k1z_zmmm512b64
			0,// Pmovsxbw_xmm_xmmm64
			0,// VEX_Vpmovsxbw_xmm_xmmm64
			0,// VEX_Vpmovsxbw_ymm_xmmm128
			0,// EVEX_Vpmovsxbw_xmm_k1z_xmmm64
			0,// EVEX_Vpmovsxbw_ymm_k1z_xmmm128
			0,// EVEX_Vpmovsxbw_zmm_k1z_ymmm256
			0,// EVEX_Vpmovswb_xmmm64_k1z_xmm
			0,// EVEX_Vpmovswb_xmmm128_k1z_ymm
			0,// EVEX_Vpmovswb_ymmm256_k1z_zmm
			0,// Pmovsxbd_xmm_xmmm32
			0,// VEX_Vpmovsxbd_xmm_xmmm32
			0,// VEX_Vpmovsxbd_ymm_xmmm64
			0,// EVEX_Vpmovsxbd_xmm_k1z_xmmm32
			0,// EVEX_Vpmovsxbd_ymm_k1z_xmmm64
			0,// EVEX_Vpmovsxbd_zmm_k1z_xmmm128
			0,// EVEX_Vpmovsdb_xmmm32_k1z_xmm
			0,// EVEX_Vpmovsdb_xmmm64_k1z_ymm
			0,// EVEX_Vpmovsdb_xmmm128_k1z_zmm
			0,// Pmovsxbq_xmm_xmmm16
			0,// VEX_Vpmovsxbq_xmm_xmmm16
			0,// VEX_Vpmovsxbq_ymm_xmmm32
			0,// EVEX_Vpmovsxbq_xmm_k1z_xmmm16
			0,// EVEX_Vpmovsxbq_ymm_k1z_xmmm32
			0,// EVEX_Vpmovsxbq_zmm_k1z_xmmm64
			0,// EVEX_Vpmovsqb_xmmm16_k1z_xmm
			0,// EVEX_Vpmovsqb_xmmm32_k1z_ymm
			0,// EVEX_Vpmovsqb_xmmm64_k1z_zmm
			0,// Pmovsxwd_xmm_xmmm64
			0,// VEX_Vpmovsxwd_xmm_xmmm64
			0,// VEX_Vpmovsxwd_ymm_xmmm128
			0,// EVEX_Vpmovsxwd_xmm_k1z_xmmm64
			0,// EVEX_Vpmovsxwd_ymm_k1z_xmmm128
			0,// EVEX_Vpmovsxwd_zmm_k1z_ymmm256
			0,// EVEX_Vpmovsdw_xmmm64_k1z_xmm
			0,// EVEX_Vpmovsdw_xmmm128_k1z_ymm
			0,// EVEX_Vpmovsdw_ymmm256_k1z_zmm
			0,// Pmovsxwq_xmm_xmmm32
			0,// VEX_Vpmovsxwq_xmm_xmmm32
			0,// VEX_Vpmovsxwq_ymm_xmmm64
			0,// EVEX_Vpmovsxwq_xmm_k1z_xmmm32
			0,// EVEX_Vpmovsxwq_ymm_k1z_xmmm64
			0,// EVEX_Vpmovsxwq_zmm_k1z_xmmm128
			0,// EVEX_Vpmovsqw_xmmm32_k1z_xmm
			0,// EVEX_Vpmovsqw_xmmm64_k1z_ymm
			0,// EVEX_Vpmovsqw_xmmm128_k1z_zmm
			0,// Pmovsxdq_xmm_xmmm64
			0,// VEX_Vpmovsxdq_xmm_xmmm64
			0,// VEX_Vpmovsxdq_ymm_xmmm128
			0,// EVEX_Vpmovsxdq_xmm_k1z_xmmm64
			0,// EVEX_Vpmovsxdq_ymm_k1z_xmmm128
			0,// EVEX_Vpmovsxdq_zmm_k1z_ymmm256
			0,// EVEX_Vpmovsqd_xmmm64_k1z_xmm
			0,// EVEX_Vpmovsqd_xmmm128_k1z_ymm
			0,// EVEX_Vpmovsqd_ymmm256_k1z_zmm
			0,// EVEX_Vptestmb_kr_k1_xmm_xmmm128
			0,// EVEX_Vptestmb_kr_k1_ymm_ymmm256
			0,// EVEX_Vptestmb_kr_k1_zmm_zmmm512
			0,// EVEX_Vptestmw_kr_k1_xmm_xmmm128
			0,// EVEX_Vptestmw_kr_k1_ymm_ymmm256
			0,// EVEX_Vptestmw_kr_k1_zmm_zmmm512
			0,// EVEX_Vptestnmb_kr_k1_xmm_xmmm128
			0,// EVEX_Vptestnmb_kr_k1_ymm_ymmm256
			0,// EVEX_Vptestnmb_kr_k1_zmm_zmmm512
			0,// EVEX_Vptestnmw_kr_k1_xmm_xmmm128
			0,// EVEX_Vptestnmw_kr_k1_ymm_ymmm256
			0,// EVEX_Vptestnmw_kr_k1_zmm_zmmm512
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vptestmd_kr_k1_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vptestmd_kr_k1_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vptestmd_kr_k1_zmm_zmmm512b32
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vptestmq_kr_k1_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vptestmq_kr_k1_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vptestmq_kr_k1_zmm_zmmm512b64
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vptestnmd_kr_k1_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vptestnmd_kr_k1_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vptestnmd_kr_k1_zmm_zmmm512b32
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vptestnmq_kr_k1_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vptestnmq_kr_k1_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vptestnmq_kr_k1_zmm_zmmm512b64
			0,// Pmuldq_xmm_xmmm128
			0,// VEX_Vpmuldq_xmm_xmm_xmmm128
			0,// VEX_Vpmuldq_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_2xInt32,// EVEX_Vpmuldq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_2xInt32,// EVEX_Vpmuldq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_2xInt32,// EVEX_Vpmuldq_zmm_k1z_zmm_zmmm512b64
			0,// EVEX_Vpmovm2b_xmm_kr
			0,// EVEX_Vpmovm2b_ymm_kr
			0,// EVEX_Vpmovm2b_zmm_kr
			0,// EVEX_Vpmovm2w_xmm_kr
			0,// EVEX_Vpmovm2w_ymm_kr
			0,// EVEX_Vpmovm2w_zmm_kr
			0,// Pcmpeqq_xmm_xmmm128
			0,// VEX_Vpcmpeqq_xmm_xmm_xmmm128
			0,// VEX_Vpcmpeqq_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vpcmpeqq_kr_k1_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vpcmpeqq_kr_k1_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vpcmpeqq_kr_k1_zmm_zmmm512b64
			0,// EVEX_Vpmovb2m_kr_xmm
			0,// EVEX_Vpmovb2m_kr_ymm
			0,// EVEX_Vpmovb2m_kr_zmm
			0,// EVEX_Vpmovw2m_kr_xmm
			0,// EVEX_Vpmovw2m_kr_ymm
			0,// EVEX_Vpmovw2m_kr_zmm
			0,// Movntdqa_xmm_m128
			0,// VEX_Vmovntdqa_xmm_m128
			0,// VEX_Vmovntdqa_ymm_m256
			0,// EVEX_Vmovntdqa_xmm_m128
			0,// EVEX_Vmovntdqa_ymm_m256
			0,// EVEX_Vmovntdqa_zmm_m512
			0,// EVEX_Vpbroadcastmb2q_xmm_kr
			0,// EVEX_Vpbroadcastmb2q_ymm_kr
			0,// EVEX_Vpbroadcastmb2q_zmm_kr
			0,// Packusdw_xmm_xmmm128
			0,// VEX_Vpackusdw_xmm_xmm_xmmm128
			0,// VEX_Vpackusdw_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Int32,// EVEX_Vpackusdw_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Int32,// EVEX_Vpackusdw_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Int32,// EVEX_Vpackusdw_zmm_k1z_zmm_zmmm512b32
			0,// VEX_Vmaskmovps_xmm_xmm_m128
			0,// VEX_Vmaskmovps_ymm_ymm_m256
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vscalefps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vscalefps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vscalefps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vscalefpd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vscalefpd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vscalefpd_zmm_k1z_zmm_zmmm512b64_er
			0,// VEX_Vmaskmovpd_xmm_xmm_m128
			0,// VEX_Vmaskmovpd_ymm_ymm_m256
			0,// EVEX_Vscalefss_xmm_k1z_xmm_xmmm32_er
			0,// EVEX_Vscalefsd_xmm_k1z_xmm_xmmm64_er
			0,// VEX_Vmaskmovps_m128_xmm_xmm
			0,// VEX_Vmaskmovps_m256_ymm_ymm
			0,// VEX_Vmaskmovpd_m128_xmm_xmm
			0,// VEX_Vmaskmovpd_m256_ymm_ymm
			0,// Pmovzxbw_xmm_xmmm64
			0,// VEX_Vpmovzxbw_xmm_xmmm64
			0,// VEX_Vpmovzxbw_ymm_xmmm128
			0,// EVEX_Vpmovzxbw_xmm_k1z_xmmm64
			0,// EVEX_Vpmovzxbw_ymm_k1z_xmmm128
			0,// EVEX_Vpmovzxbw_zmm_k1z_ymmm256
			0,// EVEX_Vpmovwb_xmmm64_k1z_xmm
			0,// EVEX_Vpmovwb_xmmm128_k1z_ymm
			0,// EVEX_Vpmovwb_ymmm256_k1z_zmm
			0,// Pmovzxbd_xmm_xmmm32
			0,// VEX_Vpmovzxbd_xmm_xmmm32
			0,// VEX_Vpmovzxbd_ymm_xmmm64
			0,// EVEX_Vpmovzxbd_xmm_k1z_xmmm32
			0,// EVEX_Vpmovzxbd_ymm_k1z_xmmm64
			0,// EVEX_Vpmovzxbd_zmm_k1z_xmmm128
			0,// EVEX_Vpmovdb_xmmm32_k1z_xmm
			0,// EVEX_Vpmovdb_xmmm64_k1z_ymm
			0,// EVEX_Vpmovdb_xmmm128_k1z_zmm
			0,// Pmovzxbq_xmm_xmmm16
			0,// VEX_Vpmovzxbq_xmm_xmmm16
			0,// VEX_Vpmovzxbq_ymm_xmmm32
			0,// EVEX_Vpmovzxbq_xmm_k1z_xmmm16
			0,// EVEX_Vpmovzxbq_ymm_k1z_xmmm32
			0,// EVEX_Vpmovzxbq_zmm_k1z_xmmm64
			0,// EVEX_Vpmovqb_xmmm16_k1z_xmm
			0,// EVEX_Vpmovqb_xmmm32_k1z_ymm
			0,// EVEX_Vpmovqb_xmmm64_k1z_zmm
			0,// Pmovzxwd_xmm_xmmm64
			0,// VEX_Vpmovzxwd_xmm_xmmm64
			0,// VEX_Vpmovzxwd_ymm_xmmm128
			0,// EVEX_Vpmovzxwd_xmm_k1z_xmmm64
			0,// EVEX_Vpmovzxwd_ymm_k1z_xmmm128
			0,// EVEX_Vpmovzxwd_zmm_k1z_ymmm256
			0,// EVEX_Vpmovdw_xmmm64_k1z_xmm
			0,// EVEX_Vpmovdw_xmmm128_k1z_ymm
			0,// EVEX_Vpmovdw_ymmm256_k1z_zmm
			0,// Pmovzxwq_xmm_xmmm32
			0,// VEX_Vpmovzxwq_xmm_xmmm32
			0,// VEX_Vpmovzxwq_ymm_xmmm64
			0,// EVEX_Vpmovzxwq_xmm_k1z_xmmm32
			0,// EVEX_Vpmovzxwq_ymm_k1z_xmmm64
			0,// EVEX_Vpmovzxwq_zmm_k1z_xmmm128
			0,// EVEX_Vpmovqw_xmmm32_k1z_xmm
			0,// EVEX_Vpmovqw_xmmm64_k1z_ymm
			0,// EVEX_Vpmovqw_xmmm128_k1z_zmm
			0,// Pmovzxdq_xmm_xmmm64
			0,// VEX_Vpmovzxdq_xmm_xmmm64
			0,// VEX_Vpmovzxdq_ymm_xmmm128
			0,// EVEX_Vpmovzxdq_xmm_k1z_xmmm64
			0,// EVEX_Vpmovzxdq_ymm_k1z_xmmm128
			0,// EVEX_Vpmovzxdq_zmm_k1z_ymmm256
			0,// EVEX_Vpmovqd_xmmm64_k1z_xmm
			0,// EVEX_Vpmovqd_xmmm128_k1z_ymm
			0,// EVEX_Vpmovqd_ymmm256_k1z_zmm
			0,// VEX_Vpermd_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vpermd_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vpermd_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vpermq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vpermq_zmm_k1z_zmm_zmmm512b64
			0,// Pcmpgtq_xmm_xmmm128
			0,// VEX_Vpcmpgtq_xmm_xmm_xmmm128
			0,// VEX_Vpcmpgtq_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Int64,// EVEX_Vpcmpgtq_kr_k1_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_Int64,// EVEX_Vpcmpgtq_kr_k1_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_Int64,// EVEX_Vpcmpgtq_kr_k1_zmm_zmmm512b64
			0,// Pminsb_xmm_xmmm128
			0,// VEX_Vpminsb_xmm_xmm_xmmm128
			0,// VEX_Vpminsb_ymm_ymm_ymmm256
			0,// EVEX_Vpminsb_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpminsb_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpminsb_zmm_k1z_zmm_zmmm512
			0,// EVEX_Vpmovm2d_xmm_kr
			0,// EVEX_Vpmovm2d_ymm_kr
			0,// EVEX_Vpmovm2d_zmm_kr
			0,// EVEX_Vpmovm2q_xmm_kr
			0,// EVEX_Vpmovm2q_ymm_kr
			0,// EVEX_Vpmovm2q_zmm_kr
			0,// Pminsd_xmm_xmmm128
			0,// VEX_Vpminsd_xmm_xmm_xmmm128
			0,// VEX_Vpminsd_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Int32,// EVEX_Vpminsd_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Int32,// EVEX_Vpminsd_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Int32,// EVEX_Vpminsd_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Broadcast128_Int64,// EVEX_Vpminsq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_Int64,// EVEX_Vpminsq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_Int64,// EVEX_Vpminsq_zmm_k1z_zmm_zmmm512b64
			0,// EVEX_Vpmovd2m_kr_xmm
			0,// EVEX_Vpmovd2m_kr_ymm
			0,// EVEX_Vpmovd2m_kr_zmm
			0,// EVEX_Vpmovq2m_kr_xmm
			0,// EVEX_Vpmovq2m_kr_ymm
			0,// EVEX_Vpmovq2m_kr_zmm
			0,// Pminuw_xmm_xmmm128
			0,// VEX_Vpminuw_xmm_xmm_xmmm128
			0,// VEX_Vpminuw_ymm_ymm_ymmm256
			0,// EVEX_Vpminuw_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpminuw_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpminuw_zmm_k1z_zmm_zmmm512
			0,// EVEX_Vpbroadcastmw2d_xmm_kr
			0,// EVEX_Vpbroadcastmw2d_ymm_kr
			0,// EVEX_Vpbroadcastmw2d_zmm_kr
			0,// Pminud_xmm_xmmm128
			0,// VEX_Vpminud_xmm_xmm_xmmm128
			0,// VEX_Vpminud_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vpminud_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vpminud_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vpminud_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vpminuq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vpminuq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vpminuq_zmm_k1z_zmm_zmmm512b64
			0,// Pmaxsb_xmm_xmmm128
			0,// VEX_Vpmaxsb_xmm_xmm_xmmm128
			0,// VEX_Vpmaxsb_ymm_ymm_ymmm256
			0,// EVEX_Vpmaxsb_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpmaxsb_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpmaxsb_zmm_k1z_zmm_zmmm512
			0,// Pmaxsd_xmm_xmmm128
			0,// VEX_Vpmaxsd_xmm_xmm_xmmm128
			0,// VEX_Vpmaxsd_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Int32,// EVEX_Vpmaxsd_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Int32,// EVEX_Vpmaxsd_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Int32,// EVEX_Vpmaxsd_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Broadcast128_Int64,// EVEX_Vpmaxsq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_Int64,// EVEX_Vpmaxsq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_Int64,// EVEX_Vpmaxsq_zmm_k1z_zmm_zmmm512b64
			0,// Pmaxuw_xmm_xmmm128
			0,// VEX_Vpmaxuw_xmm_xmm_xmmm128
			0,// VEX_Vpmaxuw_ymm_ymm_ymmm256
			0,// EVEX_Vpmaxuw_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpmaxuw_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpmaxuw_zmm_k1z_zmm_zmmm512
			0,// Pmaxud_xmm_xmmm128
			0,// VEX_Vpmaxud_xmm_xmm_xmmm128
			0,// VEX_Vpmaxud_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vpmaxud_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vpmaxud_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vpmaxud_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vpmaxuq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vpmaxuq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vpmaxuq_zmm_k1z_zmm_zmmm512b64
			0,// Pmulld_xmm_xmmm128
			0,// VEX_Vpmulld_xmm_xmm_xmmm128
			0,// VEX_Vpmulld_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Int32,// EVEX_Vpmulld_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Int32,// EVEX_Vpmulld_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Int32,// EVEX_Vpmulld_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Broadcast128_Int64,// EVEX_Vpmullq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_Int64,// EVEX_Vpmullq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_Int64,// EVEX_Vpmullq_zmm_k1z_zmm_zmmm512b64
			0,// Phminposuw_xmm_xmmm128
			0,// VEX_Vphminposuw_xmm_xmmm128
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vgetexpps_xmm_k1z_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vgetexpps_ymm_k1z_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vgetexpps_zmm_k1z_zmmm512b32_sae
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vgetexppd_xmm_k1z_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vgetexppd_ymm_k1z_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vgetexppd_zmm_k1z_zmmm512b64_sae
			0,// EVEX_Vgetexpss_xmm_k1z_xmm_xmmm32_sae
			0,// EVEX_Vgetexpsd_xmm_k1z_xmm_xmmm64_sae
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vplzcntd_xmm_k1z_xmmm128b32
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vplzcntd_ymm_k1z_ymmm256b32
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vplzcntd_zmm_k1z_zmmm512b32
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vplzcntq_xmm_k1z_xmmm128b64
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vplzcntq_ymm_k1z_ymmm256b64
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vplzcntq_zmm_k1z_zmmm512b64
			0,// VEX_Vpsrlvd_xmm_xmm_xmmm128
			0,// VEX_Vpsrlvd_ymm_ymm_ymmm256
			0,// VEX_Vpsrlvq_xmm_xmm_xmmm128
			0,// VEX_Vpsrlvq_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vpsrlvd_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vpsrlvd_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vpsrlvd_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vpsrlvq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vpsrlvq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vpsrlvq_zmm_k1z_zmm_zmmm512b64
			0,// VEX_Vpsravd_xmm_xmm_xmmm128
			0,// VEX_Vpsravd_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vpsravd_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vpsravd_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vpsravd_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vpsravq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vpsravq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vpsravq_zmm_k1z_zmm_zmmm512b64
			0,// VEX_Vpsllvd_xmm_xmm_xmmm128
			0,// VEX_Vpsllvd_ymm_ymm_ymmm256
			0,// VEX_Vpsllvq_xmm_xmm_xmmm128
			0,// VEX_Vpsllvq_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vpsllvd_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vpsllvd_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vpsllvd_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vpsllvq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vpsllvq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vpsllvq_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vrcp14ps_xmm_k1z_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vrcp14ps_ymm_k1z_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vrcp14ps_zmm_k1z_zmmm512b32
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vrcp14pd_xmm_k1z_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vrcp14pd_ymm_k1z_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vrcp14pd_zmm_k1z_zmmm512b64
			0,// EVEX_Vrcp14ss_xmm_k1z_xmm_xmmm32
			0,// EVEX_Vrcp14sd_xmm_k1z_xmm_xmmm64
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vrsqrt14ps_xmm_k1z_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vrsqrt14ps_ymm_k1z_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vrsqrt14ps_zmm_k1z_zmmm512b32
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vrsqrt14pd_xmm_k1z_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vrsqrt14pd_ymm_k1z_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vrsqrt14pd_zmm_k1z_zmmm512b64
			0,// EVEX_Vrsqrt14ss_xmm_k1z_xmm_xmmm32
			0,// EVEX_Vrsqrt14sd_xmm_k1z_xmm_xmmm64
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vpdpbusd_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vpdpbusd_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vpdpbusd_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vpdpbusds_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vpdpbusds_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vpdpbusds_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Broadcast128_2xInt16,// EVEX_Vpdpwssd_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_2xInt16,// EVEX_Vpdpwssd_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_2xInt16,// EVEX_Vpdpwssd_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Broadcast128_2xBFloat16,// EVEX_Vdpbf16ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_2xBFloat16,// EVEX_Vdpbf16ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_2xBFloat16,// EVEX_Vdpbf16ps_zmm_k1z_zmm_zmmm512b32
			0,// EVEX_Vp4dpwssd_zmm_k1z_zmmp3_m128
			(byte)MemorySize.Broadcast128_2xInt16,// EVEX_Vpdpwssds_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_2xInt16,// EVEX_Vpdpwssds_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_2xInt16,// EVEX_Vpdpwssds_zmm_k1z_zmm_zmmm512b32
			0,// EVEX_Vp4dpwssds_zmm_k1z_zmmp3_m128
			0,// EVEX_Vpopcntb_xmm_k1z_xmmm128
			0,// EVEX_Vpopcntb_ymm_k1z_ymmm256
			0,// EVEX_Vpopcntb_zmm_k1z_zmmm512
			0,// EVEX_Vpopcntw_xmm_k1z_xmmm128
			0,// EVEX_Vpopcntw_ymm_k1z_ymmm256
			0,// EVEX_Vpopcntw_zmm_k1z_zmmm512
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vpopcntd_xmm_k1z_xmmm128b32
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vpopcntd_ymm_k1z_ymmm256b32
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vpopcntd_zmm_k1z_zmmm512b32
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vpopcntq_xmm_k1z_xmmm128b64
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vpopcntq_ymm_k1z_ymmm256b64
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vpopcntq_zmm_k1z_zmmm512b64
			0,// VEX_Vpbroadcastd_xmm_xmmm32
			0,// VEX_Vpbroadcastd_ymm_xmmm32
			0,// EVEX_Vpbroadcastd_xmm_k1z_xmmm32
			0,// EVEX_Vpbroadcastd_ymm_k1z_xmmm32
			0,// EVEX_Vpbroadcastd_zmm_k1z_xmmm32
			0,// VEX_Vpbroadcastq_xmm_xmmm64
			0,// VEX_Vpbroadcastq_ymm_xmmm64
			0,// EVEX_Vbroadcasti32x2_xmm_k1z_xmmm64
			0,// EVEX_Vbroadcasti32x2_ymm_k1z_xmmm64
			0,// EVEX_Vbroadcasti32x2_zmm_k1z_xmmm64
			0,// EVEX_Vpbroadcastq_xmm_k1z_xmmm64
			0,// EVEX_Vpbroadcastq_ymm_k1z_xmmm64
			0,// EVEX_Vpbroadcastq_zmm_k1z_xmmm64
			0,// VEX_Vbroadcasti128_ymm_m128
			0,// EVEX_Vbroadcasti32x4_ymm_k1z_m128
			0,// EVEX_Vbroadcasti32x4_zmm_k1z_m128
			0,// EVEX_Vbroadcasti64x2_ymm_k1z_m128
			0,// EVEX_Vbroadcasti64x2_zmm_k1z_m128
			0,// EVEX_Vbroadcasti32x8_zmm_k1z_m256
			0,// EVEX_Vbroadcasti64x4_zmm_k1z_m256
			0,// EVEX_Vpexpandb_xmm_k1z_xmmm128
			0,// EVEX_Vpexpandb_ymm_k1z_ymmm256
			0,// EVEX_Vpexpandb_zmm_k1z_zmmm512
			0,// EVEX_Vpexpandw_xmm_k1z_xmmm128
			0,// EVEX_Vpexpandw_ymm_k1z_ymmm256
			0,// EVEX_Vpexpandw_zmm_k1z_zmmm512
			0,// EVEX_Vpcompressb_xmmm128_k1z_xmm
			0,// EVEX_Vpcompressb_ymmm256_k1z_ymm
			0,// EVEX_Vpcompressb_zmmm512_k1z_zmm
			0,// EVEX_Vpcompressw_xmmm128_k1z_xmm
			0,// EVEX_Vpcompressw_ymmm256_k1z_ymm
			0,// EVEX_Vpcompressw_zmmm512_k1z_zmm
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vpblendmd_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vpblendmd_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vpblendmd_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vpblendmq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vpblendmq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vpblendmq_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vblendmps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vblendmps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vblendmps_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vblendmpd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vblendmpd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vblendmpd_zmm_k1z_zmm_zmmm512b64
			0,// EVEX_Vpblendmb_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpblendmb_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpblendmb_zmm_k1z_zmm_zmmm512
			0,// EVEX_Vpblendmw_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpblendmw_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpblendmw_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vp2intersectd_kp1_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vp2intersectd_kp1_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vp2intersectd_kp1_zmm_zmmm512b32
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vp2intersectq_kp1_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vp2intersectq_kp1_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vp2intersectq_kp1_zmm_zmmm512b64
			0,// EVEX_Vpshldvw_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpshldvw_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpshldvw_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vpshldvd_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vpshldvd_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vpshldvd_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vpshldvq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vpshldvq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vpshldvq_zmm_k1z_zmm_zmmm512b64
			0,// EVEX_Vpshrdvw_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpshrdvw_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpshrdvw_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vcvtneps2bf16_xmm_k1z_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vcvtneps2bf16_xmm_k1z_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vcvtneps2bf16_ymm_k1z_zmmm512b32
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vcvtne2ps2bf16_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vcvtne2ps2bf16_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vcvtne2ps2bf16_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vpshrdvd_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vpshrdvd_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vpshrdvd_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vpshrdvq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vpshrdvq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vpshrdvq_zmm_k1z_zmm_zmmm512b64
			0,// EVEX_Vpermi2b_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpermi2b_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpermi2b_zmm_k1z_zmm_zmmm512
			0,// EVEX_Vpermi2w_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpermi2w_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpermi2w_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vpermi2d_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vpermi2d_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vpermi2d_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vpermi2q_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vpermi2q_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vpermi2q_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vpermi2ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vpermi2ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vpermi2ps_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vpermi2pd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vpermi2pd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vpermi2pd_zmm_k1z_zmm_zmmm512b64
			0,// VEX_Vpbroadcastb_xmm_xmmm8
			0,// VEX_Vpbroadcastb_ymm_xmmm8
			0,// EVEX_Vpbroadcastb_xmm_k1z_xmmm8
			0,// EVEX_Vpbroadcastb_ymm_k1z_xmmm8
			0,// EVEX_Vpbroadcastb_zmm_k1z_xmmm8
			0,// VEX_Vpbroadcastw_xmm_xmmm16
			0,// VEX_Vpbroadcastw_ymm_xmmm16
			0,// EVEX_Vpbroadcastw_xmm_k1z_xmmm16
			0,// EVEX_Vpbroadcastw_ymm_k1z_xmmm16
			0,// EVEX_Vpbroadcastw_zmm_k1z_xmmm16
			0,// EVEX_Vpbroadcastb_xmm_k1z_r32
			0,// EVEX_Vpbroadcastb_ymm_k1z_r32
			0,// EVEX_Vpbroadcastb_zmm_k1z_r32
			0,// EVEX_Vpbroadcastw_xmm_k1z_r32
			0,// EVEX_Vpbroadcastw_ymm_k1z_r32
			0,// EVEX_Vpbroadcastw_zmm_k1z_r32
			0,// EVEX_Vpbroadcastd_xmm_k1z_r32
			0,// EVEX_Vpbroadcastd_ymm_k1z_r32
			0,// EVEX_Vpbroadcastd_zmm_k1z_r32
			0,// EVEX_Vpbroadcastq_xmm_k1z_r64
			0,// EVEX_Vpbroadcastq_ymm_k1z_r64
			0,// EVEX_Vpbroadcastq_zmm_k1z_r64
			0,// EVEX_Vpermt2b_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpermt2b_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpermt2b_zmm_k1z_zmm_zmmm512
			0,// EVEX_Vpermt2w_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpermt2w_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpermt2w_zmm_k1z_zmm_zmmm512
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vpermt2d_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vpermt2d_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vpermt2d_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vpermt2q_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vpermt2q_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vpermt2q_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vpermt2ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vpermt2ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vpermt2ps_zmm_k1z_zmm_zmmm512b32
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vpermt2pd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vpermt2pd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vpermt2pd_zmm_k1z_zmm_zmmm512b64
			0,// Invept_r32_m128
			0,// Invept_r64_m128
			0,// Invvpid_r32_m128
			0,// Invvpid_r64_m128
			0,// Invpcid_r32_m128
			0,// Invpcid_r64_m128
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vpmultishiftqb_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vpmultishiftqb_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vpmultishiftqb_zmm_k1z_zmm_zmmm512b64
			0,// EVEX_Vexpandps_xmm_k1z_xmmm128
			0,// EVEX_Vexpandps_ymm_k1z_ymmm256
			0,// EVEX_Vexpandps_zmm_k1z_zmmm512
			0,// EVEX_Vexpandpd_xmm_k1z_xmmm128
			0,// EVEX_Vexpandpd_ymm_k1z_ymmm256
			0,// EVEX_Vexpandpd_zmm_k1z_zmmm512
			0,// EVEX_Vpexpandd_xmm_k1z_xmmm128
			0,// EVEX_Vpexpandd_ymm_k1z_ymmm256
			0,// EVEX_Vpexpandd_zmm_k1z_zmmm512
			0,// EVEX_Vpexpandq_xmm_k1z_xmmm128
			0,// EVEX_Vpexpandq_ymm_k1z_ymmm256
			0,// EVEX_Vpexpandq_zmm_k1z_zmmm512
			0,// EVEX_Vcompressps_xmmm128_k1z_xmm
			0,// EVEX_Vcompressps_ymmm256_k1z_ymm
			0,// EVEX_Vcompressps_zmmm512_k1z_zmm
			0,// EVEX_Vcompresspd_xmmm128_k1z_xmm
			0,// EVEX_Vcompresspd_ymmm256_k1z_ymm
			0,// EVEX_Vcompresspd_zmmm512_k1z_zmm
			0,// EVEX_Vpcompressd_xmmm128_k1z_xmm
			0,// EVEX_Vpcompressd_ymmm256_k1z_ymm
			0,// EVEX_Vpcompressd_zmmm512_k1z_zmm
			0,// EVEX_Vpcompressq_xmmm128_k1z_xmm
			0,// EVEX_Vpcompressq_ymmm256_k1z_ymm
			0,// EVEX_Vpcompressq_zmmm512_k1z_zmm
			0,// VEX_Vpmaskmovd_xmm_xmm_m128
			0,// VEX_Vpmaskmovd_ymm_ymm_m256
			0,// VEX_Vpmaskmovq_xmm_xmm_m128
			0,// VEX_Vpmaskmovq_ymm_ymm_m256
			0,// EVEX_Vpermb_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpermb_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpermb_zmm_k1z_zmm_zmmm512
			0,// EVEX_Vpermw_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vpermw_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vpermw_zmm_k1z_zmm_zmmm512
			0,// VEX_Vpmaskmovd_m128_xmm_xmm
			0,// VEX_Vpmaskmovd_m256_ymm_ymm
			0,// VEX_Vpmaskmovq_m128_xmm_xmm
			0,// VEX_Vpmaskmovq_m256_ymm_ymm
			0,// EVEX_Vpshufbitqmb_kr_k1_xmm_xmmm128
			0,// EVEX_Vpshufbitqmb_kr_k1_ymm_ymmm256
			0,// EVEX_Vpshufbitqmb_kr_k1_zmm_zmmm512
			0,// VEX_Vpgatherdd_xmm_vm32x_xmm
			0,// VEX_Vpgatherdd_ymm_vm32y_ymm
			0,// VEX_Vpgatherdq_xmm_vm32x_xmm
			0,// VEX_Vpgatherdq_ymm_vm32x_ymm
			0,// EVEX_Vpgatherdd_xmm_k1_vm32x
			0,// EVEX_Vpgatherdd_ymm_k1_vm32y
			0,// EVEX_Vpgatherdd_zmm_k1_vm32z
			0,// EVEX_Vpgatherdq_xmm_k1_vm32x
			0,// EVEX_Vpgatherdq_ymm_k1_vm32x
			0,// EVEX_Vpgatherdq_zmm_k1_vm32y
			0,// VEX_Vpgatherqd_xmm_vm64x_xmm
			0,// VEX_Vpgatherqd_xmm_vm64y_xmm
			0,// VEX_Vpgatherqq_xmm_vm64x_xmm
			0,// VEX_Vpgatherqq_ymm_vm64y_ymm
			0,// EVEX_Vpgatherqd_xmm_k1_vm64x
			0,// EVEX_Vpgatherqd_xmm_k1_vm64y
			0,// EVEX_Vpgatherqd_ymm_k1_vm64z
			0,// EVEX_Vpgatherqq_xmm_k1_vm64x
			0,// EVEX_Vpgatherqq_ymm_k1_vm64y
			0,// EVEX_Vpgatherqq_zmm_k1_vm64z
			0,// VEX_Vgatherdps_xmm_vm32x_xmm
			0,// VEX_Vgatherdps_ymm_vm32y_ymm
			0,// VEX_Vgatherdpd_xmm_vm32x_xmm
			0,// VEX_Vgatherdpd_ymm_vm32x_ymm
			0,// EVEX_Vgatherdps_xmm_k1_vm32x
			0,// EVEX_Vgatherdps_ymm_k1_vm32y
			0,// EVEX_Vgatherdps_zmm_k1_vm32z
			0,// EVEX_Vgatherdpd_xmm_k1_vm32x
			0,// EVEX_Vgatherdpd_ymm_k1_vm32x
			0,// EVEX_Vgatherdpd_zmm_k1_vm32y
			0,// VEX_Vgatherqps_xmm_vm64x_xmm
			0,// VEX_Vgatherqps_xmm_vm64y_xmm
			0,// VEX_Vgatherqpd_xmm_vm64x_xmm
			0,// VEX_Vgatherqpd_ymm_vm64y_ymm
			0,// EVEX_Vgatherqps_xmm_k1_vm64x
			0,// EVEX_Vgatherqps_xmm_k1_vm64y
			0,// EVEX_Vgatherqps_ymm_k1_vm64z
			0,// EVEX_Vgatherqpd_xmm_k1_vm64x
			0,// EVEX_Vgatherqpd_ymm_k1_vm64y
			0,// EVEX_Vgatherqpd_zmm_k1_vm64z
			0,// VEX_Vfmaddsub132ps_xmm_xmm_xmmm128
			0,// VEX_Vfmaddsub132ps_ymm_ymm_ymmm256
			0,// VEX_Vfmaddsub132pd_xmm_xmm_xmmm128
			0,// VEX_Vfmaddsub132pd_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vfmaddsub132ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vfmaddsub132ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vfmaddsub132ps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vfmaddsub132pd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vfmaddsub132pd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vfmaddsub132pd_zmm_k1z_zmm_zmmm512b64_er
			0,// VEX_Vfmsubadd132ps_xmm_xmm_xmmm128
			0,// VEX_Vfmsubadd132ps_ymm_ymm_ymmm256
			0,// VEX_Vfmsubadd132pd_xmm_xmm_xmmm128
			0,// VEX_Vfmsubadd132pd_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vfmsubadd132ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vfmsubadd132ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vfmsubadd132ps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vfmsubadd132pd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vfmsubadd132pd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vfmsubadd132pd_zmm_k1z_zmm_zmmm512b64_er
			0,// VEX_Vfmadd132ps_xmm_xmm_xmmm128
			0,// VEX_Vfmadd132ps_ymm_ymm_ymmm256
			0,// VEX_Vfmadd132pd_xmm_xmm_xmmm128
			0,// VEX_Vfmadd132pd_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vfmadd132ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vfmadd132ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vfmadd132ps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vfmadd132pd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vfmadd132pd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vfmadd132pd_zmm_k1z_zmm_zmmm512b64_er
			0,// VEX_Vfmadd132ss_xmm_xmm_xmmm32
			0,// VEX_Vfmadd132sd_xmm_xmm_xmmm64
			0,// EVEX_Vfmadd132ss_xmm_k1z_xmm_xmmm32_er
			0,// EVEX_Vfmadd132sd_xmm_k1z_xmm_xmmm64_er
			0,// VEX_Vfmsub132ps_xmm_xmm_xmmm128
			0,// VEX_Vfmsub132ps_ymm_ymm_ymmm256
			0,// VEX_Vfmsub132pd_xmm_xmm_xmmm128
			0,// VEX_Vfmsub132pd_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vfmsub132ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vfmsub132ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vfmsub132ps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vfmsub132pd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vfmsub132pd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vfmsub132pd_zmm_k1z_zmm_zmmm512b64_er
			0,// EVEX_V4fmaddps_zmm_k1z_zmmp3_m128
			0,// VEX_Vfmsub132ss_xmm_xmm_xmmm32
			0,// VEX_Vfmsub132sd_xmm_xmm_xmmm64
			0,// EVEX_Vfmsub132ss_xmm_k1z_xmm_xmmm32_er
			0,// EVEX_Vfmsub132sd_xmm_k1z_xmm_xmmm64_er
			0,// EVEX_V4fmaddss_xmm_k1z_xmmp3_m128
			0,// VEX_Vfnmadd132ps_xmm_xmm_xmmm128
			0,// VEX_Vfnmadd132ps_ymm_ymm_ymmm256
			0,// VEX_Vfnmadd132pd_xmm_xmm_xmmm128
			0,// VEX_Vfnmadd132pd_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vfnmadd132ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vfnmadd132ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vfnmadd132ps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vfnmadd132pd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vfnmadd132pd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vfnmadd132pd_zmm_k1z_zmm_zmmm512b64_er
			0,// VEX_Vfnmadd132ss_xmm_xmm_xmmm32
			0,// VEX_Vfnmadd132sd_xmm_xmm_xmmm64
			0,// EVEX_Vfnmadd132ss_xmm_k1z_xmm_xmmm32_er
			0,// EVEX_Vfnmadd132sd_xmm_k1z_xmm_xmmm64_er
			0,// VEX_Vfnmsub132ps_xmm_xmm_xmmm128
			0,// VEX_Vfnmsub132ps_ymm_ymm_ymmm256
			0,// VEX_Vfnmsub132pd_xmm_xmm_xmmm128
			0,// VEX_Vfnmsub132pd_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vfnmsub132ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vfnmsub132ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vfnmsub132ps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vfnmsub132pd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vfnmsub132pd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vfnmsub132pd_zmm_k1z_zmm_zmmm512b64_er
			0,// VEX_Vfnmsub132ss_xmm_xmm_xmmm32
			0,// VEX_Vfnmsub132sd_xmm_xmm_xmmm64
			0,// EVEX_Vfnmsub132ss_xmm_k1z_xmm_xmmm32_er
			0,// EVEX_Vfnmsub132sd_xmm_k1z_xmm_xmmm64_er
			0,// EVEX_Vpscatterdd_vm32x_k1_xmm
			0,// EVEX_Vpscatterdd_vm32y_k1_ymm
			0,// EVEX_Vpscatterdd_vm32z_k1_zmm
			0,// EVEX_Vpscatterdq_vm32x_k1_xmm
			0,// EVEX_Vpscatterdq_vm32x_k1_ymm
			0,// EVEX_Vpscatterdq_vm32y_k1_zmm
			0,// EVEX_Vpscatterqd_vm64x_k1_xmm
			0,// EVEX_Vpscatterqd_vm64y_k1_xmm
			0,// EVEX_Vpscatterqd_vm64z_k1_ymm
			0,// EVEX_Vpscatterqq_vm64x_k1_xmm
			0,// EVEX_Vpscatterqq_vm64y_k1_ymm
			0,// EVEX_Vpscatterqq_vm64z_k1_zmm
			0,// EVEX_Vscatterdps_vm32x_k1_xmm
			0,// EVEX_Vscatterdps_vm32y_k1_ymm
			0,// EVEX_Vscatterdps_vm32z_k1_zmm
			0,// EVEX_Vscatterdpd_vm32x_k1_xmm
			0,// EVEX_Vscatterdpd_vm32x_k1_ymm
			0,// EVEX_Vscatterdpd_vm32y_k1_zmm
			0,// EVEX_Vscatterqps_vm64x_k1_xmm
			0,// EVEX_Vscatterqps_vm64y_k1_xmm
			0,// EVEX_Vscatterqps_vm64z_k1_ymm
			0,// EVEX_Vscatterqpd_vm64x_k1_xmm
			0,// EVEX_Vscatterqpd_vm64y_k1_ymm
			0,// EVEX_Vscatterqpd_vm64z_k1_zmm
			0,// VEX_Vfmaddsub213ps_xmm_xmm_xmmm128
			0,// VEX_Vfmaddsub213ps_ymm_ymm_ymmm256
			0,// VEX_Vfmaddsub213pd_xmm_xmm_xmmm128
			0,// VEX_Vfmaddsub213pd_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vfmaddsub213ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vfmaddsub213ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vfmaddsub213ps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vfmaddsub213pd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vfmaddsub213pd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vfmaddsub213pd_zmm_k1z_zmm_zmmm512b64_er
			0,// VEX_Vfmsubadd213ps_xmm_xmm_xmmm128
			0,// VEX_Vfmsubadd213ps_ymm_ymm_ymmm256
			0,// VEX_Vfmsubadd213pd_xmm_xmm_xmmm128
			0,// VEX_Vfmsubadd213pd_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vfmsubadd213ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vfmsubadd213ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vfmsubadd213ps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vfmsubadd213pd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vfmsubadd213pd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vfmsubadd213pd_zmm_k1z_zmm_zmmm512b64_er
			0,// VEX_Vfmadd213ps_xmm_xmm_xmmm128
			0,// VEX_Vfmadd213ps_ymm_ymm_ymmm256
			0,// VEX_Vfmadd213pd_xmm_xmm_xmmm128
			0,// VEX_Vfmadd213pd_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vfmadd213ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vfmadd213ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vfmadd213ps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vfmadd213pd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vfmadd213pd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vfmadd213pd_zmm_k1z_zmm_zmmm512b64_er
			0,// VEX_Vfmadd213ss_xmm_xmm_xmmm32
			0,// VEX_Vfmadd213sd_xmm_xmm_xmmm64
			0,// EVEX_Vfmadd213ss_xmm_k1z_xmm_xmmm32_er
			0,// EVEX_Vfmadd213sd_xmm_k1z_xmm_xmmm64_er
			0,// VEX_Vfmsub213ps_xmm_xmm_xmmm128
			0,// VEX_Vfmsub213ps_ymm_ymm_ymmm256
			0,// VEX_Vfmsub213pd_xmm_xmm_xmmm128
			0,// VEX_Vfmsub213pd_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vfmsub213ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vfmsub213ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vfmsub213ps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vfmsub213pd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vfmsub213pd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vfmsub213pd_zmm_k1z_zmm_zmmm512b64_er
			0,// EVEX_V4fnmaddps_zmm_k1z_zmmp3_m128
			0,// VEX_Vfmsub213ss_xmm_xmm_xmmm32
			0,// VEX_Vfmsub213sd_xmm_xmm_xmmm64
			0,// EVEX_Vfmsub213ss_xmm_k1z_xmm_xmmm32_er
			0,// EVEX_Vfmsub213sd_xmm_k1z_xmm_xmmm64_er
			0,// EVEX_V4fnmaddss_xmm_k1z_xmmp3_m128
			0,// VEX_Vfnmadd213ps_xmm_xmm_xmmm128
			0,// VEX_Vfnmadd213ps_ymm_ymm_ymmm256
			0,// VEX_Vfnmadd213pd_xmm_xmm_xmmm128
			0,// VEX_Vfnmadd213pd_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vfnmadd213ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vfnmadd213ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vfnmadd213ps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vfnmadd213pd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vfnmadd213pd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vfnmadd213pd_zmm_k1z_zmm_zmmm512b64_er
			0,// VEX_Vfnmadd213ss_xmm_xmm_xmmm32
			0,// VEX_Vfnmadd213sd_xmm_xmm_xmmm64
			0,// EVEX_Vfnmadd213ss_xmm_k1z_xmm_xmmm32_er
			0,// EVEX_Vfnmadd213sd_xmm_k1z_xmm_xmmm64_er
			0,// VEX_Vfnmsub213ps_xmm_xmm_xmmm128
			0,// VEX_Vfnmsub213ps_ymm_ymm_ymmm256
			0,// VEX_Vfnmsub213pd_xmm_xmm_xmmm128
			0,// VEX_Vfnmsub213pd_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vfnmsub213ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vfnmsub213ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vfnmsub213ps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vfnmsub213pd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vfnmsub213pd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vfnmsub213pd_zmm_k1z_zmm_zmmm512b64_er
			0,// VEX_Vfnmsub213ss_xmm_xmm_xmmm32
			0,// VEX_Vfnmsub213sd_xmm_xmm_xmmm64
			0,// EVEX_Vfnmsub213ss_xmm_k1z_xmm_xmmm32_er
			0,// EVEX_Vfnmsub213sd_xmm_k1z_xmm_xmmm64_er
			(byte)MemorySize.Broadcast128_UInt52,// EVEX_Vpmadd52luq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_UInt52,// EVEX_Vpmadd52luq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_UInt52,// EVEX_Vpmadd52luq_zmm_k1z_zmm_zmmm512b64
			(byte)MemorySize.Broadcast128_UInt52,// EVEX_Vpmadd52huq_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_UInt52,// EVEX_Vpmadd52huq_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_UInt52,// EVEX_Vpmadd52huq_zmm_k1z_zmm_zmmm512b64
			0,// VEX_Vfmaddsub231ps_xmm_xmm_xmmm128
			0,// VEX_Vfmaddsub231ps_ymm_ymm_ymmm256
			0,// VEX_Vfmaddsub231pd_xmm_xmm_xmmm128
			0,// VEX_Vfmaddsub231pd_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vfmaddsub231ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vfmaddsub231ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vfmaddsub231ps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vfmaddsub231pd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vfmaddsub231pd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vfmaddsub231pd_zmm_k1z_zmm_zmmm512b64_er
			0,// VEX_Vfmsubadd231ps_xmm_xmm_xmmm128
			0,// VEX_Vfmsubadd231ps_ymm_ymm_ymmm256
			0,// VEX_Vfmsubadd231pd_xmm_xmm_xmmm128
			0,// VEX_Vfmsubadd231pd_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vfmsubadd231ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vfmsubadd231ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vfmsubadd231ps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vfmsubadd231pd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vfmsubadd231pd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vfmsubadd231pd_zmm_k1z_zmm_zmmm512b64_er
			0,// VEX_Vfmadd231ps_xmm_xmm_xmmm128
			0,// VEX_Vfmadd231ps_ymm_ymm_ymmm256
			0,// VEX_Vfmadd231pd_xmm_xmm_xmmm128
			0,// VEX_Vfmadd231pd_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vfmadd231ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vfmadd231ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vfmadd231ps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vfmadd231pd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vfmadd231pd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vfmadd231pd_zmm_k1z_zmm_zmmm512b64_er
			0,// VEX_Vfmadd231ss_xmm_xmm_xmmm32
			0,// VEX_Vfmadd231sd_xmm_xmm_xmmm64
			0,// EVEX_Vfmadd231ss_xmm_k1z_xmm_xmmm32_er
			0,// EVEX_Vfmadd231sd_xmm_k1z_xmm_xmmm64_er
			0,// VEX_Vfmsub231ps_xmm_xmm_xmmm128
			0,// VEX_Vfmsub231ps_ymm_ymm_ymmm256
			0,// VEX_Vfmsub231pd_xmm_xmm_xmmm128
			0,// VEX_Vfmsub231pd_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vfmsub231ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vfmsub231ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vfmsub231ps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vfmsub231pd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vfmsub231pd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vfmsub231pd_zmm_k1z_zmm_zmmm512b64_er
			0,// VEX_Vfmsub231ss_xmm_xmm_xmmm32
			0,// VEX_Vfmsub231sd_xmm_xmm_xmmm64
			0,// EVEX_Vfmsub231ss_xmm_k1z_xmm_xmmm32_er
			0,// EVEX_Vfmsub231sd_xmm_k1z_xmm_xmmm64_er
			0,// VEX_Vfnmadd231ps_xmm_xmm_xmmm128
			0,// VEX_Vfnmadd231ps_ymm_ymm_ymmm256
			0,// VEX_Vfnmadd231pd_xmm_xmm_xmmm128
			0,// VEX_Vfnmadd231pd_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vfnmadd231ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vfnmadd231ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vfnmadd231ps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vfnmadd231pd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vfnmadd231pd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vfnmadd231pd_zmm_k1z_zmm_zmmm512b64_er
			0,// VEX_Vfnmadd231ss_xmm_xmm_xmmm32
			0,// VEX_Vfnmadd231sd_xmm_xmm_xmmm64
			0,// EVEX_Vfnmadd231ss_xmm_k1z_xmm_xmmm32_er
			0,// EVEX_Vfnmadd231sd_xmm_k1z_xmm_xmmm64_er
			0,// VEX_Vfnmsub231ps_xmm_xmm_xmmm128
			0,// VEX_Vfnmsub231ps_ymm_ymm_ymmm256
			0,// VEX_Vfnmsub231pd_xmm_xmm_xmmm128
			0,// VEX_Vfnmsub231pd_ymm_ymm_ymmm256
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vfnmsub231ps_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vfnmsub231ps_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vfnmsub231ps_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vfnmsub231pd_xmm_k1z_xmm_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vfnmsub231pd_ymm_k1z_ymm_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vfnmsub231pd_zmm_k1z_zmm_zmmm512b64_er
			0,// VEX_Vfnmsub231ss_xmm_xmm_xmmm32
			0,// VEX_Vfnmsub231sd_xmm_xmm_xmmm64
			0,// EVEX_Vfnmsub231ss_xmm_k1z_xmm_xmmm32_er
			0,// EVEX_Vfnmsub231sd_xmm_k1z_xmm_xmmm64_er
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vpconflictd_xmm_k1z_xmmm128b32
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vpconflictd_ymm_k1z_ymmm256b32
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vpconflictd_zmm_k1z_zmmm512b32
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vpconflictq_xmm_k1z_xmmm128b64
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vpconflictq_ymm_k1z_ymmm256b64
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vpconflictq_zmm_k1z_zmmm512b64
			0,// EVEX_Vgatherpf0dps_vm32z_k1
			0,// EVEX_Vgatherpf0dpd_vm32y_k1
			0,// EVEX_Vgatherpf1dps_vm32z_k1
			0,// EVEX_Vgatherpf1dpd_vm32y_k1
			0,// EVEX_Vscatterpf0dps_vm32z_k1
			0,// EVEX_Vscatterpf0dpd_vm32y_k1
			0,// EVEX_Vscatterpf1dps_vm32z_k1
			0,// EVEX_Vscatterpf1dpd_vm32y_k1
			0,// EVEX_Vgatherpf0qps_vm64z_k1
			0,// EVEX_Vgatherpf0qpd_vm64z_k1
			0,// EVEX_Vgatherpf1qps_vm64z_k1
			0,// EVEX_Vgatherpf1qpd_vm64z_k1
			0,// EVEX_Vscatterpf0qps_vm64z_k1
			0,// EVEX_Vscatterpf0qpd_vm64z_k1
			0,// EVEX_Vscatterpf1qps_vm64z_k1
			0,// EVEX_Vscatterpf1qpd_vm64z_k1
			0,// Sha1nexte_xmm_xmmm128
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vexp2ps_zmm_k1z_zmmm512b32_sae
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vexp2pd_zmm_k1z_zmmm512b64_sae
			0,// Sha1msg1_xmm_xmmm128
			0,// Sha1msg2_xmm_xmmm128
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vrcp28ps_zmm_k1z_zmmm512b32_sae
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vrcp28pd_zmm_k1z_zmmm512b64_sae
			0,// Sha256rnds2_xmm_xmmm128
			0,// EVEX_Vrcp28ss_xmm_k1z_xmm_xmmm32_sae
			0,// EVEX_Vrcp28sd_xmm_k1z_xmm_xmmm64_sae
			0,// Sha256msg1_xmm_xmmm128
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vrsqrt28ps_zmm_k1z_zmmm512b32_sae
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vrsqrt28pd_zmm_k1z_zmmm512b64_sae
			0,// Sha256msg2_xmm_xmmm128
			0,// EVEX_Vrsqrt28ss_xmm_k1z_xmm_xmmm32_sae
			0,// EVEX_Vrsqrt28sd_xmm_k1z_xmm_xmmm64_sae
			0,// Gf2p8mulb_xmm_xmmm128
			0,// VEX_Vgf2p8mulb_xmm_xmm_xmmm128
			0,// VEX_Vgf2p8mulb_ymm_ymm_ymmm256
			0,// EVEX_Vgf2p8mulb_xmm_k1z_xmm_xmmm128
			0,// EVEX_Vgf2p8mulb_ymm_k1z_ymm_ymmm256
			0,// EVEX_Vgf2p8mulb_zmm_k1z_zmm_zmmm512
			0,// Aesimc_xmm_xmmm128
			0,// VEX_Vaesimc_xmm_xmmm128
			0,// Aesenc_xmm_xmmm128
			0,// VEX_Vaesenc_xmm_xmm_xmmm128
			0,// VEX_Vaesenc_ymm_ymm_ymmm256
			0,// EVEX_Vaesenc_xmm_xmm_xmmm128
			0,// EVEX_Vaesenc_ymm_ymm_ymmm256
			0,// EVEX_Vaesenc_zmm_zmm_zmmm512
			0,// Aesenclast_xmm_xmmm128
			0,// VEX_Vaesenclast_xmm_xmm_xmmm128
			0,// VEX_Vaesenclast_ymm_ymm_ymmm256
			0,// EVEX_Vaesenclast_xmm_xmm_xmmm128
			0,// EVEX_Vaesenclast_ymm_ymm_ymmm256
			0,// EVEX_Vaesenclast_zmm_zmm_zmmm512
			0,// Aesdec_xmm_xmmm128
			0,// VEX_Vaesdec_xmm_xmm_xmmm128
			0,// VEX_Vaesdec_ymm_ymm_ymmm256
			0,// EVEX_Vaesdec_xmm_xmm_xmmm128
			0,// EVEX_Vaesdec_ymm_ymm_ymmm256
			0,// EVEX_Vaesdec_zmm_zmm_zmmm512
			0,// Aesdeclast_xmm_xmmm128
			0,// VEX_Vaesdeclast_xmm_xmm_xmmm128
			0,// VEX_Vaesdeclast_ymm_ymm_ymmm256
			0,// EVEX_Vaesdeclast_xmm_xmm_xmmm128
			0,// EVEX_Vaesdeclast_ymm_ymm_ymmm256
			0,// EVEX_Vaesdeclast_zmm_zmm_zmmm512
			0,// Movbe_r16_m16
			0,// Movbe_r32_m32
			0,// Movbe_r64_m64
			0,// Crc32_r32_rm8
			0,// Crc32_r64_rm8
			0,// Movbe_m16_r16
			0,// Movbe_m32_r32
			0,// Movbe_m64_r64
			0,// Crc32_r32_rm16
			0,// Crc32_r32_rm32
			0,// Crc32_r64_rm64
			0,// VEX_Andn_r32_r32_rm32
			0,// VEX_Andn_r64_r64_rm64
			0,// VEX_Blsr_r32_rm32
			0,// VEX_Blsr_r64_rm64
			0,// VEX_Blsmsk_r32_rm32
			0,// VEX_Blsmsk_r64_rm64
			0,// VEX_Blsi_r32_rm32
			0,// VEX_Blsi_r64_rm64
			0,// VEX_Bzhi_r32_rm32_r32
			0,// VEX_Bzhi_r64_rm64_r64
			0,// Wrussd_m32_r32
			0,// Wrussq_m64_r64
			0,// VEX_Pext_r32_r32_rm32
			0,// VEX_Pext_r64_r64_rm64
			0,// VEX_Pdep_r32_r32_rm32
			0,// VEX_Pdep_r64_r64_rm64
			0,// Wrssd_m32_r32
			0,// Wrssq_m64_r64
			0,// Adcx_r32_rm32
			0,// Adcx_r64_rm64
			0,// Adox_r32_rm32
			0,// Adox_r64_rm64
			0,// VEX_Mulx_r32_r32_rm32
			0,// VEX_Mulx_r64_r64_rm64
			0,// VEX_Bextr_r32_rm32_r32
			0,// VEX_Bextr_r64_rm64_r64
			0,// VEX_Shlx_r32_rm32_r32
			0,// VEX_Shlx_r64_rm64_r64
			0,// VEX_Sarx_r32_rm32_r32
			0,// VEX_Sarx_r64_rm64_r64
			0,// VEX_Shrx_r32_rm32_r32
			0,// VEX_Shrx_r64_rm64_r64
			0,// Movdir64b_r16_m512
			0,// Movdir64b_r32_m512
			0,// Movdir64b_r64_m512
			0,// Enqcmds_r16_m512
			0,// Enqcmds_r32_m512
			0,// Enqcmds_r64_m512
			0,// Enqcmd_r16_m512
			0,// Enqcmd_r32_m512
			0,// Enqcmd_r64_m512
			0,// Movdiri_m32_r32
			0,// Movdiri_m64_r64
			0,// VEX_Vpermq_ymm_ymmm256_imm8
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vpermq_ymm_k1z_ymmm256b64_imm8
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vpermq_zmm_k1z_zmmm512b64_imm8
			0,// VEX_Vpermpd_ymm_ymmm256_imm8
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vpermpd_ymm_k1z_ymmm256b64_imm8
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vpermpd_zmm_k1z_zmmm512b64_imm8
			0,// VEX_Vpblendd_xmm_xmm_xmmm128_imm8
			0,// VEX_Vpblendd_ymm_ymm_ymmm256_imm8
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Valignd_xmm_k1z_xmm_xmmm128b32_imm8
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Valignd_ymm_k1z_ymm_ymmm256b32_imm8
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Valignd_zmm_k1z_zmm_zmmm512b32_imm8
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Valignq_xmm_k1z_xmm_xmmm128b64_imm8
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Valignq_ymm_k1z_ymm_ymmm256b64_imm8
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Valignq_zmm_k1z_zmm_zmmm512b64_imm8
			0,// VEX_Vpermilps_xmm_xmmm128_imm8
			0,// VEX_Vpermilps_ymm_ymmm256_imm8
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vpermilps_xmm_k1z_xmmm128b32_imm8
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vpermilps_ymm_k1z_ymmm256b32_imm8
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vpermilps_zmm_k1z_zmmm512b32_imm8
			0,// VEX_Vpermilpd_xmm_xmmm128_imm8
			0,// VEX_Vpermilpd_ymm_ymmm256_imm8
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vpermilpd_xmm_k1z_xmmm128b64_imm8
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vpermilpd_ymm_k1z_ymmm256b64_imm8
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vpermilpd_zmm_k1z_zmmm512b64_imm8
			0,// VEX_Vperm2f128_ymm_ymm_ymmm256_imm8
			0,// Roundps_xmm_xmmm128_imm8
			0,// VEX_Vroundps_xmm_xmmm128_imm8
			0,// VEX_Vroundps_ymm_ymmm256_imm8
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vrndscaleps_xmm_k1z_xmmm128b32_imm8
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vrndscaleps_ymm_k1z_ymmm256b32_imm8
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vrndscaleps_zmm_k1z_zmmm512b32_imm8_sae
			0,// Roundpd_xmm_xmmm128_imm8
			0,// VEX_Vroundpd_xmm_xmmm128_imm8
			0,// VEX_Vroundpd_ymm_ymmm256_imm8
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vrndscalepd_xmm_k1z_xmmm128b64_imm8
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vrndscalepd_ymm_k1z_ymmm256b64_imm8
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vrndscalepd_zmm_k1z_zmmm512b64_imm8_sae
			0,// Roundss_xmm_xmmm32_imm8
			0,// VEX_Vroundss_xmm_xmm_xmmm32_imm8
			0,// EVEX_Vrndscaless_xmm_k1z_xmm_xmmm32_imm8_sae
			0,// Roundsd_xmm_xmmm64_imm8
			0,// VEX_Vroundsd_xmm_xmm_xmmm64_imm8
			0,// EVEX_Vrndscalesd_xmm_k1z_xmm_xmmm64_imm8_sae
			0,// Blendps_xmm_xmmm128_imm8
			0,// VEX_Vblendps_xmm_xmm_xmmm128_imm8
			0,// VEX_Vblendps_ymm_ymm_ymmm256_imm8
			0,// Blendpd_xmm_xmmm128_imm8
			0,// VEX_Vblendpd_xmm_xmm_xmmm128_imm8
			0,// VEX_Vblendpd_ymm_ymm_ymmm256_imm8
			0,// Pblendw_xmm_xmmm128_imm8
			0,// VEX_Vpblendw_xmm_xmm_xmmm128_imm8
			0,// VEX_Vpblendw_ymm_ymm_ymmm256_imm8
			0,// Palignr_mm_mmm64_imm8
			0,// Palignr_xmm_xmmm128_imm8
			0,// VEX_Vpalignr_xmm_xmm_xmmm128_imm8
			0,// VEX_Vpalignr_ymm_ymm_ymmm256_imm8
			0,// EVEX_Vpalignr_xmm_k1z_xmm_xmmm128_imm8
			0,// EVEX_Vpalignr_ymm_k1z_ymm_ymmm256_imm8
			0,// EVEX_Vpalignr_zmm_k1z_zmm_zmmm512_imm8
			0,// Pextrb_r32m8_xmm_imm8
			0,// Pextrb_r64m8_xmm_imm8
			0,// VEX_Vpextrb_r32m8_xmm_imm8
			0,// VEX_Vpextrb_r64m8_xmm_imm8
			0,// EVEX_Vpextrb_r32m8_xmm_imm8
			0,// EVEX_Vpextrb_r64m8_xmm_imm8
			0,// Pextrw_r32m16_xmm_imm8
			0,// Pextrw_r64m16_xmm_imm8
			0,// VEX_Vpextrw_r32m16_xmm_imm8
			0,// VEX_Vpextrw_r64m16_xmm_imm8
			0,// EVEX_Vpextrw_r32m16_xmm_imm8
			0,// EVEX_Vpextrw_r64m16_xmm_imm8
			0,// Pextrd_rm32_xmm_imm8
			0,// Pextrq_rm64_xmm_imm8
			0,// VEX_Vpextrd_rm32_xmm_imm8
			0,// VEX_Vpextrq_rm64_xmm_imm8
			0,// EVEX_Vpextrd_rm32_xmm_imm8
			0,// EVEX_Vpextrq_rm64_xmm_imm8
			0,// Extractps_rm32_xmm_imm8
			0,// Extractps_r64m32_xmm_imm8
			0,// VEX_Vextractps_rm32_xmm_imm8
			0,// VEX_Vextractps_r64m32_xmm_imm8
			0,// EVEX_Vextractps_rm32_xmm_imm8
			0,// EVEX_Vextractps_r64m32_xmm_imm8
			0,// VEX_Vinsertf128_ymm_ymm_xmmm128_imm8
			0,// EVEX_Vinsertf32x4_ymm_k1z_ymm_xmmm128_imm8
			0,// EVEX_Vinsertf32x4_zmm_k1z_zmm_xmmm128_imm8
			0,// EVEX_Vinsertf64x2_ymm_k1z_ymm_xmmm128_imm8
			0,// EVEX_Vinsertf64x2_zmm_k1z_zmm_xmmm128_imm8
			0,// VEX_Vextractf128_xmmm128_ymm_imm8
			0,// EVEX_Vextractf32x4_xmmm128_k1z_ymm_imm8
			0,// EVEX_Vextractf32x4_xmmm128_k1z_zmm_imm8
			0,// EVEX_Vextractf64x2_xmmm128_k1z_ymm_imm8
			0,// EVEX_Vextractf64x2_xmmm128_k1z_zmm_imm8
			0,// EVEX_Vinsertf32x8_zmm_k1z_zmm_ymmm256_imm8
			0,// EVEX_Vinsertf64x4_zmm_k1z_zmm_ymmm256_imm8
			0,// EVEX_Vextractf32x8_ymmm256_k1z_zmm_imm8
			0,// EVEX_Vextractf64x4_ymmm256_k1z_zmm_imm8
			0,// VEX_Vcvtps2ph_xmmm64_xmm_imm8
			0,// VEX_Vcvtps2ph_xmmm128_ymm_imm8
			0,// EVEX_Vcvtps2ph_xmmm64_k1z_xmm_imm8
			0,// EVEX_Vcvtps2ph_xmmm128_k1z_ymm_imm8
			0,// EVEX_Vcvtps2ph_ymmm256_k1z_zmm_imm8_sae
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vpcmpud_kr_k1_xmm_xmmm128b32_imm8
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vpcmpud_kr_k1_ymm_ymmm256b32_imm8
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vpcmpud_kr_k1_zmm_zmmm512b32_imm8
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vpcmpuq_kr_k1_xmm_xmmm128b64_imm8
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vpcmpuq_kr_k1_ymm_ymmm256b64_imm8
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vpcmpuq_kr_k1_zmm_zmmm512b64_imm8
			(byte)MemorySize.Broadcast128_Int32,// EVEX_Vpcmpd_kr_k1_xmm_xmmm128b32_imm8
			(byte)MemorySize.Broadcast256_Int32,// EVEX_Vpcmpd_kr_k1_ymm_ymmm256b32_imm8
			(byte)MemorySize.Broadcast512_Int32,// EVEX_Vpcmpd_kr_k1_zmm_zmmm512b32_imm8
			(byte)MemorySize.Broadcast128_Int64,// EVEX_Vpcmpq_kr_k1_xmm_xmmm128b64_imm8
			(byte)MemorySize.Broadcast256_Int64,// EVEX_Vpcmpq_kr_k1_ymm_ymmm256b64_imm8
			(byte)MemorySize.Broadcast512_Int64,// EVEX_Vpcmpq_kr_k1_zmm_zmmm512b64_imm8
			0,// Pinsrb_xmm_r32m8_imm8
			0,// Pinsrb_xmm_r64m8_imm8
			0,// VEX_Vpinsrb_xmm_xmm_r32m8_imm8
			0,// VEX_Vpinsrb_xmm_xmm_r64m8_imm8
			0,// EVEX_Vpinsrb_xmm_xmm_r32m8_imm8
			0,// EVEX_Vpinsrb_xmm_xmm_r64m8_imm8
			0,// Insertps_xmm_xmmm32_imm8
			0,// VEX_Vinsertps_xmm_xmm_xmmm32_imm8
			0,// EVEX_Vinsertps_xmm_xmm_xmmm32_imm8
			0,// Pinsrd_xmm_rm32_imm8
			0,// Pinsrq_xmm_rm64_imm8
			0,// VEX_Vpinsrd_xmm_xmm_rm32_imm8
			0,// VEX_Vpinsrq_xmm_xmm_rm64_imm8
			0,// EVEX_Vpinsrd_xmm_xmm_rm32_imm8
			0,// EVEX_Vpinsrq_xmm_xmm_rm64_imm8
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vshuff32x4_ymm_k1z_ymm_ymmm256b32_imm8
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vshuff32x4_zmm_k1z_zmm_zmmm512b32_imm8
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vshuff64x2_ymm_k1z_ymm_ymmm256b64_imm8
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vshuff64x2_zmm_k1z_zmm_zmmm512b64_imm8
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vpternlogd_xmm_k1z_xmm_xmmm128b32_imm8
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vpternlogd_ymm_k1z_ymm_ymmm256b32_imm8
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vpternlogd_zmm_k1z_zmm_zmmm512b32_imm8
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vpternlogq_xmm_k1z_xmm_xmmm128b64_imm8
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vpternlogq_ymm_k1z_ymm_ymmm256b64_imm8
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vpternlogq_zmm_k1z_zmm_zmmm512b64_imm8
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vgetmantps_xmm_k1z_xmmm128b32_imm8
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vgetmantps_ymm_k1z_ymmm256b32_imm8
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vgetmantps_zmm_k1z_zmmm512b32_imm8_sae
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vgetmantpd_xmm_k1z_xmmm128b64_imm8
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vgetmantpd_ymm_k1z_ymmm256b64_imm8
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vgetmantpd_zmm_k1z_zmmm512b64_imm8_sae
			0,// EVEX_Vgetmantss_xmm_k1z_xmm_xmmm32_imm8_sae
			0,// EVEX_Vgetmantsd_xmm_k1z_xmm_xmmm64_imm8_sae
			0,// VEX_Kshiftrb_kr_kr_imm8
			0,// VEX_Kshiftrw_kr_kr_imm8
			0,// VEX_Kshiftrd_kr_kr_imm8
			0,// VEX_Kshiftrq_kr_kr_imm8
			0,// VEX_Kshiftlb_kr_kr_imm8
			0,// VEX_Kshiftlw_kr_kr_imm8
			0,// VEX_Kshiftld_kr_kr_imm8
			0,// VEX_Kshiftlq_kr_kr_imm8
			0,// VEX_Vinserti128_ymm_ymm_xmmm128_imm8
			0,// EVEX_Vinserti32x4_ymm_k1z_ymm_xmmm128_imm8
			0,// EVEX_Vinserti32x4_zmm_k1z_zmm_xmmm128_imm8
			0,// EVEX_Vinserti64x2_ymm_k1z_ymm_xmmm128_imm8
			0,// EVEX_Vinserti64x2_zmm_k1z_zmm_xmmm128_imm8
			0,// VEX_Vextracti128_xmmm128_ymm_imm8
			0,// EVEX_Vextracti32x4_xmmm128_k1z_ymm_imm8
			0,// EVEX_Vextracti32x4_xmmm128_k1z_zmm_imm8
			0,// EVEX_Vextracti64x2_xmmm128_k1z_ymm_imm8
			0,// EVEX_Vextracti64x2_xmmm128_k1z_zmm_imm8
			0,// EVEX_Vinserti32x8_zmm_k1z_zmm_ymmm256_imm8
			0,// EVEX_Vinserti64x4_zmm_k1z_zmm_ymmm256_imm8
			0,// EVEX_Vextracti32x8_ymmm256_k1z_zmm_imm8
			0,// EVEX_Vextracti64x4_ymmm256_k1z_zmm_imm8
			0,// EVEX_Vpcmpub_kr_k1_xmm_xmmm128_imm8
			0,// EVEX_Vpcmpub_kr_k1_ymm_ymmm256_imm8
			0,// EVEX_Vpcmpub_kr_k1_zmm_zmmm512_imm8
			0,// EVEX_Vpcmpuw_kr_k1_xmm_xmmm128_imm8
			0,// EVEX_Vpcmpuw_kr_k1_ymm_ymmm256_imm8
			0,// EVEX_Vpcmpuw_kr_k1_zmm_zmmm512_imm8
			0,// EVEX_Vpcmpb_kr_k1_xmm_xmmm128_imm8
			0,// EVEX_Vpcmpb_kr_k1_ymm_ymmm256_imm8
			0,// EVEX_Vpcmpb_kr_k1_zmm_zmmm512_imm8
			0,// EVEX_Vpcmpw_kr_k1_xmm_xmmm128_imm8
			0,// EVEX_Vpcmpw_kr_k1_ymm_ymmm256_imm8
			0,// EVEX_Vpcmpw_kr_k1_zmm_zmmm512_imm8
			0,// Dpps_xmm_xmmm128_imm8
			0,// VEX_Vdpps_xmm_xmm_xmmm128_imm8
			0,// VEX_Vdpps_ymm_ymm_ymmm256_imm8
			0,// Dppd_xmm_xmmm128_imm8
			0,// VEX_Vdppd_xmm_xmm_xmmm128_imm8
			0,// Mpsadbw_xmm_xmmm128_imm8
			0,// VEX_Vmpsadbw_xmm_xmm_xmmm128_imm8
			0,// VEX_Vmpsadbw_ymm_ymm_ymmm256_imm8
			0,// EVEX_Vdbpsadbw_xmm_k1z_xmm_xmmm128_imm8
			0,// EVEX_Vdbpsadbw_ymm_k1z_ymm_ymmm256_imm8
			0,// EVEX_Vdbpsadbw_zmm_k1z_zmm_zmmm512_imm8
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vshufi32x4_ymm_k1z_ymm_ymmm256b32_imm8
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vshufi32x4_zmm_k1z_zmm_zmmm512b32_imm8
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vshufi64x2_ymm_k1z_ymm_ymmm256b64_imm8
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vshufi64x2_zmm_k1z_zmm_zmmm512b64_imm8
			0,// Pclmulqdq_xmm_xmmm128_imm8
			0,// VEX_Vpclmulqdq_xmm_xmm_xmmm128_imm8
			0,// VEX_Vpclmulqdq_ymm_ymm_ymmm256_imm8
			0,// EVEX_Vpclmulqdq_xmm_xmm_xmmm128_imm8
			0,// EVEX_Vpclmulqdq_ymm_ymm_ymmm256_imm8
			0,// EVEX_Vpclmulqdq_zmm_zmm_zmmm512_imm8
			0,// VEX_Vperm2i128_ymm_ymm_ymmm256_imm8
			0,// VEX_Vpermil2ps_xmm_xmm_xmmm128_xmm_imm4
			0,// VEX_Vpermil2ps_ymm_ymm_ymmm256_ymm_imm4
			0,// VEX_Vpermil2ps_xmm_xmm_xmm_xmmm128_imm4
			0,// VEX_Vpermil2ps_ymm_ymm_ymm_ymmm256_imm4
			0,// VEX_Vpermil2pd_xmm_xmm_xmmm128_xmm_imm4
			0,// VEX_Vpermil2pd_ymm_ymm_ymmm256_ymm_imm4
			0,// VEX_Vpermil2pd_xmm_xmm_xmm_xmmm128_imm4
			0,// VEX_Vpermil2pd_ymm_ymm_ymm_ymmm256_imm4
			0,// VEX_Vblendvps_xmm_xmm_xmmm128_xmm
			0,// VEX_Vblendvps_ymm_ymm_ymmm256_ymm
			0,// VEX_Vblendvpd_xmm_xmm_xmmm128_xmm
			0,// VEX_Vblendvpd_ymm_ymm_ymmm256_ymm
			0,// VEX_Vpblendvb_xmm_xmm_xmmm128_xmm
			0,// VEX_Vpblendvb_ymm_ymm_ymmm256_ymm
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vrangeps_xmm_k1z_xmm_xmmm128b32_imm8
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vrangeps_ymm_k1z_ymm_ymmm256b32_imm8
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vrangeps_zmm_k1z_zmm_zmmm512b32_imm8_sae
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vrangepd_xmm_k1z_xmm_xmmm128b64_imm8
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vrangepd_ymm_k1z_ymm_ymmm256b64_imm8
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vrangepd_zmm_k1z_zmm_zmmm512b64_imm8_sae
			0,// EVEX_Vrangess_xmm_k1z_xmm_xmmm32_imm8_sae
			0,// EVEX_Vrangesd_xmm_k1z_xmm_xmmm64_imm8_sae
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vfixupimmps_xmm_k1z_xmm_xmmm128b32_imm8
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vfixupimmps_ymm_k1z_ymm_ymmm256b32_imm8
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vfixupimmps_zmm_k1z_zmm_zmmm512b32_imm8_sae
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vfixupimmpd_xmm_k1z_xmm_xmmm128b64_imm8
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vfixupimmpd_ymm_k1z_ymm_ymmm256b64_imm8
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vfixupimmpd_zmm_k1z_zmm_zmmm512b64_imm8_sae
			0,// EVEX_Vfixupimmss_xmm_k1z_xmm_xmmm32_imm8_sae
			0,// EVEX_Vfixupimmsd_xmm_k1z_xmm_xmmm64_imm8_sae
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vreduceps_xmm_k1z_xmmm128b32_imm8
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vreduceps_ymm_k1z_ymmm256b32_imm8
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vreduceps_zmm_k1z_zmmm512b32_imm8_sae
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vreducepd_xmm_k1z_xmmm128b64_imm8
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vreducepd_ymm_k1z_ymmm256b64_imm8
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vreducepd_zmm_k1z_zmmm512b64_imm8_sae
			0,// EVEX_Vreducess_xmm_k1z_xmm_xmmm32_imm8_sae
			0,// EVEX_Vreducesd_xmm_k1z_xmm_xmmm64_imm8_sae
			0,// VEX_Vfmaddsubps_xmm_xmm_xmmm128_xmm
			0,// VEX_Vfmaddsubps_ymm_ymm_ymmm256_ymm
			0,// VEX_Vfmaddsubps_xmm_xmm_xmm_xmmm128
			0,// VEX_Vfmaddsubps_ymm_ymm_ymm_ymmm256
			0,// VEX_Vfmaddsubpd_xmm_xmm_xmmm128_xmm
			0,// VEX_Vfmaddsubpd_ymm_ymm_ymmm256_ymm
			0,// VEX_Vfmaddsubpd_xmm_xmm_xmm_xmmm128
			0,// VEX_Vfmaddsubpd_ymm_ymm_ymm_ymmm256
			0,// VEX_Vfmsubaddps_xmm_xmm_xmmm128_xmm
			0,// VEX_Vfmsubaddps_ymm_ymm_ymmm256_ymm
			0,// VEX_Vfmsubaddps_xmm_xmm_xmm_xmmm128
			0,// VEX_Vfmsubaddps_ymm_ymm_ymm_ymmm256
			0,// VEX_Vfmsubaddpd_xmm_xmm_xmmm128_xmm
			0,// VEX_Vfmsubaddpd_ymm_ymm_ymmm256_ymm
			0,// VEX_Vfmsubaddpd_xmm_xmm_xmm_xmmm128
			0,// VEX_Vfmsubaddpd_ymm_ymm_ymm_ymmm256
			0,// Pcmpestrm_xmm_xmmm128_imm8
			0,// Pcmpestrm64_xmm_xmmm128_imm8
			0,// VEX_Vpcmpestrm_xmm_xmmm128_imm8
			0,// VEX_Vpcmpestrm64_xmm_xmmm128_imm8
			0,// Pcmpestri_xmm_xmmm128_imm8
			0,// Pcmpestri64_xmm_xmmm128_imm8
			0,// VEX_Vpcmpestri_xmm_xmmm128_imm8
			0,// VEX_Vpcmpestri64_xmm_xmmm128_imm8
			0,// Pcmpistrm_xmm_xmmm128_imm8
			0,// VEX_Vpcmpistrm_xmm_xmmm128_imm8
			0,// Pcmpistri_xmm_xmmm128_imm8
			0,// VEX_Vpcmpistri_xmm_xmmm128_imm8
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vfpclassps_kr_k1_xmmm128b32_imm8
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vfpclassps_kr_k1_ymmm256b32_imm8
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vfpclassps_kr_k1_zmmm512b32_imm8
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vfpclasspd_kr_k1_xmmm128b64_imm8
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vfpclasspd_kr_k1_ymmm256b64_imm8
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vfpclasspd_kr_k1_zmmm512b64_imm8
			0,// EVEX_Vfpclassss_kr_k1_xmmm32_imm8
			0,// EVEX_Vfpclasssd_kr_k1_xmmm64_imm8
			0,// VEX_Vfmaddps_xmm_xmm_xmmm128_xmm
			0,// VEX_Vfmaddps_ymm_ymm_ymmm256_ymm
			0,// VEX_Vfmaddps_xmm_xmm_xmm_xmmm128
			0,// VEX_Vfmaddps_ymm_ymm_ymm_ymmm256
			0,// VEX_Vfmaddpd_xmm_xmm_xmmm128_xmm
			0,// VEX_Vfmaddpd_ymm_ymm_ymmm256_ymm
			0,// VEX_Vfmaddpd_xmm_xmm_xmm_xmmm128
			0,// VEX_Vfmaddpd_ymm_ymm_ymm_ymmm256
			0,// VEX_Vfmaddss_xmm_xmm_xmmm32_xmm
			0,// VEX_Vfmaddss_xmm_xmm_xmm_xmmm32
			0,// VEX_Vfmaddsd_xmm_xmm_xmmm64_xmm
			0,// VEX_Vfmaddsd_xmm_xmm_xmm_xmmm64
			0,// VEX_Vfmsubps_xmm_xmm_xmmm128_xmm
			0,// VEX_Vfmsubps_ymm_ymm_ymmm256_ymm
			0,// VEX_Vfmsubps_xmm_xmm_xmm_xmmm128
			0,// VEX_Vfmsubps_ymm_ymm_ymm_ymmm256
			0,// VEX_Vfmsubpd_xmm_xmm_xmmm128_xmm
			0,// VEX_Vfmsubpd_ymm_ymm_ymmm256_ymm
			0,// VEX_Vfmsubpd_xmm_xmm_xmm_xmmm128
			0,// VEX_Vfmsubpd_ymm_ymm_ymm_ymmm256
			0,// VEX_Vfmsubss_xmm_xmm_xmmm32_xmm
			0,// VEX_Vfmsubss_xmm_xmm_xmm_xmmm32
			0,// VEX_Vfmsubsd_xmm_xmm_xmmm64_xmm
			0,// VEX_Vfmsubsd_xmm_xmm_xmm_xmmm64
			0,// EVEX_Vpshldw_xmm_k1z_xmm_xmmm128_imm8
			0,// EVEX_Vpshldw_ymm_k1z_ymm_ymmm256_imm8
			0,// EVEX_Vpshldw_zmm_k1z_zmm_zmmm512_imm8
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vpshldd_xmm_k1z_xmm_xmmm128b32_imm8
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vpshldd_ymm_k1z_ymm_ymmm256b32_imm8
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vpshldd_zmm_k1z_zmm_zmmm512b32_imm8
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vpshldq_xmm_k1z_xmm_xmmm128b64_imm8
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vpshldq_ymm_k1z_ymm_ymmm256b64_imm8
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vpshldq_zmm_k1z_zmm_zmmm512b64_imm8
			0,// EVEX_Vpshrdw_xmm_k1z_xmm_xmmm128_imm8
			0,// EVEX_Vpshrdw_ymm_k1z_ymm_ymmm256_imm8
			0,// EVEX_Vpshrdw_zmm_k1z_zmm_zmmm512_imm8
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vpshrdd_xmm_k1z_xmm_xmmm128b32_imm8
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vpshrdd_ymm_k1z_ymm_ymmm256b32_imm8
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vpshrdd_zmm_k1z_zmm_zmmm512b32_imm8
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vpshrdq_xmm_k1z_xmm_xmmm128b64_imm8
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vpshrdq_ymm_k1z_ymm_ymmm256b64_imm8
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vpshrdq_zmm_k1z_zmm_zmmm512b64_imm8
			0,// VEX_Vfnmaddps_xmm_xmm_xmmm128_xmm
			0,// VEX_Vfnmaddps_ymm_ymm_ymmm256_ymm
			0,// VEX_Vfnmaddps_xmm_xmm_xmm_xmmm128
			0,// VEX_Vfnmaddps_ymm_ymm_ymm_ymmm256
			0,// VEX_Vfnmaddpd_xmm_xmm_xmmm128_xmm
			0,// VEX_Vfnmaddpd_ymm_ymm_ymmm256_ymm
			0,// VEX_Vfnmaddpd_xmm_xmm_xmm_xmmm128
			0,// VEX_Vfnmaddpd_ymm_ymm_ymm_ymmm256
			0,// VEX_Vfnmaddss_xmm_xmm_xmmm32_xmm
			0,// VEX_Vfnmaddss_xmm_xmm_xmm_xmmm32
			0,// VEX_Vfnmaddsd_xmm_xmm_xmmm64_xmm
			0,// VEX_Vfnmaddsd_xmm_xmm_xmm_xmmm64
			0,// VEX_Vfnmsubps_xmm_xmm_xmmm128_xmm
			0,// VEX_Vfnmsubps_ymm_ymm_ymmm256_ymm
			0,// VEX_Vfnmsubps_xmm_xmm_xmm_xmmm128
			0,// VEX_Vfnmsubps_ymm_ymm_ymm_ymmm256
			0,// VEX_Vfnmsubpd_xmm_xmm_xmmm128_xmm
			0,// VEX_Vfnmsubpd_ymm_ymm_ymmm256_ymm
			0,// VEX_Vfnmsubpd_xmm_xmm_xmm_xmmm128
			0,// VEX_Vfnmsubpd_ymm_ymm_ymm_ymmm256
			0,// VEX_Vfnmsubss_xmm_xmm_xmmm32_xmm
			0,// VEX_Vfnmsubss_xmm_xmm_xmm_xmmm32
			0,// VEX_Vfnmsubsd_xmm_xmm_xmmm64_xmm
			0,// VEX_Vfnmsubsd_xmm_xmm_xmm_xmmm64
			0,// Sha1rnds4_xmm_xmmm128_imm8
			0,// Gf2p8affineqb_xmm_xmmm128_imm8
			0,// VEX_Vgf2p8affineqb_xmm_xmm_xmmm128_imm8
			0,// VEX_Vgf2p8affineqb_ymm_ymm_ymmm256_imm8
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vgf2p8affineqb_xmm_k1z_xmm_xmmm128b64_imm8
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vgf2p8affineqb_ymm_k1z_ymm_ymmm256b64_imm8
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vgf2p8affineqb_zmm_k1z_zmm_zmmm512b64_imm8
			0,// Gf2p8affineinvqb_xmm_xmmm128_imm8
			0,// VEX_Vgf2p8affineinvqb_xmm_xmm_xmmm128_imm8
			0,// VEX_Vgf2p8affineinvqb_ymm_ymm_ymmm256_imm8
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vgf2p8affineinvqb_xmm_k1z_xmm_xmmm128b64_imm8
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vgf2p8affineinvqb_ymm_k1z_ymm_ymmm256b64_imm8
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vgf2p8affineinvqb_zmm_k1z_zmm_zmmm512b64_imm8
			0,// Aeskeygenassist_xmm_xmmm128_imm8
			0,// VEX_Vaeskeygenassist_xmm_xmmm128_imm8
			0,// VEX_Rorx_r32_rm32_imm8
			0,// VEX_Rorx_r64_rm64_imm8
			0,// XOP_Vpmacssww_xmm_xmm_xmmm128_xmm
			0,// XOP_Vpmacsswd_xmm_xmm_xmmm128_xmm
			0,// XOP_Vpmacssdql_xmm_xmm_xmmm128_xmm
			0,// XOP_Vpmacssdd_xmm_xmm_xmmm128_xmm
			0,// XOP_Vpmacssdqh_xmm_xmm_xmmm128_xmm
			0,// XOP_Vpmacsww_xmm_xmm_xmmm128_xmm
			0,// XOP_Vpmacswd_xmm_xmm_xmmm128_xmm
			0,// XOP_Vpmacsdql_xmm_xmm_xmmm128_xmm
			0,// XOP_Vpmacsdd_xmm_xmm_xmmm128_xmm
			0,// XOP_Vpmacsdqh_xmm_xmm_xmmm128_xmm
			0,// XOP_Vpcmov_xmm_xmm_xmmm128_xmm
			0,// XOP_Vpcmov_ymm_ymm_ymmm256_ymm
			0,// XOP_Vpcmov_xmm_xmm_xmm_xmmm128
			0,// XOP_Vpcmov_ymm_ymm_ymm_ymmm256
			0,// XOP_Vpperm_xmm_xmm_xmmm128_xmm
			0,// XOP_Vpperm_xmm_xmm_xmm_xmmm128
			0,// XOP_Vpmadcsswd_xmm_xmm_xmmm128_xmm
			0,// XOP_Vpmadcswd_xmm_xmm_xmmm128_xmm
			0,// XOP_Vprotb_xmm_xmmm128_imm8
			0,// XOP_Vprotw_xmm_xmmm128_imm8
			0,// XOP_Vprotd_xmm_xmmm128_imm8
			0,// XOP_Vprotq_xmm_xmmm128_imm8
			0,// XOP_Vpcomb_xmm_xmm_xmmm128_imm8
			0,// XOP_Vpcomw_xmm_xmm_xmmm128_imm8
			0,// XOP_Vpcomd_xmm_xmm_xmmm128_imm8
			0,// XOP_Vpcomq_xmm_xmm_xmmm128_imm8
			0,// XOP_Vpcomub_xmm_xmm_xmmm128_imm8
			0,// XOP_Vpcomuw_xmm_xmm_xmmm128_imm8
			0,// XOP_Vpcomud_xmm_xmm_xmmm128_imm8
			0,// XOP_Vpcomuq_xmm_xmm_xmmm128_imm8
			0,// XOP_Blcfill_r32_rm32
			0,// XOP_Blcfill_r64_rm64
			0,// XOP_Blsfill_r32_rm32
			0,// XOP_Blsfill_r64_rm64
			0,// XOP_Blcs_r32_rm32
			0,// XOP_Blcs_r64_rm64
			0,// XOP_Tzmsk_r32_rm32
			0,// XOP_Tzmsk_r64_rm64
			0,// XOP_Blcic_r32_rm32
			0,// XOP_Blcic_r64_rm64
			0,// XOP_Blsic_r32_rm32
			0,// XOP_Blsic_r64_rm64
			0,// XOP_T1mskc_r32_rm32
			0,// XOP_T1mskc_r64_rm64
			0,// XOP_Blcmsk_r32_rm32
			0,// XOP_Blcmsk_r64_rm64
			0,// XOP_Blci_r32_rm32
			0,// XOP_Blci_r64_rm64
			0,// XOP_Llwpcb_r32
			0,// XOP_Llwpcb_r64
			0,// XOP_Slwpcb_r32
			0,// XOP_Slwpcb_r64
			0,// XOP_Vfrczps_xmm_xmmm128
			0,// XOP_Vfrczps_ymm_ymmm256
			0,// XOP_Vfrczpd_xmm_xmmm128
			0,// XOP_Vfrczpd_ymm_ymmm256
			0,// XOP_Vfrczss_xmm_xmmm32
			0,// XOP_Vfrczsd_xmm_xmmm64
			0,// XOP_Vprotb_xmm_xmmm128_xmm
			0,// XOP_Vprotb_xmm_xmm_xmmm128
			0,// XOP_Vprotw_xmm_xmmm128_xmm
			0,// XOP_Vprotw_xmm_xmm_xmmm128
			0,// XOP_Vprotd_xmm_xmmm128_xmm
			0,// XOP_Vprotd_xmm_xmm_xmmm128
			0,// XOP_Vprotq_xmm_xmmm128_xmm
			0,// XOP_Vprotq_xmm_xmm_xmmm128
			0,// XOP_Vpshlb_xmm_xmmm128_xmm
			0,// XOP_Vpshlb_xmm_xmm_xmmm128
			0,// XOP_Vpshlw_xmm_xmmm128_xmm
			0,// XOP_Vpshlw_xmm_xmm_xmmm128
			0,// XOP_Vpshld_xmm_xmmm128_xmm
			0,// XOP_Vpshld_xmm_xmm_xmmm128
			0,// XOP_Vpshlq_xmm_xmmm128_xmm
			0,// XOP_Vpshlq_xmm_xmm_xmmm128
			0,// XOP_Vpshab_xmm_xmmm128_xmm
			0,// XOP_Vpshab_xmm_xmm_xmmm128
			0,// XOP_Vpshaw_xmm_xmmm128_xmm
			0,// XOP_Vpshaw_xmm_xmm_xmmm128
			0,// XOP_Vpshad_xmm_xmmm128_xmm
			0,// XOP_Vpshad_xmm_xmm_xmmm128
			0,// XOP_Vpshaq_xmm_xmmm128_xmm
			0,// XOP_Vpshaq_xmm_xmm_xmmm128
			0,// XOP_Vphaddbw_xmm_xmmm128
			0,// XOP_Vphaddbd_xmm_xmmm128
			0,// XOP_Vphaddbq_xmm_xmmm128
			0,// XOP_Vphaddwd_xmm_xmmm128
			0,// XOP_Vphaddwq_xmm_xmmm128
			0,// XOP_Vphadddq_xmm_xmmm128
			0,// XOP_Vphaddubw_xmm_xmmm128
			0,// XOP_Vphaddubd_xmm_xmmm128
			0,// XOP_Vphaddubq_xmm_xmmm128
			0,// XOP_Vphadduwd_xmm_xmmm128
			0,// XOP_Vphadduwq_xmm_xmmm128
			0,// XOP_Vphaddudq_xmm_xmmm128
			0,// XOP_Vphsubbw_xmm_xmmm128
			0,// XOP_Vphsubwd_xmm_xmmm128
			0,// XOP_Vphsubdq_xmm_xmmm128
			0,// XOP_Bextr_r32_rm32_imm32
			0,// XOP_Bextr_r64_rm64_imm32
			0,// XOP_Lwpins_r32_rm32_imm32
			0,// XOP_Lwpins_r64_rm32_imm32
			0,// XOP_Lwpval_r32_rm32_imm32
			0,// XOP_Lwpval_r64_rm32_imm32
			0,// D3NOW_Pi2fw_mm_mmm64
			0,// D3NOW_Pi2fd_mm_mmm64
			0,// D3NOW_Pf2iw_mm_mmm64
			0,// D3NOW_Pf2id_mm_mmm64
			0,// D3NOW_Pfrcpv_mm_mmm64
			0,// D3NOW_Pfrsqrtv_mm_mmm64
			0,// D3NOW_Pfnacc_mm_mmm64
			0,// D3NOW_Pfpnacc_mm_mmm64
			0,// D3NOW_Pfcmpge_mm_mmm64
			0,// D3NOW_Pfmin_mm_mmm64
			0,// D3NOW_Pfrcp_mm_mmm64
			0,// D3NOW_Pfrsqrt_mm_mmm64
			0,// D3NOW_Pfsub_mm_mmm64
			0,// D3NOW_Pfadd_mm_mmm64
			0,// D3NOW_Pfcmpgt_mm_mmm64
			0,// D3NOW_Pfmax_mm_mmm64
			0,// D3NOW_Pfrcpit1_mm_mmm64
			0,// D3NOW_Pfrsqit1_mm_mmm64
			0,// D3NOW_Pfsubr_mm_mmm64
			0,// D3NOW_Pfacc_mm_mmm64
			0,// D3NOW_Pfcmpeq_mm_mmm64
			0,// D3NOW_Pfmul_mm_mmm64
			0,// D3NOW_Pfrcpit2_mm_mmm64
			0,// D3NOW_Pmulhrw_mm_mmm64
			0,// D3NOW_Pswapd_mm_mmm64
			0,// D3NOW_Pavgusb_mm_mmm64
			0,// Rmpadjust
			0,// Rmpupdate
			0,// Psmash
			0,// Pvalidatew
			0,// Pvalidated
			0,// Pvalidateq
			0,// Serialize
			0,// Xsusldtrk
			0,// Xresldtrk
			0,// Invlpgbw
			0,// Invlpgbd
			0,// Invlpgbq
			0,// Tlbsync
			0,// Prefetchreserved3_m8
			0,// Prefetchreserved4_m8
			0,// Prefetchreserved5_m8
			0,// Prefetchreserved6_m8
			0,// Prefetchreserved7_m8
			0,// Ud0
			0,// Vmgexit
			0,// Getsecq
			0,// VEX_Ldtilecfg_m512
			0,// VEX_Tilerelease
			0,// VEX_Sttilecfg_m512
			0,// VEX_Tilezero_tmm
			0,// VEX_Tileloaddt1_tmm_sibmem
			0,// VEX_Tilestored_sibmem_tmm
			0,// VEX_Tileloadd_tmm_sibmem
			0,// VEX_Tdpbf16ps_tmm_tmm_tmm
			0,// VEX_Tdpbuud_tmm_tmm_tmm
			0,// VEX_Tdpbusd_tmm_tmm_tmm
			0,// VEX_Tdpbsud_tmm_tmm_tmm
			0,// VEX_Tdpbssd_tmm_tmm_tmm
			0,// Fnstdw_AX
			0,// Fnstsg_AX
			0,// Rdshr_rm32
			0,// Wrshr_rm32
			0,// Smint
			0,// Dmint
			0,// Rdm
			0,// Svdc_m80_Sreg
			0,// Rsdc_Sreg_m80
			0,// Svldt_m80
			0,// Rsldt_m80
			0,// Svts_m80
			0,// Rsts_m80
			0,// Smint_0F7E
			0,// Bb0_reset
			0,// Bb1_reset
			0,// Cpu_write
			0,// Cpu_read
			0,// Altinst
			0,// Paveb_mm_mmm64
			0,// Paddsiw_mm_mmm64
			0,// Pmagw_mm_mmm64
			0,// Pdistib_mm_m64
			0,// Psubsiw_mm_mmm64
			0,// Pmvzb_mm_m64
			0,// Pmulhrw_mm_mmm64
			0,// Pmvnzb_mm_m64
			0,// Pmvlzb_mm_m64
			0,// Pmvgezb_mm_m64
			0,// Pmulhriw_mm_mmm64
			0,// Pmachriw_mm_m64
			0,// Cyrix_D9D7
			0,// Cyrix_D9E2
			0,// Ftstp
			0,// Cyrix_D9E7
			0,// Frint2
			0,// Frichop
			0,// Cyrix_DED8
			0,// Cyrix_DEDA
			0,// Cyrix_DEDC
			0,// Cyrix_DEDD
			0,// Cyrix_DEDE
			0,// Frinear
			0,// Tdcall
			0,// Seamret
			0,// Seamops
			0,// Seamcall
			0,// Aesencwide128kl_m384
			0,// Aesdecwide128kl_m384
			0,// Aesencwide256kl_m512
			0,// Aesdecwide256kl_m512
			0,// Loadiwkey_xmm_xmm
			0,// Aesenc128kl_xmm_m384
			0,// Aesdec128kl_xmm_m384
			0,// Aesenc256kl_xmm_m512
			0,// Aesdec256kl_xmm_m512
			0,// Encodekey128_r32_r32
			0,// Encodekey256_r32_r32
			0,// VEX_Vbroadcastss_xmm_xmm
			0,// VEX_Vbroadcastss_ymm_xmm
			0,// VEX_Vbroadcastsd_ymm_xmm
			0,// Vmgexit_F2
			0,// Uiret
			0,// Testui
			0,// Clui
			0,// Stui
			0,// Senduipi_r64
			0,// Hreset_imm8
			0,// VEX_Vpdpbusd_xmm_xmm_xmmm128
			0,// VEX_Vpdpbusd_ymm_ymm_ymmm256
			0,// VEX_Vpdpbusds_xmm_xmm_xmmm128
			0,// VEX_Vpdpbusds_ymm_ymm_ymmm256
			0,// VEX_Vpdpwssd_xmm_xmm_xmmm128
			0,// VEX_Vpdpwssd_ymm_ymm_ymmm256
			0,// VEX_Vpdpwssds_xmm_xmm_xmmm128
			0,// VEX_Vpdpwssds_ymm_ymm_ymmm256
			0,// Ccs_hash_16
			0,// Ccs_hash_32
			0,// Ccs_hash_64
			0,// Ccs_encrypt_16
			0,// Ccs_encrypt_32
			0,// Ccs_encrypt_64
			0,// Lkgs_rm16
			0,// Lkgs_r32m16
			0,// Lkgs_r64m16
			0,// Eretu
			0,// Erets
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vaddph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vaddph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Broadcast512_Float16,// EVEX_Vaddph_zmm_k1z_zmm_zmmm512b16_er
			0,// EVEX_Vaddsh_xmm_k1z_xmm_xmmm16_er
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vcmpph_kr_k1_xmm_xmmm128b16_imm8
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vcmpph_kr_k1_ymm_ymmm256b16_imm8
			(byte)MemorySize.Broadcast512_Float16,// EVEX_Vcmpph_kr_k1_zmm_zmmm512b16_imm8_sae
			0,// EVEX_Vcmpsh_kr_k1_xmm_xmmm16_imm8_sae
			0,// EVEX_Vcomish_xmm_xmmm16_sae
			(byte)MemorySize.Broadcast128_Int32,// EVEX_Vcvtdq2ph_xmm_k1z_xmmm128b32
			(byte)MemorySize.Broadcast256_Int32,// EVEX_Vcvtdq2ph_xmm_k1z_ymmm256b32
			(byte)MemorySize.Broadcast512_Int32,// EVEX_Vcvtdq2ph_ymm_k1z_zmmm512b32_er
			(byte)MemorySize.Broadcast128_Float64,// EVEX_Vcvtpd2ph_xmm_k1z_xmmm128b64
			(byte)MemorySize.Broadcast256_Float64,// EVEX_Vcvtpd2ph_xmm_k1z_ymmm256b64
			(byte)MemorySize.Broadcast512_Float64,// EVEX_Vcvtpd2ph_xmm_k1z_zmmm512b64_er
			(byte)MemorySize.Broadcast64_Float16,// EVEX_Vcvtph2dq_xmm_k1z_xmmm64b16
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vcvtph2dq_ymm_k1z_xmmm128b16
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vcvtph2dq_zmm_k1z_ymmm256b16_er
			(byte)MemorySize.Broadcast32_Float16,// EVEX_Vcvtph2pd_xmm_k1z_xmmm32b16
			(byte)MemorySize.Broadcast64_Float16,// EVEX_Vcvtph2pd_ymm_k1z_xmmm64b16
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vcvtph2pd_zmm_k1z_xmmm128b16_sae
			(byte)MemorySize.Broadcast64_Float16,// EVEX_Vcvtph2psx_xmm_k1z_xmmm64b16
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vcvtph2psx_ymm_k1z_xmmm128b16
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vcvtph2psx_zmm_k1z_ymmm256b16_sae
			(byte)MemorySize.Broadcast32_Float16,// EVEX_Vcvtph2qq_xmm_k1z_xmmm32b16
			(byte)MemorySize.Broadcast64_Float16,// EVEX_Vcvtph2qq_ymm_k1z_xmmm64b16
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vcvtph2qq_zmm_k1z_xmmm128b16_er
			(byte)MemorySize.Broadcast64_Float16,// EVEX_Vcvtph2udq_xmm_k1z_xmmm64b16
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vcvtph2udq_ymm_k1z_xmmm128b16
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vcvtph2udq_zmm_k1z_ymmm256b16_er
			(byte)MemorySize.Broadcast32_Float16,// EVEX_Vcvtph2uqq_xmm_k1z_xmmm32b16
			(byte)MemorySize.Broadcast64_Float16,// EVEX_Vcvtph2uqq_ymm_k1z_xmmm64b16
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vcvtph2uqq_zmm_k1z_xmmm128b16_er
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vcvtph2uw_xmm_k1z_xmmm128b16
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vcvtph2uw_ymm_k1z_ymmm256b16
			(byte)MemorySize.Broadcast512_Float16,// EVEX_Vcvtph2uw_zmm_k1z_zmmm512b16_er
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vcvtph2w_xmm_k1z_xmmm128b16
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vcvtph2w_ymm_k1z_ymmm256b16
			(byte)MemorySize.Broadcast512_Float16,// EVEX_Vcvtph2w_zmm_k1z_zmmm512b16_er
			(byte)MemorySize.Broadcast128_Float32,// EVEX_Vcvtps2phx_xmm_k1z_xmmm128b32
			(byte)MemorySize.Broadcast256_Float32,// EVEX_Vcvtps2phx_xmm_k1z_ymmm256b32
			(byte)MemorySize.Broadcast512_Float32,// EVEX_Vcvtps2phx_ymm_k1z_zmmm512b32_er
			(byte)MemorySize.Broadcast128_Int64,// EVEX_Vcvtqq2ph_xmm_k1z_xmmm128b64
			(byte)MemorySize.Broadcast256_Int64,// EVEX_Vcvtqq2ph_xmm_k1z_ymmm256b64
			(byte)MemorySize.Broadcast512_Int64,// EVEX_Vcvtqq2ph_xmm_k1z_zmmm512b64_er
			0,// EVEX_Vcvtsd2sh_xmm_k1z_xmm_xmmm64_er
			0,// EVEX_Vcvtsh2sd_xmm_k1z_xmm_xmmm16_sae
			0,// EVEX_Vcvtsh2si_r32_xmmm16_er
			0,// EVEX_Vcvtsh2si_r64_xmmm16_er
			0,// EVEX_Vcvtsh2ss_xmm_k1z_xmm_xmmm16_sae
			0,// EVEX_Vcvtsh2usi_r32_xmmm16_er
			0,// EVEX_Vcvtsh2usi_r64_xmmm16_er
			0,// EVEX_Vcvtsi2sh_xmm_xmm_rm32_er
			0,// EVEX_Vcvtsi2sh_xmm_xmm_rm64_er
			0,// EVEX_Vcvtss2sh_xmm_k1z_xmm_xmmm32_er
			(byte)MemorySize.Broadcast64_Float16,// EVEX_Vcvttph2dq_xmm_k1z_xmmm64b16
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vcvttph2dq_ymm_k1z_xmmm128b16
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vcvttph2dq_zmm_k1z_ymmm256b16_sae
			(byte)MemorySize.Broadcast32_Float16,// EVEX_Vcvttph2qq_xmm_k1z_xmmm32b16
			(byte)MemorySize.Broadcast64_Float16,// EVEX_Vcvttph2qq_ymm_k1z_xmmm64b16
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vcvttph2qq_zmm_k1z_xmmm128b16_sae
			(byte)MemorySize.Broadcast64_Float16,// EVEX_Vcvttph2udq_xmm_k1z_xmmm64b16
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vcvttph2udq_ymm_k1z_xmmm128b16
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vcvttph2udq_zmm_k1z_ymmm256b16_sae
			(byte)MemorySize.Broadcast32_Float16,// EVEX_Vcvttph2uqq_xmm_k1z_xmmm32b16
			(byte)MemorySize.Broadcast64_Float16,// EVEX_Vcvttph2uqq_ymm_k1z_xmmm64b16
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vcvttph2uqq_zmm_k1z_xmmm128b16_sae
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vcvttph2uw_xmm_k1z_xmmm128b16
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vcvttph2uw_ymm_k1z_ymmm256b16
			(byte)MemorySize.Broadcast512_Float16,// EVEX_Vcvttph2uw_zmm_k1z_zmmm512b16_sae
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vcvttph2w_xmm_k1z_xmmm128b16
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vcvttph2w_ymm_k1z_ymmm256b16
			(byte)MemorySize.Broadcast512_Float16,// EVEX_Vcvttph2w_zmm_k1z_zmmm512b16_sae
			0,// EVEX_Vcvttsh2si_r32_xmmm16_sae
			0,// EVEX_Vcvttsh2si_r64_xmmm16_sae
			0,// EVEX_Vcvttsh2usi_r32_xmmm16_sae
			0,// EVEX_Vcvttsh2usi_r64_xmmm16_sae
			(byte)MemorySize.Broadcast128_UInt32,// EVEX_Vcvtudq2ph_xmm_k1z_xmmm128b32
			(byte)MemorySize.Broadcast256_UInt32,// EVEX_Vcvtudq2ph_xmm_k1z_ymmm256b32
			(byte)MemorySize.Broadcast512_UInt32,// EVEX_Vcvtudq2ph_ymm_k1z_zmmm512b32_er
			(byte)MemorySize.Broadcast128_UInt64,// EVEX_Vcvtuqq2ph_xmm_k1z_xmmm128b64
			(byte)MemorySize.Broadcast256_UInt64,// EVEX_Vcvtuqq2ph_xmm_k1z_ymmm256b64
			(byte)MemorySize.Broadcast512_UInt64,// EVEX_Vcvtuqq2ph_xmm_k1z_zmmm512b64_er
			0,// EVEX_Vcvtusi2sh_xmm_xmm_rm32_er
			0,// EVEX_Vcvtusi2sh_xmm_xmm_rm64_er
			(byte)MemorySize.Broadcast128_UInt16,// EVEX_Vcvtuw2ph_xmm_k1z_xmmm128b16
			(byte)MemorySize.Broadcast256_UInt16,// EVEX_Vcvtuw2ph_ymm_k1z_ymmm256b16
			(byte)MemorySize.Broadcast512_UInt16,// EVEX_Vcvtuw2ph_zmm_k1z_zmmm512b16_er
			(byte)MemorySize.Broadcast128_Int16,// EVEX_Vcvtw2ph_xmm_k1z_xmmm128b16
			(byte)MemorySize.Broadcast256_Int16,// EVEX_Vcvtw2ph_ymm_k1z_ymmm256b16
			(byte)MemorySize.Broadcast512_Int16,// EVEX_Vcvtw2ph_zmm_k1z_zmmm512b16_er
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vdivph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vdivph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Broadcast512_Float16,// EVEX_Vdivph_zmm_k1z_zmm_zmmm512b16_er
			0,// EVEX_Vdivsh_xmm_k1z_xmm_xmmm16_er
			(byte)MemorySize.Broadcast128_2xFloat16,// EVEX_Vfcmaddcph_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_2xFloat16,// EVEX_Vfcmaddcph_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_2xFloat16,// EVEX_Vfcmaddcph_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Broadcast128_2xFloat16,// EVEX_Vfmaddcph_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_2xFloat16,// EVEX_Vfmaddcph_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_2xFloat16,// EVEX_Vfmaddcph_zmm_k1z_zmm_zmmm512b32_er
			0,// EVEX_Vfcmaddcsh_xmm_k1z_xmm_xmmm32_er
			0,// EVEX_Vfmaddcsh_xmm_k1z_xmm_xmmm32_er
			(byte)MemorySize.Broadcast128_2xFloat16,// EVEX_Vfcmulcph_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_2xFloat16,// EVEX_Vfcmulcph_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_2xFloat16,// EVEX_Vfcmulcph_zmm_k1z_zmm_zmmm512b32_er
			(byte)MemorySize.Broadcast128_2xFloat16,// EVEX_Vfmulcph_xmm_k1z_xmm_xmmm128b32
			(byte)MemorySize.Broadcast256_2xFloat16,// EVEX_Vfmulcph_ymm_k1z_ymm_ymmm256b32
			(byte)MemorySize.Broadcast512_2xFloat16,// EVEX_Vfmulcph_zmm_k1z_zmm_zmmm512b32_er
			0,// EVEX_Vfcmulcsh_xmm_k1z_xmm_xmmm32_er
			0,// EVEX_Vfmulcsh_xmm_k1z_xmm_xmmm32_er
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vfmaddsub132ph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vfmaddsub132ph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Broadcast512_Float16,// EVEX_Vfmaddsub132ph_zmm_k1z_zmm_zmmm512b16_er
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vfmaddsub213ph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vfmaddsub213ph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Broadcast512_Float16,// EVEX_Vfmaddsub213ph_zmm_k1z_zmm_zmmm512b16_er
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vfmaddsub231ph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vfmaddsub231ph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Broadcast512_Float16,// EVEX_Vfmaddsub231ph_zmm_k1z_zmm_zmmm512b16_er
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vfmsubadd132ph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vfmsubadd132ph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Broadcast512_Float16,// EVEX_Vfmsubadd132ph_zmm_k1z_zmm_zmmm512b16_er
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vfmsubadd213ph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vfmsubadd213ph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Broadcast512_Float16,// EVEX_Vfmsubadd213ph_zmm_k1z_zmm_zmmm512b16_er
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vfmsubadd231ph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vfmsubadd231ph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Broadcast512_Float16,// EVEX_Vfmsubadd231ph_zmm_k1z_zmm_zmmm512b16_er
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vfmadd132ph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vfmadd132ph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Broadcast512_Float16,// EVEX_Vfmadd132ph_zmm_k1z_zmm_zmmm512b16_er
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vfmadd213ph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vfmadd213ph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Broadcast512_Float16,// EVEX_Vfmadd213ph_zmm_k1z_zmm_zmmm512b16_er
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vfmadd231ph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vfmadd231ph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Broadcast512_Float16,// EVEX_Vfmadd231ph_zmm_k1z_zmm_zmmm512b16_er
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vfnmadd132ph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vfnmadd132ph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Broadcast512_Float16,// EVEX_Vfnmadd132ph_zmm_k1z_zmm_zmmm512b16_er
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vfnmadd213ph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vfnmadd213ph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Broadcast512_Float16,// EVEX_Vfnmadd213ph_zmm_k1z_zmm_zmmm512b16_er
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vfnmadd231ph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vfnmadd231ph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Broadcast512_Float16,// EVEX_Vfnmadd231ph_zmm_k1z_zmm_zmmm512b16_er
			0,// EVEX_Vfmadd132sh_xmm_k1z_xmm_xmmm16_er
			0,// EVEX_Vfmadd213sh_xmm_k1z_xmm_xmmm16_er
			0,// EVEX_Vfmadd231sh_xmm_k1z_xmm_xmmm16_er
			0,// EVEX_Vfnmadd132sh_xmm_k1z_xmm_xmmm16_er
			0,// EVEX_Vfnmadd213sh_xmm_k1z_xmm_xmmm16_er
			0,// EVEX_Vfnmadd231sh_xmm_k1z_xmm_xmmm16_er
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vfmsub132ph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vfmsub132ph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Broadcast512_Float16,// EVEX_Vfmsub132ph_zmm_k1z_zmm_zmmm512b16_er
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vfmsub213ph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vfmsub213ph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Broadcast512_Float16,// EVEX_Vfmsub213ph_zmm_k1z_zmm_zmmm512b16_er
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vfmsub231ph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vfmsub231ph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Broadcast512_Float16,// EVEX_Vfmsub231ph_zmm_k1z_zmm_zmmm512b16_er
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vfnmsub132ph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vfnmsub132ph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Broadcast512_Float16,// EVEX_Vfnmsub132ph_zmm_k1z_zmm_zmmm512b16_er
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vfnmsub213ph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vfnmsub213ph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Broadcast512_Float16,// EVEX_Vfnmsub213ph_zmm_k1z_zmm_zmmm512b16_er
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vfnmsub231ph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vfnmsub231ph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Broadcast512_Float16,// EVEX_Vfnmsub231ph_zmm_k1z_zmm_zmmm512b16_er
			0,// EVEX_Vfmsub132sh_xmm_k1z_xmm_xmmm16_er
			0,// EVEX_Vfmsub213sh_xmm_k1z_xmm_xmmm16_er
			0,// EVEX_Vfmsub231sh_xmm_k1z_xmm_xmmm16_er
			0,// EVEX_Vfnmsub132sh_xmm_k1z_xmm_xmmm16_er
			0,// EVEX_Vfnmsub213sh_xmm_k1z_xmm_xmmm16_er
			0,// EVEX_Vfnmsub231sh_xmm_k1z_xmm_xmmm16_er
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vfpclassph_kr_k1_xmmm128b16_imm8
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vfpclassph_kr_k1_ymmm256b16_imm8
			(byte)MemorySize.Broadcast512_Float16,// EVEX_Vfpclassph_kr_k1_zmmm512b16_imm8
			0,// EVEX_Vfpclasssh_kr_k1_xmmm16_imm8
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vgetexpph_xmm_k1z_xmmm128b16
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vgetexpph_ymm_k1z_ymmm256b16
			(byte)MemorySize.Broadcast512_Float16,// EVEX_Vgetexpph_zmm_k1z_zmmm512b16_sae
			0,// EVEX_Vgetexpsh_xmm_k1z_xmm_xmmm16_sae
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vgetmantph_xmm_k1z_xmmm128b16_imm8
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vgetmantph_ymm_k1z_ymmm256b16_imm8
			(byte)MemorySize.Broadcast512_Float16,// EVEX_Vgetmantph_zmm_k1z_zmmm512b16_imm8_sae
			0,// EVEX_Vgetmantsh_xmm_k1z_xmm_xmmm16_imm8_sae
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vmaxph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vmaxph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Broadcast512_Float16,// EVEX_Vmaxph_zmm_k1z_zmm_zmmm512b16_sae
			0,// EVEX_Vmaxsh_xmm_k1z_xmm_xmmm16_sae
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vminph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vminph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Broadcast512_Float16,// EVEX_Vminph_zmm_k1z_zmm_zmmm512b16_sae
			0,// EVEX_Vminsh_xmm_k1z_xmm_xmmm16_sae
			0,// EVEX_Vmovsh_xmm_k1z_m16
			0,// EVEX_Vmovsh_m16_k1_xmm
			0,// EVEX_Vmovsh_xmm_k1z_xmm_xmm
			0,// EVEX_Vmovsh_xmm_k1z_xmm_xmm_MAP5_11
			0,// EVEX_Vmovw_xmm_r32m16
			0,// EVEX_Vmovw_xmm_r64m16
			0,// EVEX_Vmovw_r32m16_xmm
			0,// EVEX_Vmovw_r64m16_xmm
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vmulph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vmulph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Broadcast512_Float16,// EVEX_Vmulph_zmm_k1z_zmm_zmmm512b16_er
			0,// EVEX_Vmulsh_xmm_k1z_xmm_xmmm16_er
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vrcpph_xmm_k1z_xmmm128b16
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vrcpph_ymm_k1z_ymmm256b16
			(byte)MemorySize.Broadcast512_Float16,// EVEX_Vrcpph_zmm_k1z_zmmm512b16
			0,// EVEX_Vrcpsh_xmm_k1z_xmm_xmmm16
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vreduceph_xmm_k1z_xmmm128b16_imm8
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vreduceph_ymm_k1z_ymmm256b16_imm8
			(byte)MemorySize.Broadcast512_Float16,// EVEX_Vreduceph_zmm_k1z_zmmm512b16_imm8_sae
			0,// EVEX_Vreducesh_xmm_k1z_xmm_xmmm16_imm8_sae
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vrndscaleph_xmm_k1z_xmmm128b16_imm8
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vrndscaleph_ymm_k1z_ymmm256b16_imm8
			(byte)MemorySize.Broadcast512_Float16,// EVEX_Vrndscaleph_zmm_k1z_zmmm512b16_imm8_sae
			0,// EVEX_Vrndscalesh_xmm_k1z_xmm_xmmm16_imm8_sae
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vrsqrtph_xmm_k1z_xmmm128b16
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vrsqrtph_ymm_k1z_ymmm256b16
			(byte)MemorySize.Broadcast512_Float16,// EVEX_Vrsqrtph_zmm_k1z_zmmm512b16
			0,// EVEX_Vrsqrtsh_xmm_k1z_xmm_xmmm16
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vscalefph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vscalefph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Broadcast512_Float16,// EVEX_Vscalefph_zmm_k1z_zmm_zmmm512b16_er
			0,// EVEX_Vscalefsh_xmm_k1z_xmm_xmmm16_er
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vsqrtph_xmm_k1z_xmmm128b16
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vsqrtph_ymm_k1z_ymmm256b16
			(byte)MemorySize.Broadcast512_Float16,// EVEX_Vsqrtph_zmm_k1z_zmmm512b16_er
			0,// EVEX_Vsqrtsh_xmm_k1z_xmm_xmmm16_er
			(byte)MemorySize.Broadcast128_Float16,// EVEX_Vsubph_xmm_k1z_xmm_xmmm128b16
			(byte)MemorySize.Broadcast256_Float16,// EVEX_Vsubph_ymm_k1z_ymm_ymmm256b16
			(byte)MemorySize.Broadcast512_Float16,// EVEX_Vsubph_zmm_k1z_zmm_zmmm512b16_er
			0,// EVEX_Vsubsh_xmm_k1z_xmm_xmmm16_er
			0,// EVEX_Vucomish_xmm_xmmm16_sae
			0,// Rdudbg
			0,// Wrudbg
		};
	}
}
